/*
GenCS.c:  ?????.csv t@C Sfmt?????.cs t@C쐬
*/

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <direct.h>

enum { NumOfFiles=10,NumOfMacros=15,NumOfLines=32 };
int Mexp[]={607,1279,2281,4253,11213,19937,
            44497,86243,132049,216091};
int Data[NumOfFiles][NumOfLines][NumOfMacros];
char buf[4096],fname[128];
int file,line,macro,*x,swap; char*p;FILE*fp;

int Big[4][13]={
 {330, 5,3, 9,3,0xeffffffb,0xdfbebfff,0xbfbf7bef,0x9ffd7bff,
                0x00000001,0x00000000,0xa3ac4000,0xecc1327a},
 {366, 6,7,19,1,0xfdbffbff,0xbff7ff3f,0xfd77efff,0xbf9ff3ff,
                0x00000001,0x00000000,0x00000000,0xe9528d85},
 {110,19,1,21,1,0xffffbb5f,0xfb6ebf95,0xfffefffa,0xcff77fff,
                0x00000001,0x00000000,0xcb520000,0xc7e91c7d},
 {627,11,3,10,1,0xbff7bff7,0xbfffffff,0xbffffa7f,0xffddfbfb,
                0xf8000001,0x89e80709,0x3bd2b64b,0x0c64b1e4}
};

#define MEXP Mexp[file]
#define N128 (MEXP/128+1)
#define N32  (N128*4)
#define N16  (N128*8)
#define LAG  (N32>=623?11:N32>=68?7:N32>=39?5:3)
#define MID  ((N32-LAG)/2)
#define MLG  (MID+LAG)
#define POS1 x[2]
#define SL1  x[3]
#define SL2  x[4]
#define SR1  x[5]
#define SR2  x[6]
#define MSK1 x[7]
#define MSK2 x[8]
#define MSK3 x[9]
#define MSK4 x[10]

void GenAll(void) {
    fprintf(fp,"        int a=0,b=%d,c=%d,d=%d; uint y; uint[]p=x;\n",POS1*4,N32-8,N32-4);
    fprintf(fp,"\n");
    fprintf(fp,"        do {\n");

    if (SL2<4) fprintf(fp,"            y=p[a+3]^(p[a+3]<<%d)^(p[a+2]>>%d)^((p[b+3]>>%d)&0x%08xU);\n",SL2*8,32-SL2*8,SR1,MSK4);
    else       fprintf(fp,"            y=p[a+3]^(p[a+2]<<%d)^(p[a+1]>>%d)^((p[b+3]>>%d)&0x%08xU);\n",SL2*8-32,64-SL2*8,SR1,MSK4);
    if (SR2<4) fprintf(fp,"            p[a+3]=y^(p[c+3]>>%d)^(p[d+3]<<%d);\n",SR2*8,SL1);
    else       fprintf(fp,"            p[a+3]=y^(p[d+3]<<%d);\n",SL1);
    
    if (SL2<4) fprintf(fp,"            y=p[a+2]^(p[a+2]<<%d)^(p[a+1]>>%d)^((p[b+2]>>%d)&0x%08xU);\n",SL2*8,32-SL2*8,SR1,MSK3);
    else       fprintf(fp,"            y=p[a+2]^(p[a+1]<<%d)^(p[a]>>%d)^((p[b+2]>>%d)&0x%08xU);\n",SL2*8-32,64-SL2*8,SR1,MSK3);
    if (SR2<4) fprintf(fp,"            p[a+2]=y^((p[c+2]>>%d)|(p[c+3]<<%d))^(p[d+2]<<%d);\n",SR2*8,32-SR2*8,SL1);
    else       fprintf(fp,"            p[a+2]=y^(p[c+3]>>%d)^(p[d+2]<<%d);\n",SR2*8-32,SL1);
    
    if (SL2<4) fprintf(fp,"            y=p[a+1]^(p[a+1]<<%d)^(p[a]>>%d)^((p[b+1]>>%d)&0x%08xU);\n",SL2*8,32-SL2*8,SR1,MSK2);
    else       fprintf(fp,"            y=p[a+1]^(p[a]<<%d)^((p[b+1]>>%d)&0x%08xU);\n",SL2*8-32,SR1,MSK2);
    if (SR2<4) fprintf(fp,"            p[a+1]=y^((p[c+1]>>%d)|(p[c+2]<<%d))^(p[d+1]<<%d);\n",SR2*8,32-SR2*8,SL1);
    else       fprintf(fp,"            p[a+1]=y^((p[c+2]>>%d)|(p[c+3]<<%d))^(p[d+1]<<%d);\n",SR2*8-32,64-SR2*8,SL1);

    if (SL2<4) fprintf(fp,"            y=p[a]^(p[a]<<%d)^((p[b]>>%d)&0x%08xU);\n",SL2*8,SR1,MSK1);
    else       fprintf(fp,"            y=p[a]^((p[b]>>%d)&0x%08xU);\n",SR1,MSK1);
    if (SR2<4) fprintf(fp,"            p[a]=y^((p[c]>>%d)|(p[c+1]<<%d))^(p[d]<<%d);\n",SR2*8,32-SR2*8,SL1);
    else       fprintf(fp,"            p[a]=y^((p[c+1]>>%d)|(p[c+2]<<%d))^(p[d]<<%d);\n",SR2*8-32,64-SR2*8,SL1);

    fprintf(fp,"            c=d; d=a; a+=4; b+=4;\n");
    fprintf(fp,"            if (b==%d) b=0;\n",N32);
    fprintf(fp,"        } while (a!=%d);\n",N32);
    fprintf(fp,"    }\n");
    fprintf(fp,"\n");
}

void Header(char*virtua)
{
    fprintf(fp,"/*\n");
    fprintf(fp,"Sfmt%d.cs Cu\n",MEXP);
    fprintf(fp,"coded by isaku@pb4.so-net.ne.jp\n");
    fprintf(fp,"*/\n");
    fprintf(fp,"\n");
    fprintf(fp,"using System;\n");
    fprintf(fp,"\n");
    fprintf(fp,"class Sfmt\n");
    fprintf(fp,"{\n");
    fprintf(fp,"    int    index;\n");
    fprintf(fp,"    int    coin_bits; /* NextBit ł̎c̃rbg */\n");
    fprintf(fp,"    uint   coin_save; /* NextBit ł̒lێ */\n");
    fprintf(fp,"    int    byte_pos;  /* NextByte ŎgpoCg */\n");
    fprintf(fp,"    uint   byte_save; /* NextByte ł̒lێ */\n");
    fprintf(fp,"    int    range; /* NextIntEx őO͈̔ */\n");
    fprintf(fp,"    uint   bse; /* NextIntEx őO̊l */\n");
    fprintf(fp,"    int    shift; /* NextIntEx őÕVtg */\n");
    fprintf(fp,"    int    normal_sw; /* NextNormal ŎcĂ */\n");
    fprintf(fp,"    double normal_save; /* NextNormal ̎c̒l */\n");
    fprintf(fp,"    protected uint[]x=new uint[%d]; /* ԃe[u */\n",N32);
    fprintf(fp,"\n");
    fprintf(fp,"    static uint[]ParityData=\n");
    fprintf(fp,"    { 0x%08lxU,0x%08lxU,0x%08lxU,0x%08lxU };\n\n",x[11],x[12],x[13],x[14]);
    fprintf(fp,"    protected%s uint[]GetParity() { return ParityData; }\n\n",virtua);
    fprintf(fp,"    public%s string IdString { get {\n",virtua);
    fprintf(fp,"        return\"SFMT-%d:%d-%d-%d-%d-%d:%08x-%08x-%08x-%08x\";\n    } }\n\n",
                     MEXP,x[2],x[3],x[4],x[5],x[6],x[7],x[8],x[9],x[10]);
    fprintf(fp,"    public%s void gen_rand_all() {\n",virtua);
    GenAll();
    fprintf(fp,"    void period_certification() {\n");
    fprintf(fp,"        uint work,inner=0; int i,j; uint[] parity=GetParity();\n");
    fprintf(fp,"\n");
    fprintf(fp,"        index=%d; range=0; normal_sw=0; coin_bits=0; byte_pos=0;\n",N32);
    fprintf(fp,"        for (i=0;i<4;i++) inner^=x[i]&parity[i];\n");
    fprintf(fp,"        for (i=16;i>0;i>>=1) inner^=inner>>i;\n");
    fprintf(fp,"        inner&=1;\n");
    fprintf(fp,"        if (inner==1) return;\n");
    fprintf(fp,"        for (i=0;i<4;i++) for (j=0,work=1;j<32;j++,work<<=1)\n");
    fprintf(fp,"         if ((work&parity[i])!=0) { x[i]^=work; return; }\n");
    fprintf(fp,"    }\n");
    fprintf(fp,"\n");
    fprintf(fp,"    /* ̎ s ɂ鏉 */\n");
    fprintf(fp,"    public void InitMt(uint s) {\n");
    fprintf(fp,"        unchecked {\n");
    fprintf(fp,"            x[0]=s;\n");
    fprintf(fp,"            for (uint p=1;p<%d;p++)\n",N32);
    fprintf(fp,"                x[p]=s=1812433253*(s^(s>>30))+p;\n");
    fprintf(fp,"            period_certification();\n");
    fprintf(fp,"        }\n");
    fprintf(fp,"    }\n");
    fprintf(fp,"\n");
    fprintf(fp,"    public Sfmt(uint s) { InitMt(s); }\n");
    fprintf(fp,"\n");
    fprintf(fp,"    /* z init_key ɂ鏉 */\n");
    fprintf(fp,"    public void InitMtEx(uint[]init_key) {\n");
    fprintf(fp,"        uint r,i,j,c,key_len=(uint)init_key.Length;\n");
    fprintf(fp,"\n");
    fprintf(fp,"        unchecked {\n");
    fprintf(fp,"            for (i=0;i<%d;i++) x[i]=0x8b8b8b8b;\n",N32);
    fprintf(fp,"            if (key_len+1>%d) c=key_len+1; else c=%d;\n",N32,N32);
    fprintf(fp,"            r=x[0]^x[%d]^x[%d]; r=(r^(r>>27))*1664525;\n",MID,N32-1);
    fprintf(fp,"            x[%d]+=r; r+=key_len; x[%d]+=r; x[0]=r; c--;\n",MID,MLG);
    fprintf(fp,"            for (i=1,j=0;j<c&&j<key_len;j++) {\n");
    fprintf(fp,"                r=x[i]^x[(i+%d)%%%d]^x[(i+%d)%%%d];\n",MID,N32,N32-1,N32);
    fprintf(fp,"                r=(r^(r>>27))*1664525; x[(i+%d)%%%d]+=r;\n",MID,N32);
    fprintf(fp,"                r+=init_key[j]+i; x[(i+%d)%%%d]+=r;\n",MLG,N32);
    fprintf(fp,"                x[i]=r; i=(i+1)%%%d;\n",N32);
    fprintf(fp,"            }\n");
    fprintf(fp,"            for (;j<c;j++) {\n");
    fprintf(fp,"                r=x[i]^x[(i+%d)%%%d]^x[(i+%d)%%%d];\n",MID,N32,N32-1,N32);
    fprintf(fp,"                r=(r^(r>>27))*1664525; x[(i+%d)%%%d]+=r; r+=i;\n",MID,N32);
    fprintf(fp,"                x[(i+%d)%%%d]+=r; x[i]=r; i=(i+1)%%%d;\n",MLG,N32,N32);
    fprintf(fp,"            }\n");
    fprintf(fp,"            for (j=0;j<%d;j++) {\n",N32);
    fprintf(fp,"                r=x[i]+x[(i+%d)%%%d]+x[(i+%d)%%%d];\n",MID,N32,N32-1,N32);
    fprintf(fp,"                r=(r^(r>>27))*1566083941; x[(i+%d)%%%d]^=r;\n",MID,N32);
    fprintf(fp,"                r-=i; x[(i+%d)%%%d]^=r; x[i]=r; i=(i+1)%%%d;\n",MLG,N32,N32);
    fprintf(fp,"            }\n");
    fprintf(fp,"            period_certification();\n");
    fprintf(fp,"        }\n");
    fprintf(fp,"    }\n");
    fprintf(fp,"\n");
    fprintf(fp,"    public Sfmt(uint[]init_key) { InitMtEx(init_key); }\n");
    fprintf(fp,"\n");
    fprintf(fp,"    /* 32rbgȂ̗ */\n");
    fprintf(fp,"    public uint NextMt() {\n");
    fprintf(fp,"        if (index==%d) { gen_rand_all(); index=0; }\n",N32);
    fprintf(fp,"        return x[index++];\n");
    fprintf(fp,"    }\n");
    fprintf(fp,"\n");
    fprintf(fp,"    /* Oȏ n ̐ */\n");
    fprintf(fp,"    public int NextInt(int n)\n");
    fprintf(fp,"    { return(int)(n*(1.0/4294967296.0)*NextMt()); }\n");
    fprintf(fp,"\n");
    fprintf(fp,"    /* OȏP̗(53bitx) */\n");
    fprintf(fp,"    public double NextUnif() {\n");
    fprintf(fp,"        uint z=NextMt()>>11,y=NextMt();\n");
    fprintf(fp,"        return(y*2097152.0+z)*(1.0/9007199254740992.0);\n");
    fprintf(fp,"    }\n");
    fprintf(fp,"\n");
    fprintf(fp,"    /* OPԂ */\n");
    fprintf(fp,"    public int NextBit() {\n");
    fprintf(fp,"        if (--coin_bits==-1)\n");
    fprintf(fp,"        { coin_bits=31; return(int)(coin_save=NextMt())&1; }\n");
    fprintf(fp,"        else return(int)(coin_save>>=1)&1;\n");
    fprintf(fp,"    }\n");
    fprintf(fp,"\n");
    fprintf(fp,"    /* OQTTԂ */\n");
    fprintf(fp,"    public int NextByte() {\n");
    fprintf(fp,"        if (--byte_pos==-1)\n");
    fprintf(fp,"        { byte_pos=3; return(int)(byte_save=NextMt())&255; }\n");
    fprintf(fp,"        else return(int)(byte_save>>=8)&255;\n");
    fprintf(fp,"    }\n");
    fprintf(fp,"\n");
    fprintf(fp,"    /* ۂߌ덷̂ȂOȏ range_ ̐ */\n");
    fprintf(fp,"    public int NextIntEx(int range_) {\n");
    fprintf(fp,"        uint y_,base_,remain_; int shift_;\n");
    fprintf(fp,"\n");
    fprintf(fp,"        if (range_<=0) return 0;\n");
    fprintf(fp,"        if (range_!=range) {\n");
    fprintf(fp,"            bse=(uint)(range=range_);\n");
    fprintf(fp,"            for (shift=0;bse<=(1UL<<30);shift++) bse<<=1;\n");
    fprintf(fp,"        }\n");
    fprintf(fp,"        for (;;) {\n");
    fprintf(fp,"            y_=NextMt()>>1;\n");
    fprintf(fp,"            if (y_<bse) return(int)(y_>>shift);\n");
    fprintf(fp,"            base_=bse; shift_=shift; y_-=base_;\n");
    fprintf(fp,"            remain_=(1U<<31)-base_;\n");
    fprintf(fp,"            for (;remain_>=(uint)range_;remain_-=base_) {\n");
    fprintf(fp,"                for (;base_>remain_;base_>>=1) shift_--;\n");
    fprintf(fp,"                if (y_<base_) return(int)(y_>>shift_);\n");
    fprintf(fp,"                else y_-=base_;\n");
    fprintf(fp,"            }\n");
    fprintf(fp,"        }\n");
    fprintf(fp,"    }\n");
    fprintf(fp,"\n");
    fprintf(fp,"    /* Rx˂̃JCQ敪z */\n");
    fprintf(fp,"    public double NextChisq(double n)\n");
    fprintf(fp,"    { return 2*NextGamma(0.5*n); }\n");
    fprintf(fp,"\n");
    fprintf(fp,"    /* p[^̃K}z */\n");
    fprintf(fp,"    public double NextGamma(double a) {\n");
    fprintf(fp,"        double t,u,X,y;\n");
    fprintf(fp,"        if (a>1) {\n");
    fprintf(fp,"            t=Math.Sqrt(2*a-1);\n");
    fprintf(fp,"            do {\n");
    fprintf(fp,"                do {\n");
    fprintf(fp,"                    do {\n");
    fprintf(fp,"                        X=1-NextUnif();\n");
    fprintf(fp,"                        y=2*NextUnif()-1;\n");
    fprintf(fp,"                    } while (X*X+y*y>1);\n");
    fprintf(fp,"                    y/=X; X=t*y+a-1;\n");
    fprintf(fp,"                } while (X<=0);\n");
    fprintf(fp,"                u=(a-1)*Math.Log(X/(a-1))-t*y;\n");
    fprintf(fp,"            } while (u<-50||NextUnif()>(1+y*y)*Math.Exp(u));\n");
    fprintf(fp,"        } else {\n");
    fprintf(fp,"            t=2.718281828459045235/(a+2.718281828459045235);\n");
    fprintf(fp,"            do {\n");
    fprintf(fp,"                if (NextUnif()<t) {\n");
    fprintf(fp,"                    X=Math.Pow(NextUnif(),1/a); y=Math.Exp(-X);\n");
    fprintf(fp,"                } else {\n");
    fprintf(fp,"                    X=1-Math.Log(1-NextUnif()); y=Math.Pow(X,a-1);\n");
    fprintf(fp,"                }\n");
    fprintf(fp,"            } while (NextUnif()>=y);\n");
    fprintf(fp,"        }\n");
    fprintf(fp,"        return X;\n");
    fprintf(fp,"    }\n");
    fprintf(fp,"\n");
    fprintf(fp,"    /* mo̊􉽕z */\n");
    fprintf(fp,"    public int NextGeometric(double p)\n");
    fprintf(fp,"    { return(int)Math.Ceiling(Math.Log(1.0-NextUnif())/Math.Log(1-p)); }\n");
    fprintf(fp,"\n");
    fprintf(fp,"    /* Opz */\n");
    fprintf(fp,"    public double NextTriangle()\n");
    fprintf(fp,"    { double a=NextUnif(),b=NextUnif(); return a-b; }\n");
    fprintf(fp,"\n");
    fprintf(fp,"    /* ςP̎wz */\n");
    fprintf(fp,"    public double NextExp()\n");
    fprintf(fp,"    { return-Math.Log(1-NextUnif()); }\n");
    fprintf(fp,"\n");
    fprintf(fp,"    /* WKz(ő8.57) */\n");
    fprintf(fp,"    public double NextNormal()\n");
    fprintf(fp,"    {\n");
    fprintf(fp,"        if (normal_sw==0) {\n");
    fprintf(fp,"            double t=Math.Sqrt(-2*Math.Log(1.0-NextUnif()));\n");
    fprintf(fp,"            double u=3.141592653589793*2*NextUnif();\n");
    fprintf(fp,"            normal_save=t*Math.Sin(u); normal_sw=1;\n");
    fprintf(fp,"            return t*Math.Cos(u);\n");
    fprintf(fp,"        }else{ normal_sw=0; return normal_save; }\n");
    fprintf(fp,"    }\n");
    fprintf(fp,"\n");
    fprintf(fp,"    /* m̃_PʃxNg */\n");
    fprintf(fp,"    public void NextUnitVect(out double[]v,int n) {\n");
    fprintf(fp,"        int i; double r=0;\n");
    fprintf(fp,"        v=new double[n];\n");
    fprintf(fp,"        for (i=0;i<n;i++) { v[i]=NextNormal(); r+=v[i]*v[i]; }\n");
    fprintf(fp,"        if (r==0.0) r=1.0;\n");
    fprintf(fp,"        r=Math.Sqrt(r);\n");
    fprintf(fp,"        for (i=0;i<n;i++) v[i]/=r;\n");
    fprintf(fp,"    }\n");
    fprintf(fp,"\n");
    fprintf(fp,"    /* p[^m,ôQz */\n");
    fprintf(fp,"    public int NextBinomial(int n,double p) {\n");
    fprintf(fp,"        int i,r=0;\n");
    fprintf(fp,"        for (i=0;i<n;i++) if (NextUnif()<p) r++;\n");
    fprintf(fp,"        return r;\n");
    fprintf(fp,"    }\n");
    fprintf(fp,"\n");
    fprintf(fp,"    /* ֌Wq̂QϗʐKz */\n");
    fprintf(fp,"    public void NextBinormal(double r,out double a,out double b) {\n");
    fprintf(fp,"        double r1,r2,s;\n");
    fprintf(fp,"        do {\n");
    fprintf(fp,"            r1=2*NextUnif()-1;\n");
    fprintf(fp,"            r2=2*NextUnif()-1;\n");
    fprintf(fp,"            s=r1*r1+r2*r2;\n");
    fprintf(fp,"        } while (s>1||s==0);\n");
    fprintf(fp,"        s= -Math.Log(s)/s; r1=Math.Sqrt((1+r)*s)*r1;\n");
    fprintf(fp,"        r2=Math.Sqrt((1-r)*s)*r2; a=r1+r2; b=r1-r2;\n");
    fprintf(fp,"    }\n");
    fprintf(fp,"\n");
    fprintf(fp,"    /* p[^`,ãx[^z */\n");
    fprintf(fp,"    public double NextBeta(double a,double b) {\n");
    fprintf(fp,"        double temp=NextGamma(a);\n");
    fprintf(fp,"        return temp/(temp+NextGamma(b));\n");
    fprintf(fp,"    }\n");
    fprintf(fp,"\n");
    fprintf(fp,"    /* p[^m̗ݏ敪z */\n");
    fprintf(fp,"    public double NextPower(double n)\n");
    fprintf(fp,"    { return Math.Pow(NextUnif(),1.0/(n+1)); }\n");
    fprintf(fp,"\n");
    fprintf(fp,"    /* WXeBbNz */\n");
    fprintf(fp,"    public double NextLogistic() {\n");
    fprintf(fp,"        double r;\n");
    fprintf(fp,"        do r=NextUnif(); while (r==0);\n");
    fprintf(fp,"        return Math.Log(r/(1-r));\n");
    fprintf(fp,"    }\n");
    fprintf(fp,"\n");
    fprintf(fp,"    /* R[V[z */\n");
    fprintf(fp,"    public double NextCauchy() {\n");
    fprintf(fp,"        double x,y;\n");
    fprintf(fp,"        do { x=1-NextUnif(); y=2*NextUnif()-1; }\n");
    fprintf(fp,"        while (x*x+y*y>1);\n");
    fprintf(fp,"        return y/x;\n");
    fprintf(fp,"    }\n");
    fprintf(fp,"\n");
    fprintf(fp,"    /* Rx n1,n2 ̂ez */\n");
    fprintf(fp,"    public double NextFDist(double n1,double n2) {\n");
    fprintf(fp,"        double nc1=NextChisq(n1),nc2=NextChisq(n2);\n");
    fprintf(fp,"        return (nc1*n2)/(nc2*n1);\n");
    fprintf(fp,"    }\n");
    fprintf(fp,"\n");
    fprintf(fp,"    /* σɂ̃|A\z */\n");
    fprintf(fp,"    public int NextPoisson(double lambda) {\n");
    fprintf(fp,"        int k; lambda=Math.Exp(lambda)*NextUnif();\n");
    fprintf(fp,"        for (k=0;lambda>1;k++) lambda*=NextUnif();\n");
    fprintf(fp,"        return k;\n");
    fprintf(fp,"    }\n");
    fprintf(fp,"\n");
    fprintf(fp,"    /* Rxm̂z */\n");
    fprintf(fp,"    public double NextTDist(double n) {\n");
    fprintf(fp,"        double a,b,c;\n");
    fprintf(fp,"        if (n<=2) {\n");
    fprintf(fp,"            do a=NextChisq(n); while (a==0);\n");
    fprintf(fp,"            return NextNormal()/Math.Sqrt(a/n);\n");
    fprintf(fp,"        }\n");
    fprintf(fp,"        do {\n");
    fprintf(fp,"            a=NextNormal(); b=a*a/(n-2);\n");
    fprintf(fp,"            c=Math.Log(1-NextUnif())/(1-0.5*n);\n");
    fprintf(fp,"        } while (Math.Exp(-b-c)>1-b);\n");
    fprintf(fp,"        return a/Math.Sqrt((1-2.0/n)*(1-b));\n");
    fprintf(fp,"    }\n");
    fprintf(fp,"\n");
    fprintf(fp,"    /* p[^̃Cuz */\n");
    fprintf(fp,"    public double NextWeibull(double alpha)\n");
    fprintf(fp,"    { return Math.Pow(-Math.Log(1-NextUnif()),1/alpha); }\n");
    fprintf(fp,"}\n");
    fprintf(fp,"\n");
}

void Each(void)
{
    x=Data[file][line];
    fprintf(fp,"class Sfmt%d : Sfmt\n",line);
    fprintf(fp,"{\n");
    fprintf(fp,"    public override string IdString { get {\n");
    fprintf(fp,"        return\"SFMT-%d:%d-%d-%d-%d-%d:%08x-%08x-%08x-%08x\";\n    } }\n\n",
                     MEXP,x[2],x[3],x[4],x[5],x[6],x[7],x[8],x[9],x[10]);
    fprintf(fp,"    static uint[]ParityData=\n");
    fprintf(fp,"    { 0x%08lxU,0x%08lxU,0x%08lxU,0x%08lxU };\n\n",x[11],x[12],x[13],x[14]);
    fprintf(fp,"    protected override uint[]GetParity() { return ParityData; }\n");
    fprintf(fp,"\n");
    fprintf(fp,"    public override void gen_rand_all() {\n");
    GenAll();
    fprintf(fp,"    public Sfmt%d(uint s) : base(s) { }\n",line);
    fprintf(fp,"    public Sfmt%d(uint[]init_key) : base(init_key) { }\n",line);
    fprintf(fp,"}\n\n");
}

void Gen_m(void)
{
    fprintf(fp,"class Sfmt_m\n");
    fprintf(fp,"{\n");
    if (file<6) {
        fprintf(fp,"    static Sfmt[]z={\n");
        fprintf(fp,"        new Sfmt(1),\n");
        fprintf(fp,"        new Sfmt1 (unchecked((uint) -1)),\n");
        fprintf(fp,"        new Sfmt2 (unchecked((uint) -2)),\n");
        fprintf(fp,"        new Sfmt3 (unchecked((uint) -3)),\n");
        fprintf(fp,"        new Sfmt4 (unchecked((uint) -4)),\n");
        fprintf(fp,"        new Sfmt5 (unchecked((uint) -5)),\n");
        fprintf(fp,"        new Sfmt6 (unchecked((uint) -6)),\n");
        fprintf(fp,"        new Sfmt7 (unchecked((uint) -7)),\n");
        fprintf(fp,"        new Sfmt8 (unchecked((uint) -8)),\n");
        fprintf(fp,"        new Sfmt9 (unchecked((uint) -9)),\n");
        fprintf(fp,"        new Sfmt10(unchecked((uint)-10)),\n");
        fprintf(fp,"        new Sfmt11(unchecked((uint)-11)),\n");
        fprintf(fp,"        new Sfmt12(unchecked((uint)-12)),\n");
        fprintf(fp,"        new Sfmt13(unchecked((uint)-13)),\n");
        fprintf(fp,"        new Sfmt14(unchecked((uint)-14)),\n");
        fprintf(fp,"        new Sfmt15(unchecked((uint)-15)),\n");
        fprintf(fp,"        new Sfmt16(unchecked((uint)-16)),\n");
        fprintf(fp,"        new Sfmt17(unchecked((uint)-17)),\n");
        fprintf(fp,"        new Sfmt18(unchecked((uint)-18)),\n");
        fprintf(fp,"        new Sfmt19(unchecked((uint)-19)),\n");
        fprintf(fp,"        new Sfmt20(unchecked((uint)-20)),\n");
        fprintf(fp,"        new Sfmt21(unchecked((uint)-21)),\n");
        fprintf(fp,"        new Sfmt22(unchecked((uint)-22)),\n");
        fprintf(fp,"        new Sfmt23(unchecked((uint)-23)),\n");
        fprintf(fp,"        new Sfmt24(unchecked((uint)-24)),\n");
        fprintf(fp,"        new Sfmt25(unchecked((uint)-25)),\n");
        fprintf(fp,"        new Sfmt26(unchecked((uint)-26)),\n");
        fprintf(fp,"        new Sfmt27(unchecked((uint)-27)),\n");
        fprintf(fp,"        new Sfmt28(unchecked((uint)-28)),\n");
        fprintf(fp,"        new Sfmt29(unchecked((uint)-29)),\n");
        fprintf(fp,"        new Sfmt30(unchecked((uint)-30)),\n");
        fprintf(fp,"        new Sfmt31(unchecked((uint)-31))\n");
        fprintf(fp,"    };\n\n");
    } else {
        fprintf(fp,"    static Sfmt[]z={\n");
        fprintf(fp,"        new Sfmt(1),\n");
        fprintf(fp,"        new Sfmt(unchecked((uint) -1)),\n");
        fprintf(fp,"        new Sfmt(unchecked((uint) -2)),\n");
        fprintf(fp,"        new Sfmt(unchecked((uint) -3)),\n");
        fprintf(fp,"        new Sfmt(unchecked((uint) -4)),\n");
        fprintf(fp,"        new Sfmt(unchecked((uint) -5)),\n");
        fprintf(fp,"        new Sfmt(unchecked((uint) -6)),\n");
        fprintf(fp,"        new Sfmt(unchecked((uint) -7)),\n");
        fprintf(fp,"        new Sfmt(unchecked((uint) -8)),\n");
        fprintf(fp,"        new Sfmt(unchecked((uint) -9)),\n");
        fprintf(fp,"        new Sfmt(unchecked((uint)-10)),\n");
        fprintf(fp,"        new Sfmt(unchecked((uint)-11)),\n");
        fprintf(fp,"        new Sfmt(unchecked((uint)-12)),\n");
        fprintf(fp,"        new Sfmt(unchecked((uint)-13)),\n");
        fprintf(fp,"        new Sfmt(unchecked((uint)-14)),\n");
        fprintf(fp,"        new Sfmt(unchecked((uint)-15)),\n");
        fprintf(fp,"        new Sfmt(unchecked((uint)-16)),\n");
        fprintf(fp,"        new Sfmt(unchecked((uint)-17)),\n");
        fprintf(fp,"        new Sfmt(unchecked((uint)-18)),\n");
        fprintf(fp,"        new Sfmt(unchecked((uint)-19)),\n");
        fprintf(fp,"        new Sfmt(unchecked((uint)-20)),\n");
        fprintf(fp,"        new Sfmt(unchecked((uint)-21)),\n");
        fprintf(fp,"        new Sfmt(unchecked((uint)-22)),\n");
        fprintf(fp,"        new Sfmt(unchecked((uint)-23)),\n");
        fprintf(fp,"        new Sfmt(unchecked((uint)-24)),\n");
        fprintf(fp,"        new Sfmt(unchecked((uint)-25)),\n");
        fprintf(fp,"        new Sfmt(unchecked((uint)-26)),\n");
        fprintf(fp,"        new Sfmt(unchecked((uint)-27)),\n");
        fprintf(fp,"        new Sfmt(unchecked((uint)-28)),\n");
        fprintf(fp,"        new Sfmt(unchecked((uint)-29)),\n");
        fprintf(fp,"        new Sfmt(unchecked((uint)-30)),\n");
        fprintf(fp,"        new Sfmt(unchecked((uint)-31))\n");
        fprintf(fp,"    };\n\n");
    }
    fprintf(fp,"    public static string IdString_m(int i)\n");
    fprintf(fp,"    { return z[i].IdString; }\n\n");
    fprintf(fp,"    public static void InitMt_m(int i,uint s)\n");
    fprintf(fp,"    { z[i].InitMt(s); }\n\n");
    fprintf(fp,"    public static void InitMtEx_m(int i,uint[]k)\n");
    fprintf(fp,"    { z[i].InitMtEx(k); }\n\n");
    fprintf(fp,"    public static uint NextMt_m(int i)\n");
    fprintf(fp,"    { return z[i].NextMt(); }\n\n");
    fprintf(fp,"    public static int NextInt_m(int i,int n)\n");
    fprintf(fp,"    { return z[i].NextInt(n); }\n\n");
    fprintf(fp,"    public static int NextBit_m(int i)\n");
    fprintf(fp,"    { return z[i].NextBit(); }\n\n");
    fprintf(fp,"    public static int NextByte_m(int i)\n");
    fprintf(fp,"    { return z[i].NextByte(); }\n\n");
    fprintf(fp,"    public static double NextUnif_m(int i)\n");
    fprintf(fp,"    { return z[i].NextUnif(); }\n\n");
    fprintf(fp,"    public static int NextIntEx_m(int i,int r)\n");
    fprintf(fp,"    { return z[i].NextIntEx(r); }\n\n");
    fprintf(fp,"    public static double NextChisq_m(int i,double n)\n");
    fprintf(fp,"    { return z[i].NextChisq(n); }\n\n");
    fprintf(fp,"    public static double NextGamma_m(int i,double a)\n");
    fprintf(fp,"    { return z[i].NextGamma(a); }\n\n");
    fprintf(fp,"    public static int NextGeometric_m(int i,double p)\n");
    fprintf(fp,"    { return z[i].NextGeometric(p); }\n\n");
    fprintf(fp,"    public static double NextTriangle_m(int i)\n");
    fprintf(fp,"    { return z[i].NextTriangle(); }\n\n");
    fprintf(fp,"    public static double NextExp_m(int i)\n");
    fprintf(fp,"    { return z[i].NextExp(); }\n\n");
    fprintf(fp,"    public static double NextNormal_m(int i)\n");
    fprintf(fp,"    { return z[i].NextNormal(); }\n\n");
    fprintf(fp,"    public static void NextUnitVect_m(int i,out double[]v,int n)\n");
    fprintf(fp,"    { z[i].NextUnitVect(out v,n); }\n\n");
    fprintf(fp,"    public static int NextBinomial_m(int i,int n,double p)\n");
    fprintf(fp,"    { return z[i].NextBinomial(n,p); }\n\n");
    fprintf(fp,"    public static void NextBinormal_m(int i,double r,out double a,out double b)\n");
    fprintf(fp,"    { z[i].NextBinormal(r,out a,out b); }\n\n");
    fprintf(fp,"    public static double NextBeta_m(int i,double a,double b)\n");
    fprintf(fp,"    { return z[i].NextBeta(a,b); }\n\n");
    fprintf(fp,"    public static double NextPower_m(int i,double n)\n");
    fprintf(fp,"    { return z[i].NextPower(n); }\n\n");
    fprintf(fp,"    public static double NextLogistic_m(int i)\n");
    fprintf(fp,"    { return z[i].NextLogistic(); }\n\n");
    fprintf(fp,"    public static double NextCauchy_m(int i)\n");
    fprintf(fp,"    { return z[i].NextCauchy(); }\n\n");
    fprintf(fp,"    public static int NextPoisson_m(int i,double l)\n");
    fprintf(fp,"    { return z[i].NextPoisson(l); }\n\n");
    fprintf(fp,"    public static double NextFDist_m(int i,double n1,double n2)\n");
    fprintf(fp,"    { return z[i].NextFDist(n1,n2); }\n\n");
    fprintf(fp,"    public static double NextTDist_m(int i,double n)\n");
    fprintf(fp,"    { return z[i].NextTDist(n); }\n\n");
    fprintf(fp,"    public static double NextWeibull_m(int i,double a)\n");
    fprintf(fp,"    { return z[i].NextWeibull(a); }\n\n");
    fprintf(fp,"}\n");
    fprintf(fp,"\n");
}

/*
@16i̕longɕϊ鄠
@*/
int htol(char*p)
{
    static char tbl[]="0123456789abcdef"; int ret=0,i,c;

    while ((c=*p++)!=0) {
        for (i=0;i<16&&tbl[i]!=c;i++) ;
        ret=ret*16+i;
    }
    return ret;
}

int main(void)
{
    for (file=0;file<6;file++) {
        sprintf(fname,"%d.csv",Mexp[file]);
        fp=fopen(fname,"r");
        if (fp==0) { printf("'%s'cannot open\n",fname); return 1;}
        if (fgets(buf,sizeof buf,fp)==0)
        { printf("'%s'is empty\n",fname); return 1; }
        for (line=0;line<NumOfLines;line++) {
            p=fgets(buf,sizeof buf,fp);
            if (p==0) {
                printf("'%s':%d unexpected EOF\n",fname,line);
                return 1;
            }
            p=strtok(buf,",\r\n");
            for (macro=0;macro<NumOfMacros;macro++) {
                if (p==0) {
                    printf("'%s':%d unexpected EOLN\n",fname,line);
                    return 1;
                }
                if (macro>=7&&macro<=14)
                    Data[file][line][macro]=htol(p);
                else
                    Data[file][line][macro]=atol(p);
                p=strtok(0,",\r\n");
            }
        }
        fclose(fp);
    }

    for (file=6;file<10;file++) {
        Data[file][0][0]=Mexp[file];
        for (macro=2;macro<=14;macro++)
            Data[file][0][macro]=Big[file-6][macro-2];
    }
         
    /* MEXP=1279 ̍ŏ̃CftHgŖ̂œւ */
    for (macro=0;macro<NumOfMacros;macro++) {
        swap=Data[1][0][macro];
        Data[1][0][macro]=Data[1][1][macro];
        Data[1][1][macro]=swap;
    }

    printf("OK\n");

    if (mkdir("..\\SfmtCS")==0) printf("'..\\SfmtCS'was created\n");
    for (file=0;file<NumOfFiles;file++) {
        sprintf(fname,"..\\SfmtCS\\Sfmt%d.cs",MEXP);
        fp=fopen(fname,"w");
        if (fp==0) { printf("'%s'cannot create\n",fname); return 1;}
        x=Data[file][0];
        if (file<6) {
            Header(" virtual");
            for (line=1;line<NumOfLines;line++) Each();
        } else Header("");
        Gen_m();
        fclose(fp);
        printf("'%s'was created\n",fname);
    }
    return 0;
}
