/*
GenPara.c:  ?????.csv t@Cp[^t@C쐬
*/

#include <stdio.h>
#include <string.h>
#include <stdlib.h>

enum { NumOfFiles=6,NumOfMacros=15,NumOfLines=32 };
long Mexp[]={607L,1279L,2281L,4253L,11213L,19937L};
long Data[NumOfFiles][NumOfLines][NumOfMacros];

long htol(char*p)
{
    static char tbl[]="0123456789abcdef"; long ret=0; int i,c;

    while ((c=*p++)!=0) {
        for (i=0;i<16&&tbl[i]!=c;i++) ;
        ret=ret*16+i;
    }
    return ret;
}

int main(void)
{
    static char buf[2048],fname[128];
    int file,i,line,macro; long*x,swap; FILE*fp; char*p;

    for (file=0;file<NumOfFiles;file++) {
        sprintf(fname,"%ld.csv",Mexp[file]);
        fp=fopen(fname,"r");
        if (fp==0) { printf("'%s'cannot open\n",fname); return 1;}
        if (fgets(buf,sizeof buf,fp)==0)
        { printf("'%s'is empty\n",fname); return 1; }
        for (line=0;line<NumOfLines;line++) {
            p=fgets(buf,sizeof buf,fp);
            if (p==0) {
                printf("'%s':%d unexpected EOF\n",fname,line);
                return 1;
            }
            p=strtok(buf,",\r\n");
            for (macro=0;macro<NumOfMacros;macro++) {
                if (p==0) {
                    printf("'%s':%d unexpected EOLN\n",fname,line);
                    return 1;
                }
                if (macro>=7&&macro<=14)
                    Data[file][line][macro]=htol(p);
                else
                    Data[file][line][macro]=atol(p);
                p=strtok(0,",\r\n");
            }
        }
        fclose(fp);
    }
    for (macro=0;macro<NumOfMacros;macro++) {
        swap=Data[1][0][macro];
        Data[1][0][macro]=Data[1][1][macro];
        Data[1][1][macro]=swap;
    }
    printf("OK\n");
    for (;;) {
back:
        do {
            for (file=0;file<NumOfFiles;file++)
                printf("%d:%6ld.csv\n",file+1,Mexp[file]);
            printf("choose file ([ENTER]to quit)>");
            fgets(buf,sizeof buf,stdin);
            if (*buf=='\n'||*buf=='\r') return 0;
            file=atoi(strtok(buf," \t\r\n"))-1;
        } while (file<0||file>=NumOfFiles);
        do {
            printf("No.POS1 SL1 SL2 SR1 SR2          ");
            printf("No.POS1 SL1 SL2 SR1 SR2\n");
            for (i=0;i<NumOfLines;i++) {
                line=(i%2)*(NumOfLines/2)+i/2;
                printf("%2d:",line);
                for (macro=2;macro<7;macro++)
                    printf("%4ld",Data[file][line][macro]);
                if (i&1) printf("\n"); else printf("          ");
            }
            printf("choose line ([ENTER]to back)>");
            fgets(buf,sizeof buf,stdin);
            if (*buf=='\n'||*buf=='\r') goto back;
            line=atoi(strtok(buf," \t\r\n"));
        } while (line<0||line>=NumOfLines);
        x=Data[file][line];
        sprintf(fname,"%ld-%02d.h",Mexp[file],line);
        fp=fopen(fname,"w");
        if (fp==0) { printf("'%s'cannot create\n",fname); return 1;}
        fprintf(fp,"/* MEXP:%ld  TYPE:%d */\n",Mexp[file],line+1);
        fprintf(fp,"#define POS1    %ld\n", x[2]);
        fprintf(fp,"#define SL1     %ld\n", x[3]);
        fprintf(fp,"#define SL2     %ld\n", x[4]);
        fprintf(fp,"#define SR1     %ld\n", x[5]);
        fprintf(fp,"#define SR2     %ld\n", x[6]);
        fprintf(fp,"#define MSK1    0x%08lxUL\n",x[7]);
        fprintf(fp,"#define MSK2    0x%08lxUL\n",x[8]);
        fprintf(fp,"#define MSK3    0x%08lxUL\n",x[9]);
        fprintf(fp,"#define MSK4    0x%08lxUL\n",x[10]);
        fprintf(fp,"#define PARITY1 0x%08lxUL\n",x[11]);
        fprintf(fp,"#define PARITY2 0x%08lxUL\n",x[12]);
        fprintf(fp,"#define PARITY3 0x%08lxUL\n",x[13]);
        fprintf(fp,"#define PARITY4 0x%08lxUL\n",x[14]);
        fprintf(fp,"#define IDSTR \\\n\"SFMT-%ld:%ld-%ld-%ld-%ld-"
                   "%ld:%08lx-%08lx-%08lx-%08lx\"\n",
          Mexp[file],x[2],x[3],x[4],x[5],x[6],x[7],x[8],x[9],x[10]);
        fclose(fp);
        printf("'%s'was created\n",fname);
    }
}
