/*
GenVB.c:  ?????.csv t@C Sfmt?????.vb t@C쐬
*/

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <direct.h>

enum { NumOfFiles=10,NumOfMacros=15,NumOfLines=32 };
int Mexp[]={607,1279,2281,4253,11213,19937,
            44497,86243,132049,216091};
int Data[NumOfFiles][NumOfLines][NumOfMacros];
char buf[4096],fname[128];
int i,file,line,macro,*x,swap; char*p;FILE*fp;

int Big[4][13]={
 {330, 5,3, 9,3,0xeffffffb,0xdfbebfff,0xbfbf7bef,0x9ffd7bff,
                0x00000001,0x00000000,0xa3ac4000,0xecc1327a},
 {366, 6,7,19,1,0xfdbffbff,0xbff7ff3f,0xfd77efff,0xbf9ff3ff,
                0x00000001,0x00000000,0x00000000,0xe9528d85},
 {110,19,1,21,1,0xffffbb5f,0xfb6ebf95,0xfffefffa,0xcff77fff,
                0x00000001,0x00000000,0xcb520000,0xc7e91c7d},
 {627,11,3,10,1,0xbff7bff7,0xbfffffff,0xbffffa7f,0xffddfbfb,
                0xf8000001,0x89e80709,0x3bd2b64b,0x0c64b1e4}
};

#define MEXP Mexp[file]
#define N128 (MEXP/128+1)
#define N32  (N128*4)
#define N16  (N128*8)
#define LAG  (N32>=623?11:N32>=68?7:N32>=39?5:3)
#define MID  ((N32-LAG)/2)
#define MLG  (MID+LAG)
#define POS1 x[2]
#define SL1  x[3]
#define SL2  x[4]
#define SR1  x[5]
#define SR2  x[6]
#define MSK1 x[7]
#define MSK2 x[8]
#define MSK3 x[9]
#define MSK4 x[10]

void GenAll(void) {
    fprintf(fp,"        Dim a As Integer = 0 : Dim b As Integer = %d : Dim c As Integer = %d\n",POS1*4,N32-8);
    fprintf(fp,"        Dim d As Integer = %d : Dim y As UInteger : Dim p As UInteger() = x\n",N32-4);
    fprintf(fp,"\n");
    fprintf(fp,"        Do\n");

    if (SL2<4) fprintf(fp,"            y = p(a + 3) Xor (p(a + 3) << %d) Xor (p(a + 2) >> %d) Xor ((p(b + 3) >> %d) And &H%08X)\n",SL2*8,32-SL2*8,SR1,MSK4);
    else       fprintf(fp,"            y = p(a + 3) Xor (p(a + 2) << %d) Xor (p(a + 1) >> %d) Xor ((p(b + 3) >> %d) And &H%08X)\n",SL2*8-32,64-SL2*8,SR1,MSK4);
    if (SR2<4) fprintf(fp,"            p(a + 3) = y Xor (p(c + 3) >> %d) Xor (p(d + 3) << %d)\n",SR2*8,SL1);
    else       fprintf(fp,"            p(a + 3) = y Xor (p(d + 3) << %d)\n",SL1);
    
    if (SL2<4) fprintf(fp,"            y = p(a + 2) Xor (p(a + 2) << %d) Xor (p(a + 1) >> %d) Xor ((p(b + 2) >> %d) And &H%08X)\n",SL2*8,32-SL2*8,SR1,MSK3);
    else       fprintf(fp,"            y = p(a + 2) Xor (p(a + 1) << %d) Xor (p(a) >> %d) Xor ((p(b + 2) >> %d) And &H%08X)\n",SL2*8-32,64-SL2*8,SR1,MSK3);
    if (SR2<4) fprintf(fp,"            p(a + 2) = y Xor ((p(c + 2) >> %d) or (p(c + 3) << %d)) Xor (p(d + 2) << %d)\n",SR2*8,32-SR2*8,SL1);
    else       fprintf(fp,"            p(a + 2) = y Xor (p(c + 3) >> %d) Xor (p(d + 2) << %d)\n",SR2*8-32,SL1);
    
    if (SL2<4) fprintf(fp,"            y = p(a + 1) Xor (p(a + 1) << %d) Xor (p(a) >> %d) Xor ((p(b + 1) >> %d) And &H%08X)\n",SL2*8,32-SL2*8,SR1,MSK2);
    else       fprintf(fp,"            y = p(a + 1) Xor (p(a) << %d) Xor ((p(b + 1) >> %d) And &H%08X)\n",SL2*8-32,SR1,MSK2);
    if (SR2<4) fprintf(fp,"            p(a + 1) = y Xor ((p(c + 1) >> %d) or (p(c + 2) << %d)) Xor (p(d + 1) << %d)\n",SR2*8,32-SR2*8,SL1);
    else       fprintf(fp,"            p(a + 1) = y Xor ((p(c + 2) >> %d) or (p(c + 3) << %d)) Xor (p(d + 1) << %d)\n",SR2*8-32,64-SR2*8,SL1);

    if (SL2<4) fprintf(fp,"            y = p(a) Xor (p(a) << %d) Xor ((p(b) >> %d) And &H%08X)\n",SL2*8,SR1,MSK1);
    else       fprintf(fp,"            y = p(a) Xor ((p(b) >> %d) And &H%08X)\n",SR1,MSK1);
    if (SR2<4) fprintf(fp,"            p(a) = y Xor ((p(c) >> %d) or (p(c + 1) << %d)) Xor (p(d) << %d)\n",SR2*8,32-SR2*8,SL1);
    else       fprintf(fp,"            p(a) = y Xor ((p(c + 1) >> %d) or (p(c + 2) << %d)) Xor (p(d) << %d)\n",SR2*8-32,64-SR2*8,SL1);

    fprintf(fp,"            c = d : d = a : a += 4 : b += 4\n");
    fprintf(fp,"            If b = %d Then b = 0\n",N32);
    fprintf(fp,"        Loop While a <> %d\n",N32);
    fprintf(fp,"    End Sub\n");
    fprintf(fp,"\n");
}

void Header(char*virtua)
{
    fprintf(fp,"'\n");
    fprintf(fp,"' Sfmt%d.vb Cu\n",MEXP);
    fprintf(fp,"' coded by isaku@pb4.so-net.ne.jp\n");
    fprintf(fp,"' \n");
    fprintf(fp,"\n");
    fprintf(fp,"Class Sfmt\n");
    fprintf(fp,"\n");
    fprintf(fp,"    Private index As Integer\n");
    fprintf(fp,"    Private coin_bits As Integer ' NextBit ł̎c̃rbg\n");
    fprintf(fp,"    Private coin_save As UInteger ' NextBit ł̒lێ\n");
    fprintf(fp,"    Private byte_pos As Integer ' NextByte ŎgpoCg\n");
    fprintf(fp,"    Private byte_save As UInteger ' NextByte ł̒lێ\n");
    fprintf(fp,"    Private range As Integer ' NextIntEx őO͈̔\n");
    fprintf(fp,"    Private bse As UInteger  ' NextIntEx őO̊l\n");
    fprintf(fp,"    Private shift As Integer ' NextIntEx őÕVtg\n");
    fprintf(fp,"    Private normal_sw As Integer  ' NextNormal ŎcĂ\n");
    fprintf(fp,"    Private normal_save As Double ' NextNormal ̎c̒l\n");
    fprintf(fp,"    Protected x(%d) As UInteger ' ԃe[u\n",N32-1);
    fprintf(fp,"    Private Shared ParityData As UInteger() = {&H%lX&, &H%lX&, &H%lX&, &H%lX&}\n",x[11],x[12],x[13],x[14]);
    fprintf(fp,"\n");
    fprintf(fp,"    Protected Overridable Function GetParity() As UInteger()\n");
    fprintf(fp,"        Return ParityData\n");
    fprintf(fp,"    End Function\n");
    fprintf(fp,"\n");
    fprintf(fp,"    Public readonly Overridable Property IdString() As String\n");
    fprintf(fp,"        Get\n");
    fprintf(fp,"            Return \"SFMT-%d:%d-%d-%d-%d-%d:%08x-%08x-%08x-%08x\"\n",
                     MEXP,x[2],x[3],x[4],x[5],x[6],x[7],x[8],x[9],x[10]);
    fprintf(fp,"        End Get\n");
    fprintf(fp,"    End Property\n");
    fprintf(fp,"\n");
    fprintf(fp,"    Protected%s Sub gen_rand_all()\n",virtua);
    GenAll();
    fprintf(fp,"    Private Sub period_certification()\n");
    fprintf(fp,"        Dim work As UInteger : Dim inner As UInteger = 0 : Dim i, j As Integer\n");
    fprintf(fp,"        Dim parity As UInteger() = GetParity()\n");
    fprintf(fp,"\n");
    fprintf(fp,"        index = %d : range = 0 : normal_sw = 0 : coin_bits = 0 : byte_pos = 0\n",N32);
    fprintf(fp,"        For i = 0 To 3 : inner = inner Xor x(i) And parity(i) : Next\n");
    fprintf(fp,"        i = 16 : Do : inner = inner Xor inner >> i : i >>= 1 : Loop While i > 0\n");
    fprintf(fp,"        inner = inner And 1\n");
    fprintf(fp,"        If inner = 1 Then Return\n");
    fprintf(fp,"        For i = 0 To 3\n");
    fprintf(fp,"            j = 0 : work = 1\n");
    fprintf(fp,"            Do\n");
    fprintf(fp,"                If (work And parity(i)) <> 0 Then\n");
    fprintf(fp,"                    x(i) = x(i) Xor work\n");
    fprintf(fp,"                    Return\n");
    fprintf(fp,"                End If\n");
    fprintf(fp,"                j += 1\n");
    fprintf(fp,"                work <<= 1\n");
    fprintf(fp,"            Loop While j < 32\n");
    fprintf(fp,"        Next\n");
    fprintf(fp,"    End Sub\n");
    fprintf(fp,"\n");
    fprintf(fp,"    ' ̎ s ɂ鏉\n");
    fprintf(fp,"    Public Sub InitMt(ByVal s As UInteger)\n");
    fprintf(fp,"        Dim p As UInteger\n");
    fprintf(fp,"        x(0) = s\n");
    fprintf(fp,"        For p = 1 To %d\n",N32-1);
    fprintf(fp,"            s = 1812433253 * (s Xor (s >> 30)) + p\n");
    fprintf(fp,"            x(p) = s\n");
    fprintf(fp,"        Next\n");
    fprintf(fp,"        period_certification()\n");
    fprintf(fp,"    End Sub\n");
    fprintf(fp,"\n");
    fprintf(fp,"    Sub New(ByVal s As UInteger)\n");
    fprintf(fp,"        InitMt(s)\n");
    fprintf(fp,"    End Sub\n");
    fprintf(fp,"    \n");

    fprintf(fp,"    ' z init_key ɂ鏉\n");
    fprintf(fp,"    Public Sub InitMtEx(ByVal init_key() As UInteger)\n");
    fprintf(fp,"        Dim r, i, j, c As UInteger\n");
    fprintf(fp,"        Dim key_len As UInteger = init_key.Length\n");
    fprintf(fp,"\n");
    fprintf(fp,"        For i = 0 To %d : x(i) = &H8B8B8B8B& : Next\n",N32-1);
    fprintf(fp,"        If key_len + 1 > %d Then c = key_len + 1 Else c = %d\n",N32,N32);
    fprintf(fp,"        r = x(0) Xor x(%d) Xor x(%d) : r = (r Xor (r >> 27)) * 1664525\n",MID,N32-1);
    fprintf(fp,"        x(%d) += r : r += key_len : x(%d) += r : x(0) = r : c -= 1\n",MID,MLG);
    fprintf(fp,"        i = 1 : j = 0\n");
    fprintf(fp,"        Do While j < c And j < key_len\n");
    fprintf(fp,"            r = x(i) Xor x((i + %d) Mod %d) Xor x((i + %d) Mod %d)\n",MID,N32,N32-1,N32);
    fprintf(fp,"            r = (r Xor (r >> 27)) * 1664525 : x((i + %d) Mod %d) += r\n",MID,N32);
    fprintf(fp,"            r += init_key(j) + i : x((i + %d) Mod %d) += r\n",MLG,N32);
    fprintf(fp,"            x(i) = r : i = (i + 1) Mod %d : j += 1\n",N32);
    fprintf(fp,"        Loop\n");
    fprintf(fp,"        Do While j < c\n");
    fprintf(fp,"            r = x(i) Xor x((i + %d) Mod %d) Xor x((i + %d) Mod %d)\n",MID,N32,N32-1,N32);
    fprintf(fp,"            r = (r Xor (r >> 27)) * 1664525 : x((i + %d) Mod %d) += r : r += i\n",MID,N32);
    fprintf(fp,"            x((i + %d) Mod %d) += r : x(i) = r : i = (i + 1) Mod %d : j += 1\n",MLG,N32,N32);
    fprintf(fp,"        Loop\n");
    fprintf(fp,"        For j = 0 To %d\n",N32-1);
    fprintf(fp,"            r = x(i) + x((i + %d) Mod %d) + x((i + %d) Mod %d)\n",MID,N32,N32-1,N32);
    fprintf(fp,"            r = (r Xor (r >> 27)) * 1566083941\n");
    fprintf(fp,"            c = (i + %d) Mod %d : x(c) = x(c) Xor r : r -= i\n",MID,N32);
    fprintf(fp,"            c = (i + %d) Mod %d : x(c) = x(c) Xor r\n",MLG,N32);
    fprintf(fp,"            x(i) = r : i = (i + 1) Mod %d\n",N32);
    fprintf(fp,"        Next\n");
    fprintf(fp,"        period_certification()\n");
    fprintf(fp,"    End Sub\n");
    fprintf(fp,"\n");
    fprintf(fp,"\n");
    fprintf(fp,"    Sub New(ByVal init_key() As UInteger)\n");
    fprintf(fp,"        InitMtEx(init_key)\n");
    fprintf(fp,"    End Sub\n");
    fprintf(fp,"    \n");

    fprintf(fp,"    ' 32rbgȂ̗\n");
    fprintf(fp,"    Public Function NextMt() As UInteger\n");
    fprintf(fp,"        If index = %d Then\n",N32);
    fprintf(fp,"            gen_rand_all()\n");
    fprintf(fp,"            index = 0\n");
    fprintf(fp,"        End If\n");
    fprintf(fp,"        nextmt = x(index)\n");
    fprintf(fp,"        index += 1\n");
    fprintf(fp,"    End Function\n");
    fprintf(fp,"\n");
    fprintf(fp,"    ' Oȏ n ̐\n");
    fprintf(fp,"    Public Function NextInt(ByVal n As Integer) As Integer\n");
    fprintf(fp,"        Return Int(n * (1.0 / 4294967296.0) * NextMt())\n");
    fprintf(fp,"    End Function\n");
    fprintf(fp,"\n");
    fprintf(fp,"    ' OPԂ\n");
    fprintf(fp,"    Public Function NextBit() As integer\n");
    fprintf(fp,"        coin_bits = coin_bits - 1\n");
    fprintf(fp,"        If coin_bits = -1 Then\n");
    fprintf(fp,"            coin_bits = 31\n");
    fprintf(fp,"            coin_save = NextMt\n");
    fprintf(fp,"        Else\n");
    fprintf(fp,"            coin_save = coin_save >> 1\n");
    fprintf(fp,"        End If\n");
    fprintf(fp,"        NextBit = coin_save And 1\n");
    fprintf(fp,"    End Function\n");
    fprintf(fp,"\n");
    fprintf(fp,"    ' OPԂ\n");
    fprintf(fp,"    Public Function NextByte() As integer\n");
    fprintf(fp,"        byte_pos = byte_pos - 1\n");
    fprintf(fp,"        If byte_pos = -1 Then\n");
    fprintf(fp,"            byte_pos = 3\n");
    fprintf(fp,"            byte_save = NextMt\n");
    fprintf(fp,"        Else\n");
    fprintf(fp,"            byte_save = byte_save >> 8\n");
    fprintf(fp,"        End If\n");
    fprintf(fp,"        NextByte = byte_save And 255\n");
    fprintf(fp,"    End Function\n");
    fprintf(fp,"\n");
    fprintf(fp,"    ' OȏP̗(53bitx)\n");
    fprintf(fp,"    Public Function NextUnif() As Double\n");
    fprintf(fp,"        Dim z As UInteger = NextMt() >> 11\n");
    fprintf(fp,"        Dim y As UInteger = NextMt()\n");
    fprintf(fp,"        Return (y * 2097152.0 + z) * (1.0 / 9007199254740992.0)\n");
    fprintf(fp,"    End Function\n");
    fprintf(fp,"\n");
    fprintf(fp,"    ' ۂߌ덷̂ȂOȏ range_ ̐\n");
    fprintf(fp,"    Public Function NextIntEx(ByVal range_ As Integer) As Integer\n");
    fprintf(fp,"        Dim y_, base_, remain_, shift_ As UInteger\n");
    fprintf(fp,"\n");
    fprintf(fp,"        If range_ <= 0 Then Return 0\n");
    fprintf(fp,"        If range_ <> range Then\n");
    fprintf(fp,"            range = range_ : bse = range_ : shift = 0\n");
    fprintf(fp,"            Do While bse <= 1 << 30\n");
    fprintf(fp,"                bse <<= 1 : shift += 1\n");
    fprintf(fp,"            Loop\n");
    fprintf(fp,"        End If\n");
    fprintf(fp,"        Do\n");
    fprintf(fp,"            y_ = NextMt() >> 1\n");
    fprintf(fp,"            If y_ < bse Then Return int(y_ >> shift)\n");
    fprintf(fp,"            base_ = bse : shift_ = shift : y_ -= base_\n");
    fprintf(fp,"            remain_ = (1 << 31) - base_\n");
    fprintf(fp,"            Do While remain_ >= range_\n");
    fprintf(fp,"                Do While base_ > remain_\n");
    fprintf(fp,"                    base_ >>= 1 : shift_ -= 1\n");
    fprintf(fp,"                Loop\n");
    fprintf(fp,"                If y_ < base_ Then Return int(y_ >> shift_)\n");
    fprintf(fp,"                y_ -= base_\n");
    fprintf(fp,"                remain_ -= base_\n");
    fprintf(fp,"            Loop\n");
    fprintf(fp,"        Loop\n");
    fprintf(fp,"    End Function\n");
    fprintf(fp,"    \n");
    fprintf(fp,"    ' Rx˂̃JCQ敪z\n");
    fprintf(fp,"    Public Function NextChisq(ByVal n As Double) As Double\n");
    fprintf(fp,"        Return 2 * NextGamma(0.5 * n)\n");
    fprintf(fp,"    End Function\n");
    fprintf(fp,"\n");
    fprintf(fp,"    ' p[^̃K}z\n");
    fprintf(fp,"    Public Function NextGamma(ByVal a As Double) As double\n");
    fprintf(fp,"        Dim t, u, xx, y As Double\n");
    fprintf(fp,"        If a > 1 Then\n");
    fprintf(fp,"            t = Math.Sqrt(2 * a - 1)\n");
    fprintf(fp,"            Do\n");
    fprintf(fp,"                Do\n");
    fprintf(fp,"                    Do\n");
    fprintf(fp,"                        Do\n");
    fprintf(fp,"                            xx = 1 - NextUnif()\n");
    fprintf(fp,"                            y = 2 * NextUnif() - 1\n");
    fprintf(fp,"                        Loop While xx * xx + y * y > 1\n");
    fprintf(fp,"                        y /= xx : xx = t * y + a - 1\n");
    fprintf(fp,"                    Loop While xx <= 0\n");
    fprintf(fp,"                    u = (a - 1) * Math.Log(xx / (a - 1)) - t * y\n");
    fprintf(fp,"                Loop While u < -50.0\n");
    fprintf(fp,"            Loop While NextUnif() > (1 + y * y) * Math.Exp(u)\n");
    fprintf(fp,"        Else\n");
    fprintf(fp,"            t = 2.7182818284590451 / (a + 2.7182818284590451)\n");
    fprintf(fp,"            Do\n");
    fprintf(fp,"                If NextUnif() < t Then\n");
    fprintf(fp,"                    xx = Math.Pow(NextUnif(), 1 / a) : y = Math.Exp(-xx)\n");
    fprintf(fp,"                Else\n");
    fprintf(fp,"                    xx = 1 - Math.Log(1 - NextUnif()) : y = Math.Pow(xx, a - 1)\n");
    fprintf(fp,"                End If\n");
    fprintf(fp,"            Loop While NextUnif() >= y\n");
    fprintf(fp,"        End If\n");
    fprintf(fp,"        Return xx\n");
    fprintf(fp,"    End Function\n");
    fprintf(fp,"\n");
    fprintf(fp,"    ' mo̊􉽕z\n");
    fprintf(fp,"    Public Function NextGeometric(ByVal p As Double) As Integer\n");
    fprintf(fp,"        Return int(Math.Ceiling(Math.Log(1.0 - NextUnif()) / Math.Log(1 - p)))\n");
    fprintf(fp,"    End Function\n");
    fprintf(fp,"\n");
    fprintf(fp,"    ' Opz\n");
    fprintf(fp,"    Public Function NextTriangle() As Double\n");
    fprintf(fp,"        Dim a As Double = NextUnif()\n");
    fprintf(fp,"        Dim b As Double = NextUnif()\n");
    fprintf(fp,"\n");
    fprintf(fp,"        Return a - b\n");
    fprintf(fp,"    End Function\n");
    fprintf(fp,"    \n");
    fprintf(fp,"    ' ςP̎wz\n");
    fprintf(fp,"    Public Function NextExp() As Double\n");
    fprintf(fp,"        Return -Math.Log(1 - NextUnif())\n");
    fprintf(fp,"    End Function\n");
    fprintf(fp,"\n");
    fprintf(fp,"    ' WKz(ő8.57)\n");
    fprintf(fp,"    Public Function NextNormal() As Double\n");
    fprintf(fp,"        Dim t, u As Double\n");
    fprintf(fp,"        If normal_sw = 0 Then\n");
    fprintf(fp,"            t = Math.Sqrt(-2 * Math.Log(1.0 - NextUnif()))\n");
    fprintf(fp,"            u = 3.1415926535897931 * 2 * NextUnif()\n");
    fprintf(fp,"            normal_save = t * Math.Sin(u) : normal_sw = 1\n");
    fprintf(fp,"            Return t * Math.Cos(u)\n");
    fprintf(fp,"        Else\n");
    fprintf(fp,"            normal_sw = 0 : Return normal_save\n");
    fprintf(fp,"        End If\n");
    fprintf(fp,"    End Function\n");
    fprintf(fp,"    \n");
    fprintf(fp,"    ' m̃_PʃxNg\n");
    fprintf(fp,"    Public Sub NextUnitVect(ByRef v As Double(), ByVal n As Integer)\n");
    fprintf(fp,"        Dim i As Integer : Dim r As Double = 0\n");
    fprintf(fp,"        ReDim v(n - 1)\n");
    fprintf(fp,"        For i = 0 To n - 1\n");
    fprintf(fp,"            v(i) = NextNormal() : r += v(i) * v(i)\n");
    fprintf(fp,"        Next\n");
    fprintf(fp,"        If r = 0 Then\n");
    fprintf(fp,"            r = 1\n");
    fprintf(fp,"        End If\n");
    fprintf(fp,"        r = Math.Sqrt(r)\n");
    fprintf(fp,"        For i = 0 To n - 1 : v(i) /= r : Next\n");
    fprintf(fp,"    End Sub\n");
    fprintf(fp,"\n");
    fprintf(fp,"    ' p[^m,ôQz\n");
    fprintf(fp,"    Public Function NextBinomial(ByVal n As Integer, ByVal p As Double) As Integer\n");
    fprintf(fp,"        Dim i As Integer : Dim r As Integer = 0\n");
    fprintf(fp,"\n");
    fprintf(fp,"        For i = 0 To n - 1\n");
    fprintf(fp,"            If NextUnif() < p Then r += 1\n");
    fprintf(fp,"        Next\n");
    fprintf(fp,"        Return r\n");
    fprintf(fp,"    End Function\n");
    fprintf(fp,"\n");
    fprintf(fp,"    ' ֌Wq̂QϗʐKz\n");
    fprintf(fp,"    Public Sub NextBinormal(ByVal r As Double, ByRef a As Double, ByRef b As Double)\n");
    fprintf(fp,"        Dim r1, r2, s As Double\n");
    fprintf(fp,"        Do\n");
    fprintf(fp,"            r1 = 2 * NextUnif() - 1\n");
    fprintf(fp,"            r2 = 2 * NextUnif() - 1\n");
    fprintf(fp,"            s = r1 * r1 + r2 * r2\n");
    fprintf(fp,"        Loop While s > 1 Or s = 0\n");
    fprintf(fp,"        s = -Math.Log(s) / s : r1 = Math.Sqrt((1 + r) * s) * r1\n");
    fprintf(fp,"        r2 = Math.Sqrt((1 - r) * s) * r2 : a = r1 + r2 : b = r1 - r2\n");
    fprintf(fp,"    End Sub\n");
    fprintf(fp,"\n");
    fprintf(fp,"    ' p[^`,ãx[^z\n");
    fprintf(fp,"    Public Function NextBeta(ByVal a As Double, ByVal b As Double) As Double\n");
    fprintf(fp,"        Dim temp As Double = NextGamma(a)\n");
    fprintf(fp,"        Return temp / (temp + NextGamma(b))\n");
    fprintf(fp,"    End Function\n");
    fprintf(fp,"\n");
    fprintf(fp,"    ' p[^m̗ݏ敪z\n");
    fprintf(fp,"    Public Function NextPower(ByVal n As Double) As Double\n");
    fprintf(fp,"        Return Math.Pow(NextUnif(), 1.0 / (n + 1))\n");
    fprintf(fp,"    End Function\n");
    fprintf(fp,"\n");
    fprintf(fp,"    ' WXeBbNz\n");
    fprintf(fp,"    Public Function NextLogistic() As Double\n");
    fprintf(fp,"        Dim r As Double\n");
    fprintf(fp,"        Do : r = NextUnif() : Loop While r = 0\n");
    fprintf(fp,"        Return Math.Log(r / (1 - r))\n");
    fprintf(fp,"    End Function\n");
    fprintf(fp,"\n");
    fprintf(fp,"    ' R[V[z\n");
    fprintf(fp,"    Public Function NextCauchy() As Double\n");
    fprintf(fp,"        Dim x, y As Double\n");
    fprintf(fp,"        Do\n");
    fprintf(fp,"            x = 1 - NextUnif() : y = 2 * NextUnif() - 1\n");
    fprintf(fp,"        Loop While x * x + y * y > 1\n");
    fprintf(fp,"        Return y / x\n");
    fprintf(fp,"    End Function\n");
    fprintf(fp,"\n");
    fprintf(fp,"    ' Rx n1,n2 ̂ez\n");
    fprintf(fp,"    Public Function NextFDist(ByVal n1 As Double, ByVal n2 As Double) As Double\n");
    fprintf(fp,"        Dim nc1 As Double = NextChisq(n1)\n");
    fprintf(fp,"        Dim nc2 As Double = NextChisq(n2)\n");
    fprintf(fp,"        Return (nc1 * n2) / (nc2 * n1)\n");
    fprintf(fp,"    End Function\n");
    fprintf(fp,"\n");
    fprintf(fp,"    ' σɂ̃|A\z\n");
    fprintf(fp,"    Public Function NextPoisson(ByVal lambda As Double) As Integer\n");
    fprintf(fp,"        Dim k As Integer = 0\n");
    fprintf(fp,"\n");
    fprintf(fp,"        lambda = Math.Exp(lambda) * NextUnif()\n");
    fprintf(fp,"        Do While lambda > 1\n");
    fprintf(fp,"            lambda *= NextUnif()\n");
    fprintf(fp,"            k += 1\n");
    fprintf(fp,"        Loop\n");
    fprintf(fp,"        Return k\n");
    fprintf(fp,"    End Function\n");
    fprintf(fp,"\n");
    fprintf(fp,"    ' Rxm̂z\n");
    fprintf(fp,"    Public Function NextTDist(ByVal n As Double) As Double\n");
    fprintf(fp,"        Dim a, b, c As Double\n");
    fprintf(fp,"        If n <= 2 Then\n");
    fprintf(fp,"            Do : a = NextChisq(n) : Loop While a = 0\n");
    fprintf(fp,"            Return NextNormal() / Math.Sqrt(a / n)\n");
    fprintf(fp,"        End If\n");
    fprintf(fp,"        Do\n");
    fprintf(fp,"            a = NextNormal() : b = a * a / (n - 2)\n");
    fprintf(fp,"            c = Math.Log(1 - NextUnif()) / (1 - 0.5 * n)\n");
    fprintf(fp,"        Loop While Math.Exp(-b - c) > 1 - b\n");
    fprintf(fp,"        Return a / Math.Sqrt((1 - 2.0 / n) * (1 - b))\n");
    fprintf(fp,"    End Function\n");
    fprintf(fp,"\n");
    fprintf(fp,"    ' p[^̃Cuz\n");
    fprintf(fp,"    Public Function NextWeibull(ByVal alpha As Double) As Double\n");
    fprintf(fp,"        Return Math.Pow(-Math.Log(1 - NextUnif()), 1 / alpha)\n");
    fprintf(fp,"    End Function\n");
    fprintf(fp,"End Class\n");
    fprintf(fp,"\n");
}

void Each(void)
{
    x=Data[file][line];
    fprintf(fp,"Class Sfmt%d\n",line);
    fprintf(fp,"    Inherits Sfmt\n");
    fprintf(fp,"\n");
    fprintf(fp,"    Public readonly Overrides Property IdString() As String\n");
    fprintf(fp,"        Get\n");
    fprintf(fp,"            Return \"SFMT-%d:%d-%d-%d-%d-%d:%08x-%08x-%08x-%08x\"\n",
                     MEXP,x[2],x[3],x[4],x[5],x[6],x[7],x[8],x[9],x[10]);
    fprintf(fp,"        End Get\n");
    fprintf(fp,"    End Property\n");
    fprintf(fp,"\n");

    fprintf(fp,"    Private Shared ParityData As UInteger() = {&H%lX&, &H%lX&, &H%lX&, &H%lX&}\n",x[11],x[12],x[13],x[14]);
    fprintf(fp,"\n");
    fprintf(fp,"    Protected Overrides Function GetParity() As UInteger()\n");
    fprintf(fp,"        Return ParityData\n");
    fprintf(fp,"    End Function\n");
    fprintf(fp,"\n");
    fprintf(fp,"    Protected overrides Sub gen_rand_all()\n");
    GenAll();
    fprintf(fp,"    Sub New(ByVal s As UInteger)\n");
    fprintf(fp,"        MyBase.New(s)\n");
    fprintf(fp,"    End Sub\n");
    fprintf(fp,"\n");
    fprintf(fp,"    Sub New(ByVal init_key As UInteger())\n");
    fprintf(fp,"        MyBase.New(init_key)\n");
    fprintf(fp,"    End Sub\n");
    fprintf(fp,"\n");
    fprintf(fp,"End Class\n");
    fprintf(fp,"\n");
}

void Gen_m(void)
{
    fprintf(fp,"Class Sfmt_m\n");
    fprintf(fp,"\n");
    if (file<6) {
        fprintf(fp,"    Private Shared z as Sfmt() = { _\n");
        fprintf(fp,"        New Sfmt  (1), _\n");
        for (i=1;i<31;i++)
            fprintf(fp,"        New Sfmt%-2d(&H%X&), _\n",i,-i);
        fprintf(fp,"        New Sfmt31(&H%X&) _\n",-31);
        fprintf(fp,"    }\n\n");
    } else {
        fprintf(fp,"    Private Shared z As Sfmt() = { _\n");
        fprintf(fp,"        New Sfmt(1), _\n");
        for (i=1;i<31;i++)
            fprintf(fp,"        New Sfmt(&H%X&), _\n",-i);
        fprintf(fp,"        New Sfmt(&H%X&) _\n",-31);
        fprintf(fp,"    }\n\n");
    }
    fprintf(fp,"    Public Shared Function IdString_m(ByVal i As Integer) As String\n");
    fprintf(fp,"        Return z(i).IdString\n");
    fprintf(fp,"    End Function\n\n");
    fprintf(fp,"    Public Shared Sub InitMt_m(ByVal i As Integer,ByVal s As UInteger)\n");
    fprintf(fp,"        z(i).InitMt(s)\n");
    fprintf(fp,"    End Sub\n\n");
    fprintf(fp,"    Public Shared Sub InitMtEx_m(ByVal i As Integer,ByVal k As UInteger())\n");
    fprintf(fp,"        z(i).InitMtEx(k)\n");
    fprintf(fp,"    End Sub\n\n");
    fprintf(fp,"    Public Shared Function NextMt_m(ByVal i As Integer) As UInteger\n");
    fprintf(fp,"        Return z(i).NextMt()\n");
    fprintf(fp,"    End Function\n\n");
    fprintf(fp,"    Public Shared Function NextInt_m(ByVal i As Integer,ByVal n As Integer) As Integer\n");
    fprintf(fp,"        Return z(i).NextInt(n)\n");
    fprintf(fp,"    End Function\n\n");
    fprintf(fp,"    Public Shared Function NextBit_m(ByVal i As Integer) As Integer\n");
    fprintf(fp,"        Return z(i).NextBit()\n");
    fprintf(fp,"    End Function\n\n");
    fprintf(fp,"    Public Shared Function NextByte_m(ByVal i As Integer) As Integer\n");
    fprintf(fp,"        Return z(i).NextByte()\n");
    fprintf(fp,"    End Function\n\n");
    fprintf(fp,"    Public Shared Function NextUnif_m(ByVal i As Integer) As Double\n");
    fprintf(fp,"        Return z(i).NextUnif()\n");
    fprintf(fp,"    End Function\n\n");
    fprintf(fp,"    Public Shared Function NextIntEx_m(ByVal i As Integer,ByVal r As Integer) As Integer\n");
    fprintf(fp,"        Return z(i).NextIntEx(r)\n");
    fprintf(fp,"    End Function\n\n");
    fprintf(fp,"    Public Shared Function NextChisq_m(ByVal i As Integer,ByVal n As Double) As Double\n");
    fprintf(fp,"        Return z(i).NextChisq(n)\n");
    fprintf(fp,"    End Function\n\n");
    fprintf(fp,"    Public Shared Function NextGamma_m(ByVal i As Integer,ByVal a As Double) As Double\n");
    fprintf(fp,"        Return z(i).NextGamma(a)\n");
    fprintf(fp,"    End Function\n\n");
    fprintf(fp,"    Public Shared Function NextGeometric_m(ByVal i As Integer,ByVal p As Double) As Integer\n");
    fprintf(fp,"        Return z(i).NextGeometric(p)\n");
    fprintf(fp,"    End Function\n\n");
    fprintf(fp,"    Public Shared Function NextTriangle_m(ByVal i As Integer) As Double\n");
    fprintf(fp,"        Return z(i).NextTriangle()\n");
    fprintf(fp,"    End Function\n\n");
    fprintf(fp,"    Public Shared Function NextExp_m(ByVal i As Integer) As Double\n");
    fprintf(fp,"        Return z(i).NextExp()\n");
    fprintf(fp,"    End Function\n\n");
    fprintf(fp,"    Public Shared Function NextNormal_m(ByVal i As Integer) As Double\n");
    fprintf(fp,"        Return z(i).NextNormal()\n");
    fprintf(fp,"    End Function\n\n");
    fprintf(fp,"    Public Shared Sub NextUnitVect_m(ByVal i As Integer,ByRef v As Double(),ByVal n As Integer)\n");
    fprintf(fp,"        z(i).NextUnitVect(v,n)\n");
    fprintf(fp,"    End Sub\n\n");
    fprintf(fp,"    Public Shared Function NextBinomial_m(ByVal i As Integer,ByVal n As Integer,ByVal p As Double) As Integer\n");
    fprintf(fp,"        Return z(i).NextBinomial(n,p)\n");
    fprintf(fp,"    End Function\n\n");
    fprintf(fp,"    Public Shared Sub NextBinormal_m(ByVal i As Integer,ByVal r As Double,ByRef a As Double,ByRef b As Double)\n");
    fprintf(fp,"        z(i).NextBinormal(r,a,b)\n");
    fprintf(fp,"    End Sub\n\n");
    fprintf(fp,"    Public Shared Function NextBeta_m(ByVal i As Integer,ByVal a As Double,ByVal b As Double) As Double\n");
    fprintf(fp,"        Return z(i).NextBeta(a,b)\n");
    fprintf(fp,"    End Function\n\n");
    fprintf(fp,"    Public Shared Function NextPower_m(ByVal i As Integer,ByVal n As Double) As Double\n");
    fprintf(fp,"        Return z(i).NextPower(n)\n");
    fprintf(fp,"    End Function\n\n");
    fprintf(fp,"    Public Shared Function NextLogistic_m(ByVal i As Integer) As Double\n");
    fprintf(fp,"        Return z(i).NextLogistic()\n");
    fprintf(fp,"    End Function\n\n");
    fprintf(fp,"    Public Shared Function NextCauchy_m(ByVal i As Integer) As Double\n");
    fprintf(fp,"        Return z(i).NextCauchy()\n");
    fprintf(fp,"    End Function\n\n");
    fprintf(fp,"    Public Shared Function NextPoisson_m(ByVal i As Integer,ByVal l As Double) As Integer\n");
    fprintf(fp,"        Return z(i).NextPoisson(l)\n");
    fprintf(fp,"    End Function\n\n");
    fprintf(fp,"    Public Shared Function NextFDist_m(ByVal i As Integer,ByVal n1 As Double,ByVal n2 As Double) As Double\n");
    fprintf(fp,"        Return z(i).NextFDist(n1,n2)\n");
    fprintf(fp,"    End Function\n\n");
    fprintf(fp,"    Public Shared Function NextTDist_m(ByVal i As Integer,ByVal n As Double) As Double\n");
    fprintf(fp,"        Return z(i).NextTDist(n)\n");
    fprintf(fp,"    End Function\n\n");
    fprintf(fp,"    Public Shared Function NextWeibull_m(ByVal i As Integer,ByVal a As Double) As Double\n");
    fprintf(fp,"        Return z(i).NextWeibull(a)\n");
    fprintf(fp,"    End Function\n\n");
    fprintf(fp,"End Class\n");
    fprintf(fp,"\n");
}

/*
@16i̕longɕϊ鄠
@*/
int htol(char*p)
{
    static char tbl[]="0123456789abcdef"; int ret=0,i,c;

    while ((c=*p++)!=0) {
        for (i=0;i<16&&tbl[i]!=c;i++) ;
        ret=ret*16+i;
    }
    return ret;
}

int main(void)
{
    for (file=0;file<6;file++) {
        sprintf(fname,"%d.csv",Mexp[file]);
        fp=fopen(fname,"r");
        if (fp==0) { printf("'%s'cannot open\n",fname); return 1;}
        if (fgets(buf,sizeof buf,fp)==0)
        { printf("'%s'is empty\n",fname); return 1; }
        for (line=0;line<NumOfLines;line++) {
            p=fgets(buf,sizeof buf,fp);
            if (p==0) {
                printf("'%s':%d unexpected EOF\n",fname,line);
                return 1;
            }
            p=strtok(buf,",\r\n");
            for (macro=0;macro<NumOfMacros;macro++) {
                if (p==0) {
                    printf("'%s':%d unexpected EOLN\n",fname,line);
                    return 1;
                }
                if (macro>=7&&macro<=14)
                    Data[file][line][macro]=htol(p);
                else
                    Data[file][line][macro]=atol(p);
                p=strtok(0,",\r\n");
            }
        }
        fclose(fp);
    }

    for (file=6;file<10;file++) {
        Data[file][0][0]=Mexp[file];
        for (macro=2;macro<=14;macro++)
            Data[file][0][macro]=Big[file-6][macro-2];
    }
         
    /* MEXP=1279 ̍ŏ̃CftHgŖ̂œւ */
    for (macro=0;macro<NumOfMacros;macro++) {
        swap=Data[1][0][macro];
        Data[1][0][macro]=Data[1][1][macro];
        Data[1][1][macro]=swap;
    }

    printf("OK\n");

    if (mkdir("..\\SfmtVB")==0) printf("'..\\SfmtVB'was created\n");
    for (file=0;file<NumOfFiles;file++) {
        sprintf(fname,"..\\SfmtVB\\Sfmt%d.vb",MEXP);
        fp=fopen(fname,"w");
        if (fp==0) { printf("'%s'cannot create\n",fname); return 1;}
        x=Data[file][0];
        if (file<6) {
            Header(" Overridable");
            for (line=1;line<NumOfLines;line++) Each();
        } else Header("");
        Gen_m();
        fclose(fp);
        printf("'%s'was created\n",fname);
    }
    return 0;
}
