/*
Sfmt12.java Cu(11213)
coded by isaku@pb4.so-net.ne.jp
*/

class Sfmt12 extends Sfmt
{
    public String IdString() {
        return"SFMT-11213:79-22-1-17-1:ffbf7ff7-9dffdfdf-dfef97bf-dfeebf7f";
    }

    protected int[]GetParity()
    { return new int[]{ 0x00000001,0x00000000,0x68cbe000,0x1c20bdd1 }; }


    public void gen_rand_all() {
        int a=0,b=316,c=344,d=348,y; int[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<8)^(p[a+2]>>>24)^((p[b+3]>>>17)&0xdfeebf7f);
            p[a+3]=y^(p[c+3]>>>8)^(p[d+3]<<22);
            y=p[a+2]^(p[a+2]<<8)^(p[a+1]>>>24)^((p[b+2]>>>17)&0xdfef97bf);
            p[a+2]=y^((p[c+2]>>>8)|(p[c+3]<<24))^(p[d+2]<<22);
            y=p[a+1]^(p[a+1]<<8)^(p[a]>>>24)^((p[b+1]>>>17)&0x9dffdfdf);
            p[a+1]=y^((p[c+1]>>>8)|(p[c+2]<<24))^(p[d+1]<<22);
            y=p[a]^(p[a]<<8)^((p[b]>>>17)&0xffbf7ff7);
            p[a]=y^((p[c]>>>8)|(p[c+1]<<24))^(p[d]<<22);
            c=d; d=a; a+=4; b+=4;
            if (b==352) b=0;
        } while (a!=352);
    }

    Sfmt12(int s) { super(s); }
    Sfmt12(int[]init_key)  { super(init_key); }
}
