/*
Sfmt16.java Cu(11213)
coded by isaku@pb4.so-net.ne.jp
*/

class Sfmt16 extends Sfmt
{
    public String IdString() {
        return"SFMT-11213:69-6-3-3-1:effdfdff-f9bffbff-dff1ffff-f7f8dfff";
    }

    protected int[]GetParity()
    { return new int[]{ 0x00000001,0x00000000,0x83409000,0xc4651bf2 }; }


    public void gen_rand_all() {
        int a=0,b=276,c=344,d=348,y; int[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<24)^(p[a+2]>>>8)^((p[b+3]>>>3)&0xf7f8dfff);
            p[a+3]=y^(p[c+3]>>>8)^(p[d+3]<<6);
            y=p[a+2]^(p[a+2]<<24)^(p[a+1]>>>8)^((p[b+2]>>>3)&0xdff1ffff);
            p[a+2]=y^((p[c+2]>>>8)|(p[c+3]<<24))^(p[d+2]<<6);
            y=p[a+1]^(p[a+1]<<24)^(p[a]>>>8)^((p[b+1]>>>3)&0xf9bffbff);
            p[a+1]=y^((p[c+1]>>>8)|(p[c+2]<<24))^(p[d+1]<<6);
            y=p[a]^(p[a]<<24)^((p[b]>>>3)&0xeffdfdff);
            p[a]=y^((p[c]>>>8)|(p[c+1]<<24))^(p[d]<<6);
            c=d; d=a; a+=4; b+=4;
            if (b==352) b=0;
        } while (a!=352);
    }

    Sfmt16(int s) { super(s); }
    Sfmt16(int[]init_key)  { super(init_key); }
}
