/*
Sfmt17.java Cu(11213)
coded by isaku@pb4.so-net.ne.jp
*/

class Sfmt17 extends Sfmt
{
    public String IdString() {
        return"SFMT-11213:48-12-3-17-1:de5fffbf-f7d5f7be-fff7757d-fffeef79";
    }

    protected int[]GetParity()
    { return new int[]{ 0x00000001,0x00000000,0xa25c0200,0xa9cb6a61 }; }


    public void gen_rand_all() {
        int a=0,b=192,c=344,d=348,y; int[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<24)^(p[a+2]>>>8)^((p[b+3]>>>17)&0xfffeef79);
            p[a+3]=y^(p[c+3]>>>8)^(p[d+3]<<12);
            y=p[a+2]^(p[a+2]<<24)^(p[a+1]>>>8)^((p[b+2]>>>17)&0xfff7757d);
            p[a+2]=y^((p[c+2]>>>8)|(p[c+3]<<24))^(p[d+2]<<12);
            y=p[a+1]^(p[a+1]<<24)^(p[a]>>>8)^((p[b+1]>>>17)&0xf7d5f7be);
            p[a+1]=y^((p[c+1]>>>8)|(p[c+2]<<24))^(p[d+1]<<12);
            y=p[a]^(p[a]<<24)^((p[b]>>>17)&0xde5fffbf);
            p[a]=y^((p[c]>>>8)|(p[c+1]<<24))^(p[d]<<12);
            c=d; d=a; a+=4; b+=4;
            if (b==352) b=0;
        } while (a!=352);
    }

    Sfmt17(int s) { super(s); }
    Sfmt17(int[]init_key)  { super(init_key); }
}
