/*
Sfmt20.java Cu(11213)
coded by isaku@pb4.so-net.ne.jp
*/

class Sfmt20 extends Sfmt
{
    public String IdString() {
        return"SFMT-11213:36-5-7-17-1:ccfe7ffe-fadfffff-fffffdff-ffefefff";
    }

    protected int[]GetParity()
    { return new int[]{ 0x00000001,0x00000000,0x637cd000,0xedd65806 }; }


    public void gen_rand_all() {
        int a=0,b=144,c=344,d=348,y; int[]p=x;

        do {
            y=p[a+3]^(p[a+2]<<24)^(p[a+1]>>>8)^((p[b+3]>>>17)&0xffefefff);
            p[a+3]=y^(p[c+3]>>>8)^(p[d+3]<<5);
            y=p[a+2]^(p[a+1]<<24)^(p[a]>>>8)^((p[b+2]>>>17)&0xfffffdff);
            p[a+2]=y^((p[c+2]>>>8)|(p[c+3]<<24))^(p[d+2]<<5);
            y=p[a+1]^(p[a]<<24)^((p[b+1]>>>17)&0xfadfffff);
            p[a+1]=y^((p[c+1]>>>8)|(p[c+2]<<24))^(p[d+1]<<5);
            y=p[a]^((p[b]>>>17)&0xccfe7ffe);
            p[a]=y^((p[c]>>>8)|(p[c+1]<<24))^(p[d]<<5);
            c=d; d=a; a+=4; b+=4;
            if (b==352) b=0;
        } while (a!=352);
    }

    Sfmt20(int s) { super(s); }
    Sfmt20(int[]init_key)  { super(init_key); }
}
