/*
Sfmt21.java Cu(11213)
coded by isaku@pb4.so-net.ne.jp
*/

class Sfmt21 extends Sfmt
{
    public String IdString() {
        return"SFMT-11213:12-7-3-11-1:fffbe5fb-fdfdf7df-fffdf7ff-fffffffb";
    }

    protected int[]GetParity()
    { return new int[]{ 0x00000001,0x00000000,0x43f60800,0x4f337b1d }; }


    public void gen_rand_all() {
        int a=0,b=48,c=344,d=348,y; int[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<24)^(p[a+2]>>>8)^((p[b+3]>>>11)&0xfffffffb);
            p[a+3]=y^(p[c+3]>>>8)^(p[d+3]<<7);
            y=p[a+2]^(p[a+2]<<24)^(p[a+1]>>>8)^((p[b+2]>>>11)&0xfffdf7ff);
            p[a+2]=y^((p[c+2]>>>8)|(p[c+3]<<24))^(p[d+2]<<7);
            y=p[a+1]^(p[a+1]<<24)^(p[a]>>>8)^((p[b+1]>>>11)&0xfdfdf7df);
            p[a+1]=y^((p[c+1]>>>8)|(p[c+2]<<24))^(p[d+1]<<7);
            y=p[a]^(p[a]<<24)^((p[b]>>>11)&0xfffbe5fb);
            p[a]=y^((p[c]>>>8)|(p[c+1]<<24))^(p[d]<<7);
            c=d; d=a; a+=4; b+=4;
            if (b==352) b=0;
        } while (a!=352);
    }

    Sfmt21(int s) { super(s); }
    Sfmt21(int[]init_key)  { super(init_key); }
}
