/*
Sfmt3.java Cu(11213)
coded by isaku@pb4.so-net.ne.jp
*/

class Sfmt3 extends Sfmt
{
    public String IdString() {
        return"SFMT-11213:63-22-1-13-1:f5fbfffb-ffffffbf-df7ffcb7-dffff7ff";
    }

    protected int[]GetParity()
    { return new int[]{ 0x00000001,0x00000000,0xf73ca000,0x2ad648b9 }; }


    public void gen_rand_all() {
        int a=0,b=252,c=344,d=348,y; int[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<8)^(p[a+2]>>>24)^((p[b+3]>>>13)&0xdffff7ff);
            p[a+3]=y^(p[c+3]>>>8)^(p[d+3]<<22);
            y=p[a+2]^(p[a+2]<<8)^(p[a+1]>>>24)^((p[b+2]>>>13)&0xdf7ffcb7);
            p[a+2]=y^((p[c+2]>>>8)|(p[c+3]<<24))^(p[d+2]<<22);
            y=p[a+1]^(p[a+1]<<8)^(p[a]>>>24)^((p[b+1]>>>13)&0xffffffbf);
            p[a+1]=y^((p[c+1]>>>8)|(p[c+2]<<24))^(p[d+1]<<22);
            y=p[a]^(p[a]<<8)^((p[b]>>>13)&0xf5fbfffb);
            p[a]=y^((p[c]>>>8)|(p[c+1]<<24))^(p[d]<<22);
            c=d; d=a; a+=4; b+=4;
            if (b==352) b=0;
        } while (a!=352);
    }

    Sfmt3(int s) { super(s); }
    Sfmt3(int[]init_key)  { super(init_key); }
}
