/*
Sfmt30.java Cu(11213)
coded by isaku@pb4.so-net.ne.jp
*/

class Sfmt30 extends Sfmt
{
    public String IdString() {
        return"SFMT-11213:85-5-7-14-1:ffbfeffe-fbfddbeb-fbdfffff-bfffffff";
    }

    protected int[]GetParity()
    { return new int[]{ 0x00000001,0x00000000,0xa7420000,0xea7b6ca0 }; }


    public void gen_rand_all() {
        int a=0,b=340,c=344,d=348,y; int[]p=x;

        do {
            y=p[a+3]^(p[a+2]<<24)^(p[a+1]>>>8)^((p[b+3]>>>14)&0xbfffffff);
            p[a+3]=y^(p[c+3]>>>8)^(p[d+3]<<5);
            y=p[a+2]^(p[a+1]<<24)^(p[a]>>>8)^((p[b+2]>>>14)&0xfbdfffff);
            p[a+2]=y^((p[c+2]>>>8)|(p[c+3]<<24))^(p[d+2]<<5);
            y=p[a+1]^(p[a]<<24)^((p[b+1]>>>14)&0xfbfddbeb);
            p[a+1]=y^((p[c+1]>>>8)|(p[c+2]<<24))^(p[d+1]<<5);
            y=p[a]^((p[b]>>>14)&0xffbfeffe);
            p[a]=y^((p[c]>>>8)|(p[c+1]<<24))^(p[d]<<5);
            c=d; d=a; a+=4; b+=4;
            if (b==352) b=0;
        } while (a!=352);
    }

    Sfmt30(int s) { super(s); }
    Sfmt30(int[]init_key)  { super(init_key); }
}
