/*
Sfmt31.java Cu(11213)
coded by isaku@pb4.so-net.ne.jp
*/

class Sfmt31 extends Sfmt
{
    public String IdString() {
        return"SFMT-11213:13-15-5-10-3:fffaffff-effef9ff-fe7e9bdb-ff7ffbfe";
    }

    protected int[]GetParity()
    { return new int[]{ 0x00000001,0x00000000,0x42c21400,0xfde64440 }; }


    public void gen_rand_all() {
        int a=0,b=52,c=344,d=348,y; int[]p=x;

        do {
            y=p[a+3]^(p[a+2]<<8)^(p[a+1]>>>24)^((p[b+3]>>>10)&0xff7ffbfe);
            p[a+3]=y^(p[c+3]>>>24)^(p[d+3]<<15);
            y=p[a+2]^(p[a+1]<<8)^(p[a]>>>24)^((p[b+2]>>>10)&0xfe7e9bdb);
            p[a+2]=y^((p[c+2]>>>24)|(p[c+3]<<8))^(p[d+2]<<15);
            y=p[a+1]^(p[a]<<8)^((p[b+1]>>>10)&0xeffef9ff);
            p[a+1]=y^((p[c+1]>>>24)|(p[c+2]<<8))^(p[d+1]<<15);
            y=p[a]^((p[b]>>>10)&0xfffaffff);
            p[a]=y^((p[c]>>>24)|(p[c+1]<<8))^(p[d]<<15);
            c=d; d=a; a+=4; b+=4;
            if (b==352) b=0;
        } while (a!=352);
    }

    Sfmt31(int s) { super(s); }
    Sfmt31(int[]init_key)  { super(init_key); }
}
