/*
Sfmt4.java Cu(11213)
coded by isaku@pb4.so-net.ne.jp
*/

class Sfmt4 extends Sfmt
{
    public String IdString() {
        return"SFMT-11213:73-12-3-9-1:ddffdff7-6baffff7-7bd5ffff-efd3fbff";
    }

    protected int[]GetParity()
    { return new int[]{ 0x00000001,0x00000000,0xf75e8000,0xb53672e0 }; }


    public void gen_rand_all() {
        int a=0,b=292,c=344,d=348,y; int[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<24)^(p[a+2]>>>8)^((p[b+3]>>>9)&0xefd3fbff);
            p[a+3]=y^(p[c+3]>>>8)^(p[d+3]<<12);
            y=p[a+2]^(p[a+2]<<24)^(p[a+1]>>>8)^((p[b+2]>>>9)&0x7bd5ffff);
            p[a+2]=y^((p[c+2]>>>8)|(p[c+3]<<24))^(p[d+2]<<12);
            y=p[a+1]^(p[a+1]<<24)^(p[a]>>>8)^((p[b+1]>>>9)&0x6baffff7);
            p[a+1]=y^((p[c+1]>>>8)|(p[c+2]<<24))^(p[d+1]<<12);
            y=p[a]^(p[a]<<24)^((p[b]>>>9)&0xddffdff7);
            p[a]=y^((p[c]>>>8)|(p[c+1]<<24))^(p[d]<<12);
            c=d; d=a; a+=4; b+=4;
            if (b==352) b=0;
        } while (a!=352);
    }

    Sfmt4(int s) { super(s); }
    Sfmt4(int[]init_key)  { super(init_key); }
}
