/*
Sfmt5.java Cu(11213)
coded by isaku@pb4.so-net.ne.jp
*/

class Sfmt5 extends Sfmt
{
    public String IdString() {
        return"SFMT-11213:48-10-3-9-5:5dffefcd-c6ffffdf-fe77bfff-ffefefff";
    }

    protected int[]GetParity()
    { return new int[]{ 0x00000001,0x00000000,0x6f4ea000,0x1b8db4ba }; }


    public void gen_rand_all() {
        int a=0,b=192,c=344,d=348,y; int[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<24)^(p[a+2]>>>8)^((p[b+3]>>>9)&0xffefefff);
            p[a+3]=y^(p[d+3]<<10);
            y=p[a+2]^(p[a+2]<<24)^(p[a+1]>>>8)^((p[b+2]>>>9)&0xfe77bfff);
            p[a+2]=y^(p[c+3]>>>8)^(p[d+2]<<10);
            y=p[a+1]^(p[a+1]<<24)^(p[a]>>>8)^((p[b+1]>>>9)&0xc6ffffdf);
            p[a+1]=y^((p[c+2]>>>8)|(p[c+3]<<24))^(p[d+1]<<10);
            y=p[a]^(p[a]<<24)^((p[b]>>>9)&0x5dffefcd);
            p[a]=y^((p[c+1]>>>8)|(p[c+2]<<24))^(p[d]<<10);
            c=d; d=a; a+=4; b+=4;
            if (b==352) b=0;
        } while (a!=352);
    }

    Sfmt5(int s) { super(s); }
    Sfmt5(int[]init_key)  { super(init_key); }
}
