/*
Sfmt11.java Cu(1279)
coded by isaku@pb4.so-net.ne.jp
*/

class Sfmt11 extends Sfmt
{
    public String IdString() {
        return"SFMT-1279:1-6-3-13-3:ffeecff3-ffffedff-dbf7bfff-d1ffdffd";
    }

    protected int[]GetParity()
    { return new int[]{ 0x00000001,0x00000000,0x00000000,0x20000000 }; }


    public void gen_rand_all() {
        int a=0,b=4,c=32,d=36,y; int[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<24)^(p[a+2]>>>8)^((p[b+3]>>>13)&0xd1ffdffd);
            p[a+3]=y^(p[c+3]>>>24)^(p[d+3]<<6);
            y=p[a+2]^(p[a+2]<<24)^(p[a+1]>>>8)^((p[b+2]>>>13)&0xdbf7bfff);
            p[a+2]=y^((p[c+2]>>>24)|(p[c+3]<<8))^(p[d+2]<<6);
            y=p[a+1]^(p[a+1]<<24)^(p[a]>>>8)^((p[b+1]>>>13)&0xffffedff);
            p[a+1]=y^((p[c+1]>>>24)|(p[c+2]<<8))^(p[d+1]<<6);
            y=p[a]^(p[a]<<24)^((p[b]>>>13)&0xffeecff3);
            p[a]=y^((p[c]>>>24)|(p[c+1]<<8))^(p[d]<<6);
            c=d; d=a; a+=4; b+=4;
            if (b==40) b=0;
        } while (a!=40);
    }

    Sfmt11(int s) { super(s); }
    Sfmt11(int[]init_key)  { super(init_key); }
}
