/*
Sfmt21.java Cu(1279)
coded by isaku@pb4.so-net.ne.jp
*/

class Sfmt21 extends Sfmt
{
    public String IdString() {
        return"SFMT-1279:7-27-1-2-1:fffb67ff-defbe67b-ef1fffff-3effff8f";
    }

    protected int[]GetParity()
    { return new int[]{ 0x00000001,0x00000000,0x00000000,0x80000000 }; }


    public void gen_rand_all() {
        int a=0,b=28,c=32,d=36,y; int[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<8)^(p[a+2]>>>24)^((p[b+3]>>>2)&0x3effff8f);
            p[a+3]=y^(p[c+3]>>>8)^(p[d+3]<<27);
            y=p[a+2]^(p[a+2]<<8)^(p[a+1]>>>24)^((p[b+2]>>>2)&0xef1fffff);
            p[a+2]=y^((p[c+2]>>>8)|(p[c+3]<<24))^(p[d+2]<<27);
            y=p[a+1]^(p[a+1]<<8)^(p[a]>>>24)^((p[b+1]>>>2)&0xdefbe67b);
            p[a+1]=y^((p[c+1]>>>8)|(p[c+2]<<24))^(p[d+1]<<27);
            y=p[a]^(p[a]<<8)^((p[b]>>>2)&0xfffb67ff);
            p[a]=y^((p[c]>>>8)|(p[c+1]<<24))^(p[d]<<27);
            c=d; d=a; a+=4; b+=4;
            if (b==40) b=0;
        } while (a!=40);
    }

    Sfmt21(int s) { super(s); }
    Sfmt21(int[]init_key)  { super(init_key); }
}
