/*
Sfmt24.java Cu(1279)
coded by isaku@pb4.so-net.ne.jp
*/

class Sfmt24 extends Sfmt
{
    public String IdString() {
        return"SFMT-1279:6-5-7-11-1:4fdffdff-c7feff7f-f5ffbe7f-3fddff97";
    }

    protected int[]GetParity()
    { return new int[]{ 0x00000001,0x00000000,0x00000000,0x80000000 }; }


    public void gen_rand_all() {
        int a=0,b=24,c=32,d=36,y; int[]p=x;

        do {
            y=p[a+3]^(p[a+2]<<24)^(p[a+1]>>>8)^((p[b+3]>>>11)&0x3fddff97);
            p[a+3]=y^(p[c+3]>>>8)^(p[d+3]<<5);
            y=p[a+2]^(p[a+1]<<24)^(p[a]>>>8)^((p[b+2]>>>11)&0xf5ffbe7f);
            p[a+2]=y^((p[c+2]>>>8)|(p[c+3]<<24))^(p[d+2]<<5);
            y=p[a+1]^(p[a]<<24)^((p[b+1]>>>11)&0xc7feff7f);
            p[a+1]=y^((p[c+1]>>>8)|(p[c+2]<<24))^(p[d+1]<<5);
            y=p[a]^((p[b]>>>11)&0x4fdffdff);
            p[a]=y^((p[c]>>>8)|(p[c+1]<<24))^(p[d]<<5);
            c=d; d=a; a+=4; b+=4;
            if (b==40) b=0;
        } while (a!=40);
    }

    Sfmt24(int s) { super(s); }
    Sfmt24(int[]init_key)  { super(init_key); }
}
