/*
Sfmt26.java Cu(1279)
coded by isaku@pb4.so-net.ne.jp
*/

class Sfmt26 extends Sfmt
{
    public String IdString() {
        return"SFMT-1279:2-12-5-3-3:bfdefeef-bffffeff-fffefffb-fbfbdffe";
    }

    protected int[]GetParity()
    { return new int[]{ 0x00000001,0x00000000,0x00000000,0x00000000 }; }


    public void gen_rand_all() {
        int a=0,b=8,c=32,d=36,y; int[]p=x;

        do {
            y=p[a+3]^(p[a+2]<<8)^(p[a+1]>>>24)^((p[b+3]>>>3)&0xfbfbdffe);
            p[a+3]=y^(p[c+3]>>>24)^(p[d+3]<<12);
            y=p[a+2]^(p[a+1]<<8)^(p[a]>>>24)^((p[b+2]>>>3)&0xfffefffb);
            p[a+2]=y^((p[c+2]>>>24)|(p[c+3]<<8))^(p[d+2]<<12);
            y=p[a+1]^(p[a]<<8)^((p[b+1]>>>3)&0xbffffeff);
            p[a+1]=y^((p[c+1]>>>24)|(p[c+2]<<8))^(p[d+1]<<12);
            y=p[a]^((p[b]>>>3)&0xbfdefeef);
            p[a]=y^((p[c]>>>24)|(p[c+1]<<8))^(p[d]<<12);
            c=d; d=a; a+=4; b+=4;
            if (b==40) b=0;
        } while (a!=40);
    }

    Sfmt26(int s) { super(s); }
    Sfmt26(int[]init_key)  { super(init_key); }
}
