/*
Sfmt28.java Cu(1279)
coded by isaku@pb4.so-net.ne.jp
*/

class Sfmt28 extends Sfmt
{
    public String IdString() {
        return"SFMT-1279:6-19-1-7-3:fdffefff-5ffbdffd-efbbfff3-ff7e7bb7";
    }

    protected int[]GetParity()
    { return new int[]{ 0x00000001,0x00000000,0x00000000,0x00000000 }; }


    public void gen_rand_all() {
        int a=0,b=24,c=32,d=36,y; int[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<8)^(p[a+2]>>>24)^((p[b+3]>>>7)&0xff7e7bb7);
            p[a+3]=y^(p[c+3]>>>24)^(p[d+3]<<19);
            y=p[a+2]^(p[a+2]<<8)^(p[a+1]>>>24)^((p[b+2]>>>7)&0xefbbfff3);
            p[a+2]=y^((p[c+2]>>>24)|(p[c+3]<<8))^(p[d+2]<<19);
            y=p[a+1]^(p[a+1]<<8)^(p[a]>>>24)^((p[b+1]>>>7)&0x5ffbdffd);
            p[a+1]=y^((p[c+1]>>>24)|(p[c+2]<<8))^(p[d+1]<<19);
            y=p[a]^(p[a]<<8)^((p[b]>>>7)&0xfdffefff);
            p[a]=y^((p[c]>>>24)|(p[c+1]<<8))^(p[d]<<19);
            c=d; d=a; a+=4; b+=4;
            if (b==40) b=0;
        } while (a!=40);
    }

    Sfmt28(int s) { super(s); }
    Sfmt28(int[]init_key)  { super(init_key); }
}
