/*
Sfmt30.java Cu(1279)
coded by isaku@pb4.so-net.ne.jp
*/

class Sfmt30 extends Sfmt
{
    public String IdString() {
        return"SFMT-1279:6-14-1-3-7:ffffbffd-fffbffdf-ffffffff-fedffde5";
    }

    protected int[]GetParity()
    { return new int[]{ 0x00000001,0x00000000,0x00000000,0x00000000 }; }


    public void gen_rand_all() {
        int a=0,b=24,c=32,d=36,y; int[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<8)^(p[a+2]>>>24)^((p[b+3]>>>3)&0xfedffde5);
            p[a+3]=y^(p[d+3]<<14);
            y=p[a+2]^(p[a+2]<<8)^(p[a+1]>>>24)^((p[b+2]>>>3)&0xffffffff);
            p[a+2]=y^(p[c+3]>>>24)^(p[d+2]<<14);
            y=p[a+1]^(p[a+1]<<8)^(p[a]>>>24)^((p[b+1]>>>3)&0xfffbffdf);
            p[a+1]=y^((p[c+2]>>>24)|(p[c+3]<<8))^(p[d+1]<<14);
            y=p[a]^(p[a]<<8)^((p[b]>>>3)&0xffffbffd);
            p[a]=y^((p[c+1]>>>24)|(p[c+2]<<8))^(p[d]<<14);
            c=d; d=a; a+=4; b+=4;
            if (b==40) b=0;
        } while (a!=40);
    }

    Sfmt30(int s) { super(s); }
    Sfmt30(int[]init_key)  { super(init_key); }
}
