/*
Sfmt7.java Cu(1279)
coded by isaku@pb4.so-net.ne.jp
*/

class Sfmt7 extends Sfmt
{
    public String IdString() {
        return"SFMT-1279:6-17-3-5-3:afffffff-ff37bffb-e7bdffdd-fffdffdd";
    }

    protected int[]GetParity()
    { return new int[]{ 0x00000001,0x00000000,0x00000000,0x80000000 }; }


    public void gen_rand_all() {
        int a=0,b=24,c=32,d=36,y; int[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<24)^(p[a+2]>>>8)^((p[b+3]>>>5)&0xfffdffdd);
            p[a+3]=y^(p[c+3]>>>24)^(p[d+3]<<17);
            y=p[a+2]^(p[a+2]<<24)^(p[a+1]>>>8)^((p[b+2]>>>5)&0xe7bdffdd);
            p[a+2]=y^((p[c+2]>>>24)|(p[c+3]<<8))^(p[d+2]<<17);
            y=p[a+1]^(p[a+1]<<24)^(p[a]>>>8)^((p[b+1]>>>5)&0xff37bffb);
            p[a+1]=y^((p[c+1]>>>24)|(p[c+2]<<8))^(p[d+1]<<17);
            y=p[a]^(p[a]<<24)^((p[b]>>>5)&0xafffffff);
            p[a]=y^((p[c]>>>24)|(p[c+1]<<8))^(p[d]<<17);
            c=d; d=a; a+=4; b+=4;
            if (b==40) b=0;
        } while (a!=40);
    }

    Sfmt7(int s) { super(s); }
    Sfmt7(int[]init_key)  { super(init_key); }
}
