/*
Sfmt8.java Cu(1279)
coded by isaku@pb4.so-net.ne.jp
*/

class Sfmt8 extends Sfmt
{
    public String IdString() {
        return"SFMT-1279:2-18-1-11-1:deffffef-deb7effb-df77defe-dfdfd5cf";
    }

    protected int[]GetParity()
    { return new int[]{ 0x00000001,0x00000000,0x00000000,0x40000000 }; }


    public void gen_rand_all() {
        int a=0,b=8,c=32,d=36,y; int[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<8)^(p[a+2]>>>24)^((p[b+3]>>>11)&0xdfdfd5cf);
            p[a+3]=y^(p[c+3]>>>8)^(p[d+3]<<18);
            y=p[a+2]^(p[a+2]<<8)^(p[a+1]>>>24)^((p[b+2]>>>11)&0xdf77defe);
            p[a+2]=y^((p[c+2]>>>8)|(p[c+3]<<24))^(p[d+2]<<18);
            y=p[a+1]^(p[a+1]<<8)^(p[a]>>>24)^((p[b+1]>>>11)&0xdeb7effb);
            p[a+1]=y^((p[c+1]>>>8)|(p[c+2]<<24))^(p[d+1]<<18);
            y=p[a]^(p[a]<<8)^((p[b]>>>11)&0xdeffffef);
            p[a]=y^((p[c]>>>8)|(p[c+1]<<24))^(p[d]<<18);
            c=d; d=a; a+=4; b+=4;
            if (b==40) b=0;
        } while (a!=40);
    }

    Sfmt8(int s) { super(s); }
    Sfmt8(int[]init_key)  { super(init_key); }
}
