/*
Sfmt12.java Cu(19937)
coded by isaku@pb4.so-net.ne.jp
*/

class Sfmt12 extends Sfmt
{
    public String IdString() {
        return"SFMT-19937:75-9-3-4-3:fffeffff-ffeff7df-bbbffeef-bfbffeff";
    }

    protected int[]GetParity()
    { return new int[]{ 0x00000001,0x00000000,0x80000000,0x0b6f3e5c }; }


    public void gen_rand_all() {
        int a=0,b=300,c=616,d=620,y; int[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<24)^(p[a+2]>>>8)^((p[b+3]>>>4)&0xbfbffeff);
            p[a+3]=y^(p[c+3]>>>24)^(p[d+3]<<9);
            y=p[a+2]^(p[a+2]<<24)^(p[a+1]>>>8)^((p[b+2]>>>4)&0xbbbffeef);
            p[a+2]=y^((p[c+2]>>>24)|(p[c+3]<<8))^(p[d+2]<<9);
            y=p[a+1]^(p[a+1]<<24)^(p[a]>>>8)^((p[b+1]>>>4)&0xffeff7df);
            p[a+1]=y^((p[c+1]>>>24)|(p[c+2]<<8))^(p[d+1]<<9);
            y=p[a]^(p[a]<<24)^((p[b]>>>4)&0xfffeffff);
            p[a]=y^((p[c]>>>24)|(p[c+1]<<8))^(p[d]<<9);
            c=d; d=a; a+=4; b+=4;
            if (b==624) b=0;
        } while (a!=624);
    }

    Sfmt12(int s) { super(s); }
    Sfmt12(int[]init_key)  { super(init_key); }
}
