/*
Sfmt16.java Cu(19937)
coded by isaku@pb4.so-net.ne.jp
*/

class Sfmt16 extends Sfmt
{
    public String IdString() {
        return"SFMT-19937:92-9-3-5-3:cfffbbff-fffffff7-fff7ffef-ff9fffdf";
    }

    protected int[]GetParity()
    { return new int[]{ 0x00000001,0x00000000,0x00000000,0xfb62abcc }; }


    public void gen_rand_all() {
        int a=0,b=368,c=616,d=620,y; int[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<24)^(p[a+2]>>>8)^((p[b+3]>>>5)&0xff9fffdf);
            p[a+3]=y^(p[c+3]>>>24)^(p[d+3]<<9);
            y=p[a+2]^(p[a+2]<<24)^(p[a+1]>>>8)^((p[b+2]>>>5)&0xfff7ffef);
            p[a+2]=y^((p[c+2]>>>24)|(p[c+3]<<8))^(p[d+2]<<9);
            y=p[a+1]^(p[a+1]<<24)^(p[a]>>>8)^((p[b+1]>>>5)&0xfffffff7);
            p[a+1]=y^((p[c+1]>>>24)|(p[c+2]<<8))^(p[d+1]<<9);
            y=p[a]^(p[a]<<24)^((p[b]>>>5)&0xcfffbbff);
            p[a]=y^((p[c]>>>24)|(p[c+1]<<8))^(p[d]<<9);
            c=d; d=a; a+=4; b+=4;
            if (b==624) b=0;
        } while (a!=624);
    }

    Sfmt16(int s) { super(s); }
    Sfmt16(int[]init_key)  { super(init_key); }
}
