/*
Sfmt20.java Cu(19937)
coded by isaku@pb4.so-net.ne.jp
*/

class Sfmt20 extends Sfmt
{
    public String IdString() {
        return"SFMT-19937:125-11-3-16-3:bfdfffff-7fffbe7f-bbfffff7-f7fdddff";
    }

    protected int[]GetParity()
    { return new int[]{ 0x00000001,0x00000000,0x40000000,0x63cd4800 }; }


    public void gen_rand_all() {
        int a=0,b=500,c=616,d=620,y; int[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<24)^(p[a+2]>>>8)^((p[b+3]>>>16)&0xf7fdddff);
            p[a+3]=y^(p[c+3]>>>24)^(p[d+3]<<11);
            y=p[a+2]^(p[a+2]<<24)^(p[a+1]>>>8)^((p[b+2]>>>16)&0xbbfffff7);
            p[a+2]=y^((p[c+2]>>>24)|(p[c+3]<<8))^(p[d+2]<<11);
            y=p[a+1]^(p[a+1]<<24)^(p[a]>>>8)^((p[b+1]>>>16)&0x7fffbe7f);
            p[a+1]=y^((p[c+1]>>>24)|(p[c+2]<<8))^(p[d+1]<<11);
            y=p[a]^(p[a]<<24)^((p[b]>>>16)&0xbfdfffff);
            p[a]=y^((p[c]>>>24)|(p[c+1]<<8))^(p[d]<<11);
            c=d; d=a; a+=4; b+=4;
            if (b==624) b=0;
        } while (a!=624);
    }

    Sfmt20(int s) { super(s); }
    Sfmt20(int[]init_key)  { super(init_key); }
}
