/*
Sfmt24.java Cu(19937)
coded by isaku@pb4.so-net.ne.jp
*/

class Sfmt24 extends Sfmt
{
    public String IdString() {
        return"SFMT-19937:2-13-3-11-1:fdffbffd-fff3b33f-fff7ff7e-ffdfef7f";
    }

    protected int[]GetParity()
    { return new int[]{ 0x00000001,0x00000000,0x80000000,0xad42c1d1 }; }


    public void gen_rand_all() {
        int a=0,b=8,c=616,d=620,y; int[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<24)^(p[a+2]>>>8)^((p[b+3]>>>11)&0xffdfef7f);
            p[a+3]=y^(p[c+3]>>>8)^(p[d+3]<<13);
            y=p[a+2]^(p[a+2]<<24)^(p[a+1]>>>8)^((p[b+2]>>>11)&0xfff7ff7e);
            p[a+2]=y^((p[c+2]>>>8)|(p[c+3]<<24))^(p[d+2]<<13);
            y=p[a+1]^(p[a+1]<<24)^(p[a]>>>8)^((p[b+1]>>>11)&0xfff3b33f);
            p[a+1]=y^((p[c+1]>>>8)|(p[c+2]<<24))^(p[d+1]<<13);
            y=p[a]^(p[a]<<24)^((p[b]>>>11)&0xfdffbffd);
            p[a]=y^((p[c]>>>8)|(p[c+1]<<24))^(p[d]<<13);
            c=d; d=a; a+=4; b+=4;
            if (b==624) b=0;
        } while (a!=624);
    }

    Sfmt24(int s) { super(s); }
    Sfmt24(int[]init_key)  { super(init_key); }
}
