/*
Sfmt29.java Cu(19937)
coded by isaku@pb4.so-net.ne.jp
*/

class Sfmt29 extends Sfmt
{
    public String IdString() {
        return"SFMT-19937:110-17-3-9-3:bffffffb-7b7fffff-ffffdf5f-fbffdeff";
    }

    protected int[]GetParity()
    { return new int[]{ 0x00000001,0x00000000,0x20000000,0x4bf4dbf0 }; }


    public void gen_rand_all() {
        int a=0,b=440,c=616,d=620,y; int[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<24)^(p[a+2]>>>8)^((p[b+3]>>>9)&0xfbffdeff);
            p[a+3]=y^(p[c+3]>>>24)^(p[d+3]<<17);
            y=p[a+2]^(p[a+2]<<24)^(p[a+1]>>>8)^((p[b+2]>>>9)&0xffffdf5f);
            p[a+2]=y^((p[c+2]>>>24)|(p[c+3]<<8))^(p[d+2]<<17);
            y=p[a+1]^(p[a+1]<<24)^(p[a]>>>8)^((p[b+1]>>>9)&0x7b7fffff);
            p[a+1]=y^((p[c+1]>>>24)|(p[c+2]<<8))^(p[d+1]<<17);
            y=p[a]^(p[a]<<24)^((p[b]>>>9)&0xbffffffb);
            p[a]=y^((p[c]>>>24)|(p[c+1]<<8))^(p[d]<<17);
            c=d; d=a; a+=4; b+=4;
            if (b==624) b=0;
        } while (a!=624);
    }

    Sfmt29(int s) { super(s); }
    Sfmt29(int[]init_key)  { super(init_key); }
}
