/*
Sfmt3.java Cu(19937)
coded by isaku@pb4.so-net.ne.jp
*/

class Sfmt3 extends Sfmt
{
    public String IdString() {
        return"SFMT-19937:45-14-3-5-5:aefefbbd-feffffff-d7edffff-f7fdffbe";
    }

    protected int[]GetParity()
    { return new int[]{ 0x00000001,0x00000000,0x00000000,0x0116914c }; }


    public void gen_rand_all() {
        int a=0,b=180,c=616,d=620,y; int[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<24)^(p[a+2]>>>8)^((p[b+3]>>>5)&0xf7fdffbe);
            p[a+3]=y^(p[d+3]<<14);
            y=p[a+2]^(p[a+2]<<24)^(p[a+1]>>>8)^((p[b+2]>>>5)&0xd7edffff);
            p[a+2]=y^(p[c+3]>>>8)^(p[d+2]<<14);
            y=p[a+1]^(p[a+1]<<24)^(p[a]>>>8)^((p[b+1]>>>5)&0xfeffffff);
            p[a+1]=y^((p[c+2]>>>8)|(p[c+3]<<24))^(p[d+1]<<14);
            y=p[a]^(p[a]<<24)^((p[b]>>>5)&0xaefefbbd);
            p[a]=y^((p[c+1]>>>8)|(p[c+2]<<24))^(p[d]<<14);
            c=d; d=a; a+=4; b+=4;
            if (b==624) b=0;
        } while (a!=624);
    }

    Sfmt3(int s) { super(s); }
    Sfmt3(int[]init_key)  { super(init_key); }
}
