/*
Sfmt7.java Cu(19937)
coded by isaku@pb4.so-net.ne.jp
*/

class Sfmt7 extends Sfmt
{
    public String IdString() {
        return"SFMT-19937:122-12-3-3-5:fef73bff-65eb7ff7-76ffffff-bfdeffeb";
    }

    protected int[]GetParity()
    { return new int[]{ 0x00000001,0x00000000,0x40000000,0x2bbdd900 }; }


    public void gen_rand_all() {
        int a=0,b=488,c=616,d=620,y; int[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<24)^(p[a+2]>>>8)^((p[b+3]>>>3)&0xbfdeffeb);
            p[a+3]=y^(p[d+3]<<12);
            y=p[a+2]^(p[a+2]<<24)^(p[a+1]>>>8)^((p[b+2]>>>3)&0x76ffffff);
            p[a+2]=y^(p[c+3]>>>8)^(p[d+2]<<12);
            y=p[a+1]^(p[a+1]<<24)^(p[a]>>>8)^((p[b+1]>>>3)&0x65eb7ff7);
            p[a+1]=y^((p[c+2]>>>8)|(p[c+3]<<24))^(p[d+1]<<12);
            y=p[a]^(p[a]<<24)^((p[b]>>>3)&0xfef73bff);
            p[a]=y^((p[c+1]>>>8)|(p[c+2]<<24))^(p[d]<<12);
            c=d; d=a; a+=4; b+=4;
            if (b==624) b=0;
        } while (a!=624);
    }

    Sfmt7(int s) { super(s); }
    Sfmt7(int[]init_key)  { super(init_key); }
}
