/*
Sfmt8.java Cu(19937)
coded by isaku@pb4.so-net.ne.jp
*/

class Sfmt8 extends Sfmt
{
    public String IdString() {
        return"SFMT-19937:64-10-3-13-1:fff8bfff-ffffffff-5fffffbf-ef7ff21e";
    }

    protected int[]GetParity()
    { return new int[]{ 0x00000001,0x00000000,0x00000000,0xdb186980 }; }


    public void gen_rand_all() {
        int a=0,b=256,c=616,d=620,y; int[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<24)^(p[a+2]>>>8)^((p[b+3]>>>13)&0xef7ff21e);
            p[a+3]=y^(p[c+3]>>>8)^(p[d+3]<<10);
            y=p[a+2]^(p[a+2]<<24)^(p[a+1]>>>8)^((p[b+2]>>>13)&0x5fffffbf);
            p[a+2]=y^((p[c+2]>>>8)|(p[c+3]<<24))^(p[d+2]<<10);
            y=p[a+1]^(p[a+1]<<24)^(p[a]>>>8)^((p[b+1]>>>13)&0xffffffff);
            p[a+1]=y^((p[c+1]>>>8)|(p[c+2]<<24))^(p[d+1]<<10);
            y=p[a]^(p[a]<<24)^((p[b]>>>13)&0xfff8bfff);
            p[a]=y^((p[c]>>>8)|(p[c+1]<<24))^(p[d]<<10);
            c=d; d=a; a+=4; b+=4;
            if (b==624) b=0;
        } while (a!=624);
    }

    Sfmt8(int s) { super(s); }
    Sfmt8(int[]init_key)  { super(init_key); }
}
