/*
Sfmt12.java Cu(2281)
coded by isaku@pb4.so-net.ne.jp
*/

class Sfmt12 extends Sfmt
{
    public String IdString() {
        return"SFMT-2281:5-5-3-6-1:dfff7dff-ff79fffe-eff77ffd-effb75df";
    }

    protected int[]GetParity()
    { return new int[]{ 0x00000001,0x00000000,0x00000000,0xc22bf800 }; }


    public void gen_rand_all() {
        int a=0,b=20,c=64,d=68,y; int[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<24)^(p[a+2]>>>8)^((p[b+3]>>>6)&0xeffb75df);
            p[a+3]=y^(p[c+3]>>>8)^(p[d+3]<<5);
            y=p[a+2]^(p[a+2]<<24)^(p[a+1]>>>8)^((p[b+2]>>>6)&0xeff77ffd);
            p[a+2]=y^((p[c+2]>>>8)|(p[c+3]<<24))^(p[d+2]<<5);
            y=p[a+1]^(p[a+1]<<24)^(p[a]>>>8)^((p[b+1]>>>6)&0xff79fffe);
            p[a+1]=y^((p[c+1]>>>8)|(p[c+2]<<24))^(p[d+1]<<5);
            y=p[a]^(p[a]<<24)^((p[b]>>>6)&0xdfff7dff);
            p[a]=y^((p[c]>>>8)|(p[c+1]<<24))^(p[d]<<5);
            c=d; d=a; a+=4; b+=4;
            if (b==72) b=0;
        } while (a!=72);
    }

    Sfmt12(int s) { super(s); }
    Sfmt12(int[]init_key)  { super(init_key); }
}
