/*
Sfmt13.java Cu(2281)
coded by isaku@pb4.so-net.ne.jp
*/

class Sfmt13 extends Sfmt
{
    public String IdString() {
        return"SFMT-2281:16-18-5-1-1:7ffffbff-fffff7bf-df7e6fff-fff7cfcf";
    }

    protected int[]GetParity()
    { return new int[]{ 0x00000001,0x00000000,0x00000000,0x3d350a80 }; }


    public void gen_rand_all() {
        int a=0,b=64,c=64,d=68,y; int[]p=x;

        do {
            y=p[a+3]^(p[a+2]<<8)^(p[a+1]>>>24)^((p[b+3]>>>1)&0xfff7cfcf);
            p[a+3]=y^(p[c+3]>>>8)^(p[d+3]<<18);
            y=p[a+2]^(p[a+1]<<8)^(p[a]>>>24)^((p[b+2]>>>1)&0xdf7e6fff);
            p[a+2]=y^((p[c+2]>>>8)|(p[c+3]<<24))^(p[d+2]<<18);
            y=p[a+1]^(p[a]<<8)^((p[b+1]>>>1)&0xfffff7bf);
            p[a+1]=y^((p[c+1]>>>8)|(p[c+2]<<24))^(p[d+1]<<18);
            y=p[a]^((p[b]>>>1)&0x7ffffbff);
            p[a]=y^((p[c]>>>8)|(p[c+1]<<24))^(p[d]<<18);
            c=d; d=a; a+=4; b+=4;
            if (b==72) b=0;
        } while (a!=72);
    }

    Sfmt13(int s) { super(s); }
    Sfmt13(int[]init_key)  { super(init_key); }
}
