/*
Sfmt16.java Cu(2281)
coded by isaku@pb4.so-net.ne.jp
*/

class Sfmt16 extends Sfmt
{
    public String IdString() {
        return"SFMT-2281:4-14-3-13-1:d7ffffdf-bfdfffff-fbfffdfe-5ffbffff";
    }

    protected int[]GetParity()
    { return new int[]{ 0x00000001,0x00000000,0x00000000,0x011ecc00 }; }


    public void gen_rand_all() {
        int a=0,b=16,c=64,d=68,y; int[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<24)^(p[a+2]>>>8)^((p[b+3]>>>13)&0x5ffbffff);
            p[a+3]=y^(p[c+3]>>>8)^(p[d+3]<<14);
            y=p[a+2]^(p[a+2]<<24)^(p[a+1]>>>8)^((p[b+2]>>>13)&0xfbfffdfe);
            p[a+2]=y^((p[c+2]>>>8)|(p[c+3]<<24))^(p[d+2]<<14);
            y=p[a+1]^(p[a+1]<<24)^(p[a]>>>8)^((p[b+1]>>>13)&0xbfdfffff);
            p[a+1]=y^((p[c+1]>>>8)|(p[c+2]<<24))^(p[d+1]<<14);
            y=p[a]^(p[a]<<24)^((p[b]>>>13)&0xd7ffffdf);
            p[a]=y^((p[c]>>>8)|(p[c+1]<<24))^(p[d]<<14);
            c=d; d=a; a+=4; b+=4;
            if (b==72) b=0;
        } while (a!=72);
    }

    Sfmt16(int s) { super(s); }
    Sfmt16(int[]init_key)  { super(init_key); }
}
