/*
Sfmt18.java Cu(2281)
coded by isaku@pb4.so-net.ne.jp
*/

class Sfmt18 extends Sfmt
{
    public String IdString() {
        return"SFMT-2281:6-9-7-21-1:beddbdff-fbffbd7f-f95b7fff-7fefbfff";
    }

    protected int[]GetParity()
    { return new int[]{ 0x00000001,0x00000000,0x00000000,0x197e2080 }; }


    public void gen_rand_all() {
        int a=0,b=24,c=64,d=68,y; int[]p=x;

        do {
            y=p[a+3]^(p[a+2]<<24)^(p[a+1]>>>8)^((p[b+3]>>>21)&0x7fefbfff);
            p[a+3]=y^(p[c+3]>>>8)^(p[d+3]<<9);
            y=p[a+2]^(p[a+1]<<24)^(p[a]>>>8)^((p[b+2]>>>21)&0xf95b7fff);
            p[a+2]=y^((p[c+2]>>>8)|(p[c+3]<<24))^(p[d+2]<<9);
            y=p[a+1]^(p[a]<<24)^((p[b+1]>>>21)&0xfbffbd7f);
            p[a+1]=y^((p[c+1]>>>8)|(p[c+2]<<24))^(p[d+1]<<9);
            y=p[a]^((p[b]>>>21)&0xbeddbdff);
            p[a]=y^((p[c]>>>8)|(p[c+1]<<24))^(p[d]<<9);
            c=d; d=a; a+=4; b+=4;
            if (b==72) b=0;
        } while (a!=72);
    }

    Sfmt18(int s) { super(s); }
    Sfmt18(int[]init_key)  { super(init_key); }
}
