/*
Sfmt19.java Cu(2281)
coded by isaku@pb4.so-net.ne.jp
*/

class Sfmt19 extends Sfmt
{
    public String IdString() {
        return"SFMT-2281:1-9-3-12-1:eff7fcfa-f3ee7fef-bdb47dff-dbf6dfff";
    }

    protected int[]GetParity()
    { return new int[]{ 0x00000001,0x00000000,0x00000000,0x2bbd0a00 }; }


    public void gen_rand_all() {
        int a=0,b=4,c=64,d=68,y; int[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<24)^(p[a+2]>>>8)^((p[b+3]>>>12)&0xdbf6dfff);
            p[a+3]=y^(p[c+3]>>>8)^(p[d+3]<<9);
            y=p[a+2]^(p[a+2]<<24)^(p[a+1]>>>8)^((p[b+2]>>>12)&0xbdb47dff);
            p[a+2]=y^((p[c+2]>>>8)|(p[c+3]<<24))^(p[d+2]<<9);
            y=p[a+1]^(p[a+1]<<24)^(p[a]>>>8)^((p[b+1]>>>12)&0xf3ee7fef);
            p[a+1]=y^((p[c+1]>>>8)|(p[c+2]<<24))^(p[d+1]<<9);
            y=p[a]^(p[a]<<24)^((p[b]>>>12)&0xeff7fcfa);
            p[a]=y^((p[c]>>>8)|(p[c+1]<<24))^(p[d]<<9);
            c=d; d=a; a+=4; b+=4;
            if (b==72) b=0;
        } while (a!=72);
    }

    Sfmt19(int s) { super(s); }
    Sfmt19(int[]init_key)  { super(init_key); }
}
