/*
Sfmt2.java Cu(2281)
coded by isaku@pb4.so-net.ne.jp
*/

class Sfmt2 extends Sfmt
{
    public String IdString() {
        return"SFMT-2281:7-9-3-4-1:dfffef7b-ffefffff-fcfeffff-b6ff77cf";
    }

    protected int[]GetParity()
    { return new int[]{ 0x00000001,0x00000000,0x00000000,0x907c9c00 }; }


    public void gen_rand_all() {
        int a=0,b=28,c=64,d=68,y; int[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<24)^(p[a+2]>>>8)^((p[b+3]>>>4)&0xb6ff77cf);
            p[a+3]=y^(p[c+3]>>>8)^(p[d+3]<<9);
            y=p[a+2]^(p[a+2]<<24)^(p[a+1]>>>8)^((p[b+2]>>>4)&0xfcfeffff);
            p[a+2]=y^((p[c+2]>>>8)|(p[c+3]<<24))^(p[d+2]<<9);
            y=p[a+1]^(p[a+1]<<24)^(p[a]>>>8)^((p[b+1]>>>4)&0xffefffff);
            p[a+1]=y^((p[c+1]>>>8)|(p[c+2]<<24))^(p[d+1]<<9);
            y=p[a]^(p[a]<<24)^((p[b]>>>4)&0xdfffef7b);
            p[a]=y^((p[c]>>>8)|(p[c+1]<<24))^(p[d]<<9);
            c=d; d=a; a+=4; b+=4;
            if (b==72) b=0;
        } while (a!=72);
    }

    Sfmt2(int s) { super(s); }
    Sfmt2(int[]init_key)  { super(init_key); }
}
