/*
Sfmt25.java Cu(2281)
coded by isaku@pb4.so-net.ne.jp
*/

class Sfmt25 extends Sfmt
{
    public String IdString() {
        return"SFMT-2281:5-4-7-19-1:ffbfbfff-ffffbfff-fff7ceee-ffffefff";
    }

    protected int[]GetParity()
    { return new int[]{ 0x00000001,0x00000000,0x00000000,0x859df000 }; }


    public void gen_rand_all() {
        int a=0,b=20,c=64,d=68,y; int[]p=x;

        do {
            y=p[a+3]^(p[a+2]<<24)^(p[a+1]>>>8)^((p[b+3]>>>19)&0xffffefff);
            p[a+3]=y^(p[c+3]>>>8)^(p[d+3]<<4);
            y=p[a+2]^(p[a+1]<<24)^(p[a]>>>8)^((p[b+2]>>>19)&0xfff7ceee);
            p[a+2]=y^((p[c+2]>>>8)|(p[c+3]<<24))^(p[d+2]<<4);
            y=p[a+1]^(p[a]<<24)^((p[b+1]>>>19)&0xffffbfff);
            p[a+1]=y^((p[c+1]>>>8)|(p[c+2]<<24))^(p[d+1]<<4);
            y=p[a]^((p[b]>>>19)&0xffbfbfff);
            p[a]=y^((p[c]>>>8)|(p[c+1]<<24))^(p[d]<<4);
            c=d; d=a; a+=4; b+=4;
            if (b==72) b=0;
        } while (a!=72);
    }

    Sfmt25(int s) { super(s); }
    Sfmt25(int[]init_key)  { super(init_key); }
}
