/*
Sfmt26.java Cu(2281)
coded by isaku@pb4.so-net.ne.jp
*/

class Sfmt26 extends Sfmt
{
    public String IdString() {
        return"SFMT-2281:3-2-7-1-1:fffefbef-7ffffbf7-ffffffff-6fff7fff";
    }

    protected int[]GetParity()
    { return new int[]{ 0x00000001,0x00000000,0x00000000,0xcc1df840 }; }


    public void gen_rand_all() {
        int a=0,b=12,c=64,d=68,y; int[]p=x;

        do {
            y=p[a+3]^(p[a+2]<<24)^(p[a+1]>>>8)^((p[b+3]>>>1)&0x6fff7fff);
            p[a+3]=y^(p[c+3]>>>8)^(p[d+3]<<2);
            y=p[a+2]^(p[a+1]<<24)^(p[a]>>>8)^((p[b+2]>>>1)&0xffffffff);
            p[a+2]=y^((p[c+2]>>>8)|(p[c+3]<<24))^(p[d+2]<<2);
            y=p[a+1]^(p[a]<<24)^((p[b+1]>>>1)&0x7ffffbf7);
            p[a+1]=y^((p[c+1]>>>8)|(p[c+2]<<24))^(p[d+1]<<2);
            y=p[a]^((p[b]>>>1)&0xfffefbef);
            p[a]=y^((p[c]>>>8)|(p[c+1]<<24))^(p[d]<<2);
            c=d; d=a; a+=4; b+=4;
            if (b==72) b=0;
        } while (a!=72);
    }

    Sfmt26(int s) { super(s); }
    Sfmt26(int[]init_key)  { super(init_key); }
}
