/*
Sfmt27.java Cu(2281)
coded by isaku@pb4.so-net.ne.jp
*/

class Sfmt27 extends Sfmt
{
    public String IdString() {
        return"SFMT-2281:14-20-7-9-1:7bffc3f9-ddfff2fb-ddfbf6fb-77dfdfff";
    }

    protected int[]GetParity()
    { return new int[]{ 0x00000001,0x00000000,0x00000000,0xf6dae320 }; }


    public void gen_rand_all() {
        int a=0,b=56,c=64,d=68,y; int[]p=x;

        do {
            y=p[a+3]^(p[a+2]<<24)^(p[a+1]>>>8)^((p[b+3]>>>9)&0x77dfdfff);
            p[a+3]=y^(p[c+3]>>>8)^(p[d+3]<<20);
            y=p[a+2]^(p[a+1]<<24)^(p[a]>>>8)^((p[b+2]>>>9)&0xddfbf6fb);
            p[a+2]=y^((p[c+2]>>>8)|(p[c+3]<<24))^(p[d+2]<<20);
            y=p[a+1]^(p[a]<<24)^((p[b+1]>>>9)&0xddfff2fb);
            p[a+1]=y^((p[c+1]>>>8)|(p[c+2]<<24))^(p[d+1]<<20);
            y=p[a]^((p[b]>>>9)&0x7bffc3f9);
            p[a]=y^((p[c]>>>8)|(p[c+1]<<24))^(p[d]<<20);
            c=d; d=a; a+=4; b+=4;
            if (b==72) b=0;
        } while (a!=72);
    }

    Sfmt27(int s) { super(s); }
    Sfmt27(int[]init_key)  { super(init_key); }
}
