/*
Sfmt29.java Cu(2281)
coded by isaku@pb4.so-net.ne.jp
*/

class Sfmt29 extends Sfmt
{
    public String IdString() {
        return"SFMT-2281:2-9-7-17-1:ffffffff-7fbff9df-7f6fefcf-efffffde";
    }

    protected int[]GetParity()
    { return new int[]{ 0x00000001,0x00000000,0x00000000,0xcb8f6a00 }; }


    public void gen_rand_all() {
        int a=0,b=8,c=64,d=68,y; int[]p=x;

        do {
            y=p[a+3]^(p[a+2]<<24)^(p[a+1]>>>8)^((p[b+3]>>>17)&0xefffffde);
            p[a+3]=y^(p[c+3]>>>8)^(p[d+3]<<9);
            y=p[a+2]^(p[a+1]<<24)^(p[a]>>>8)^((p[b+2]>>>17)&0x7f6fefcf);
            p[a+2]=y^((p[c+2]>>>8)|(p[c+3]<<24))^(p[d+2]<<9);
            y=p[a+1]^(p[a]<<24)^((p[b+1]>>>17)&0x7fbff9df);
            p[a+1]=y^((p[c+1]>>>8)|(p[c+2]<<24))^(p[d+1]<<9);
            y=p[a]^((p[b]>>>17)&0xffffffff);
            p[a]=y^((p[c]>>>8)|(p[c+1]<<24))^(p[d]<<9);
            c=d; d=a; a+=4; b+=4;
            if (b==72) b=0;
        } while (a!=72);
    }

    Sfmt29(int s) { super(s); }
    Sfmt29(int[]init_key)  { super(init_key); }
}
