/*
Sfmt3.java Cu(2281)
coded by isaku@pb4.so-net.ne.jp
*/

class Sfmt3 extends Sfmt
{
    public String IdString() {
        return"SFMT-2281:8-10-3-7-1:dbffedff-fffbfffd-f7ffffdf-ffff7ff7";
    }

    protected int[]GetParity()
    { return new int[]{ 0x00000001,0x00000000,0x00000000,0x0a826800 }; }


    public void gen_rand_all() {
        int a=0,b=32,c=64,d=68,y; int[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<24)^(p[a+2]>>>8)^((p[b+3]>>>7)&0xffff7ff7);
            p[a+3]=y^(p[c+3]>>>8)^(p[d+3]<<10);
            y=p[a+2]^(p[a+2]<<24)^(p[a+1]>>>8)^((p[b+2]>>>7)&0xf7ffffdf);
            p[a+2]=y^((p[c+2]>>>8)|(p[c+3]<<24))^(p[d+2]<<10);
            y=p[a+1]^(p[a+1]<<24)^(p[a]>>>8)^((p[b+1]>>>7)&0xfffbfffd);
            p[a+1]=y^((p[c+1]>>>8)|(p[c+2]<<24))^(p[d+1]<<10);
            y=p[a]^(p[a]<<24)^((p[b]>>>7)&0xdbffedff);
            p[a]=y^((p[c]>>>8)|(p[c+1]<<24))^(p[d]<<10);
            c=d; d=a; a+=4; b+=4;
            if (b==72) b=0;
        } while (a!=72);
    }

    Sfmt3(int s) { super(s); }
    Sfmt3(int[]init_key)  { super(init_key); }
}
