/*
Sfmt30.java Cu(2281)
coded by isaku@pb4.so-net.ne.jp
*/

class Sfmt30 extends Sfmt
{
    public String IdString() {
        return"SFMT-2281:15-12-1-1-7:fdffffff-ffffdef7-ff3fffff-f37776f7";
    }

    protected int[]GetParity()
    { return new int[]{ 0x00000001,0x00000000,0x00000000,0x16537800 }; }


    public void gen_rand_all() {
        int a=0,b=60,c=64,d=68,y; int[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<8)^(p[a+2]>>>24)^((p[b+3]>>>1)&0xf37776f7);
            p[a+3]=y^(p[d+3]<<12);
            y=p[a+2]^(p[a+2]<<8)^(p[a+1]>>>24)^((p[b+2]>>>1)&0xff3fffff);
            p[a+2]=y^(p[c+3]>>>24)^(p[d+2]<<12);
            y=p[a+1]^(p[a+1]<<8)^(p[a]>>>24)^((p[b+1]>>>1)&0xffffdef7);
            p[a+1]=y^((p[c+2]>>>24)|(p[c+3]<<8))^(p[d+1]<<12);
            y=p[a]^(p[a]<<8)^((p[b]>>>1)&0xfdffffff);
            p[a]=y^((p[c+1]>>>24)|(p[c+2]<<8))^(p[d]<<12);
            c=d; d=a; a+=4; b+=4;
            if (b==72) b=0;
        } while (a!=72);
    }

    Sfmt30(int s) { super(s); }
    Sfmt30(int[]init_key)  { super(init_key); }
}
