/*
Sfmt31.java Cu(2281)
coded by isaku@pb4.so-net.ne.jp
*/

class Sfmt31 extends Sfmt
{
    public String IdString() {
        return"SFMT-2281:9-11-5-6-3:e7fffba3-ffdf7fdf-efbf7fff-fd7cf7bf";
    }

    protected int[]GetParity()
    { return new int[]{ 0x00000001,0x00000000,0x00000000,0xc4cbc800 }; }


    public void gen_rand_all() {
        int a=0,b=36,c=64,d=68,y; int[]p=x;

        do {
            y=p[a+3]^(p[a+2]<<8)^(p[a+1]>>>24)^((p[b+3]>>>6)&0xfd7cf7bf);
            p[a+3]=y^(p[c+3]>>>24)^(p[d+3]<<11);
            y=p[a+2]^(p[a+1]<<8)^(p[a]>>>24)^((p[b+2]>>>6)&0xefbf7fff);
            p[a+2]=y^((p[c+2]>>>24)|(p[c+3]<<8))^(p[d+2]<<11);
            y=p[a+1]^(p[a]<<8)^((p[b+1]>>>6)&0xffdf7fdf);
            p[a+1]=y^((p[c+1]>>>24)|(p[c+2]<<8))^(p[d+1]<<11);
            y=p[a]^((p[b]>>>6)&0xe7fffba3);
            p[a]=y^((p[c]>>>24)|(p[c+1]<<8))^(p[d]<<11);
            c=d; d=a; a+=4; b+=4;
            if (b==72) b=0;
        } while (a!=72);
    }

    Sfmt31(int s) { super(s); }
    Sfmt31(int[]init_key)  { super(init_key); }
}
