/*
Sfmt14.java Cu(4253)
coded by isaku@pb4.so-net.ne.jp
*/

class Sfmt14 extends Sfmt
{
    public String IdString() {
        return"SFMT-4253:11-21-3-6-1:fffffea7-fffdff3a-bfffffcf-dff5ffed";
    }

    protected int[]GetParity()
    { return new int[]{ 0xa0000001,0x9405b85d,0xc60478f2,0xac65a61d }; }


    public void gen_rand_all() {
        int a=0,b=44,c=128,d=132,y; int[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<24)^(p[a+2]>>>8)^((p[b+3]>>>6)&0xdff5ffed);
            p[a+3]=y^(p[c+3]>>>8)^(p[d+3]<<21);
            y=p[a+2]^(p[a+2]<<24)^(p[a+1]>>>8)^((p[b+2]>>>6)&0xbfffffcf);
            p[a+2]=y^((p[c+2]>>>8)|(p[c+3]<<24))^(p[d+2]<<21);
            y=p[a+1]^(p[a+1]<<24)^(p[a]>>>8)^((p[b+1]>>>6)&0xfffdff3a);
            p[a+1]=y^((p[c+1]>>>8)|(p[c+2]<<24))^(p[d+1]<<21);
            y=p[a]^(p[a]<<24)^((p[b]>>>6)&0xfffffea7);
            p[a]=y^((p[c]>>>8)|(p[c+1]<<24))^(p[d]<<21);
            c=d; d=a; a+=4; b+=4;
            if (b==136) b=0;
        } while (a!=136);
    }

    Sfmt14(int s) { super(s); }
    Sfmt14(int[]init_key)  { super(init_key); }
}
