/*
Sfmt18.java Cu(4253)
coded by isaku@pb4.so-net.ne.jp
*/

class Sfmt18 extends Sfmt
{
    public String IdString() {
        return"SFMT-4253:4-11-1-3-3:f7efdbfb-f7fffffb-fffefe7f-f7eb7fef";
    }

    protected int[]GetParity()
    { return new int[]{ 0x80000001,0x9026447e,0x1f279907,0x070b4438 }; }


    public void gen_rand_all() {
        int a=0,b=16,c=128,d=132,y; int[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<8)^(p[a+2]>>>24)^((p[b+3]>>>3)&0xf7eb7fef);
            p[a+3]=y^(p[c+3]>>>24)^(p[d+3]<<11);
            y=p[a+2]^(p[a+2]<<8)^(p[a+1]>>>24)^((p[b+2]>>>3)&0xfffefe7f);
            p[a+2]=y^((p[c+2]>>>24)|(p[c+3]<<8))^(p[d+2]<<11);
            y=p[a+1]^(p[a+1]<<8)^(p[a]>>>24)^((p[b+1]>>>3)&0xf7fffffb);
            p[a+1]=y^((p[c+1]>>>24)|(p[c+2]<<8))^(p[d+1]<<11);
            y=p[a]^(p[a]<<8)^((p[b]>>>3)&0xf7efdbfb);
            p[a]=y^((p[c]>>>24)|(p[c+1]<<8))^(p[d]<<11);
            c=d; d=a; a+=4; b+=4;
            if (b==136) b=0;
        } while (a!=136);
    }

    Sfmt18(int s) { super(s); }
    Sfmt18(int[]init_key)  { super(init_key); }
}
