/*
Sfmt19.java Cu(4253)
coded by isaku@pb4.so-net.ne.jp
*/

class Sfmt19 extends Sfmt
{
    public String IdString() {
        return"SFMT-4253:32-3-3-11-3:ffffeffd-ffffeff7-ffffffef-ffdfffff";
    }

    protected int[]GetParity()
    { return new int[]{ 0x00000001,0x3725b98f,0xd6e1adeb,0xdfbc6de4 }; }


    public void gen_rand_all() {
        int a=0,b=128,c=128,d=132,y; int[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<24)^(p[a+2]>>>8)^((p[b+3]>>>11)&0xffdfffff);
            p[a+3]=y^(p[c+3]>>>24)^(p[d+3]<<3);
            y=p[a+2]^(p[a+2]<<24)^(p[a+1]>>>8)^((p[b+2]>>>11)&0xffffffef);
            p[a+2]=y^((p[c+2]>>>24)|(p[c+3]<<8))^(p[d+2]<<3);
            y=p[a+1]^(p[a+1]<<24)^(p[a]>>>8)^((p[b+1]>>>11)&0xffffeff7);
            p[a+1]=y^((p[c+1]>>>24)|(p[c+2]<<8))^(p[d+1]<<3);
            y=p[a]^(p[a]<<24)^((p[b]>>>11)&0xffffeffd);
            p[a]=y^((p[c]>>>24)|(p[c+1]<<8))^(p[d]<<3);
            c=d; d=a; a+=4; b+=4;
            if (b==136) b=0;
        } while (a!=136);
    }

    Sfmt19(int s) { super(s); }
    Sfmt19(int[]init_key)  { super(init_key); }
}
