/*
Sfmt2.java Cu(4253)
coded by isaku@pb4.so-net.ne.jp
*/

class Sfmt2 extends Sfmt
{
    public String IdString() {
        return"SFMT-4253:15-25-1-2-1:dffff3ff-ffdebf7f-ffdfbdf7-fbffffff";
    }

    protected int[]GetParity()
    { return new int[]{ 0x20000001,0x8b4ecd15,0xb3480fc1,0x35ab1967 }; }


    public void gen_rand_all() {
        int a=0,b=60,c=128,d=132,y; int[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<8)^(p[a+2]>>>24)^((p[b+3]>>>2)&0xfbffffff);
            p[a+3]=y^(p[c+3]>>>8)^(p[d+3]<<25);
            y=p[a+2]^(p[a+2]<<8)^(p[a+1]>>>24)^((p[b+2]>>>2)&0xffdfbdf7);
            p[a+2]=y^((p[c+2]>>>8)|(p[c+3]<<24))^(p[d+2]<<25);
            y=p[a+1]^(p[a+1]<<8)^(p[a]>>>24)^((p[b+1]>>>2)&0xffdebf7f);
            p[a+1]=y^((p[c+1]>>>8)|(p[c+2]<<24))^(p[d+1]<<25);
            y=p[a]^(p[a]<<8)^((p[b]>>>2)&0xdffff3ff);
            p[a]=y^((p[c]>>>8)|(p[c+1]<<24))^(p[d]<<25);
            c=d; d=a; a+=4; b+=4;
            if (b==136) b=0;
        } while (a!=136);
    }

    Sfmt2(int s) { super(s); }
    Sfmt2(int[]init_key)  { super(init_key); }
}
