/*
Sfmt20.java Cu(4253)
coded by isaku@pb4.so-net.ne.jp
*/

class Sfmt20 extends Sfmt
{
    public String IdString() {
        return"SFMT-4253:9-5-3-26-1:b9ffffdf-f9fdff7f-fffebffe-b6ff7ffd";
    }

    protected int[]GetParity()
    { return new int[]{ 0x10000001,0xbc129652,0xb4c6341b,0x13cb9597 }; }


    public void gen_rand_all() {
        int a=0,b=36,c=128,d=132,y; int[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<24)^(p[a+2]>>>8)^((p[b+3]>>>26)&0xb6ff7ffd);
            p[a+3]=y^(p[c+3]>>>8)^(p[d+3]<<5);
            y=p[a+2]^(p[a+2]<<24)^(p[a+1]>>>8)^((p[b+2]>>>26)&0xfffebffe);
            p[a+2]=y^((p[c+2]>>>8)|(p[c+3]<<24))^(p[d+2]<<5);
            y=p[a+1]^(p[a+1]<<24)^(p[a]>>>8)^((p[b+1]>>>26)&0xf9fdff7f);
            p[a+1]=y^((p[c+1]>>>8)|(p[c+2]<<24))^(p[d+1]<<5);
            y=p[a]^(p[a]<<24)^((p[b]>>>26)&0xb9ffffdf);
            p[a]=y^((p[c]>>>8)|(p[c+1]<<24))^(p[d]<<5);
            c=d; d=a; a+=4; b+=4;
            if (b==136) b=0;
        } while (a!=136);
    }

    Sfmt20(int s) { super(s); }
    Sfmt20(int[]init_key)  { super(init_key); }
}
