/*
Sfmt21.java Cu(4253)
coded by isaku@pb4.so-net.ne.jp
*/

class Sfmt21 extends Sfmt
{
    public String IdString() {
        return"SFMT-4253:32-3-3-3-5:fffffeff-fffb9d7f-ffdb9ff7-bff9fff7";
    }

    protected int[]GetParity()
    { return new int[]{ 0x60000001,0x0623be05,0x4730c7b7,0xe4dcb68e }; }


    public void gen_rand_all() {
        int a=0,b=128,c=128,d=132,y; int[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<24)^(p[a+2]>>>8)^((p[b+3]>>>3)&0xbff9fff7);
            p[a+3]=y^(p[d+3]<<3);
            y=p[a+2]^(p[a+2]<<24)^(p[a+1]>>>8)^((p[b+2]>>>3)&0xffdb9ff7);
            p[a+2]=y^(p[c+3]>>>8)^(p[d+2]<<3);
            y=p[a+1]^(p[a+1]<<24)^(p[a]>>>8)^((p[b+1]>>>3)&0xfffb9d7f);
            p[a+1]=y^((p[c+2]>>>8)|(p[c+3]<<24))^(p[d+1]<<3);
            y=p[a]^(p[a]<<24)^((p[b]>>>3)&0xfffffeff);
            p[a]=y^((p[c+1]>>>8)|(p[c+2]<<24))^(p[d]<<3);
            c=d; d=a; a+=4; b+=4;
            if (b==136) b=0;
        } while (a!=136);
    }

    Sfmt21(int s) { super(s); }
    Sfmt21(int[]init_key)  { super(init_key); }
}
