/*
Sfmt22.java Cu(4253)
coded by isaku@pb4.so-net.ne.jp
*/

class Sfmt22 extends Sfmt
{
    public String IdString() {
        return"SFMT-4253:32-21-3-7-1:ff3feefd-ffffecff-fffffcfd-fffbadfd";
    }

    protected int[]GetParity()
    { return new int[]{ 0x70000001,0xb4dc9c74,0xfa71d735,0x2b9421bd }; }


    public void gen_rand_all() {
        int a=0,b=128,c=128,d=132,y; int[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<24)^(p[a+2]>>>8)^((p[b+3]>>>7)&0xfffbadfd);
            p[a+3]=y^(p[c+3]>>>8)^(p[d+3]<<21);
            y=p[a+2]^(p[a+2]<<24)^(p[a+1]>>>8)^((p[b+2]>>>7)&0xfffffcfd);
            p[a+2]=y^((p[c+2]>>>8)|(p[c+3]<<24))^(p[d+2]<<21);
            y=p[a+1]^(p[a+1]<<24)^(p[a]>>>8)^((p[b+1]>>>7)&0xffffecff);
            p[a+1]=y^((p[c+1]>>>8)|(p[c+2]<<24))^(p[d+1]<<21);
            y=p[a]^(p[a]<<24)^((p[b]>>>7)&0xff3feefd);
            p[a]=y^((p[c]>>>8)|(p[c+1]<<24))^(p[d]<<21);
            c=d; d=a; a+=4; b+=4;
            if (b==136) b=0;
        } while (a!=136);
    }

    Sfmt22(int s) { super(s); }
    Sfmt22(int[]init_key)  { super(init_key); }
}
