/*
Sfmt24.java Cu(4253)
coded by isaku@pb4.so-net.ne.jp
*/

class Sfmt24 extends Sfmt
{
    public String IdString() {
        return"SFMT-4253:27-11-5-8-3:d73d23f7-ef7fffff-eeffffdf-fffbf6cf";
    }

    protected int[]GetParity()
    { return new int[]{ 0x40000001,0xbec29ed7,0x722046bc,0x7d6ac005 }; }


    public void gen_rand_all() {
        int a=0,b=108,c=128,d=132,y; int[]p=x;

        do {
            y=p[a+3]^(p[a+2]<<8)^(p[a+1]>>>24)^((p[b+3]>>>8)&0xfffbf6cf);
            p[a+3]=y^(p[c+3]>>>24)^(p[d+3]<<11);
            y=p[a+2]^(p[a+1]<<8)^(p[a]>>>24)^((p[b+2]>>>8)&0xeeffffdf);
            p[a+2]=y^((p[c+2]>>>24)|(p[c+3]<<8))^(p[d+2]<<11);
            y=p[a+1]^(p[a]<<8)^((p[b+1]>>>8)&0xef7fffff);
            p[a+1]=y^((p[c+1]>>>24)|(p[c+2]<<8))^(p[d+1]<<11);
            y=p[a]^((p[b]>>>8)&0xd73d23f7);
            p[a]=y^((p[c]>>>24)|(p[c+1]<<8))^(p[d]<<11);
            c=d; d=a; a+=4; b+=4;
            if (b==136) b=0;
        } while (a!=136);
    }

    Sfmt24(int s) { super(s); }
    Sfmt24(int[]init_key)  { super(init_key); }
}
