/*
Sfmt26.java Cu(4253)
coded by isaku@pb4.so-net.ne.jp
*/

class Sfmt26 extends Sfmt
{
    public String IdString() {
        return"SFMT-4253:12-29-1-1-1:fff7dffd-ffdd7fbd-ffffbff7-ffff9dff";
    }

    protected int[]GetParity()
    { return new int[]{ 0xe0000001,0x8ecaba1b,0x4a61645b,0x6aac5023 }; }


    public void gen_rand_all() {
        int a=0,b=48,c=128,d=132,y; int[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<8)^(p[a+2]>>>24)^((p[b+3]>>>1)&0xffff9dff);
            p[a+3]=y^(p[c+3]>>>8)^(p[d+3]<<29);
            y=p[a+2]^(p[a+2]<<8)^(p[a+1]>>>24)^((p[b+2]>>>1)&0xffffbff7);
            p[a+2]=y^((p[c+2]>>>8)|(p[c+3]<<24))^(p[d+2]<<29);
            y=p[a+1]^(p[a+1]<<8)^(p[a]>>>24)^((p[b+1]>>>1)&0xffdd7fbd);
            p[a+1]=y^((p[c+1]>>>8)|(p[c+2]<<24))^(p[d+1]<<29);
            y=p[a]^(p[a]<<8)^((p[b]>>>1)&0xfff7dffd);
            p[a]=y^((p[c]>>>8)|(p[c+1]<<24))^(p[d]<<29);
            c=d; d=a; a+=4; b+=4;
            if (b==136) b=0;
        } while (a!=136);
    }

    Sfmt26(int s) { super(s); }
    Sfmt26(int[]init_key)  { super(init_key); }
}
