/*
Sfmt28.java Cu(4253)
coded by isaku@pb4.so-net.ne.jp
*/

class Sfmt28 extends Sfmt
{
    public String IdString() {
        return"SFMT-4253:24-2-3-7-1:ef8ffffa-fffbfff8-f7ffbfe9-77ffbffd";
    }

    protected int[]GetParity()
    { return new int[]{ 0x20000001,0x8f3c8ae4,0xa3cf01c6,0xa91d27dd }; }


    public void gen_rand_all() {
        int a=0,b=96,c=128,d=132,y; int[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<24)^(p[a+2]>>>8)^((p[b+3]>>>7)&0x77ffbffd);
            p[a+3]=y^(p[c+3]>>>8)^(p[d+3]<<2);
            y=p[a+2]^(p[a+2]<<24)^(p[a+1]>>>8)^((p[b+2]>>>7)&0xf7ffbfe9);
            p[a+2]=y^((p[c+2]>>>8)|(p[c+3]<<24))^(p[d+2]<<2);
            y=p[a+1]^(p[a+1]<<24)^(p[a]>>>8)^((p[b+1]>>>7)&0xfffbfff8);
            p[a+1]=y^((p[c+1]>>>8)|(p[c+2]<<24))^(p[d+1]<<2);
            y=p[a]^(p[a]<<24)^((p[b]>>>7)&0xef8ffffa);
            p[a]=y^((p[c]>>>8)|(p[c+1]<<24))^(p[d]<<2);
            c=d; d=a; a+=4; b+=4;
            if (b==136) b=0;
        } while (a!=136);
    }

    Sfmt28(int s) { super(s); }
    Sfmt28(int[]init_key)  { super(init_key); }
}
