/*
Sfmt29.java Cu(4253)
coded by isaku@pb4.so-net.ne.jp
*/

class Sfmt29 extends Sfmt
{
    public String IdString() {
        return"SFMT-4253:4-14-5-9-3:7bfffff7-fff7fff3-ff9fbf9e-fffdafff";
    }

    protected int[]GetParity()
    { return new int[]{ 0xc0000001,0x93fcf151,0x739a3cf7,0x72b647f3 }; }


    public void gen_rand_all() {
        int a=0,b=16,c=128,d=132,y; int[]p=x;

        do {
            y=p[a+3]^(p[a+2]<<8)^(p[a+1]>>>24)^((p[b+3]>>>9)&0xfffdafff);
            p[a+3]=y^(p[c+3]>>>24)^(p[d+3]<<14);
            y=p[a+2]^(p[a+1]<<8)^(p[a]>>>24)^((p[b+2]>>>9)&0xff9fbf9e);
            p[a+2]=y^((p[c+2]>>>24)|(p[c+3]<<8))^(p[d+2]<<14);
            y=p[a+1]^(p[a]<<8)^((p[b+1]>>>9)&0xfff7fff3);
            p[a+1]=y^((p[c+1]>>>24)|(p[c+2]<<8))^(p[d+1]<<14);
            y=p[a]^((p[b]>>>9)&0x7bfffff7);
            p[a]=y^((p[c]>>>24)|(p[c+1]<<8))^(p[d]<<14);
            c=d; d=a; a+=4; b+=4;
            if (b==136) b=0;
        } while (a!=136);
    }

    Sfmt29(int s) { super(s); }
    Sfmt29(int[]init_key)  { super(init_key); }
}
