/*
Sfmt31.java Cu(4253)
coded by isaku@pb4.so-net.ne.jp
*/

class Sfmt31 extends Sfmt
{
    public String IdString() {
        return"SFMT-4253:31-15-5-14-3:efbce7ff-feb7f77f-fff3ffbf-bfffb75f";
    }

    protected int[]GetParity()
    { return new int[]{ 0x48000001,0x836a277a,0xc4833eb6,0x22b0dc59 }; }


    public void gen_rand_all() {
        int a=0,b=124,c=128,d=132,y; int[]p=x;

        do {
            y=p[a+3]^(p[a+2]<<8)^(p[a+1]>>>24)^((p[b+3]>>>14)&0xbfffb75f);
            p[a+3]=y^(p[c+3]>>>24)^(p[d+3]<<15);
            y=p[a+2]^(p[a+1]<<8)^(p[a]>>>24)^((p[b+2]>>>14)&0xfff3ffbf);
            p[a+2]=y^((p[c+2]>>>24)|(p[c+3]<<8))^(p[d+2]<<15);
            y=p[a+1]^(p[a]<<8)^((p[b+1]>>>14)&0xfeb7f77f);
            p[a+1]=y^((p[c+1]>>>24)|(p[c+2]<<8))^(p[d+1]<<15);
            y=p[a]^((p[b]>>>14)&0xefbce7ff);
            p[a]=y^((p[c]>>>24)|(p[c+1]<<8))^(p[d]<<15);
            c=d; d=a; a+=4; b+=4;
            if (b==136) b=0;
        } while (a!=136);
    }

    Sfmt31(int s) { super(s); }
    Sfmt31(int[]init_key)  { super(init_key); }
}
