/*
Sfmt4.java Cu(4253)
coded by isaku@pb4.so-net.ne.jp
*/

class Sfmt4 extends Sfmt
{
    public String IdString() {
        return"SFMT-4253:10-17-3-13-3:bffdefff-ffaffeff-9f3ebfce-bf9fffdf";
    }

    protected int[]GetParity()
    { return new int[]{ 0xa0000001,0xd3bdda16,0x4140113f,0xd458c634 }; }


    public void gen_rand_all() {
        int a=0,b=40,c=128,d=132,y; int[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<24)^(p[a+2]>>>8)^((p[b+3]>>>13)&0xbf9fffdf);
            p[a+3]=y^(p[c+3]>>>24)^(p[d+3]<<17);
            y=p[a+2]^(p[a+2]<<24)^(p[a+1]>>>8)^((p[b+2]>>>13)&0x9f3ebfce);
            p[a+2]=y^((p[c+2]>>>24)|(p[c+3]<<8))^(p[d+2]<<17);
            y=p[a+1]^(p[a+1]<<24)^(p[a]>>>8)^((p[b+1]>>>13)&0xffaffeff);
            p[a+1]=y^((p[c+1]>>>24)|(p[c+2]<<8))^(p[d+1]<<17);
            y=p[a]^(p[a]<<24)^((p[b]>>>13)&0xbffdefff);
            p[a]=y^((p[c]>>>24)|(p[c+1]<<8))^(p[d]<<17);
            c=d; d=a; a+=4; b+=4;
            if (b==136) b=0;
        } while (a!=136);
    }

    Sfmt4(int s) { super(s); }
    Sfmt4(int[]init_key)  { super(init_key); }
}
