/*
Sfmt6.java Cu(4253)
coded by isaku@pb4.so-net.ne.jp
*/

class Sfmt6 extends Sfmt
{
    public String IdString() {
        return"SFMT-4253:13-18-1-21-1:e777f7fc-f7d7bf7d-edff7f5f-ffbfff7f";
    }

    protected int[]GetParity()
    { return new int[]{ 0x40000001,0x7df3317a,0xbbfeb4c7,0x13a23b1d }; }


    public void gen_rand_all() {
        int a=0,b=52,c=128,d=132,y; int[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<8)^(p[a+2]>>>24)^((p[b+3]>>>21)&0xffbfff7f);
            p[a+3]=y^(p[c+3]>>>8)^(p[d+3]<<18);
            y=p[a+2]^(p[a+2]<<8)^(p[a+1]>>>24)^((p[b+2]>>>21)&0xedff7f5f);
            p[a+2]=y^((p[c+2]>>>8)|(p[c+3]<<24))^(p[d+2]<<18);
            y=p[a+1]^(p[a+1]<<8)^(p[a]>>>24)^((p[b+1]>>>21)&0xf7d7bf7d);
            p[a+1]=y^((p[c+1]>>>8)|(p[c+2]<<24))^(p[d+1]<<18);
            y=p[a]^(p[a]<<8)^((p[b]>>>21)&0xe777f7fc);
            p[a]=y^((p[c]>>>8)|(p[c+1]<<24))^(p[d]<<18);
            c=d; d=a; a+=4; b+=4;
            if (b==136) b=0;
        } while (a!=136);
    }

    Sfmt6(int s) { super(s); }
    Sfmt6(int[]init_key)  { super(init_key); }
}
