/*
Sfmt14.java Cu(607)
coded by isaku@pb4.so-net.ne.jp
*/

class Sfmt14 extends Sfmt
{
    public String IdString() {
        return"SFMT-607:1-23-1-20-1:f5ffbfff-bffcfffe-ffbffefe-7fffbeef";
    }

    protected int[]GetParity()
    { return new int[]{ 0x00000001,0x00000000,0x00000000,0xde196133 }; }


    public void gen_rand_all() {
        int a=0,b=4,c=12,d=16,y; int[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<8)^(p[a+2]>>>24)^((p[b+3]>>>20)&0x7fffbeef);
            p[a+3]=y^(p[c+3]>>>8)^(p[d+3]<<23);
            y=p[a+2]^(p[a+2]<<8)^(p[a+1]>>>24)^((p[b+2]>>>20)&0xffbffefe);
            p[a+2]=y^((p[c+2]>>>8)|(p[c+3]<<24))^(p[d+2]<<23);
            y=p[a+1]^(p[a+1]<<8)^(p[a]>>>24)^((p[b+1]>>>20)&0xbffcfffe);
            p[a+1]=y^((p[c+1]>>>8)|(p[c+2]<<24))^(p[d+1]<<23);
            y=p[a]^(p[a]<<8)^((p[b]>>>20)&0xf5ffbfff);
            p[a]=y^((p[c]>>>8)|(p[c+1]<<24))^(p[d]<<23);
            c=d; d=a; a+=4; b+=4;
            if (b==20) b=0;
        } while (a!=20);
    }

    Sfmt14(int s) { super(s); }
    Sfmt14(int[]init_key)  { super(init_key); }
}
