/*
Sfmt16.java Cu(607)
coded by isaku@pb4.so-net.ne.jp
*/

class Sfmt16 extends Sfmt
{
    public String IdString() {
        return"SFMT-607:1-17-3-22-5:dffffafe-dffffeff-fd77ffdf-fbfffffb";
    }

    protected int[]GetParity()
    { return new int[]{ 0x00000001,0x00000000,0x00000000,0xa7c70cc8 }; }


    public void gen_rand_all() {
        int a=0,b=4,c=12,d=16,y; int[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<24)^(p[a+2]>>>8)^((p[b+3]>>>22)&0xfbfffffb);
            p[a+3]=y^(p[d+3]<<17);
            y=p[a+2]^(p[a+2]<<24)^(p[a+1]>>>8)^((p[b+2]>>>22)&0xfd77ffdf);
            p[a+2]=y^(p[c+3]>>>8)^(p[d+2]<<17);
            y=p[a+1]^(p[a+1]<<24)^(p[a]>>>8)^((p[b+1]>>>22)&0xdffffeff);
            p[a+1]=y^((p[c+2]>>>8)|(p[c+3]<<24))^(p[d+1]<<17);
            y=p[a]^(p[a]<<24)^((p[b]>>>22)&0xdffffafe);
            p[a]=y^((p[c+1]>>>8)|(p[c+2]<<24))^(p[d]<<17);
            c=d; d=a; a+=4; b+=4;
            if (b==20) b=0;
        } while (a!=20);
    }

    Sfmt16(int s) { super(s); }
    Sfmt16(int[]init_key)  { super(init_key); }
}
