/*
Sfmt25.java Cu(607)
coded by isaku@pb4.so-net.ne.jp
*/

class Sfmt25 extends Sfmt
{
    public String IdString() {
        return"SFMT-607:1-13-3-18-7:dfbf5fff-cffd7eff-ffbe3fff-fdbfff9f";
    }

    protected int[]GetParity()
    { return new int[]{ 0x00000001,0x00000000,0x80000000,0xd28269a7 }; }


    public void gen_rand_all() {
        int a=0,b=4,c=12,d=16,y; int[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<24)^(p[a+2]>>>8)^((p[b+3]>>>18)&0xfdbfff9f);
            p[a+3]=y^(p[d+3]<<13);
            y=p[a+2]^(p[a+2]<<24)^(p[a+1]>>>8)^((p[b+2]>>>18)&0xffbe3fff);
            p[a+2]=y^(p[c+3]>>>24)^(p[d+2]<<13);
            y=p[a+1]^(p[a+1]<<24)^(p[a]>>>8)^((p[b+1]>>>18)&0xcffd7eff);
            p[a+1]=y^((p[c+2]>>>24)|(p[c+3]<<8))^(p[d+1]<<13);
            y=p[a]^(p[a]<<24)^((p[b]>>>18)&0xdfbf5fff);
            p[a]=y^((p[c+1]>>>24)|(p[c+2]<<8))^(p[d]<<13);
            c=d; d=a; a+=4; b+=4;
            if (b==20) b=0;
        } while (a!=20);
    }

    Sfmt25(int s) { super(s); }
    Sfmt25(int[]init_key)  { super(init_key); }
}
