/*
Sfmt3.java Cu(607)
coded by isaku@pb4.so-net.ne.jp
*/

class Sfmt3 extends Sfmt
{
    public String IdString() {
        return"SFMT-607:3-11-3-21-1:6fff7ffe-f5fffffe-bffffffe-afdfffff";
    }

    protected int[]GetParity()
    { return new int[]{ 0x00000001,0x00000000,0x10000000,0x6f6fec6a }; }


    public void gen_rand_all() {
        int a=0,b=12,c=12,d=16,y; int[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<24)^(p[a+2]>>>8)^((p[b+3]>>>21)&0xafdfffff);
            p[a+3]=y^(p[c+3]>>>8)^(p[d+3]<<11);
            y=p[a+2]^(p[a+2]<<24)^(p[a+1]>>>8)^((p[b+2]>>>21)&0xbffffffe);
            p[a+2]=y^((p[c+2]>>>8)|(p[c+3]<<24))^(p[d+2]<<11);
            y=p[a+1]^(p[a+1]<<24)^(p[a]>>>8)^((p[b+1]>>>21)&0xf5fffffe);
            p[a+1]=y^((p[c+1]>>>8)|(p[c+2]<<24))^(p[d+1]<<11);
            y=p[a]^(p[a]<<24)^((p[b]>>>21)&0x6fff7ffe);
            p[a]=y^((p[c]>>>8)|(p[c+1]<<24))^(p[d]<<11);
            c=d; d=a; a+=4; b+=4;
            if (b==20) b=0;
        } while (a!=20);
    }

    Sfmt3(int s) { super(s); }
    Sfmt3(int[]init_key)  { super(init_key); }
}
