/*
Sfmt31.java Cu(607)
coded by isaku@pb4.so-net.ne.jp
*/

class Sfmt31 extends Sfmt
{
    public String IdString() {
        return"SFMT-607:1-21-5-19-1:bfff7eff-7fffbfef-fffbff7f-effeff6f";
    }

    protected int[]GetParity()
    { return new int[]{ 0x00000001,0x00000000,0x00000000,0x85b22d17 }; }


    public void gen_rand_all() {
        int a=0,b=4,c=12,d=16,y; int[]p=x;

        do {
            y=p[a+3]^(p[a+2]<<8)^(p[a+1]>>>24)^((p[b+3]>>>19)&0xeffeff6f);
            p[a+3]=y^(p[c+3]>>>8)^(p[d+3]<<21);
            y=p[a+2]^(p[a+1]<<8)^(p[a]>>>24)^((p[b+2]>>>19)&0xfffbff7f);
            p[a+2]=y^((p[c+2]>>>8)|(p[c+3]<<24))^(p[d+2]<<21);
            y=p[a+1]^(p[a]<<8)^((p[b+1]>>>19)&0x7fffbfef);
            p[a+1]=y^((p[c+1]>>>8)|(p[c+2]<<24))^(p[d+1]<<21);
            y=p[a]^((p[b]>>>19)&0xbfff7eff);
            p[a]=y^((p[c]>>>8)|(p[c+1]<<24))^(p[d]<<21);
            c=d; d=a; a+=4; b+=4;
            if (b==20) b=0;
        } while (a!=20);
    }

    Sfmt31(int s) { super(s); }
    Sfmt31(int[]init_key)  { super(init_key); }
}
