/*
Sfmt7.java Cu(607)
coded by isaku@pb4.so-net.ne.jp
*/

class Sfmt7 extends Sfmt
{
    public String IdString() {
        return"SFMT-607:2-14-1-11-1:7bfffbff-fba7ffbf-f7fffe3f-f36fffff";
    }

    protected int[]GetParity()
    { return new int[]{ 0x00000001,0x00000000,0x00000000,0x170c7993 }; }


    public void gen_rand_all() {
        int a=0,b=8,c=12,d=16,y; int[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<8)^(p[a+2]>>>24)^((p[b+3]>>>11)&0xf36fffff);
            p[a+3]=y^(p[c+3]>>>8)^(p[d+3]<<14);
            y=p[a+2]^(p[a+2]<<8)^(p[a+1]>>>24)^((p[b+2]>>>11)&0xf7fffe3f);
            p[a+2]=y^((p[c+2]>>>8)|(p[c+3]<<24))^(p[d+2]<<14);
            y=p[a+1]^(p[a+1]<<8)^(p[a]>>>24)^((p[b+1]>>>11)&0xfba7ffbf);
            p[a+1]=y^((p[c+1]>>>8)|(p[c+2]<<24))^(p[d+1]<<14);
            y=p[a]^(p[a]<<8)^((p[b]>>>11)&0x7bfffbff);
            p[a]=y^((p[c]>>>8)|(p[c+1]<<24))^(p[d]<<14);
            c=d; d=a; a+=4; b+=4;
            if (b==20) b=0;
        } while (a!=20);
    }

    Sfmt7(int s) { super(s); }
    Sfmt7(int[]init_key)  { super(init_key); }
}
