/*
Sfmt8.java Cu(607)
coded by isaku@pb4.so-net.ne.jp
*/

class Sfmt8 extends Sfmt
{
    public String IdString() {
        return"SFMT-607:1-14-5-3-1:ffe7ffff-ff6fefff-7f3fffff-ff7feffb";
    }

    protected int[]GetParity()
    { return new int[]{ 0x00000001,0x00000000,0x40000000,0xf4112310 }; }


    public void gen_rand_all() {
        int a=0,b=4,c=12,d=16,y; int[]p=x;

        do {
            y=p[a+3]^(p[a+2]<<8)^(p[a+1]>>>24)^((p[b+3]>>>3)&0xff7feffb);
            p[a+3]=y^(p[c+3]>>>8)^(p[d+3]<<14);
            y=p[a+2]^(p[a+1]<<8)^(p[a]>>>24)^((p[b+2]>>>3)&0x7f3fffff);
            p[a+2]=y^((p[c+2]>>>8)|(p[c+3]<<24))^(p[d+2]<<14);
            y=p[a+1]^(p[a]<<8)^((p[b+1]>>>3)&0xff6fefff);
            p[a+1]=y^((p[c+1]>>>8)|(p[c+2]<<24))^(p[d+1]<<14);
            y=p[a]^((p[b]>>>3)&0xffe7ffff);
            p[a]=y^((p[c]>>>8)|(p[c+1]<<24))^(p[d]<<14);
            c=d; d=a; a+=4; b+=4;
            if (b==20) b=0;
        } while (a!=20);
    }

    Sfmt8(int s) { super(s); }
    Sfmt8(int[]init_key)  { super(init_key); }
}
