'
' Sfmt1279.vb Cu
' coded by isaku@pb4.so-net.ne.jp
' 

Class Sfmt

    Private index As Integer
    Private coin_bits As Integer ' NextBit ł̎c̃rbg
    Private coin_save As UInteger ' NextBit ł̒lێ
    Private byte_pos As Integer ' NextByte ŎgpoCg
    Private byte_save As UInteger ' NextByte ł̒lێ
    Private range As Integer ' NextIntEx őO͈̔
    Private bse As UInteger  ' NextIntEx őO̊l
    Private shift As Integer ' NextIntEx őÕVtg
    Private normal_sw As Integer  ' NextNormal ŎcĂ
    Private normal_save As Double ' NextNormal ̎c̒l
    Protected x(39) As UInteger ' ԃe[u
    Private Shared ParityData As UInteger() = {&H1&, &H0&, &H0&, &H20000000&}

    Protected Overridable Function GetParity() As UInteger()
        Return ParityData
    End Function

    Public readonly Overridable Property IdString() As String
        Get
            Return "SFMT-1279:7-14-3-5-1:f7fefffd-7fefcfff-aff3ef3f-b5ffff7f"
        End Get
    End Property

    Protected Overridable Sub gen_rand_all()
        Dim a As Integer = 0 : Dim b As Integer = 28 : Dim c As Integer = 32
        Dim d As Integer = 36 : Dim y As UInteger : Dim p As UInteger() = x

        Do
            y = p(a + 3) Xor (p(a + 3) << 24) Xor (p(a + 2) >> 8) Xor ((p(b + 3) >> 5) And &HB5FFFF7F)
            p(a + 3) = y Xor (p(c + 3) >> 8) Xor (p(d + 3) << 14)
            y = p(a + 2) Xor (p(a + 2) << 24) Xor (p(a + 1) >> 8) Xor ((p(b + 2) >> 5) And &HAFF3EF3F)
            p(a + 2) = y Xor ((p(c + 2) >> 8) or (p(c + 3) << 24)) Xor (p(d + 2) << 14)
            y = p(a + 1) Xor (p(a + 1) << 24) Xor (p(a) >> 8) Xor ((p(b + 1) >> 5) And &H7FEFCFFF)
            p(a + 1) = y Xor ((p(c + 1) >> 8) or (p(c + 2) << 24)) Xor (p(d + 1) << 14)
            y = p(a) Xor (p(a) << 24) Xor ((p(b) >> 5) And &HF7FEFFFD)
            p(a) = y Xor ((p(c) >> 8) or (p(c + 1) << 24)) Xor (p(d) << 14)
            c = d : d = a : a += 4 : b += 4
            If b = 40 Then b = 0
        Loop While a <> 40
    End Sub

    Private Sub period_certification()
        Dim work As UInteger : Dim inner As UInteger = 0 : Dim i, j As Integer
        Dim parity As UInteger() = GetParity()

        index = 40 : range = 0 : normal_sw = 0 : coin_bits = 0 : byte_pos = 0
        For i = 0 To 3 : inner = inner Xor x(i) And parity(i) : Next
        i = 16 : Do : inner = inner Xor inner >> i : i >>= 1 : Loop While i > 0
        inner = inner And 1
        If inner = 1 Then Return
        For i = 0 To 3
            j = 0 : work = 1
            Do
                If (work And parity(i)) <> 0 Then
                    x(i) = x(i) Xor work
                    Return
                End If
                j += 1
                work <<= 1
            Loop While j < 32
        Next
    End Sub

    ' ̎ s ɂ鏉
    Public Sub InitMt(ByVal s As UInteger)
        Dim p As UInteger
        x(0) = s
        For p = 1 To 39
            s = 1812433253 * (s Xor (s >> 30)) + p
            x(p) = s
        Next
        period_certification()
    End Sub

    Sub New(ByVal s As UInteger)
        InitMt(s)
    End Sub
    
    ' z init_key ɂ鏉
    Public Sub InitMtEx(ByVal init_key() As UInteger)
        Dim r, i, j, c As UInteger
        Dim key_len As UInteger = init_key.Length

        For i = 0 To 39 : x(i) = &H8B8B8B8B& : Next
        If key_len + 1 > 40 Then c = key_len + 1 Else c = 40
        r = x(0) Xor x(17) Xor x(39) : r = (r Xor (r >> 27)) * 1664525
        x(17) += r : r += key_len : x(22) += r : x(0) = r : c -= 1
        i = 1 : j = 0
        Do While j < c And j < key_len
            r = x(i) Xor x((i + 17) Mod 40) Xor x((i + 39) Mod 40)
            r = (r Xor (r >> 27)) * 1664525 : x((i + 17) Mod 40) += r
            r += init_key(j) + i : x((i + 22) Mod 40) += r
            x(i) = r : i = (i + 1) Mod 40 : j += 1
        Loop
        Do While j < c
            r = x(i) Xor x((i + 17) Mod 40) Xor x((i + 39) Mod 40)
            r = (r Xor (r >> 27)) * 1664525 : x((i + 17) Mod 40) += r : r += i
            x((i + 22) Mod 40) += r : x(i) = r : i = (i + 1) Mod 40 : j += 1
        Loop
        For j = 0 To 39
            r = x(i) + x((i + 17) Mod 40) + x((i + 39) Mod 40)
            r = (r Xor (r >> 27)) * 1566083941
            c = (i + 17) Mod 40 : x(c) = x(c) Xor r : r -= i
            c = (i + 22) Mod 40 : x(c) = x(c) Xor r
            x(i) = r : i = (i + 1) Mod 40
        Next
        period_certification()
    End Sub


    Sub New(ByVal init_key() As UInteger)
        InitMtEx(init_key)
    End Sub
    
    ' 32rbgȂ̗
    Public Function NextMt() As UInteger
        If index = 40 Then
            gen_rand_all()
            index = 0
        End If
        nextmt = x(index)
        index += 1
    End Function

    ' Oȏ n ̐
    Public Function NextInt(ByVal n As Integer) As Integer
        Return Int(n * (1.0 / 4294967296.0) * NextMt())
    End Function

    ' OPԂ
    Public Function NextBit() As integer
        coin_bits = coin_bits - 1
        If coin_bits = -1 Then
            coin_bits = 31
            coin_save = NextMt
        Else
            coin_save = coin_save >> 1
        End If
        NextBit = coin_save And 1
    End Function

    ' OPԂ
    Public Function NextByte() As integer
        byte_pos = byte_pos - 1
        If byte_pos = -1 Then
            byte_pos = 3
            byte_save = NextMt
        Else
            byte_save = byte_save >> 8
        End If
        NextByte = byte_save And 255
    End Function

    ' OȏP̗(53bitx)
    Public Function NextUnif() As Double
        Dim z As UInteger = NextMt() >> 11
        Dim y As UInteger = NextMt()
        Return (y * 2097152.0 + z) * (1.0 / 9007199254740992.0)
    End Function

    ' ۂߌ덷̂ȂOȏ range_ ̐
    Public Function NextIntEx(ByVal range_ As Integer) As Integer
        Dim y_, base_, remain_, shift_ As UInteger

        If range_ <= 0 Then Return 0
        If range_ <> range Then
            range = range_ : bse = range_ : shift = 0
            Do While bse <= 1 << 30
                bse <<= 1 : shift += 1
            Loop
        End If
        Do
            y_ = NextMt() >> 1
            If y_ < bse Then Return int(y_ >> shift)
            base_ = bse : shift_ = shift : y_ -= base_
            remain_ = (1 << 31) - base_
            Do While remain_ >= range_
                Do While base_ > remain_
                    base_ >>= 1 : shift_ -= 1
                Loop
                If y_ < base_ Then Return int(y_ >> shift_)
                y_ -= base_
                remain_ -= base_
            Loop
        Loop
    End Function
    
    ' Rx˂̃JCQ敪z
    Public Function NextChisq(ByVal n As Double) As Double
        Return 2 * NextGamma(0.5 * n)
    End Function

    ' p[^̃K}z
    Public Function NextGamma(ByVal a As Double) As double
        Dim t, u, xx, y As Double
        If a > 1 Then
            t = Math.Sqrt(2 * a - 1)
            Do
                Do
                    Do
                        Do
                            xx = 1 - NextUnif()
                            y = 2 * NextUnif() - 1
                        Loop While xx * xx + y * y > 1
                        y /= xx : xx = t * y + a - 1
                    Loop While xx <= 0
                    u = (a - 1) * Math.Log(xx / (a - 1)) - t * y
                Loop While u < -50.0
            Loop While NextUnif() > (1 + y * y) * Math.Exp(u)
        Else
            t = 2.7182818284590451 / (a + 2.7182818284590451)
            Do
                If NextUnif() < t Then
                    xx = Math.Pow(NextUnif(), 1 / a) : y = Math.Exp(-xx)
                Else
                    xx = 1 - Math.Log(1 - NextUnif()) : y = Math.Pow(xx, a - 1)
                End If
            Loop While NextUnif() >= y
        End If
        Return xx
    End Function

    ' mo̊􉽕z
    Public Function NextGeometric(ByVal p As Double) As Integer
        Return int(Math.Ceiling(Math.Log(1.0 - NextUnif()) / Math.Log(1 - p)))
    End Function

    ' Opz
    Public Function NextTriangle() As Double
        Dim a As Double = NextUnif()
        Dim b As Double = NextUnif()

        Return a - b
    End Function
    
    ' ςP̎wz
    Public Function NextExp() As Double
        Return -Math.Log(1 - NextUnif())
    End Function

    ' WKz(ő8.57)
    Public Function NextNormal() As Double
        Dim t, u As Double
        If normal_sw = 0 Then
            t = Math.Sqrt(-2 * Math.Log(1.0 - NextUnif()))
            u = 3.1415926535897931 * 2 * NextUnif()
            normal_save = t * Math.Sin(u) : normal_sw = 1
            Return t * Math.Cos(u)
        Else
            normal_sw = 0 : Return normal_save
        End If
    End Function
    
    ' m̃_PʃxNg
    Public Sub NextUnitVect(ByRef v As Double(), ByVal n As Integer)
        Dim i As Integer : Dim r As Double = 0
        ReDim v(n - 1)
        For i = 0 To n - 1
            v(i) = NextNormal() : r += v(i) * v(i)
        Next
        If r = 0 Then
            r = 1
        End If
        r = Math.Sqrt(r)
        For i = 0 To n - 1 : v(i) /= r : Next
    End Sub

    ' p[^m,ôQz
    Public Function NextBinomial(ByVal n As Integer, ByVal p As Double) As Integer
        Dim i As Integer : Dim r As Integer = 0

        For i = 0 To n - 1
            If NextUnif() < p Then r += 1
        Next
        Return r
    End Function

    ' ֌Wq̂QϗʐKz
    Public Sub NextBinormal(ByVal r As Double, ByRef a As Double, ByRef b As Double)
        Dim r1, r2, s As Double
        Do
            r1 = 2 * NextUnif() - 1
            r2 = 2 * NextUnif() - 1
            s = r1 * r1 + r2 * r2
        Loop While s > 1 Or s = 0
        s = -Math.Log(s) / s : r1 = Math.Sqrt((1 + r) * s) * r1
        r2 = Math.Sqrt((1 - r) * s) * r2 : a = r1 + r2 : b = r1 - r2
    End Sub

    ' p[^`,ãx[^z
    Public Function NextBeta(ByVal a As Double, ByVal b As Double) As Double
        Dim temp As Double = NextGamma(a)
        Return temp / (temp + NextGamma(b))
    End Function

    ' p[^m̗ݏ敪z
    Public Function NextPower(ByVal n As Double) As Double
        Return Math.Pow(NextUnif(), 1.0 / (n + 1))
    End Function

    ' WXeBbNz
    Public Function NextLogistic() As Double
        Dim r As Double
        Do : r = NextUnif() : Loop While r = 0
        Return Math.Log(r / (1 - r))
    End Function

    ' R[V[z
    Public Function NextCauchy() As Double
        Dim x, y As Double
        Do
            x = 1 - NextUnif() : y = 2 * NextUnif() - 1
        Loop While x * x + y * y > 1
        Return y / x
    End Function

    ' Rx n1,n2 ̂ez
    Public Function NextFDist(ByVal n1 As Double, ByVal n2 As Double) As Double
        Dim nc1 As Double = NextChisq(n1)
        Dim nc2 As Double = NextChisq(n2)
        Return (nc1 * n2) / (nc2 * n1)
    End Function

    ' σɂ̃|A\z
    Public Function NextPoisson(ByVal lambda As Double) As Integer
        Dim k As Integer = 0

        lambda = Math.Exp(lambda) * NextUnif()
        Do While lambda > 1
            lambda *= NextUnif()
            k += 1
        Loop
        Return k
    End Function

    ' Rxm̂z
    Public Function NextTDist(ByVal n As Double) As Double
        Dim a, b, c As Double
        If n <= 2 Then
            Do : a = NextChisq(n) : Loop While a = 0
            Return NextNormal() / Math.Sqrt(a / n)
        End If
        Do
            a = NextNormal() : b = a * a / (n - 2)
            c = Math.Log(1 - NextUnif()) / (1 - 0.5 * n)
        Loop While Math.Exp(-b - c) > 1 - b
        Return a / Math.Sqrt((1 - 2.0 / n) * (1 - b))
    End Function

    ' p[^̃Cuz
    Public Function NextWeibull(ByVal alpha As Double) As Double
        Return Math.Pow(-Math.Log(1 - NextUnif()), 1 / alpha)
    End Function
End Class

Class Sfmt1
    Inherits Sfmt

    Public readonly Overrides Property IdString() As String
        Get
            Return "SFMT-1279:3-18-1-1-1:fffffffb-37f5effb-b3fdaff9-fffffd7d"
        End Get
    End Property

    Private Shared ParityData As UInteger() = {&H1&, &H0&, &H0&, &H40000000&}

    Protected Overrides Function GetParity() As UInteger()
        Return ParityData
    End Function

    Protected overrides Sub gen_rand_all()
        Dim a As Integer = 0 : Dim b As Integer = 12 : Dim c As Integer = 32
        Dim d As Integer = 36 : Dim y As UInteger : Dim p As UInteger() = x

        Do
            y = p(a + 3) Xor (p(a + 3) << 8) Xor (p(a + 2) >> 24) Xor ((p(b + 3) >> 1) And &HFFFFFD7D)
            p(a + 3) = y Xor (p(c + 3) >> 8) Xor (p(d + 3) << 18)
            y = p(a + 2) Xor (p(a + 2) << 8) Xor (p(a + 1) >> 24) Xor ((p(b + 2) >> 1) And &HB3FDAFF9)
            p(a + 2) = y Xor ((p(c + 2) >> 8) or (p(c + 3) << 24)) Xor (p(d + 2) << 18)
            y = p(a + 1) Xor (p(a + 1) << 8) Xor (p(a) >> 24) Xor ((p(b + 1) >> 1) And &H37F5EFFB)
            p(a + 1) = y Xor ((p(c + 1) >> 8) or (p(c + 2) << 24)) Xor (p(d + 1) << 18)
            y = p(a) Xor (p(a) << 8) Xor ((p(b) >> 1) And &HFFFFFFFB)
            p(a) = y Xor ((p(c) >> 8) or (p(c + 1) << 24)) Xor (p(d) << 18)
            c = d : d = a : a += 4 : b += 4
            If b = 40 Then b = 0
        Loop While a <> 40
    End Sub

    Sub New(ByVal s As UInteger)
        MyBase.New(s)
    End Sub

    Sub New(ByVal init_key As UInteger())
        MyBase.New(init_key)
    End Sub

End Class

Class Sfmt2
    Inherits Sfmt

    Public readonly Overrides Property IdString() As String
        Get
            Return "SFMT-1279:6-21-1-17-1:fffbbfff-fffbdffb-ddfffdff-57ffffbf"
        End Get
    End Property

    Private Shared ParityData As UInteger() = {&H1&, &H0&, &H0&, &H0&}

    Protected Overrides Function GetParity() As UInteger()
        Return ParityData
    End Function

    Protected overrides Sub gen_rand_all()
        Dim a As Integer = 0 : Dim b As Integer = 24 : Dim c As Integer = 32
        Dim d As Integer = 36 : Dim y As UInteger : Dim p As UInteger() = x

        Do
            y = p(a + 3) Xor (p(a + 3) << 8) Xor (p(a + 2) >> 24) Xor ((p(b + 3) >> 17) And &H57FFFFBF)
            p(a + 3) = y Xor (p(c + 3) >> 8) Xor (p(d + 3) << 21)
            y = p(a + 2) Xor (p(a + 2) << 8) Xor (p(a + 1) >> 24) Xor ((p(b + 2) >> 17) And &HDDFFFDFF)
            p(a + 2) = y Xor ((p(c + 2) >> 8) or (p(c + 3) << 24)) Xor (p(d + 2) << 21)
            y = p(a + 1) Xor (p(a + 1) << 8) Xor (p(a) >> 24) Xor ((p(b + 1) >> 17) And &HFFFBDFFB)
            p(a + 1) = y Xor ((p(c + 1) >> 8) or (p(c + 2) << 24)) Xor (p(d + 1) << 21)
            y = p(a) Xor (p(a) << 8) Xor ((p(b) >> 17) And &HFFFBBFFF)
            p(a) = y Xor ((p(c) >> 8) or (p(c + 1) << 24)) Xor (p(d) << 21)
            c = d : d = a : a += 4 : b += 4
            If b = 40 Then b = 0
        Loop While a <> 40
    End Sub

    Sub New(ByVal s As UInteger)
        MyBase.New(s)
    End Sub

    Sub New(ByVal init_key As UInteger())
        MyBase.New(init_key)
    End Sub

End Class

Class Sfmt3
    Inherits Sfmt

    Public readonly Overrides Property IdString() As String
        Get
            Return "SFMT-1279:8-19-1-15-1:fbefeffd-ffefffff-dfef7eff-efeeffff"
        End Get
    End Property

    Private Shared ParityData As UInteger() = {&H1&, &H0&, &H0&, &H0&}

    Protected Overrides Function GetParity() As UInteger()
        Return ParityData
    End Function

    Protected overrides Sub gen_rand_all()
        Dim a As Integer = 0 : Dim b As Integer = 32 : Dim c As Integer = 32
        Dim d As Integer = 36 : Dim y As UInteger : Dim p As UInteger() = x

        Do
            y = p(a + 3) Xor (p(a + 3) << 8) Xor (p(a + 2) >> 24) Xor ((p(b + 3) >> 15) And &HEFEEFFFF)
            p(a + 3) = y Xor (p(c + 3) >> 8) Xor (p(d + 3) << 19)
            y = p(a + 2) Xor (p(a + 2) << 8) Xor (p(a + 1) >> 24) Xor ((p(b + 2) >> 15) And &HDFEF7EFF)
            p(a + 2) = y Xor ((p(c + 2) >> 8) or (p(c + 3) << 24)) Xor (p(d + 2) << 19)
            y = p(a + 1) Xor (p(a + 1) << 8) Xor (p(a) >> 24) Xor ((p(b + 1) >> 15) And &HFFEFFFFF)
            p(a + 1) = y Xor ((p(c + 1) >> 8) or (p(c + 2) << 24)) Xor (p(d + 1) << 19)
            y = p(a) Xor (p(a) << 8) Xor ((p(b) >> 15) And &HFBEFEFFD)
            p(a) = y Xor ((p(c) >> 8) or (p(c + 1) << 24)) Xor (p(d) << 19)
            c = d : d = a : a += 4 : b += 4
            If b = 40 Then b = 0
        Loop While a <> 40
    End Sub

    Sub New(ByVal s As UInteger)
        MyBase.New(s)
    End Sub

    Sub New(ByVal init_key As UInteger())
        MyBase.New(init_key)
    End Sub

End Class

Class Sfmt4
    Inherits Sfmt

    Public readonly Overrides Property IdString() As String
        Get
            Return "SFMT-1279:3-20-1-5-1:fddfbf9f-eefffb37-fff7df7b-fffefbef"
        End Get
    End Property

    Private Shared ParityData As UInteger() = {&H1&, &H0&, &H0&, &H0&}

    Protected Overrides Function GetParity() As UInteger()
        Return ParityData
    End Function

    Protected overrides Sub gen_rand_all()
        Dim a As Integer = 0 : Dim b As Integer = 12 : Dim c As Integer = 32
        Dim d As Integer = 36 : Dim y As UInteger : Dim p As UInteger() = x

        Do
            y = p(a + 3) Xor (p(a + 3) << 8) Xor (p(a + 2) >> 24) Xor ((p(b + 3) >> 5) And &HFFFEFBEF)
            p(a + 3) = y Xor (p(c + 3) >> 8) Xor (p(d + 3) << 20)
            y = p(a + 2) Xor (p(a + 2) << 8) Xor (p(a + 1) >> 24) Xor ((p(b + 2) >> 5) And &HFFF7DF7B)
            p(a + 2) = y Xor ((p(c + 2) >> 8) or (p(c + 3) << 24)) Xor (p(d + 2) << 20)
            y = p(a + 1) Xor (p(a + 1) << 8) Xor (p(a) >> 24) Xor ((p(b + 1) >> 5) And &HEEFFFB37)
            p(a + 1) = y Xor ((p(c + 1) >> 8) or (p(c + 2) << 24)) Xor (p(d + 1) << 20)
            y = p(a) Xor (p(a) << 8) Xor ((p(b) >> 5) And &HFDDFBF9F)
            p(a) = y Xor ((p(c) >> 8) or (p(c + 1) << 24)) Xor (p(d) << 20)
            c = d : d = a : a += 4 : b += 4
            If b = 40 Then b = 0
        Loop While a <> 40
    End Sub

    Sub New(ByVal s As UInteger)
        MyBase.New(s)
    End Sub

    Sub New(ByVal init_key As UInteger())
        MyBase.New(init_key)
    End Sub

End Class

Class Sfmt5
    Inherits Sfmt

    Public readonly Overrides Property IdString() As String
        Get
            Return "SFMT-1279:5-15-3-12-1:fddf9f97-f97fbff7-7fbfbff7-bfbf1fff"
        End Get
    End Property

    Private Shared ParityData As UInteger() = {&H1&, &H0&, &H0&, &H20000000&}

    Protected Overrides Function GetParity() As UInteger()
        Return ParityData
    End Function

    Protected overrides Sub gen_rand_all()
        Dim a As Integer = 0 : Dim b As Integer = 20 : Dim c As Integer = 32
        Dim d As Integer = 36 : Dim y As UInteger : Dim p As UInteger() = x

        Do
            y = p(a + 3) Xor (p(a + 3) << 24) Xor (p(a + 2) >> 8) Xor ((p(b + 3) >> 12) And &HBFBF1FFF)
            p(a + 3) = y Xor (p(c + 3) >> 8) Xor (p(d + 3) << 15)
            y = p(a + 2) Xor (p(a + 2) << 24) Xor (p(a + 1) >> 8) Xor ((p(b + 2) >> 12) And &H7FBFBFF7)
            p(a + 2) = y Xor ((p(c + 2) >> 8) or (p(c + 3) << 24)) Xor (p(d + 2) << 15)
            y = p(a + 1) Xor (p(a + 1) << 24) Xor (p(a) >> 8) Xor ((p(b + 1) >> 12) And &HF97FBFF7)
            p(a + 1) = y Xor ((p(c + 1) >> 8) or (p(c + 2) << 24)) Xor (p(d + 1) << 15)
            y = p(a) Xor (p(a) << 24) Xor ((p(b) >> 12) And &HFDDF9F97)
            p(a) = y Xor ((p(c) >> 8) or (p(c + 1) << 24)) Xor (p(d) << 15)
            c = d : d = a : a += 4 : b += 4
            If b = 40 Then b = 0
        Loop While a <> 40
    End Sub

    Sub New(ByVal s As UInteger)
        MyBase.New(s)
    End Sub

    Sub New(ByVal init_key As UInteger())
        MyBase.New(init_key)
    End Sub

End Class

Class Sfmt6
    Inherits Sfmt

    Public readonly Overrides Property IdString() As String
        Get
            Return "SFMT-1279:6-13-3-21-1:fffbffff-fffe96ef-edd7ff2f-f5f7f8ed"
        End Get
    End Property

    Private Shared ParityData As UInteger() = {&H1&, &H0&, &H0&, &H40000000&}

    Protected Overrides Function GetParity() As UInteger()
        Return ParityData
    End Function

    Protected overrides Sub gen_rand_all()
        Dim a As Integer = 0 : Dim b As Integer = 24 : Dim c As Integer = 32
        Dim d As Integer = 36 : Dim y As UInteger : Dim p As UInteger() = x

        Do
            y = p(a + 3) Xor (p(a + 3) << 24) Xor (p(a + 2) >> 8) Xor ((p(b + 3) >> 21) And &HF5F7F8ED)
            p(a + 3) = y Xor (p(c + 3) >> 8) Xor (p(d + 3) << 13)
            y = p(a + 2) Xor (p(a + 2) << 24) Xor (p(a + 1) >> 8) Xor ((p(b + 2) >> 21) And &HEDD7FF2F)
            p(a + 2) = y Xor ((p(c + 2) >> 8) or (p(c + 3) << 24)) Xor (p(d + 2) << 13)
            y = p(a + 1) Xor (p(a + 1) << 24) Xor (p(a) >> 8) Xor ((p(b + 1) >> 21) And &HFFFE96EF)
            p(a + 1) = y Xor ((p(c + 1) >> 8) or (p(c + 2) << 24)) Xor (p(d + 1) << 13)
            y = p(a) Xor (p(a) << 24) Xor ((p(b) >> 21) And &HFFFBFFFF)
            p(a) = y Xor ((p(c) >> 8) or (p(c + 1) << 24)) Xor (p(d) << 13)
            c = d : d = a : a += 4 : b += 4
            If b = 40 Then b = 0
        Loop While a <> 40
    End Sub

    Sub New(ByVal s As UInteger)
        MyBase.New(s)
    End Sub

    Sub New(ByVal init_key As UInteger())
        MyBase.New(init_key)
    End Sub

End Class

Class Sfmt7
    Inherits Sfmt

    Public readonly Overrides Property IdString() As String
        Get
            Return "SFMT-1279:6-17-3-5-3:afffffff-ff37bffb-e7bdffdd-fffdffdd"
        End Get
    End Property

    Private Shared ParityData As UInteger() = {&H1&, &H0&, &H0&, &H80000000&}

    Protected Overrides Function GetParity() As UInteger()
        Return ParityData
    End Function

    Protected overrides Sub gen_rand_all()
        Dim a As Integer = 0 : Dim b As Integer = 24 : Dim c As Integer = 32
        Dim d As Integer = 36 : Dim y As UInteger : Dim p As UInteger() = x

        Do
            y = p(a + 3) Xor (p(a + 3) << 24) Xor (p(a + 2) >> 8) Xor ((p(b + 3) >> 5) And &HFFFDFFDD)
            p(a + 3) = y Xor (p(c + 3) >> 24) Xor (p(d + 3) << 17)
            y = p(a + 2) Xor (p(a + 2) << 24) Xor (p(a + 1) >> 8) Xor ((p(b + 2) >> 5) And &HE7BDFFDD)
            p(a + 2) = y Xor ((p(c + 2) >> 24) or (p(c + 3) << 8)) Xor (p(d + 2) << 17)
            y = p(a + 1) Xor (p(a + 1) << 24) Xor (p(a) >> 8) Xor ((p(b + 1) >> 5) And &HFF37BFFB)
            p(a + 1) = y Xor ((p(c + 1) >> 24) or (p(c + 2) << 8)) Xor (p(d + 1) << 17)
            y = p(a) Xor (p(a) << 24) Xor ((p(b) >> 5) And &HAFFFFFFF)
            p(a) = y Xor ((p(c) >> 24) or (p(c + 1) << 8)) Xor (p(d) << 17)
            c = d : d = a : a += 4 : b += 4
            If b = 40 Then b = 0
        Loop While a <> 40
    End Sub

    Sub New(ByVal s As UInteger)
        MyBase.New(s)
    End Sub

    Sub New(ByVal init_key As UInteger())
        MyBase.New(init_key)
    End Sub

End Class

Class Sfmt8
    Inherits Sfmt

    Public readonly Overrides Property IdString() As String
        Get
            Return "SFMT-1279:2-18-1-11-1:deffffef-deb7effb-df77defe-dfdfd5cf"
        End Get
    End Property

    Private Shared ParityData As UInteger() = {&H1&, &H0&, &H0&, &H40000000&}

    Protected Overrides Function GetParity() As UInteger()
        Return ParityData
    End Function

    Protected overrides Sub gen_rand_all()
        Dim a As Integer = 0 : Dim b As Integer = 8 : Dim c As Integer = 32
        Dim d As Integer = 36 : Dim y As UInteger : Dim p As UInteger() = x

        Do
            y = p(a + 3) Xor (p(a + 3) << 8) Xor (p(a + 2) >> 24) Xor ((p(b + 3) >> 11) And &HDFDFD5CF)
            p(a + 3) = y Xor (p(c + 3) >> 8) Xor (p(d + 3) << 18)
            y = p(a + 2) Xor (p(a + 2) << 8) Xor (p(a + 1) >> 24) Xor ((p(b + 2) >> 11) And &HDF77DEFE)
            p(a + 2) = y Xor ((p(c + 2) >> 8) or (p(c + 3) << 24)) Xor (p(d + 2) << 18)
            y = p(a + 1) Xor (p(a + 1) << 8) Xor (p(a) >> 24) Xor ((p(b + 1) >> 11) And &HDEB7EFFB)
            p(a + 1) = y Xor ((p(c + 1) >> 8) or (p(c + 2) << 24)) Xor (p(d + 1) << 18)
            y = p(a) Xor (p(a) << 8) Xor ((p(b) >> 11) And &HDEFFFFEF)
            p(a) = y Xor ((p(c) >> 8) or (p(c + 1) << 24)) Xor (p(d) << 18)
            c = d : d = a : a += 4 : b += 4
            If b = 40 Then b = 0
        Loop While a <> 40
    End Sub

    Sub New(ByVal s As UInteger)
        MyBase.New(s)
    End Sub

    Sub New(ByVal init_key As UInteger())
        MyBase.New(init_key)
    End Sub

End Class

Class Sfmt9
    Inherits Sfmt

    Public readonly Overrides Property IdString() As String
        Get
            Return "SFMT-1279:8-21-1-3-7:fffdfdfe-fbbffeff-ef6fffff-ff7f76ef"
        End Get
    End Property

    Private Shared ParityData As UInteger() = {&H1&, &H0&, &H0&, &H0&}

    Protected Overrides Function GetParity() As UInteger()
        Return ParityData
    End Function

    Protected overrides Sub gen_rand_all()
        Dim a As Integer = 0 : Dim b As Integer = 32 : Dim c As Integer = 32
        Dim d As Integer = 36 : Dim y As UInteger : Dim p As UInteger() = x

        Do
            y = p(a + 3) Xor (p(a + 3) << 8) Xor (p(a + 2) >> 24) Xor ((p(b + 3) >> 3) And &HFF7F76EF)
            p(a + 3) = y Xor (p(d + 3) << 21)
            y = p(a + 2) Xor (p(a + 2) << 8) Xor (p(a + 1) >> 24) Xor ((p(b + 2) >> 3) And &HEF6FFFFF)
            p(a + 2) = y Xor (p(c + 3) >> 24) Xor (p(d + 2) << 21)
            y = p(a + 1) Xor (p(a + 1) << 8) Xor (p(a) >> 24) Xor ((p(b + 1) >> 3) And &HFBBFFEFF)
            p(a + 1) = y Xor ((p(c + 2) >> 24) or (p(c + 3) << 8)) Xor (p(d + 1) << 21)
            y = p(a) Xor (p(a) << 8) Xor ((p(b) >> 3) And &HFFFDFDFE)
            p(a) = y Xor ((p(c + 1) >> 24) or (p(c + 2) << 8)) Xor (p(d) << 21)
            c = d : d = a : a += 4 : b += 4
            If b = 40 Then b = 0
        Loop While a <> 40
    End Sub

    Sub New(ByVal s As UInteger)
        MyBase.New(s)
    End Sub

    Sub New(ByVal init_key As UInteger())
        MyBase.New(init_key)
    End Sub

End Class

Class Sfmt10
    Inherits Sfmt

    Public readonly Overrides Property IdString() As String
        Get
            Return "SFMT-1279:1-25-1-6-1:eff6fded-fffffdfc-ffffbfff-cfefffff"
        End Get
    End Property

    Private Shared ParityData As UInteger() = {&H1&, &H0&, &H0&, &H0&}

    Protected Overrides Function GetParity() As UInteger()
        Return ParityData
    End Function

    Protected overrides Sub gen_rand_all()
        Dim a As Integer = 0 : Dim b As Integer = 4 : Dim c As Integer = 32
        Dim d As Integer = 36 : Dim y As UInteger : Dim p As UInteger() = x

        Do
            y = p(a + 3) Xor (p(a + 3) << 8) Xor (p(a + 2) >> 24) Xor ((p(b + 3) >> 6) And &HCFEFFFFF)
            p(a + 3) = y Xor (p(c + 3) >> 8) Xor (p(d + 3) << 25)
            y = p(a + 2) Xor (p(a + 2) << 8) Xor (p(a + 1) >> 24) Xor ((p(b + 2) >> 6) And &HFFFFBFFF)
            p(a + 2) = y Xor ((p(c + 2) >> 8) or (p(c + 3) << 24)) Xor (p(d + 2) << 25)
            y = p(a + 1) Xor (p(a + 1) << 8) Xor (p(a) >> 24) Xor ((p(b + 1) >> 6) And &HFFFFFDFC)
            p(a + 1) = y Xor ((p(c + 1) >> 8) or (p(c + 2) << 24)) Xor (p(d + 1) << 25)
            y = p(a) Xor (p(a) << 8) Xor ((p(b) >> 6) And &HEFF6FDED)
            p(a) = y Xor ((p(c) >> 8) or (p(c + 1) << 24)) Xor (p(d) << 25)
            c = d : d = a : a += 4 : b += 4
            If b = 40 Then b = 0
        Loop While a <> 40
    End Sub

    Sub New(ByVal s As UInteger)
        MyBase.New(s)
    End Sub

    Sub New(ByVal init_key As UInteger())
        MyBase.New(init_key)
    End Sub

End Class

Class Sfmt11
    Inherits Sfmt

    Public readonly Overrides Property IdString() As String
        Get
            Return "SFMT-1279:1-6-3-13-3:ffeecff3-ffffedff-dbf7bfff-d1ffdffd"
        End Get
    End Property

    Private Shared ParityData As UInteger() = {&H1&, &H0&, &H0&, &H20000000&}

    Protected Overrides Function GetParity() As UInteger()
        Return ParityData
    End Function

    Protected overrides Sub gen_rand_all()
        Dim a As Integer = 0 : Dim b As Integer = 4 : Dim c As Integer = 32
        Dim d As Integer = 36 : Dim y As UInteger : Dim p As UInteger() = x

        Do
            y = p(a + 3) Xor (p(a + 3) << 24) Xor (p(a + 2) >> 8) Xor ((p(b + 3) >> 13) And &HD1FFDFFD)
            p(a + 3) = y Xor (p(c + 3) >> 24) Xor (p(d + 3) << 6)
            y = p(a + 2) Xor (p(a + 2) << 24) Xor (p(a + 1) >> 8) Xor ((p(b + 2) >> 13) And &HDBF7BFFF)
            p(a + 2) = y Xor ((p(c + 2) >> 24) or (p(c + 3) << 8)) Xor (p(d + 2) << 6)
            y = p(a + 1) Xor (p(a + 1) << 24) Xor (p(a) >> 8) Xor ((p(b + 1) >> 13) And &HFFFFEDFF)
            p(a + 1) = y Xor ((p(c + 1) >> 24) or (p(c + 2) << 8)) Xor (p(d + 1) << 6)
            y = p(a) Xor (p(a) << 24) Xor ((p(b) >> 13) And &HFFEECFF3)
            p(a) = y Xor ((p(c) >> 24) or (p(c + 1) << 8)) Xor (p(d) << 6)
            c = d : d = a : a += 4 : b += 4
            If b = 40 Then b = 0
        Loop While a <> 40
    End Sub

    Sub New(ByVal s As UInteger)
        MyBase.New(s)
    End Sub

    Sub New(ByVal init_key As UInteger())
        MyBase.New(init_key)
    End Sub

End Class

Class Sfmt12
    Inherits Sfmt

    Public readonly Overrides Property IdString() As String
        Get
            Return "SFMT-1279:8-6-3-9-1:effff777-eefbfdff-feffffff-fff7fffe"
        End Get
    End Property

    Private Shared ParityData As UInteger() = {&H1&, &H0&, &H0&, &H80000000&}

    Protected Overrides Function GetParity() As UInteger()
        Return ParityData
    End Function

    Protected overrides Sub gen_rand_all()
        Dim a As Integer = 0 : Dim b As Integer = 32 : Dim c As Integer = 32
        Dim d As Integer = 36 : Dim y As UInteger : Dim p As UInteger() = x

        Do
            y = p(a + 3) Xor (p(a + 3) << 24) Xor (p(a + 2) >> 8) Xor ((p(b + 3) >> 9) And &HFFF7FFFE)
            p(a + 3) = y Xor (p(c + 3) >> 8) Xor (p(d + 3) << 6)
            y = p(a + 2) Xor (p(a + 2) << 24) Xor (p(a + 1) >> 8) Xor ((p(b + 2) >> 9) And &HFEFFFFFF)
            p(a + 2) = y Xor ((p(c + 2) >> 8) or (p(c + 3) << 24)) Xor (p(d + 2) << 6)
            y = p(a + 1) Xor (p(a + 1) << 24) Xor (p(a) >> 8) Xor ((p(b + 1) >> 9) And &HEEFBFDFF)
            p(a + 1) = y Xor ((p(c + 1) >> 8) or (p(c + 2) << 24)) Xor (p(d + 1) << 6)
            y = p(a) Xor (p(a) << 24) Xor ((p(b) >> 9) And &HEFFFF777)
            p(a) = y Xor ((p(c) >> 8) or (p(c + 1) << 24)) Xor (p(d) << 6)
            c = d : d = a : a += 4 : b += 4
            If b = 40 Then b = 0
        Loop While a <> 40
    End Sub

    Sub New(ByVal s As UInteger)
        MyBase.New(s)
    End Sub

    Sub New(ByVal init_key As UInteger())
        MyBase.New(init_key)
    End Sub

End Class

Class Sfmt13
    Inherits Sfmt

    Public readonly Overrides Property IdString() As String
        Get
            Return "SFMT-1279:3-13-3-12-5:ffdf7ff7-fff4ffef-edfe5fef-ff7fdfff"
        End Get
    End Property

    Private Shared ParityData As UInteger() = {&H1&, &H0&, &H0&, &H80000000&}

    Protected Overrides Function GetParity() As UInteger()
        Return ParityData
    End Function

    Protected overrides Sub gen_rand_all()
        Dim a As Integer = 0 : Dim b As Integer = 12 : Dim c As Integer = 32
        Dim d As Integer = 36 : Dim y As UInteger : Dim p As UInteger() = x

        Do
            y = p(a + 3) Xor (p(a + 3) << 24) Xor (p(a + 2) >> 8) Xor ((p(b + 3) >> 12) And &HFF7FDFFF)
            p(a + 3) = y Xor (p(d + 3) << 13)
            y = p(a + 2) Xor (p(a + 2) << 24) Xor (p(a + 1) >> 8) Xor ((p(b + 2) >> 12) And &HEDFE5FEF)
            p(a + 2) = y Xor (p(c + 3) >> 8) Xor (p(d + 2) << 13)
            y = p(a + 1) Xor (p(a + 1) << 24) Xor (p(a) >> 8) Xor ((p(b + 1) >> 12) And &HFFF4FFEF)
            p(a + 1) = y Xor ((p(c + 2) >> 8) or (p(c + 3) << 24)) Xor (p(d + 1) << 13)
            y = p(a) Xor (p(a) << 24) Xor ((p(b) >> 12) And &HFFDF7FF7)
            p(a) = y Xor ((p(c + 1) >> 8) or (p(c + 2) << 24)) Xor (p(d) << 13)
            c = d : d = a : a += 4 : b += 4
            If b = 40 Then b = 0
        Loop While a <> 40
    End Sub

    Sub New(ByVal s As UInteger)
        MyBase.New(s)
    End Sub

    Sub New(ByVal init_key As UInteger())
        MyBase.New(init_key)
    End Sub

End Class

Class Sfmt14
    Inherits Sfmt

    Public readonly Overrides Property IdString() As String
        Get
            Return "SFMT-1279:1-19-3-4-1:ff7fffff-fffbfd7f-ffefffea-fddfdfde"
        End Get
    End Property

    Private Shared ParityData As UInteger() = {&H1&, &H0&, &H0&, &H40000000&}

    Protected Overrides Function GetParity() As UInteger()
        Return ParityData
    End Function

    Protected overrides Sub gen_rand_all()
        Dim a As Integer = 0 : Dim b As Integer = 4 : Dim c As Integer = 32
        Dim d As Integer = 36 : Dim y As UInteger : Dim p As UInteger() = x

        Do
            y = p(a + 3) Xor (p(a + 3) << 24) Xor (p(a + 2) >> 8) Xor ((p(b + 3) >> 4) And &HFDDFDFDE)
            p(a + 3) = y Xor (p(c + 3) >> 8) Xor (p(d + 3) << 19)
            y = p(a + 2) Xor (p(a + 2) << 24) Xor (p(a + 1) >> 8) Xor ((p(b + 2) >> 4) And &HFFEFFFEA)
            p(a + 2) = y Xor ((p(c + 2) >> 8) or (p(c + 3) << 24)) Xor (p(d + 2) << 19)
            y = p(a + 1) Xor (p(a + 1) << 24) Xor (p(a) >> 8) Xor ((p(b + 1) >> 4) And &HFFFBFD7F)
            p(a + 1) = y Xor ((p(c + 1) >> 8) or (p(c + 2) << 24)) Xor (p(d + 1) << 19)
            y = p(a) Xor (p(a) << 24) Xor ((p(b) >> 4) And &HFF7FFFFF)
            p(a) = y Xor ((p(c) >> 8) or (p(c + 1) << 24)) Xor (p(d) << 19)
            c = d : d = a : a += 4 : b += 4
            If b = 40 Then b = 0
        Loop While a <> 40
    End Sub

    Sub New(ByVal s As UInteger)
        MyBase.New(s)
    End Sub

    Sub New(ByVal init_key As UInteger())
        MyBase.New(init_key)
    End Sub

End Class

Class Sfmt15
    Inherits Sfmt

    Public readonly Overrides Property IdString() As String
        Get
            Return "SFMT-1279:8-6-3-3-5:f7f9f7dd-b7f7beff-f7ffdf7f-ffdff7f9"
        End Get
    End Property

    Private Shared ParityData As UInteger() = {&H1&, &H0&, &H0&, &H80000000&}

    Protected Overrides Function GetParity() As UInteger()
        Return ParityData
    End Function

    Protected overrides Sub gen_rand_all()
        Dim a As Integer = 0 : Dim b As Integer = 32 : Dim c As Integer = 32
        Dim d As Integer = 36 : Dim y As UInteger : Dim p As UInteger() = x

        Do
            y = p(a + 3) Xor (p(a + 3) << 24) Xor (p(a + 2) >> 8) Xor ((p(b + 3) >> 3) And &HFFDFF7F9)
            p(a + 3) = y Xor (p(d + 3) << 6)
            y = p(a + 2) Xor (p(a + 2) << 24) Xor (p(a + 1) >> 8) Xor ((p(b + 2) >> 3) And &HF7FFDF7F)
            p(a + 2) = y Xor (p(c + 3) >> 8) Xor (p(d + 2) << 6)
            y = p(a + 1) Xor (p(a + 1) << 24) Xor (p(a) >> 8) Xor ((p(b + 1) >> 3) And &HB7F7BEFF)
            p(a + 1) = y Xor ((p(c + 2) >> 8) or (p(c + 3) << 24)) Xor (p(d + 1) << 6)
            y = p(a) Xor (p(a) << 24) Xor ((p(b) >> 3) And &HF7F9F7DD)
            p(a) = y Xor ((p(c + 1) >> 8) or (p(c + 2) << 24)) Xor (p(d) << 6)
            c = d : d = a : a += 4 : b += 4
            If b = 40 Then b = 0
        Loop While a <> 40
    End Sub

    Sub New(ByVal s As UInteger)
        MyBase.New(s)
    End Sub

    Sub New(ByVal init_key As UInteger())
        MyBase.New(init_key)
    End Sub

End Class

Class Sfmt16
    Inherits Sfmt

    Public readonly Overrides Property IdString() As String
        Get
            Return "SFMT-1279:6-5-3-3-3:dfefeffd-dfffffbf-deffb9f7-fffffef7"
        End Get
    End Property

    Private Shared ParityData As UInteger() = {&H1&, &H0&, &H0&, &H80000000&}

    Protected Overrides Function GetParity() As UInteger()
        Return ParityData
    End Function

    Protected overrides Sub gen_rand_all()
        Dim a As Integer = 0 : Dim b As Integer = 24 : Dim c As Integer = 32
        Dim d As Integer = 36 : Dim y As UInteger : Dim p As UInteger() = x

        Do
            y = p(a + 3) Xor (p(a + 3) << 24) Xor (p(a + 2) >> 8) Xor ((p(b + 3) >> 3) And &HFFFFFEF7)
            p(a + 3) = y Xor (p(c + 3) >> 24) Xor (p(d + 3) << 5)
            y = p(a + 2) Xor (p(a + 2) << 24) Xor (p(a + 1) >> 8) Xor ((p(b + 2) >> 3) And &HDEFFB9F7)
            p(a + 2) = y Xor ((p(c + 2) >> 24) or (p(c + 3) << 8)) Xor (p(d + 2) << 5)
            y = p(a + 1) Xor (p(a + 1) << 24) Xor (p(a) >> 8) Xor ((p(b + 1) >> 3) And &HDFFFFFBF)
            p(a + 1) = y Xor ((p(c + 1) >> 24) or (p(c + 2) << 8)) Xor (p(d + 1) << 5)
            y = p(a) Xor (p(a) << 24) Xor ((p(b) >> 3) And &HDFEFEFFD)
            p(a) = y Xor ((p(c) >> 24) or (p(c + 1) << 8)) Xor (p(d) << 5)
            c = d : d = a : a += 4 : b += 4
            If b = 40 Then b = 0
        Loop While a <> 40
    End Sub

    Sub New(ByVal s As UInteger)
        MyBase.New(s)
    End Sub

    Sub New(ByVal init_key As UInteger())
        MyBase.New(init_key)
    End Sub

End Class

Class Sfmt17
    Inherits Sfmt

    Public readonly Overrides Property IdString() As String
        Get
            Return "SFMT-1279:2-19-3-13-3:fff97fff-6bfff7fe-dafffb7d-efffffff"
        End Get
    End Property

    Private Shared ParityData As UInteger() = {&H1&, &H0&, &H0&, &H0&}

    Protected Overrides Function GetParity() As UInteger()
        Return ParityData
    End Function

    Protected overrides Sub gen_rand_all()
        Dim a As Integer = 0 : Dim b As Integer = 8 : Dim c As Integer = 32
        Dim d As Integer = 36 : Dim y As UInteger : Dim p As UInteger() = x

        Do
            y = p(a + 3) Xor (p(a + 3) << 24) Xor (p(a + 2) >> 8) Xor ((p(b + 3) >> 13) And &HEFFFFFFF)
            p(a + 3) = y Xor (p(c + 3) >> 24) Xor (p(d + 3) << 19)
            y = p(a + 2) Xor (p(a + 2) << 24) Xor (p(a + 1) >> 8) Xor ((p(b + 2) >> 13) And &HDAFFFB7D)
            p(a + 2) = y Xor ((p(c + 2) >> 24) or (p(c + 3) << 8)) Xor (p(d + 2) << 19)
            y = p(a + 1) Xor (p(a + 1) << 24) Xor (p(a) >> 8) Xor ((p(b + 1) >> 13) And &H6BFFF7FE)
            p(a + 1) = y Xor ((p(c + 1) >> 24) or (p(c + 2) << 8)) Xor (p(d + 1) << 19)
            y = p(a) Xor (p(a) << 24) Xor ((p(b) >> 13) And &HFFF97FFF)
            p(a) = y Xor ((p(c) >> 24) or (p(c + 1) << 8)) Xor (p(d) << 19)
            c = d : d = a : a += 4 : b += 4
            If b = 40 Then b = 0
        Loop While a <> 40
    End Sub

    Sub New(ByVal s As UInteger)
        MyBase.New(s)
    End Sub

    Sub New(ByVal init_key As UInteger())
        MyBase.New(init_key)
    End Sub

End Class

Class Sfmt18
    Inherits Sfmt

    Public readonly Overrides Property IdString() As String
        Get
            Return "SFMT-1279:7-13-7-2-1:7df7ffff-dfd7ff7f-f7f2b3dd-e77ffddf"
        End Get
    End Property

    Private Shared ParityData As UInteger() = {&H1&, &H0&, &H0&, &H0&}

    Protected Overrides Function GetParity() As UInteger()
        Return ParityData
    End Function

    Protected overrides Sub gen_rand_all()
        Dim a As Integer = 0 : Dim b As Integer = 28 : Dim c As Integer = 32
        Dim d As Integer = 36 : Dim y As UInteger : Dim p As UInteger() = x

        Do
            y = p(a + 3) Xor (p(a + 2) << 24) Xor (p(a + 1) >> 8) Xor ((p(b + 3) >> 2) And &HE77FFDDF)
            p(a + 3) = y Xor (p(c + 3) >> 8) Xor (p(d + 3) << 13)
            y = p(a + 2) Xor (p(a + 1) << 24) Xor (p(a) >> 8) Xor ((p(b + 2) >> 2) And &HF7F2B3DD)
            p(a + 2) = y Xor ((p(c + 2) >> 8) or (p(c + 3) << 24)) Xor (p(d + 2) << 13)
            y = p(a + 1) Xor (p(a) << 24) Xor ((p(b + 1) >> 2) And &HDFD7FF7F)
            p(a + 1) = y Xor ((p(c + 1) >> 8) or (p(c + 2) << 24)) Xor (p(d + 1) << 13)
            y = p(a) Xor ((p(b) >> 2) And &H7DF7FFFF)
            p(a) = y Xor ((p(c) >> 8) or (p(c + 1) << 24)) Xor (p(d) << 13)
            c = d : d = a : a += 4 : b += 4
            If b = 40 Then b = 0
        Loop While a <> 40
    End Sub

    Sub New(ByVal s As UInteger)
        MyBase.New(s)
    End Sub

    Sub New(ByVal init_key As UInteger())
        MyBase.New(init_key)
    End Sub

End Class

Class Sfmt19
    Inherits Sfmt

    Public readonly Overrides Property IdString() As String
        Get
            Return "SFMT-1279:8-6-7-5-1:df7ffaff-dffaffff-fdd5bfef-ffd7bfdd"
        End Get
    End Property

    Private Shared ParityData As UInteger() = {&H1&, &H0&, &H0&, &H80000000&}

    Protected Overrides Function GetParity() As UInteger()
        Return ParityData
    End Function

    Protected overrides Sub gen_rand_all()
        Dim a As Integer = 0 : Dim b As Integer = 32 : Dim c As Integer = 32
        Dim d As Integer = 36 : Dim y As UInteger : Dim p As UInteger() = x

        Do
            y = p(a + 3) Xor (p(a + 2) << 24) Xor (p(a + 1) >> 8) Xor ((p(b + 3) >> 5) And &HFFD7BFDD)
            p(a + 3) = y Xor (p(c + 3) >> 8) Xor (p(d + 3) << 6)
            y = p(a + 2) Xor (p(a + 1) << 24) Xor (p(a) >> 8) Xor ((p(b + 2) >> 5) And &HFDD5BFEF)
            p(a + 2) = y Xor ((p(c + 2) >> 8) or (p(c + 3) << 24)) Xor (p(d + 2) << 6)
            y = p(a + 1) Xor (p(a) << 24) Xor ((p(b + 1) >> 5) And &HDFFAFFFF)
            p(a + 1) = y Xor ((p(c + 1) >> 8) or (p(c + 2) << 24)) Xor (p(d + 1) << 6)
            y = p(a) Xor ((p(b) >> 5) And &HDF7FFAFF)
            p(a) = y Xor ((p(c) >> 8) or (p(c + 1) << 24)) Xor (p(d) << 6)
            c = d : d = a : a += 4 : b += 4
            If b = 40 Then b = 0
        Loop While a <> 40
    End Sub

    Sub New(ByVal s As UInteger)
        MyBase.New(s)
    End Sub

    Sub New(ByVal init_key As UInteger())
        MyBase.New(init_key)
    End Sub

End Class

Class Sfmt20
    Inherits Sfmt

    Public readonly Overrides Property IdString() As String
        Get
            Return "SFMT-1279:6-13-1-1-7:fddbffff-ebffdffc-ffeff7fd-dfdffeff"
        End Get
    End Property

    Private Shared ParityData As UInteger() = {&H1&, &H0&, &H0&, &H10000000&}

    Protected Overrides Function GetParity() As UInteger()
        Return ParityData
    End Function

    Protected overrides Sub gen_rand_all()
        Dim a As Integer = 0 : Dim b As Integer = 24 : Dim c As Integer = 32
        Dim d As Integer = 36 : Dim y As UInteger : Dim p As UInteger() = x

        Do
            y = p(a + 3) Xor (p(a + 3) << 8) Xor (p(a + 2) >> 24) Xor ((p(b + 3) >> 1) And &HDFDFFEFF)
            p(a + 3) = y Xor (p(d + 3) << 13)
            y = p(a + 2) Xor (p(a + 2) << 8) Xor (p(a + 1) >> 24) Xor ((p(b + 2) >> 1) And &HFFEFF7FD)
            p(a + 2) = y Xor (p(c + 3) >> 24) Xor (p(d + 2) << 13)
            y = p(a + 1) Xor (p(a + 1) << 8) Xor (p(a) >> 24) Xor ((p(b + 1) >> 1) And &HEBFFDFFC)
            p(a + 1) = y Xor ((p(c + 2) >> 24) or (p(c + 3) << 8)) Xor (p(d + 1) << 13)
            y = p(a) Xor (p(a) << 8) Xor ((p(b) >> 1) And &HFDDBFFFF)
            p(a) = y Xor ((p(c + 1) >> 24) or (p(c + 2) << 8)) Xor (p(d) << 13)
            c = d : d = a : a += 4 : b += 4
            If b = 40 Then b = 0
        Loop While a <> 40
    End Sub

    Sub New(ByVal s As UInteger)
        MyBase.New(s)
    End Sub

    Sub New(ByVal init_key As UInteger())
        MyBase.New(init_key)
    End Sub

End Class

Class Sfmt21
    Inherits Sfmt

    Public readonly Overrides Property IdString() As String
        Get
            Return "SFMT-1279:7-27-1-2-1:fffb67ff-defbe67b-ef1fffff-3effff8f"
        End Get
    End Property

    Private Shared ParityData As UInteger() = {&H1&, &H0&, &H0&, &H80000000&}

    Protected Overrides Function GetParity() As UInteger()
        Return ParityData
    End Function

    Protected overrides Sub gen_rand_all()
        Dim a As Integer = 0 : Dim b As Integer = 28 : Dim c As Integer = 32
        Dim d As Integer = 36 : Dim y As UInteger : Dim p As UInteger() = x

        Do
            y = p(a + 3) Xor (p(a + 3) << 8) Xor (p(a + 2) >> 24) Xor ((p(b + 3) >> 2) And &H3EFFFF8F)
            p(a + 3) = y Xor (p(c + 3) >> 8) Xor (p(d + 3) << 27)
            y = p(a + 2) Xor (p(a + 2) << 8) Xor (p(a + 1) >> 24) Xor ((p(b + 2) >> 2) And &HEF1FFFFF)
            p(a + 2) = y Xor ((p(c + 2) >> 8) or (p(c + 3) << 24)) Xor (p(d + 2) << 27)
            y = p(a + 1) Xor (p(a + 1) << 8) Xor (p(a) >> 24) Xor ((p(b + 1) >> 2) And &HDEFBE67B)
            p(a + 1) = y Xor ((p(c + 1) >> 8) or (p(c + 2) << 24)) Xor (p(d + 1) << 27)
            y = p(a) Xor (p(a) << 8) Xor ((p(b) >> 2) And &HFFFB67FF)
            p(a) = y Xor ((p(c) >> 8) or (p(c + 1) << 24)) Xor (p(d) << 27)
            c = d : d = a : a += 4 : b += 4
            If b = 40 Then b = 0
        Loop While a <> 40
    End Sub

    Sub New(ByVal s As UInteger)
        MyBase.New(s)
    End Sub

    Sub New(ByVal init_key As UInteger())
        MyBase.New(init_key)
    End Sub

End Class

Class Sfmt22
    Inherits Sfmt

    Public readonly Overrides Property IdString() As String
        Get
            Return "SFMT-1279:4-26-1-3-1:fffdfffa-ffffbfeb-fffdff9a-bfffffdf"
        End Get
    End Property

    Private Shared ParityData As UInteger() = {&H1&, &H0&, &H0&, &H0&}

    Protected Overrides Function GetParity() As UInteger()
        Return ParityData
    End Function

    Protected overrides Sub gen_rand_all()
        Dim a As Integer = 0 : Dim b As Integer = 16 : Dim c As Integer = 32
        Dim d As Integer = 36 : Dim y As UInteger : Dim p As UInteger() = x

        Do
            y = p(a + 3) Xor (p(a + 3) << 8) Xor (p(a + 2) >> 24) Xor ((p(b + 3) >> 3) And &HBFFFFFDF)
            p(a + 3) = y Xor (p(c + 3) >> 8) Xor (p(d + 3) << 26)
            y = p(a + 2) Xor (p(a + 2) << 8) Xor (p(a + 1) >> 24) Xor ((p(b + 2) >> 3) And &HFFFDFF9A)
            p(a + 2) = y Xor ((p(c + 2) >> 8) or (p(c + 3) << 24)) Xor (p(d + 2) << 26)
            y = p(a + 1) Xor (p(a + 1) << 8) Xor (p(a) >> 24) Xor ((p(b + 1) >> 3) And &HFFFFBFEB)
            p(a + 1) = y Xor ((p(c + 1) >> 8) or (p(c + 2) << 24)) Xor (p(d + 1) << 26)
            y = p(a) Xor (p(a) << 8) Xor ((p(b) >> 3) And &HFFFDFFFA)
            p(a) = y Xor ((p(c) >> 8) or (p(c + 1) << 24)) Xor (p(d) << 26)
            c = d : d = a : a += 4 : b += 4
            If b = 40 Then b = 0
        Loop While a <> 40
    End Sub

    Sub New(ByVal s As UInteger)
        MyBase.New(s)
    End Sub

    Sub New(ByVal init_key As UInteger())
        MyBase.New(init_key)
    End Sub

End Class

Class Sfmt23
    Inherits Sfmt

    Public readonly Overrides Property IdString() As String
        Get
            Return "SFMT-1279:7-11-3-12-5:fdfeedff-dffcfff7-7bdffffe-ffdfffea"
        End Get
    End Property

    Private Shared ParityData As UInteger() = {&H1&, &H0&, &H0&, &H0&}

    Protected Overrides Function GetParity() As UInteger()
        Return ParityData
    End Function

    Protected overrides Sub gen_rand_all()
        Dim a As Integer = 0 : Dim b As Integer = 28 : Dim c As Integer = 32
        Dim d As Integer = 36 : Dim y As UInteger : Dim p As UInteger() = x

        Do
            y = p(a + 3) Xor (p(a + 3) << 24) Xor (p(a + 2) >> 8) Xor ((p(b + 3) >> 12) And &HFFDFFFEA)
            p(a + 3) = y Xor (p(d + 3) << 11)
            y = p(a + 2) Xor (p(a + 2) << 24) Xor (p(a + 1) >> 8) Xor ((p(b + 2) >> 12) And &H7BDFFFFE)
            p(a + 2) = y Xor (p(c + 3) >> 8) Xor (p(d + 2) << 11)
            y = p(a + 1) Xor (p(a + 1) << 24) Xor (p(a) >> 8) Xor ((p(b + 1) >> 12) And &HDFFCFFF7)
            p(a + 1) = y Xor ((p(c + 2) >> 8) or (p(c + 3) << 24)) Xor (p(d + 1) << 11)
            y = p(a) Xor (p(a) << 24) Xor ((p(b) >> 12) And &HFDFEEDFF)
            p(a) = y Xor ((p(c + 1) >> 8) or (p(c + 2) << 24)) Xor (p(d) << 11)
            c = d : d = a : a += 4 : b += 4
            If b = 40 Then b = 0
        Loop While a <> 40
    End Sub

    Sub New(ByVal s As UInteger)
        MyBase.New(s)
    End Sub

    Sub New(ByVal init_key As UInteger())
        MyBase.New(init_key)
    End Sub

End Class

Class Sfmt24
    Inherits Sfmt

    Public readonly Overrides Property IdString() As String
        Get
            Return "SFMT-1279:6-5-7-11-1:4fdffdff-c7feff7f-f5ffbe7f-3fddff97"
        End Get
    End Property

    Private Shared ParityData As UInteger() = {&H1&, &H0&, &H0&, &H80000000&}

    Protected Overrides Function GetParity() As UInteger()
        Return ParityData
    End Function

    Protected overrides Sub gen_rand_all()
        Dim a As Integer = 0 : Dim b As Integer = 24 : Dim c As Integer = 32
        Dim d As Integer = 36 : Dim y As UInteger : Dim p As UInteger() = x

        Do
            y = p(a + 3) Xor (p(a + 2) << 24) Xor (p(a + 1) >> 8) Xor ((p(b + 3) >> 11) And &H3FDDFF97)
            p(a + 3) = y Xor (p(c + 3) >> 8) Xor (p(d + 3) << 5)
            y = p(a + 2) Xor (p(a + 1) << 24) Xor (p(a) >> 8) Xor ((p(b + 2) >> 11) And &HF5FFBE7F)
            p(a + 2) = y Xor ((p(c + 2) >> 8) or (p(c + 3) << 24)) Xor (p(d + 2) << 5)
            y = p(a + 1) Xor (p(a) << 24) Xor ((p(b + 1) >> 11) And &HC7FEFF7F)
            p(a + 1) = y Xor ((p(c + 1) >> 8) or (p(c + 2) << 24)) Xor (p(d + 1) << 5)
            y = p(a) Xor ((p(b) >> 11) And &H4FDFFDFF)
            p(a) = y Xor ((p(c) >> 8) or (p(c + 1) << 24)) Xor (p(d) << 5)
            c = d : d = a : a += 4 : b += 4
            If b = 40 Then b = 0
        Loop While a <> 40
    End Sub

    Sub New(ByVal s As UInteger)
        MyBase.New(s)
    End Sub

    Sub New(ByVal init_key As UInteger())
        MyBase.New(init_key)
    End Sub

End Class

Class Sfmt25
    Inherits Sfmt

    Public readonly Overrides Property IdString() As String
        Get
            Return "SFMT-1279:8-13-1-5-3:ffdffbae-7ffbff3f-ffffab5b-e7fff35b"
        End Get
    End Property

    Private Shared ParityData As UInteger() = {&H1&, &H0&, &H0&, &H0&}

    Protected Overrides Function GetParity() As UInteger()
        Return ParityData
    End Function

    Protected overrides Sub gen_rand_all()
        Dim a As Integer = 0 : Dim b As Integer = 32 : Dim c As Integer = 32
        Dim d As Integer = 36 : Dim y As UInteger : Dim p As UInteger() = x

        Do
            y = p(a + 3) Xor (p(a + 3) << 8) Xor (p(a + 2) >> 24) Xor ((p(b + 3) >> 5) And &HE7FFF35B)
            p(a + 3) = y Xor (p(c + 3) >> 24) Xor (p(d + 3) << 13)
            y = p(a + 2) Xor (p(a + 2) << 8) Xor (p(a + 1) >> 24) Xor ((p(b + 2) >> 5) And &HFFFFAB5B)
            p(a + 2) = y Xor ((p(c + 2) >> 24) or (p(c + 3) << 8)) Xor (p(d + 2) << 13)
            y = p(a + 1) Xor (p(a + 1) << 8) Xor (p(a) >> 24) Xor ((p(b + 1) >> 5) And &H7FFBFF3F)
            p(a + 1) = y Xor ((p(c + 1) >> 24) or (p(c + 2) << 8)) Xor (p(d + 1) << 13)
            y = p(a) Xor (p(a) << 8) Xor ((p(b) >> 5) And &HFFDFFBAE)
            p(a) = y Xor ((p(c) >> 24) or (p(c + 1) << 8)) Xor (p(d) << 13)
            c = d : d = a : a += 4 : b += 4
            If b = 40 Then b = 0
        Loop While a <> 40
    End Sub

    Sub New(ByVal s As UInteger)
        MyBase.New(s)
    End Sub

    Sub New(ByVal init_key As UInteger())
        MyBase.New(init_key)
    End Sub

End Class

Class Sfmt26
    Inherits Sfmt

    Public readonly Overrides Property IdString() As String
        Get
            Return "SFMT-1279:2-12-5-3-3:bfdefeef-bffffeff-fffefffb-fbfbdffe"
        End Get
    End Property

    Private Shared ParityData As UInteger() = {&H1&, &H0&, &H0&, &H0&}

    Protected Overrides Function GetParity() As UInteger()
        Return ParityData
    End Function

    Protected overrides Sub gen_rand_all()
        Dim a As Integer = 0 : Dim b As Integer = 8 : Dim c As Integer = 32
        Dim d As Integer = 36 : Dim y As UInteger : Dim p As UInteger() = x

        Do
            y = p(a + 3) Xor (p(a + 2) << 8) Xor (p(a + 1) >> 24) Xor ((p(b + 3) >> 3) And &HFBFBDFFE)
            p(a + 3) = y Xor (p(c + 3) >> 24) Xor (p(d + 3) << 12)
            y = p(a + 2) Xor (p(a + 1) << 8) Xor (p(a) >> 24) Xor ((p(b + 2) >> 3) And &HFFFEFFFB)
            p(a + 2) = y Xor ((p(c + 2) >> 24) or (p(c + 3) << 8)) Xor (p(d + 2) << 12)
            y = p(a + 1) Xor (p(a) << 8) Xor ((p(b + 1) >> 3) And &HBFFFFEFF)
            p(a + 1) = y Xor ((p(c + 1) >> 24) or (p(c + 2) << 8)) Xor (p(d + 1) << 12)
            y = p(a) Xor ((p(b) >> 3) And &HBFDEFEEF)
            p(a) = y Xor ((p(c) >> 24) or (p(c + 1) << 8)) Xor (p(d) << 12)
            c = d : d = a : a += 4 : b += 4
            If b = 40 Then b = 0
        Loop While a <> 40
    End Sub

    Sub New(ByVal s As UInteger)
        MyBase.New(s)
    End Sub

    Sub New(ByVal init_key As UInteger())
        MyBase.New(init_key)
    End Sub

End Class

Class Sfmt27
    Inherits Sfmt

    Public readonly Overrides Property IdString() As String
        Get
            Return "SFMT-1279:6-3-3-5-3:fffffff3-f7bbffff-fafff9fb-ff77fddf"
        End Get
    End Property

    Private Shared ParityData As UInteger() = {&H1&, &H0&, &H0&, &H80000000&}

    Protected Overrides Function GetParity() As UInteger()
        Return ParityData
    End Function

    Protected overrides Sub gen_rand_all()
        Dim a As Integer = 0 : Dim b As Integer = 24 : Dim c As Integer = 32
        Dim d As Integer = 36 : Dim y As UInteger : Dim p As UInteger() = x

        Do
            y = p(a + 3) Xor (p(a + 3) << 24) Xor (p(a + 2) >> 8) Xor ((p(b + 3) >> 5) And &HFF77FDDF)
            p(a + 3) = y Xor (p(c + 3) >> 24) Xor (p(d + 3) << 3)
            y = p(a + 2) Xor (p(a + 2) << 24) Xor (p(a + 1) >> 8) Xor ((p(b + 2) >> 5) And &HFAFFF9FB)
            p(a + 2) = y Xor ((p(c + 2) >> 24) or (p(c + 3) << 8)) Xor (p(d + 2) << 3)
            y = p(a + 1) Xor (p(a + 1) << 24) Xor (p(a) >> 8) Xor ((p(b + 1) >> 5) And &HF7BBFFFF)
            p(a + 1) = y Xor ((p(c + 1) >> 24) or (p(c + 2) << 8)) Xor (p(d + 1) << 3)
            y = p(a) Xor (p(a) << 24) Xor ((p(b) >> 5) And &HFFFFFFF3)
            p(a) = y Xor ((p(c) >> 24) or (p(c + 1) << 8)) Xor (p(d) << 3)
            c = d : d = a : a += 4 : b += 4
            If b = 40 Then b = 0
        Loop While a <> 40
    End Sub

    Sub New(ByVal s As UInteger)
        MyBase.New(s)
    End Sub

    Sub New(ByVal init_key As UInteger())
        MyBase.New(init_key)
    End Sub

End Class

Class Sfmt28
    Inherits Sfmt

    Public readonly Overrides Property IdString() As String
        Get
            Return "SFMT-1279:6-19-1-7-3:fdffefff-5ffbdffd-efbbfff3-ff7e7bb7"
        End Get
    End Property

    Private Shared ParityData As UInteger() = {&H1&, &H0&, &H0&, &H0&}

    Protected Overrides Function GetParity() As UInteger()
        Return ParityData
    End Function

    Protected overrides Sub gen_rand_all()
        Dim a As Integer = 0 : Dim b As Integer = 24 : Dim c As Integer = 32
        Dim d As Integer = 36 : Dim y As UInteger : Dim p As UInteger() = x

        Do
            y = p(a + 3) Xor (p(a + 3) << 8) Xor (p(a + 2) >> 24) Xor ((p(b + 3) >> 7) And &HFF7E7BB7)
            p(a + 3) = y Xor (p(c + 3) >> 24) Xor (p(d + 3) << 19)
            y = p(a + 2) Xor (p(a + 2) << 8) Xor (p(a + 1) >> 24) Xor ((p(b + 2) >> 7) And &HEFBBFFF3)
            p(a + 2) = y Xor ((p(c + 2) >> 24) or (p(c + 3) << 8)) Xor (p(d + 2) << 19)
            y = p(a + 1) Xor (p(a + 1) << 8) Xor (p(a) >> 24) Xor ((p(b + 1) >> 7) And &H5FFBDFFD)
            p(a + 1) = y Xor ((p(c + 1) >> 24) or (p(c + 2) << 8)) Xor (p(d + 1) << 19)
            y = p(a) Xor (p(a) << 8) Xor ((p(b) >> 7) And &HFDFFEFFF)
            p(a) = y Xor ((p(c) >> 24) or (p(c + 1) << 8)) Xor (p(d) << 19)
            c = d : d = a : a += 4 : b += 4
            If b = 40 Then b = 0
        Loop While a <> 40
    End Sub

    Sub New(ByVal s As UInteger)
        MyBase.New(s)
    End Sub

    Sub New(ByVal init_key As UInteger())
        MyBase.New(init_key)
    End Sub

End Class

Class Sfmt29
    Inherits Sfmt

    Public readonly Overrides Property IdString() As String
        Get
            Return "SFMT-1279:8-11-1-5-3:7eafebff-7fdfdefd-b7d7bff5-f7bb7ff7"
        End Get
    End Property

    Private Shared ParityData As UInteger() = {&H1&, &H0&, &H0&, &H40000000&}

    Protected Overrides Function GetParity() As UInteger()
        Return ParityData
    End Function

    Protected overrides Sub gen_rand_all()
        Dim a As Integer = 0 : Dim b As Integer = 32 : Dim c As Integer = 32
        Dim d As Integer = 36 : Dim y As UInteger : Dim p As UInteger() = x

        Do
            y = p(a + 3) Xor (p(a + 3) << 8) Xor (p(a + 2) >> 24) Xor ((p(b + 3) >> 5) And &HF7BB7FF7)
            p(a + 3) = y Xor (p(c + 3) >> 24) Xor (p(d + 3) << 11)
            y = p(a + 2) Xor (p(a + 2) << 8) Xor (p(a + 1) >> 24) Xor ((p(b + 2) >> 5) And &HB7D7BFF5)
            p(a + 2) = y Xor ((p(c + 2) >> 24) or (p(c + 3) << 8)) Xor (p(d + 2) << 11)
            y = p(a + 1) Xor (p(a + 1) << 8) Xor (p(a) >> 24) Xor ((p(b + 1) >> 5) And &H7FDFDEFD)
            p(a + 1) = y Xor ((p(c + 1) >> 24) or (p(c + 2) << 8)) Xor (p(d + 1) << 11)
            y = p(a) Xor (p(a) << 8) Xor ((p(b) >> 5) And &H7EAFEBFF)
            p(a) = y Xor ((p(c) >> 24) or (p(c + 1) << 8)) Xor (p(d) << 11)
            c = d : d = a : a += 4 : b += 4
            If b = 40 Then b = 0
        Loop While a <> 40
    End Sub

    Sub New(ByVal s As UInteger)
        MyBase.New(s)
    End Sub

    Sub New(ByVal init_key As UInteger())
        MyBase.New(init_key)
    End Sub

End Class

Class Sfmt30
    Inherits Sfmt

    Public readonly Overrides Property IdString() As String
        Get
            Return "SFMT-1279:6-14-1-3-7:ffffbffd-fffbffdf-ffffffff-fedffde5"
        End Get
    End Property

    Private Shared ParityData As UInteger() = {&H1&, &H0&, &H0&, &H0&}

    Protected Overrides Function GetParity() As UInteger()
        Return ParityData
    End Function

    Protected overrides Sub gen_rand_all()
        Dim a As Integer = 0 : Dim b As Integer = 24 : Dim c As Integer = 32
        Dim d As Integer = 36 : Dim y As UInteger : Dim p As UInteger() = x

        Do
            y = p(a + 3) Xor (p(a + 3) << 8) Xor (p(a + 2) >> 24) Xor ((p(b + 3) >> 3) And &HFEDFFDE5)
            p(a + 3) = y Xor (p(d + 3) << 14)
            y = p(a + 2) Xor (p(a + 2) << 8) Xor (p(a + 1) >> 24) Xor ((p(b + 2) >> 3) And &HFFFFFFFF)
            p(a + 2) = y Xor (p(c + 3) >> 24) Xor (p(d + 2) << 14)
            y = p(a + 1) Xor (p(a + 1) << 8) Xor (p(a) >> 24) Xor ((p(b + 1) >> 3) And &HFFFBFFDF)
            p(a + 1) = y Xor ((p(c + 2) >> 24) or (p(c + 3) << 8)) Xor (p(d + 1) << 14)
            y = p(a) Xor (p(a) << 8) Xor ((p(b) >> 3) And &HFFFFBFFD)
            p(a) = y Xor ((p(c + 1) >> 24) or (p(c + 2) << 8)) Xor (p(d) << 14)
            c = d : d = a : a += 4 : b += 4
            If b = 40 Then b = 0
        Loop While a <> 40
    End Sub

    Sub New(ByVal s As UInteger)
        MyBase.New(s)
    End Sub

    Sub New(ByVal init_key As UInteger())
        MyBase.New(init_key)
    End Sub

End Class

Class Sfmt31
    Inherits Sfmt

    Public readonly Overrides Property IdString() As String
        Get
            Return "SFMT-1279:3-5-3-22-5:cffdffdf-ffff6eff-fff5fff7-efffbfff"
        End Get
    End Property

    Private Shared ParityData As UInteger() = {&H1&, &H0&, &H0&, &H0&}

    Protected Overrides Function GetParity() As UInteger()
        Return ParityData
    End Function

    Protected overrides Sub gen_rand_all()
        Dim a As Integer = 0 : Dim b As Integer = 12 : Dim c As Integer = 32
        Dim d As Integer = 36 : Dim y As UInteger : Dim p As UInteger() = x

        Do
            y = p(a + 3) Xor (p(a + 3) << 24) Xor (p(a + 2) >> 8) Xor ((p(b + 3) >> 22) And &HEFFFBFFF)
            p(a + 3) = y Xor (p(d + 3) << 5)
            y = p(a + 2) Xor (p(a + 2) << 24) Xor (p(a + 1) >> 8) Xor ((p(b + 2) >> 22) And &HFFF5FFF7)
            p(a + 2) = y Xor (p(c + 3) >> 8) Xor (p(d + 2) << 5)
            y = p(a + 1) Xor (p(a + 1) << 24) Xor (p(a) >> 8) Xor ((p(b + 1) >> 22) And &HFFFF6EFF)
            p(a + 1) = y Xor ((p(c + 2) >> 8) or (p(c + 3) << 24)) Xor (p(d + 1) << 5)
            y = p(a) Xor (p(a) << 24) Xor ((p(b) >> 22) And &HCFFDFFDF)
            p(a) = y Xor ((p(c + 1) >> 8) or (p(c + 2) << 24)) Xor (p(d) << 5)
            c = d : d = a : a += 4 : b += 4
            If b = 40 Then b = 0
        Loop While a <> 40
    End Sub

    Sub New(ByVal s As UInteger)
        MyBase.New(s)
    End Sub

    Sub New(ByVal init_key As UInteger())
        MyBase.New(init_key)
    End Sub

End Class

Class Sfmt_m

    Private Shared z as Sfmt() = { _
        New Sfmt  (1), _
        New Sfmt1 (&HFFFFFFFF&), _
        New Sfmt2 (&HFFFFFFFE&), _
        New Sfmt3 (&HFFFFFFFD&), _
        New Sfmt4 (&HFFFFFFFC&), _
        New Sfmt5 (&HFFFFFFFB&), _
        New Sfmt6 (&HFFFFFFFA&), _
        New Sfmt7 (&HFFFFFFF9&), _
        New Sfmt8 (&HFFFFFFF8&), _
        New Sfmt9 (&HFFFFFFF7&), _
        New Sfmt10(&HFFFFFFF6&), _
        New Sfmt11(&HFFFFFFF5&), _
        New Sfmt12(&HFFFFFFF4&), _
        New Sfmt13(&HFFFFFFF3&), _
        New Sfmt14(&HFFFFFFF2&), _
        New Sfmt15(&HFFFFFFF1&), _
        New Sfmt16(&HFFFFFFF0&), _
        New Sfmt17(&HFFFFFFEF&), _
        New Sfmt18(&HFFFFFFEE&), _
        New Sfmt19(&HFFFFFFED&), _
        New Sfmt20(&HFFFFFFEC&), _
        New Sfmt21(&HFFFFFFEB&), _
        New Sfmt22(&HFFFFFFEA&), _
        New Sfmt23(&HFFFFFFE9&), _
        New Sfmt24(&HFFFFFFE8&), _
        New Sfmt25(&HFFFFFFE7&), _
        New Sfmt26(&HFFFFFFE6&), _
        New Sfmt27(&HFFFFFFE5&), _
        New Sfmt28(&HFFFFFFE4&), _
        New Sfmt29(&HFFFFFFE3&), _
        New Sfmt30(&HFFFFFFE2&), _
        New Sfmt31(&HFFFFFFE1&) _
    }

    Public Shared Function IdString_m(ByVal i As Integer) As String
        Return z(i).IdString
    End Function

    Public Shared Sub InitMt_m(ByVal i As Integer,ByVal s As UInteger)
        z(i).InitMt(s)
    End Sub

    Public Shared Sub InitMtEx_m(ByVal i As Integer,ByVal k As UInteger())
        z(i).InitMtEx(k)
    End Sub

    Public Shared Function NextMt_m(ByVal i As Integer) As UInteger
        Return z(i).NextMt()
    End Function

    Public Shared Function NextInt_m(ByVal i As Integer,ByVal n As Integer) As Integer
        Return z(i).NextInt(n)
    End Function

    Public Shared Function NextBit_m(ByVal i As Integer) As Integer
        Return z(i).NextBit()
    End Function

    Public Shared Function NextByte_m(ByVal i As Integer) As Integer
        Return z(i).NextByte()
    End Function

    Public Shared Function NextUnif_m(ByVal i As Integer) As Double
        Return z(i).NextUnif()
    End Function

    Public Shared Function NextIntEx_m(ByVal i As Integer,ByVal r As Integer) As Integer
        Return z(i).NextIntEx(r)
    End Function

    Public Shared Function NextChisq_m(ByVal i As Integer,ByVal n As Double) As Double
        Return z(i).NextChisq(n)
    End Function

    Public Shared Function NextGamma_m(ByVal i As Integer,ByVal a As Double) As Double
        Return z(i).NextGamma(a)
    End Function

    Public Shared Function NextGeometric_m(ByVal i As Integer,ByVal p As Double) As Integer
        Return z(i).NextGeometric(p)
    End Function

    Public Shared Function NextTriangle_m(ByVal i As Integer) As Double
        Return z(i).NextTriangle()
    End Function

    Public Shared Function NextExp_m(ByVal i As Integer) As Double
        Return z(i).NextExp()
    End Function

    Public Shared Function NextNormal_m(ByVal i As Integer) As Double
        Return z(i).NextNormal()
    End Function

    Public Shared Sub NextUnitVect_m(ByVal i As Integer,ByRef v As Double(),ByVal n As Integer)
        z(i).NextUnitVect(v,n)
    End Sub

    Public Shared Function NextBinomial_m(ByVal i As Integer,ByVal n As Integer,ByVal p As Double) As Integer
        Return z(i).NextBinomial(n,p)
    End Function

    Public Shared Sub NextBinormal_m(ByVal i As Integer,ByVal r As Double,ByRef a As Double,ByRef b As Double)
        z(i).NextBinormal(r,a,b)
    End Sub

    Public Shared Function NextBeta_m(ByVal i As Integer,ByVal a As Double,ByVal b As Double) As Double
        Return z(i).NextBeta(a,b)
    End Function

    Public Shared Function NextPower_m(ByVal i As Integer,ByVal n As Double) As Double
        Return z(i).NextPower(n)
    End Function

    Public Shared Function NextLogistic_m(ByVal i As Integer) As Double
        Return z(i).NextLogistic()
    End Function

    Public Shared Function NextCauchy_m(ByVal i As Integer) As Double
        Return z(i).NextCauchy()
    End Function

    Public Shared Function NextPoisson_m(ByVal i As Integer,ByVal l As Double) As Integer
        Return z(i).NextPoisson(l)
    End Function

    Public Shared Function NextFDist_m(ByVal i As Integer,ByVal n1 As Double,ByVal n2 As Double) As Double
        Return z(i).NextFDist(n1,n2)
    End Function

    Public Shared Function NextTDist_m(ByVal i As Integer,ByVal n As Double) As Double
        Return z(i).NextTDist(n)
    End Function

    Public Shared Function NextWeibull_m(ByVal i As Integer,ByVal a As Double) As Double
        Return z(i).NextWeibull(a)
    End Function

End Class

