'
' Sfmt4253.vb Cu
' coded by isaku@pb4.so-net.ne.jp
' 

Class Sfmt

    Private index As Integer
    Private coin_bits As Integer ' NextBit ł̎c̃rbg
    Private coin_save As UInteger ' NextBit ł̒lێ
    Private byte_pos As Integer ' NextByte ŎgpoCg
    Private byte_save As UInteger ' NextByte ł̒lێ
    Private range As Integer ' NextIntEx őO͈̔
    Private bse As UInteger  ' NextIntEx őO̊l
    Private shift As Integer ' NextIntEx őÕVtg
    Private normal_sw As Integer  ' NextNormal ŎcĂ
    Private normal_save As Double ' NextNormal ̎c̒l
    Protected x(135) As UInteger ' ԃe[u
    Private Shared ParityData As UInteger() = {&HA8000001&, &HAF5390A3&, &HB740B3F8&, &H6C11486D&}

    Protected Overridable Function GetParity() As UInteger()
        Return ParityData
    End Function

    Public readonly Overridable Property IdString() As String
        Get
            Return "SFMT-4253:17-20-1-7-1:9f7bffff-9fffff5f-3efffffb-fffff7bb"
        End Get
    End Property

    Protected Overridable Sub gen_rand_all()
        Dim a As Integer = 0 : Dim b As Integer = 68 : Dim c As Integer = 128
        Dim d As Integer = 132 : Dim y As UInteger : Dim p As UInteger() = x

        Do
            y = p(a + 3) Xor (p(a + 3) << 8) Xor (p(a + 2) >> 24) Xor ((p(b + 3) >> 7) And &HFFFFF7BB)
            p(a + 3) = y Xor (p(c + 3) >> 8) Xor (p(d + 3) << 20)
            y = p(a + 2) Xor (p(a + 2) << 8) Xor (p(a + 1) >> 24) Xor ((p(b + 2) >> 7) And &H3EFFFFFB)
            p(a + 2) = y Xor ((p(c + 2) >> 8) or (p(c + 3) << 24)) Xor (p(d + 2) << 20)
            y = p(a + 1) Xor (p(a + 1) << 8) Xor (p(a) >> 24) Xor ((p(b + 1) >> 7) And &H9FFFFF5F)
            p(a + 1) = y Xor ((p(c + 1) >> 8) or (p(c + 2) << 24)) Xor (p(d + 1) << 20)
            y = p(a) Xor (p(a) << 8) Xor ((p(b) >> 7) And &H9F7BFFFF)
            p(a) = y Xor ((p(c) >> 8) or (p(c + 1) << 24)) Xor (p(d) << 20)
            c = d : d = a : a += 4 : b += 4
            If b = 136 Then b = 0
        Loop While a <> 136
    End Sub

    Private Sub period_certification()
        Dim work As UInteger : Dim inner As UInteger = 0 : Dim i, j As Integer
        Dim parity As UInteger() = GetParity()

        index = 136 : range = 0 : normal_sw = 0 : coin_bits = 0 : byte_pos = 0
        For i = 0 To 3 : inner = inner Xor x(i) And parity(i) : Next
        i = 16 : Do : inner = inner Xor inner >> i : i >>= 1 : Loop While i > 0
        inner = inner And 1
        If inner = 1 Then Return
        For i = 0 To 3
            j = 0 : work = 1
            Do
                If (work And parity(i)) <> 0 Then
                    x(i) = x(i) Xor work
                    Return
                End If
                j += 1
                work <<= 1
            Loop While j < 32
        Next
    End Sub

    ' ̎ s ɂ鏉
    Public Sub InitMt(ByVal s As UInteger)
        Dim p As UInteger
        x(0) = s
        For p = 1 To 135
            s = 1812433253 * (s Xor (s >> 30)) + p
            x(p) = s
        Next
        period_certification()
    End Sub

    Sub New(ByVal s As UInteger)
        InitMt(s)
    End Sub
    
    ' z init_key ɂ鏉
    Public Sub InitMtEx(ByVal init_key() As UInteger)
        Dim r, i, j, c As UInteger
        Dim key_len As UInteger = init_key.Length

        For i = 0 To 135 : x(i) = &H8B8B8B8B& : Next
        If key_len + 1 > 136 Then c = key_len + 1 Else c = 136
        r = x(0) Xor x(64) Xor x(135) : r = (r Xor (r >> 27)) * 1664525
        x(64) += r : r += key_len : x(71) += r : x(0) = r : c -= 1
        i = 1 : j = 0
        Do While j < c And j < key_len
            r = x(i) Xor x((i + 64) Mod 136) Xor x((i + 135) Mod 136)
            r = (r Xor (r >> 27)) * 1664525 : x((i + 64) Mod 136) += r
            r += init_key(j) + i : x((i + 71) Mod 136) += r
            x(i) = r : i = (i + 1) Mod 136 : j += 1
        Loop
        Do While j < c
            r = x(i) Xor x((i + 64) Mod 136) Xor x((i + 135) Mod 136)
            r = (r Xor (r >> 27)) * 1664525 : x((i + 64) Mod 136) += r : r += i
            x((i + 71) Mod 136) += r : x(i) = r : i = (i + 1) Mod 136 : j += 1
        Loop
        For j = 0 To 135
            r = x(i) + x((i + 64) Mod 136) + x((i + 135) Mod 136)
            r = (r Xor (r >> 27)) * 1566083941
            c = (i + 64) Mod 136 : x(c) = x(c) Xor r : r -= i
            c = (i + 71) Mod 136 : x(c) = x(c) Xor r
            x(i) = r : i = (i + 1) Mod 136
        Next
        period_certification()
    End Sub


    Sub New(ByVal init_key() As UInteger)
        InitMtEx(init_key)
    End Sub
    
    ' 32rbgȂ̗
    Public Function NextMt() As UInteger
        If index = 136 Then
            gen_rand_all()
            index = 0
        End If
        nextmt = x(index)
        index += 1
    End Function

    ' Oȏ n ̐
    Public Function NextInt(ByVal n As Integer) As Integer
        Return Int(n * (1.0 / 4294967296.0) * NextMt())
    End Function

    ' OPԂ
    Public Function NextBit() As integer
        coin_bits = coin_bits - 1
        If coin_bits = -1 Then
            coin_bits = 31
            coin_save = NextMt
        Else
            coin_save = coin_save >> 1
        End If
        NextBit = coin_save And 1
    End Function

    ' OPԂ
    Public Function NextByte() As integer
        byte_pos = byte_pos - 1
        If byte_pos = -1 Then
            byte_pos = 3
            byte_save = NextMt
        Else
            byte_save = byte_save >> 8
        End If
        NextByte = byte_save And 255
    End Function

    ' OȏP̗(53bitx)
    Public Function NextUnif() As Double
        Dim z As UInteger = NextMt() >> 11
        Dim y As UInteger = NextMt()
        Return (y * 2097152.0 + z) * (1.0 / 9007199254740992.0)
    End Function

    ' ۂߌ덷̂ȂOȏ range_ ̐
    Public Function NextIntEx(ByVal range_ As Integer) As Integer
        Dim y_, base_, remain_, shift_ As UInteger

        If range_ <= 0 Then Return 0
        If range_ <> range Then
            range = range_ : bse = range_ : shift = 0
            Do While bse <= 1 << 30
                bse <<= 1 : shift += 1
            Loop
        End If
        Do
            y_ = NextMt() >> 1
            If y_ < bse Then Return int(y_ >> shift)
            base_ = bse : shift_ = shift : y_ -= base_
            remain_ = (1 << 31) - base_
            Do While remain_ >= range_
                Do While base_ > remain_
                    base_ >>= 1 : shift_ -= 1
                Loop
                If y_ < base_ Then Return int(y_ >> shift_)
                y_ -= base_
                remain_ -= base_
            Loop
        Loop
    End Function
    
    ' Rx˂̃JCQ敪z
    Public Function NextChisq(ByVal n As Double) As Double
        Return 2 * NextGamma(0.5 * n)
    End Function

    ' p[^̃K}z
    Public Function NextGamma(ByVal a As Double) As double
        Dim t, u, xx, y As Double
        If a > 1 Then
            t = Math.Sqrt(2 * a - 1)
            Do
                Do
                    Do
                        Do
                            xx = 1 - NextUnif()
                            y = 2 * NextUnif() - 1
                        Loop While xx * xx + y * y > 1
                        y /= xx : xx = t * y + a - 1
                    Loop While xx <= 0
                    u = (a - 1) * Math.Log(xx / (a - 1)) - t * y
                Loop While u < -50.0
            Loop While NextUnif() > (1 + y * y) * Math.Exp(u)
        Else
            t = 2.7182818284590451 / (a + 2.7182818284590451)
            Do
                If NextUnif() < t Then
                    xx = Math.Pow(NextUnif(), 1 / a) : y = Math.Exp(-xx)
                Else
                    xx = 1 - Math.Log(1 - NextUnif()) : y = Math.Pow(xx, a - 1)
                End If
            Loop While NextUnif() >= y
        End If
        Return xx
    End Function

    ' mo̊􉽕z
    Public Function NextGeometric(ByVal p As Double) As Integer
        Return int(Math.Ceiling(Math.Log(1.0 - NextUnif()) / Math.Log(1 - p)))
    End Function

    ' Opz
    Public Function NextTriangle() As Double
        Dim a As Double = NextUnif()
        Dim b As Double = NextUnif()

        Return a - b
    End Function
    
    ' ςP̎wz
    Public Function NextExp() As Double
        Return -Math.Log(1 - NextUnif())
    End Function

    ' WKz(ő8.57)
    Public Function NextNormal() As Double
        Dim t, u As Double
        If normal_sw = 0 Then
            t = Math.Sqrt(-2 * Math.Log(1.0 - NextUnif()))
            u = 3.1415926535897931 * 2 * NextUnif()
            normal_save = t * Math.Sin(u) : normal_sw = 1
            Return t * Math.Cos(u)
        Else
            normal_sw = 0 : Return normal_save
        End If
    End Function
    
    ' m̃_PʃxNg
    Public Sub NextUnitVect(ByRef v As Double(), ByVal n As Integer)
        Dim i As Integer : Dim r As Double = 0
        ReDim v(n - 1)
        For i = 0 To n - 1
            v(i) = NextNormal() : r += v(i) * v(i)
        Next
        If r = 0 Then
            r = 1
        End If
        r = Math.Sqrt(r)
        For i = 0 To n - 1 : v(i) /= r : Next
    End Sub

    ' p[^m,ôQz
    Public Function NextBinomial(ByVal n As Integer, ByVal p As Double) As Integer
        Dim i As Integer : Dim r As Integer = 0

        For i = 0 To n - 1
            If NextUnif() < p Then r += 1
        Next
        Return r
    End Function

    ' ֌Wq̂QϗʐKz
    Public Sub NextBinormal(ByVal r As Double, ByRef a As Double, ByRef b As Double)
        Dim r1, r2, s As Double
        Do
            r1 = 2 * NextUnif() - 1
            r2 = 2 * NextUnif() - 1
            s = r1 * r1 + r2 * r2
        Loop While s > 1 Or s = 0
        s = -Math.Log(s) / s : r1 = Math.Sqrt((1 + r) * s) * r1
        r2 = Math.Sqrt((1 - r) * s) * r2 : a = r1 + r2 : b = r1 - r2
    End Sub

    ' p[^`,ãx[^z
    Public Function NextBeta(ByVal a As Double, ByVal b As Double) As Double
        Dim temp As Double = NextGamma(a)
        Return temp / (temp + NextGamma(b))
    End Function

    ' p[^m̗ݏ敪z
    Public Function NextPower(ByVal n As Double) As Double
        Return Math.Pow(NextUnif(), 1.0 / (n + 1))
    End Function

    ' WXeBbNz
    Public Function NextLogistic() As Double
        Dim r As Double
        Do : r = NextUnif() : Loop While r = 0
        Return Math.Log(r / (1 - r))
    End Function

    ' R[V[z
    Public Function NextCauchy() As Double
        Dim x, y As Double
        Do
            x = 1 - NextUnif() : y = 2 * NextUnif() - 1
        Loop While x * x + y * y > 1
        Return y / x
    End Function

    ' Rx n1,n2 ̂ez
    Public Function NextFDist(ByVal n1 As Double, ByVal n2 As Double) As Double
        Dim nc1 As Double = NextChisq(n1)
        Dim nc2 As Double = NextChisq(n2)
        Return (nc1 * n2) / (nc2 * n1)
    End Function

    ' σɂ̃|A\z
    Public Function NextPoisson(ByVal lambda As Double) As Integer
        Dim k As Integer = 0

        lambda = Math.Exp(lambda) * NextUnif()
        Do While lambda > 1
            lambda *= NextUnif()
            k += 1
        Loop
        Return k
    End Function

    ' Rxm̂z
    Public Function NextTDist(ByVal n As Double) As Double
        Dim a, b, c As Double
        If n <= 2 Then
            Do : a = NextChisq(n) : Loop While a = 0
            Return NextNormal() / Math.Sqrt(a / n)
        End If
        Do
            a = NextNormal() : b = a * a / (n - 2)
            c = Math.Log(1 - NextUnif()) / (1 - 0.5 * n)
        Loop While Math.Exp(-b - c) > 1 - b
        Return a / Math.Sqrt((1 - 2.0 / n) * (1 - b))
    End Function

    ' p[^̃Cuz
    Public Function NextWeibull(ByVal alpha As Double) As Double
        Return Math.Pow(-Math.Log(1 - NextUnif()), 1 / alpha)
    End Function
End Class

Class Sfmt1
    Inherits Sfmt

    Public readonly Overrides Property IdString() As String
        Get
            Return "SFMT-4253:25-10-3-1-3:daeeedf7-fff4eff7-ffffebfe-eff7febf"
        End Get
    End Property

    Private Shared ParityData As UInteger() = {&HC0000001&, &H78D2186&, &HE690A4A9&, &H7A5EFBE5&}

    Protected Overrides Function GetParity() As UInteger()
        Return ParityData
    End Function

    Protected overrides Sub gen_rand_all()
        Dim a As Integer = 0 : Dim b As Integer = 100 : Dim c As Integer = 128
        Dim d As Integer = 132 : Dim y As UInteger : Dim p As UInteger() = x

        Do
            y = p(a + 3) Xor (p(a + 3) << 24) Xor (p(a + 2) >> 8) Xor ((p(b + 3) >> 1) And &HEFF7FEBF)
            p(a + 3) = y Xor (p(c + 3) >> 24) Xor (p(d + 3) << 10)
            y = p(a + 2) Xor (p(a + 2) << 24) Xor (p(a + 1) >> 8) Xor ((p(b + 2) >> 1) And &HFFFFEBFE)
            p(a + 2) = y Xor ((p(c + 2) >> 24) or (p(c + 3) << 8)) Xor (p(d + 2) << 10)
            y = p(a + 1) Xor (p(a + 1) << 24) Xor (p(a) >> 8) Xor ((p(b + 1) >> 1) And &HFFF4EFF7)
            p(a + 1) = y Xor ((p(c + 1) >> 24) or (p(c + 2) << 8)) Xor (p(d + 1) << 10)
            y = p(a) Xor (p(a) << 24) Xor ((p(b) >> 1) And &HDAEEEDF7)
            p(a) = y Xor ((p(c) >> 24) or (p(c + 1) << 8)) Xor (p(d) << 10)
            c = d : d = a : a += 4 : b += 4
            If b = 136 Then b = 0
        Loop While a <> 136
    End Sub

    Sub New(ByVal s As UInteger)
        MyBase.New(s)
    End Sub

    Sub New(ByVal init_key As UInteger())
        MyBase.New(init_key)
    End Sub

End Class

Class Sfmt2
    Inherits Sfmt

    Public readonly Overrides Property IdString() As String
        Get
            Return "SFMT-4253:15-25-1-2-1:dffff3ff-ffdebf7f-ffdfbdf7-fbffffff"
        End Get
    End Property

    Private Shared ParityData As UInteger() = {&H20000001&, &H8B4ECD15&, &HB3480FC1&, &H35AB1967&}

    Protected Overrides Function GetParity() As UInteger()
        Return ParityData
    End Function

    Protected overrides Sub gen_rand_all()
        Dim a As Integer = 0 : Dim b As Integer = 60 : Dim c As Integer = 128
        Dim d As Integer = 132 : Dim y As UInteger : Dim p As UInteger() = x

        Do
            y = p(a + 3) Xor (p(a + 3) << 8) Xor (p(a + 2) >> 24) Xor ((p(b + 3) >> 2) And &HFBFFFFFF)
            p(a + 3) = y Xor (p(c + 3) >> 8) Xor (p(d + 3) << 25)
            y = p(a + 2) Xor (p(a + 2) << 8) Xor (p(a + 1) >> 24) Xor ((p(b + 2) >> 2) And &HFFDFBDF7)
            p(a + 2) = y Xor ((p(c + 2) >> 8) or (p(c + 3) << 24)) Xor (p(d + 2) << 25)
            y = p(a + 1) Xor (p(a + 1) << 8) Xor (p(a) >> 24) Xor ((p(b + 1) >> 2) And &HFFDEBF7F)
            p(a + 1) = y Xor ((p(c + 1) >> 8) or (p(c + 2) << 24)) Xor (p(d + 1) << 25)
            y = p(a) Xor (p(a) << 8) Xor ((p(b) >> 2) And &HDFFFF3FF)
            p(a) = y Xor ((p(c) >> 8) or (p(c + 1) << 24)) Xor (p(d) << 25)
            c = d : d = a : a += 4 : b += 4
            If b = 136 Then b = 0
        Loop While a <> 136
    End Sub

    Sub New(ByVal s As UInteger)
        MyBase.New(s)
    End Sub

    Sub New(ByVal init_key As UInteger())
        MyBase.New(init_key)
    End Sub

End Class

Class Sfmt3
    Inherits Sfmt

    Public readonly Overrides Property IdString() As String
        Get
            Return "SFMT-4253:28-8-3-3-5:afffdffb-ffffdfbf-fbffdf77-7d7cfef7"
        End Get
    End Property

    Private Shared ParityData As UInteger() = {&H20000001&, &H8ED2D92A&, &HEFC5D057&, &HA6E061D3&}

    Protected Overrides Function GetParity() As UInteger()
        Return ParityData
    End Function

    Protected overrides Sub gen_rand_all()
        Dim a As Integer = 0 : Dim b As Integer = 112 : Dim c As Integer = 128
        Dim d As Integer = 132 : Dim y As UInteger : Dim p As UInteger() = x

        Do
            y = p(a + 3) Xor (p(a + 3) << 24) Xor (p(a + 2) >> 8) Xor ((p(b + 3) >> 3) And &H7D7CFEF7)
            p(a + 3) = y Xor (p(d + 3) << 8)
            y = p(a + 2) Xor (p(a + 2) << 24) Xor (p(a + 1) >> 8) Xor ((p(b + 2) >> 3) And &HFBFFDF77)
            p(a + 2) = y Xor (p(c + 3) >> 8) Xor (p(d + 2) << 8)
            y = p(a + 1) Xor (p(a + 1) << 24) Xor (p(a) >> 8) Xor ((p(b + 1) >> 3) And &HFFFFDFBF)
            p(a + 1) = y Xor ((p(c + 2) >> 8) or (p(c + 3) << 24)) Xor (p(d + 1) << 8)
            y = p(a) Xor (p(a) << 24) Xor ((p(b) >> 3) And &HAFFFDFFB)
            p(a) = y Xor ((p(c + 1) >> 8) or (p(c + 2) << 24)) Xor (p(d) << 8)
            c = d : d = a : a += 4 : b += 4
            If b = 136 Then b = 0
        Loop While a <> 136
    End Sub

    Sub New(ByVal s As UInteger)
        MyBase.New(s)
    End Sub

    Sub New(ByVal init_key As UInteger())
        MyBase.New(init_key)
    End Sub

End Class

Class Sfmt4
    Inherits Sfmt

    Public readonly Overrides Property IdString() As String
        Get
            Return "SFMT-4253:10-17-3-13-3:bffdefff-ffaffeff-9f3ebfce-bf9fffdf"
        End Get
    End Property

    Private Shared ParityData As UInteger() = {&HA0000001&, &HD3BDDA16&, &H4140113F&, &HD458C634&}

    Protected Overrides Function GetParity() As UInteger()
        Return ParityData
    End Function

    Protected overrides Sub gen_rand_all()
        Dim a As Integer = 0 : Dim b As Integer = 40 : Dim c As Integer = 128
        Dim d As Integer = 132 : Dim y As UInteger : Dim p As UInteger() = x

        Do
            y = p(a + 3) Xor (p(a + 3) << 24) Xor (p(a + 2) >> 8) Xor ((p(b + 3) >> 13) And &HBF9FFFDF)
            p(a + 3) = y Xor (p(c + 3) >> 24) Xor (p(d + 3) << 17)
            y = p(a + 2) Xor (p(a + 2) << 24) Xor (p(a + 1) >> 8) Xor ((p(b + 2) >> 13) And &H9F3EBFCE)
            p(a + 2) = y Xor ((p(c + 2) >> 24) or (p(c + 3) << 8)) Xor (p(d + 2) << 17)
            y = p(a + 1) Xor (p(a + 1) << 24) Xor (p(a) >> 8) Xor ((p(b + 1) >> 13) And &HFFAFFEFF)
            p(a + 1) = y Xor ((p(c + 1) >> 24) or (p(c + 2) << 8)) Xor (p(d + 1) << 17)
            y = p(a) Xor (p(a) << 24) Xor ((p(b) >> 13) And &HBFFDEFFF)
            p(a) = y Xor ((p(c) >> 24) or (p(c + 1) << 8)) Xor (p(d) << 17)
            c = d : d = a : a += 4 : b += 4
            If b = 136 Then b = 0
        Loop While a <> 136
    End Sub

    Sub New(ByVal s As UInteger)
        MyBase.New(s)
    End Sub

    Sub New(ByVal init_key As UInteger())
        MyBase.New(init_key)
    End Sub

End Class

Class Sfmt5
    Inherits Sfmt

    Public readonly Overrides Property IdString() As String
        Get
            Return "SFMT-4253:8-7-3-19-1:bffffffb-6f9ffbff-7f9fe7f7-bfeffffb"
        End Get
    End Property

    Private Shared ParityData As UInteger() = {&H40000001&, &H4E4B2758&, &HB998E05A&, &HC4F1B268&}

    Protected Overrides Function GetParity() As UInteger()
        Return ParityData
    End Function

    Protected overrides Sub gen_rand_all()
        Dim a As Integer = 0 : Dim b As Integer = 32 : Dim c As Integer = 128
        Dim d As Integer = 132 : Dim y As UInteger : Dim p As UInteger() = x

        Do
            y = p(a + 3) Xor (p(a + 3) << 24) Xor (p(a + 2) >> 8) Xor ((p(b + 3) >> 19) And &HBFEFFFFB)
            p(a + 3) = y Xor (p(c + 3) >> 8) Xor (p(d + 3) << 7)
            y = p(a + 2) Xor (p(a + 2) << 24) Xor (p(a + 1) >> 8) Xor ((p(b + 2) >> 19) And &H7F9FE7F7)
            p(a + 2) = y Xor ((p(c + 2) >> 8) or (p(c + 3) << 24)) Xor (p(d + 2) << 7)
            y = p(a + 1) Xor (p(a + 1) << 24) Xor (p(a) >> 8) Xor ((p(b + 1) >> 19) And &H6F9FFBFF)
            p(a + 1) = y Xor ((p(c + 1) >> 8) or (p(c + 2) << 24)) Xor (p(d + 1) << 7)
            y = p(a) Xor (p(a) << 24) Xor ((p(b) >> 19) And &HBFFFFFFB)
            p(a) = y Xor ((p(c) >> 8) or (p(c + 1) << 24)) Xor (p(d) << 7)
            c = d : d = a : a += 4 : b += 4
            If b = 136 Then b = 0
        Loop While a <> 136
    End Sub

    Sub New(ByVal s As UInteger)
        MyBase.New(s)
    End Sub

    Sub New(ByVal init_key As UInteger())
        MyBase.New(init_key)
    End Sub

End Class

Class Sfmt6
    Inherits Sfmt

    Public readonly Overrides Property IdString() As String
        Get
            Return "SFMT-4253:13-18-1-21-1:e777f7fc-f7d7bf7d-edff7f5f-ffbfff7f"
        End Get
    End Property

    Private Shared ParityData As UInteger() = {&H40000001&, &H7DF3317A&, &HBBFEB4C7&, &H13A23B1D&}

    Protected Overrides Function GetParity() As UInteger()
        Return ParityData
    End Function

    Protected overrides Sub gen_rand_all()
        Dim a As Integer = 0 : Dim b As Integer = 52 : Dim c As Integer = 128
        Dim d As Integer = 132 : Dim y As UInteger : Dim p As UInteger() = x

        Do
            y = p(a + 3) Xor (p(a + 3) << 8) Xor (p(a + 2) >> 24) Xor ((p(b + 3) >> 21) And &HFFBFFF7F)
            p(a + 3) = y Xor (p(c + 3) >> 8) Xor (p(d + 3) << 18)
            y = p(a + 2) Xor (p(a + 2) << 8) Xor (p(a + 1) >> 24) Xor ((p(b + 2) >> 21) And &HEDFF7F5F)
            p(a + 2) = y Xor ((p(c + 2) >> 8) or (p(c + 3) << 24)) Xor (p(d + 2) << 18)
            y = p(a + 1) Xor (p(a + 1) << 8) Xor (p(a) >> 24) Xor ((p(b + 1) >> 21) And &HF7D7BF7D)
            p(a + 1) = y Xor ((p(c + 1) >> 8) or (p(c + 2) << 24)) Xor (p(d + 1) << 18)
            y = p(a) Xor (p(a) << 8) Xor ((p(b) >> 21) And &HE777F7FC)
            p(a) = y Xor ((p(c) >> 8) or (p(c + 1) << 24)) Xor (p(d) << 18)
            c = d : d = a : a += 4 : b += 4
            If b = 136 Then b = 0
        Loop While a <> 136
    End Sub

    Sub New(ByVal s As UInteger)
        MyBase.New(s)
    End Sub

    Sub New(ByVal init_key As UInteger())
        MyBase.New(init_key)
    End Sub

End Class

Class Sfmt7
    Inherits Sfmt

    Public readonly Overrides Property IdString() As String
        Get
            Return "SFMT-4253:14-6-3-3-5:7fdff3fb-57dfffdb-fe9ffddf-fefdae7f"
        End Get
    End Property

    Private Shared ParityData As UInteger() = {&H42000001&, &HEB34CFCE&, &H3EAB62B1&, &H95B6F6EB&}

    Protected Overrides Function GetParity() As UInteger()
        Return ParityData
    End Function

    Protected overrides Sub gen_rand_all()
        Dim a As Integer = 0 : Dim b As Integer = 56 : Dim c As Integer = 128
        Dim d As Integer = 132 : Dim y As UInteger : Dim p As UInteger() = x

        Do
            y = p(a + 3) Xor (p(a + 3) << 24) Xor (p(a + 2) >> 8) Xor ((p(b + 3) >> 3) And &HFEFDAE7F)
            p(a + 3) = y Xor (p(d + 3) << 6)
            y = p(a + 2) Xor (p(a + 2) << 24) Xor (p(a + 1) >> 8) Xor ((p(b + 2) >> 3) And &HFE9FFDDF)
            p(a + 2) = y Xor (p(c + 3) >> 8) Xor (p(d + 2) << 6)
            y = p(a + 1) Xor (p(a + 1) << 24) Xor (p(a) >> 8) Xor ((p(b + 1) >> 3) And &H57DFFFDB)
            p(a + 1) = y Xor ((p(c + 2) >> 8) or (p(c + 3) << 24)) Xor (p(d + 1) << 6)
            y = p(a) Xor (p(a) << 24) Xor ((p(b) >> 3) And &H7FDFF3FB)
            p(a) = y Xor ((p(c + 1) >> 8) or (p(c + 2) << 24)) Xor (p(d) << 6)
            c = d : d = a : a += 4 : b += 4
            If b = 136 Then b = 0
        Loop While a <> 136
    End Sub

    Sub New(ByVal s As UInteger)
        MyBase.New(s)
    End Sub

    Sub New(ByVal init_key As UInteger())
        MyBase.New(init_key)
    End Sub

End Class

Class Sfmt8
    Inherits Sfmt

    Public readonly Overrides Property IdString() As String
        Get
            Return "SFMT-4253:23-11-7-6-1:ffbfbe7f-ffbfdf6d-bfbffdfd-fffffffd"
        End Get
    End Property

    Private Shared ParityData As UInteger() = {&H60000001&, &H45BC889&, &H7B26B276&, &HF4E713F6&}

    Protected Overrides Function GetParity() As UInteger()
        Return ParityData
    End Function

    Protected overrides Sub gen_rand_all()
        Dim a As Integer = 0 : Dim b As Integer = 92 : Dim c As Integer = 128
        Dim d As Integer = 132 : Dim y As UInteger : Dim p As UInteger() = x

        Do
            y = p(a + 3) Xor (p(a + 2) << 24) Xor (p(a + 1) >> 8) Xor ((p(b + 3) >> 6) And &HFFFFFFFD)
            p(a + 3) = y Xor (p(c + 3) >> 8) Xor (p(d + 3) << 11)
            y = p(a + 2) Xor (p(a + 1) << 24) Xor (p(a) >> 8) Xor ((p(b + 2) >> 6) And &HBFBFFDFD)
            p(a + 2) = y Xor ((p(c + 2) >> 8) or (p(c + 3) << 24)) Xor (p(d + 2) << 11)
            y = p(a + 1) Xor (p(a) << 24) Xor ((p(b + 1) >> 6) And &HFFBFDF6D)
            p(a + 1) = y Xor ((p(c + 1) >> 8) or (p(c + 2) << 24)) Xor (p(d + 1) << 11)
            y = p(a) Xor ((p(b) >> 6) And &HFFBFBE7F)
            p(a) = y Xor ((p(c) >> 8) or (p(c + 1) << 24)) Xor (p(d) << 11)
            c = d : d = a : a += 4 : b += 4
            If b = 136 Then b = 0
        Loop While a <> 136
    End Sub

    Sub New(ByVal s As UInteger)
        MyBase.New(s)
    End Sub

    Sub New(ByVal init_key As UInteger())
        MyBase.New(init_key)
    End Sub

End Class

Class Sfmt9
    Inherits Sfmt

    Public readonly Overrides Property IdString() As String
        Get
            Return "SFMT-4253:16-16-3-11-3:fdffff4f-fff7fbff-ee7ffdff-dfbbfdff"
        End Get
    End Property

    Private Shared ParityData As UInteger() = {&HC0000001&, &HEB6E2A53&, &H4550962&, &HE0C0375F&}

    Protected Overrides Function GetParity() As UInteger()
        Return ParityData
    End Function

    Protected overrides Sub gen_rand_all()
        Dim a As Integer = 0 : Dim b As Integer = 64 : Dim c As Integer = 128
        Dim d As Integer = 132 : Dim y As UInteger : Dim p As UInteger() = x

        Do
            y = p(a + 3) Xor (p(a + 3) << 24) Xor (p(a + 2) >> 8) Xor ((p(b + 3) >> 11) And &HDFBBFDFF)
            p(a + 3) = y Xor (p(c + 3) >> 24) Xor (p(d + 3) << 16)
            y = p(a + 2) Xor (p(a + 2) << 24) Xor (p(a + 1) >> 8) Xor ((p(b + 2) >> 11) And &HEE7FFDFF)
            p(a + 2) = y Xor ((p(c + 2) >> 24) or (p(c + 3) << 8)) Xor (p(d + 2) << 16)
            y = p(a + 1) Xor (p(a + 1) << 24) Xor (p(a) >> 8) Xor ((p(b + 1) >> 11) And &HFFF7FBFF)
            p(a + 1) = y Xor ((p(c + 1) >> 24) or (p(c + 2) << 8)) Xor (p(d + 1) << 16)
            y = p(a) Xor (p(a) << 24) Xor ((p(b) >> 11) And &HFDFFFF4F)
            p(a) = y Xor ((p(c) >> 24) or (p(c + 1) << 8)) Xor (p(d) << 16)
            c = d : d = a : a += 4 : b += 4
            If b = 136 Then b = 0
        Loop While a <> 136
    End Sub

    Sub New(ByVal s As UInteger)
        MyBase.New(s)
    End Sub

    Sub New(ByVal init_key As UInteger())
        MyBase.New(init_key)
    End Sub

End Class

Class Sfmt10
    Inherits Sfmt

    Public readonly Overrides Property IdString() As String
        Get
            Return "SFMT-4253:28-5-3-11-5:f8fefff7-dfffffff-7fffffff-fffdfbf7"
        End Get
    End Property

    Private Shared ParityData As UInteger() = {&HA0000001&, &HE4616943&, &HA9B362C&, &HE8730649&}

    Protected Overrides Function GetParity() As UInteger()
        Return ParityData
    End Function

    Protected overrides Sub gen_rand_all()
        Dim a As Integer = 0 : Dim b As Integer = 112 : Dim c As Integer = 128
        Dim d As Integer = 132 : Dim y As UInteger : Dim p As UInteger() = x

        Do
            y = p(a + 3) Xor (p(a + 3) << 24) Xor (p(a + 2) >> 8) Xor ((p(b + 3) >> 11) And &HFFFDFBF7)
            p(a + 3) = y Xor (p(d + 3) << 5)
            y = p(a + 2) Xor (p(a + 2) << 24) Xor (p(a + 1) >> 8) Xor ((p(b + 2) >> 11) And &H7FFFFFFF)
            p(a + 2) = y Xor (p(c + 3) >> 8) Xor (p(d + 2) << 5)
            y = p(a + 1) Xor (p(a + 1) << 24) Xor (p(a) >> 8) Xor ((p(b + 1) >> 11) And &HDFFFFFFF)
            p(a + 1) = y Xor ((p(c + 2) >> 8) or (p(c + 3) << 24)) Xor (p(d + 1) << 5)
            y = p(a) Xor (p(a) << 24) Xor ((p(b) >> 11) And &HF8FEFFF7)
            p(a) = y Xor ((p(c + 1) >> 8) or (p(c + 2) << 24)) Xor (p(d) << 5)
            c = d : d = a : a += 4 : b += 4
            If b = 136 Then b = 0
        Loop While a <> 136
    End Sub

    Sub New(ByVal s As UInteger)
        MyBase.New(s)
    End Sub

    Sub New(ByVal init_key As UInteger())
        MyBase.New(init_key)
    End Sub

End Class

Class Sfmt11
    Inherits Sfmt

    Public readonly Overrides Property IdString() As String
        Get
            Return "SFMT-4253:12-17-5-5-3:ffffffff-bdffffff-e7fffffe-f3b7f7ef"
        End Get
    End Property

    Private Shared ParityData As UInteger() = {&HA0000001&, &HE4D017D4&, &HE32206C7&, &HE65FE0EE&}

    Protected Overrides Function GetParity() As UInteger()
        Return ParityData
    End Function

    Protected overrides Sub gen_rand_all()
        Dim a As Integer = 0 : Dim b As Integer = 48 : Dim c As Integer = 128
        Dim d As Integer = 132 : Dim y As UInteger : Dim p As UInteger() = x

        Do
            y = p(a + 3) Xor (p(a + 2) << 8) Xor (p(a + 1) >> 24) Xor ((p(b + 3) >> 5) And &HF3B7F7EF)
            p(a + 3) = y Xor (p(c + 3) >> 24) Xor (p(d + 3) << 17)
            y = p(a + 2) Xor (p(a + 1) << 8) Xor (p(a) >> 24) Xor ((p(b + 2) >> 5) And &HE7FFFFFE)
            p(a + 2) = y Xor ((p(c + 2) >> 24) or (p(c + 3) << 8)) Xor (p(d + 2) << 17)
            y = p(a + 1) Xor (p(a) << 8) Xor ((p(b + 1) >> 5) And &HBDFFFFFF)
            p(a + 1) = y Xor ((p(c + 1) >> 24) or (p(c + 2) << 8)) Xor (p(d + 1) << 17)
            y = p(a) Xor ((p(b) >> 5) And &HFFFFFFFF)
            p(a) = y Xor ((p(c) >> 24) or (p(c + 1) << 8)) Xor (p(d) << 17)
            c = d : d = a : a += 4 : b += 4
            If b = 136 Then b = 0
        Loop While a <> 136
    End Sub

    Sub New(ByVal s As UInteger)
        MyBase.New(s)
    End Sub

    Sub New(ByVal init_key As UInteger())
        MyBase.New(init_key)
    End Sub

End Class

Class Sfmt12
    Inherits Sfmt

    Public readonly Overrides Property IdString() As String
        Get
            Return "SFMT-4253:13-13-5-12-3:3ff7ff7f-ffffdfdf-ffbdbf7f-ffffbeff"
        End Get
    End Property

    Private Shared ParityData As UInteger() = {&H90000001&, &H655F358E&, &H996ADC07&, &H9FFD9669&}

    Protected Overrides Function GetParity() As UInteger()
        Return ParityData
    End Function

    Protected overrides Sub gen_rand_all()
        Dim a As Integer = 0 : Dim b As Integer = 52 : Dim c As Integer = 128
        Dim d As Integer = 132 : Dim y As UInteger : Dim p As UInteger() = x

        Do
            y = p(a + 3) Xor (p(a + 2) << 8) Xor (p(a + 1) >> 24) Xor ((p(b + 3) >> 12) And &HFFFFBEFF)
            p(a + 3) = y Xor (p(c + 3) >> 24) Xor (p(d + 3) << 13)
            y = p(a + 2) Xor (p(a + 1) << 8) Xor (p(a) >> 24) Xor ((p(b + 2) >> 12) And &HFFBDBF7F)
            p(a + 2) = y Xor ((p(c + 2) >> 24) or (p(c + 3) << 8)) Xor (p(d + 2) << 13)
            y = p(a + 1) Xor (p(a) << 8) Xor ((p(b + 1) >> 12) And &HFFFFDFDF)
            p(a + 1) = y Xor ((p(c + 1) >> 24) or (p(c + 2) << 8)) Xor (p(d + 1) << 13)
            y = p(a) Xor ((p(b) >> 12) And &H3FF7FF7F)
            p(a) = y Xor ((p(c) >> 24) or (p(c + 1) << 8)) Xor (p(d) << 13)
            c = d : d = a : a += 4 : b += 4
            If b = 136 Then b = 0
        Loop While a <> 136
    End Sub

    Sub New(ByVal s As UInteger)
        MyBase.New(s)
    End Sub

    Sub New(ByVal init_key As UInteger())
        MyBase.New(init_key)
    End Sub

End Class

Class Sfmt13
    Inherits Sfmt

    Public readonly Overrides Property IdString() As String
        Get
            Return "SFMT-4253:18-13-3-17-7:bdf7ffff-fbdfbfff-7fdffb3f-ffbe6bef"
        End Get
    End Property

    Private Shared ParityData As UInteger() = {&H20000001&, &HB081CFBE&, &HB3D5E047&, &H100E4768&}

    Protected Overrides Function GetParity() As UInteger()
        Return ParityData
    End Function

    Protected overrides Sub gen_rand_all()
        Dim a As Integer = 0 : Dim b As Integer = 72 : Dim c As Integer = 128
        Dim d As Integer = 132 : Dim y As UInteger : Dim p As UInteger() = x

        Do
            y = p(a + 3) Xor (p(a + 3) << 24) Xor (p(a + 2) >> 8) Xor ((p(b + 3) >> 17) And &HFFBE6BEF)
            p(a + 3) = y Xor (p(d + 3) << 13)
            y = p(a + 2) Xor (p(a + 2) << 24) Xor (p(a + 1) >> 8) Xor ((p(b + 2) >> 17) And &H7FDFFB3F)
            p(a + 2) = y Xor (p(c + 3) >> 24) Xor (p(d + 2) << 13)
            y = p(a + 1) Xor (p(a + 1) << 24) Xor (p(a) >> 8) Xor ((p(b + 1) >> 17) And &HFBDFBFFF)
            p(a + 1) = y Xor ((p(c + 2) >> 24) or (p(c + 3) << 8)) Xor (p(d + 1) << 13)
            y = p(a) Xor (p(a) << 24) Xor ((p(b) >> 17) And &HBDF7FFFF)
            p(a) = y Xor ((p(c + 1) >> 24) or (p(c + 2) << 8)) Xor (p(d) << 13)
            c = d : d = a : a += 4 : b += 4
            If b = 136 Then b = 0
        Loop While a <> 136
    End Sub

    Sub New(ByVal s As UInteger)
        MyBase.New(s)
    End Sub

    Sub New(ByVal init_key As UInteger())
        MyBase.New(init_key)
    End Sub

End Class

Class Sfmt14
    Inherits Sfmt

    Public readonly Overrides Property IdString() As String
        Get
            Return "SFMT-4253:11-21-3-6-1:fffffea7-fffdff3a-bfffffcf-dff5ffed"
        End Get
    End Property

    Private Shared ParityData As UInteger() = {&HA0000001&, &H9405B85D&, &HC60478F2&, &HAC65A61D&}

    Protected Overrides Function GetParity() As UInteger()
        Return ParityData
    End Function

    Protected overrides Sub gen_rand_all()
        Dim a As Integer = 0 : Dim b As Integer = 44 : Dim c As Integer = 128
        Dim d As Integer = 132 : Dim y As UInteger : Dim p As UInteger() = x

        Do
            y = p(a + 3) Xor (p(a + 3) << 24) Xor (p(a + 2) >> 8) Xor ((p(b + 3) >> 6) And &HDFF5FFED)
            p(a + 3) = y Xor (p(c + 3) >> 8) Xor (p(d + 3) << 21)
            y = p(a + 2) Xor (p(a + 2) << 24) Xor (p(a + 1) >> 8) Xor ((p(b + 2) >> 6) And &HBFFFFFCF)
            p(a + 2) = y Xor ((p(c + 2) >> 8) or (p(c + 3) << 24)) Xor (p(d + 2) << 21)
            y = p(a + 1) Xor (p(a + 1) << 24) Xor (p(a) >> 8) Xor ((p(b + 1) >> 6) And &HFFFDFF3A)
            p(a + 1) = y Xor ((p(c + 1) >> 8) or (p(c + 2) << 24)) Xor (p(d + 1) << 21)
            y = p(a) Xor (p(a) << 24) Xor ((p(b) >> 6) And &HFFFFFEA7)
            p(a) = y Xor ((p(c) >> 8) or (p(c + 1) << 24)) Xor (p(d) << 21)
            c = d : d = a : a += 4 : b += 4
            If b = 136 Then b = 0
        Loop While a <> 136
    End Sub

    Sub New(ByVal s As UInteger)
        MyBase.New(s)
    End Sub

    Sub New(ByVal init_key As UInteger())
        MyBase.New(init_key)
    End Sub

End Class

Class Sfmt15
    Inherits Sfmt

    Public readonly Overrides Property IdString() As String
        Get
            Return "SFMT-4253:1-12-1-7-1:ffbfff7b-fabf7ffb-ebfffefd-55fdfffe"
        End Get
    End Property

    Private Shared ParityData As UInteger() = {&H1&, &H324CB2FE&, &H442F545C&, &H69F16B2B&}

    Protected Overrides Function GetParity() As UInteger()
        Return ParityData
    End Function

    Protected overrides Sub gen_rand_all()
        Dim a As Integer = 0 : Dim b As Integer = 4 : Dim c As Integer = 128
        Dim d As Integer = 132 : Dim y As UInteger : Dim p As UInteger() = x

        Do
            y = p(a + 3) Xor (p(a + 3) << 8) Xor (p(a + 2) >> 24) Xor ((p(b + 3) >> 7) And &H55FDFFFE)
            p(a + 3) = y Xor (p(c + 3) >> 8) Xor (p(d + 3) << 12)
            y = p(a + 2) Xor (p(a + 2) << 8) Xor (p(a + 1) >> 24) Xor ((p(b + 2) >> 7) And &HEBFFFEFD)
            p(a + 2) = y Xor ((p(c + 2) >> 8) or (p(c + 3) << 24)) Xor (p(d + 2) << 12)
            y = p(a + 1) Xor (p(a + 1) << 8) Xor (p(a) >> 24) Xor ((p(b + 1) >> 7) And &HFABF7FFB)
            p(a + 1) = y Xor ((p(c + 1) >> 8) or (p(c + 2) << 24)) Xor (p(d + 1) << 12)
            y = p(a) Xor (p(a) << 8) Xor ((p(b) >> 7) And &HFFBFFF7B)
            p(a) = y Xor ((p(c) >> 8) or (p(c + 1) << 24)) Xor (p(d) << 12)
            c = d : d = a : a += 4 : b += 4
            If b = 136 Then b = 0
        Loop While a <> 136
    End Sub

    Sub New(ByVal s As UInteger)
        MyBase.New(s)
    End Sub

    Sub New(ByVal init_key As UInteger())
        MyBase.New(init_key)
    End Sub

End Class

Class Sfmt16
    Inherits Sfmt

    Public readonly Overrides Property IdString() As String
        Get
            Return "SFMT-4253:16-18-5-7-3:dfbfffff-fb7e5fff-fffbdfff-dffbbfff"
        End Get
    End Property

    Private Shared ParityData As UInteger() = {&H1&, &H92040000&, &H6265F31A&, &H68ABB978&}

    Protected Overrides Function GetParity() As UInteger()
        Return ParityData
    End Function

    Protected overrides Sub gen_rand_all()
        Dim a As Integer = 0 : Dim b As Integer = 64 : Dim c As Integer = 128
        Dim d As Integer = 132 : Dim y As UInteger : Dim p As UInteger() = x

        Do
            y = p(a + 3) Xor (p(a + 2) << 8) Xor (p(a + 1) >> 24) Xor ((p(b + 3) >> 7) And &HDFFBBFFF)
            p(a + 3) = y Xor (p(c + 3) >> 24) Xor (p(d + 3) << 18)
            y = p(a + 2) Xor (p(a + 1) << 8) Xor (p(a) >> 24) Xor ((p(b + 2) >> 7) And &HFFFBDFFF)
            p(a + 2) = y Xor ((p(c + 2) >> 24) or (p(c + 3) << 8)) Xor (p(d + 2) << 18)
            y = p(a + 1) Xor (p(a) << 8) Xor ((p(b + 1) >> 7) And &HFB7E5FFF)
            p(a + 1) = y Xor ((p(c + 1) >> 24) or (p(c + 2) << 8)) Xor (p(d + 1) << 18)
            y = p(a) Xor ((p(b) >> 7) And &HDFBFFFFF)
            p(a) = y Xor ((p(c) >> 24) or (p(c + 1) << 8)) Xor (p(d) << 18)
            c = d : d = a : a += 4 : b += 4
            If b = 136 Then b = 0
        Loop While a <> 136
    End Sub

    Sub New(ByVal s As UInteger)
        MyBase.New(s)
    End Sub

    Sub New(ByVal init_key As UInteger())
        MyBase.New(init_key)
    End Sub

End Class

Class Sfmt17
    Inherits Sfmt

    Public readonly Overrides Property IdString() As String
        Get
            Return "SFMT-4253:13-13-5-4-3:bf7febad-ff3ff756-fafaf6f6-fffffffc"
        End Get
    End Property

    Private Shared ParityData As UInteger() = {&H28000001&, &HF2E5468C&, &H7B320D81&, &HD79D5D0D&}

    Protected Overrides Function GetParity() As UInteger()
        Return ParityData
    End Function

    Protected overrides Sub gen_rand_all()
        Dim a As Integer = 0 : Dim b As Integer = 52 : Dim c As Integer = 128
        Dim d As Integer = 132 : Dim y As UInteger : Dim p As UInteger() = x

        Do
            y = p(a + 3) Xor (p(a + 2) << 8) Xor (p(a + 1) >> 24) Xor ((p(b + 3) >> 4) And &HFFFFFFFC)
            p(a + 3) = y Xor (p(c + 3) >> 24) Xor (p(d + 3) << 13)
            y = p(a + 2) Xor (p(a + 1) << 8) Xor (p(a) >> 24) Xor ((p(b + 2) >> 4) And &HFAFAF6F6)
            p(a + 2) = y Xor ((p(c + 2) >> 24) or (p(c + 3) << 8)) Xor (p(d + 2) << 13)
            y = p(a + 1) Xor (p(a) << 8) Xor ((p(b + 1) >> 4) And &HFF3FF756)
            p(a + 1) = y Xor ((p(c + 1) >> 24) or (p(c + 2) << 8)) Xor (p(d + 1) << 13)
            y = p(a) Xor ((p(b) >> 4) And &HBF7FEBAD)
            p(a) = y Xor ((p(c) >> 24) or (p(c + 1) << 8)) Xor (p(d) << 13)
            c = d : d = a : a += 4 : b += 4
            If b = 136 Then b = 0
        Loop While a <> 136
    End Sub

    Sub New(ByVal s As UInteger)
        MyBase.New(s)
    End Sub

    Sub New(ByVal init_key As UInteger())
        MyBase.New(init_key)
    End Sub

End Class

Class Sfmt18
    Inherits Sfmt

    Public readonly Overrides Property IdString() As String
        Get
            Return "SFMT-4253:4-11-1-3-3:f7efdbfb-f7fffffb-fffefe7f-f7eb7fef"
        End Get
    End Property

    Private Shared ParityData As UInteger() = {&H80000001&, &H9026447E&, &H1F279907&, &H70B4438&}

    Protected Overrides Function GetParity() As UInteger()
        Return ParityData
    End Function

    Protected overrides Sub gen_rand_all()
        Dim a As Integer = 0 : Dim b As Integer = 16 : Dim c As Integer = 128
        Dim d As Integer = 132 : Dim y As UInteger : Dim p As UInteger() = x

        Do
            y = p(a + 3) Xor (p(a + 3) << 8) Xor (p(a + 2) >> 24) Xor ((p(b + 3) >> 3) And &HF7EB7FEF)
            p(a + 3) = y Xor (p(c + 3) >> 24) Xor (p(d + 3) << 11)
            y = p(a + 2) Xor (p(a + 2) << 8) Xor (p(a + 1) >> 24) Xor ((p(b + 2) >> 3) And &HFFFEFE7F)
            p(a + 2) = y Xor ((p(c + 2) >> 24) or (p(c + 3) << 8)) Xor (p(d + 2) << 11)
            y = p(a + 1) Xor (p(a + 1) << 8) Xor (p(a) >> 24) Xor ((p(b + 1) >> 3) And &HF7FFFFFB)
            p(a + 1) = y Xor ((p(c + 1) >> 24) or (p(c + 2) << 8)) Xor (p(d + 1) << 11)
            y = p(a) Xor (p(a) << 8) Xor ((p(b) >> 3) And &HF7EFDBFB)
            p(a) = y Xor ((p(c) >> 24) or (p(c + 1) << 8)) Xor (p(d) << 11)
            c = d : d = a : a += 4 : b += 4
            If b = 136 Then b = 0
        Loop While a <> 136
    End Sub

    Sub New(ByVal s As UInteger)
        MyBase.New(s)
    End Sub

    Sub New(ByVal init_key As UInteger())
        MyBase.New(init_key)
    End Sub

End Class

Class Sfmt19
    Inherits Sfmt

    Public readonly Overrides Property IdString() As String
        Get
            Return "SFMT-4253:32-3-3-11-3:ffffeffd-ffffeff7-ffffffef-ffdfffff"
        End Get
    End Property

    Private Shared ParityData As UInteger() = {&H1&, &H3725B98F&, &HD6E1ADEB&, &HDFBC6DE4&}

    Protected Overrides Function GetParity() As UInteger()
        Return ParityData
    End Function

    Protected overrides Sub gen_rand_all()
        Dim a As Integer = 0 : Dim b As Integer = 128 : Dim c As Integer = 128
        Dim d As Integer = 132 : Dim y As UInteger : Dim p As UInteger() = x

        Do
            y = p(a + 3) Xor (p(a + 3) << 24) Xor (p(a + 2) >> 8) Xor ((p(b + 3) >> 11) And &HFFDFFFFF)
            p(a + 3) = y Xor (p(c + 3) >> 24) Xor (p(d + 3) << 3)
            y = p(a + 2) Xor (p(a + 2) << 24) Xor (p(a + 1) >> 8) Xor ((p(b + 2) >> 11) And &HFFFFFFEF)
            p(a + 2) = y Xor ((p(c + 2) >> 24) or (p(c + 3) << 8)) Xor (p(d + 2) << 3)
            y = p(a + 1) Xor (p(a + 1) << 24) Xor (p(a) >> 8) Xor ((p(b + 1) >> 11) And &HFFFFEFF7)
            p(a + 1) = y Xor ((p(c + 1) >> 24) or (p(c + 2) << 8)) Xor (p(d + 1) << 3)
            y = p(a) Xor (p(a) << 24) Xor ((p(b) >> 11) And &HFFFFEFFD)
            p(a) = y Xor ((p(c) >> 24) or (p(c + 1) << 8)) Xor (p(d) << 3)
            c = d : d = a : a += 4 : b += 4
            If b = 136 Then b = 0
        Loop While a <> 136
    End Sub

    Sub New(ByVal s As UInteger)
        MyBase.New(s)
    End Sub

    Sub New(ByVal init_key As UInteger())
        MyBase.New(init_key)
    End Sub

End Class

Class Sfmt20
    Inherits Sfmt

    Public readonly Overrides Property IdString() As String
        Get
            Return "SFMT-4253:9-5-3-26-1:b9ffffdf-f9fdff7f-fffebffe-b6ff7ffd"
        End Get
    End Property

    Private Shared ParityData As UInteger() = {&H10000001&, &HBC129652&, &HB4C6341B&, &H13CB9597&}

    Protected Overrides Function GetParity() As UInteger()
        Return ParityData
    End Function

    Protected overrides Sub gen_rand_all()
        Dim a As Integer = 0 : Dim b As Integer = 36 : Dim c As Integer = 128
        Dim d As Integer = 132 : Dim y As UInteger : Dim p As UInteger() = x

        Do
            y = p(a + 3) Xor (p(a + 3) << 24) Xor (p(a + 2) >> 8) Xor ((p(b + 3) >> 26) And &HB6FF7FFD)
            p(a + 3) = y Xor (p(c + 3) >> 8) Xor (p(d + 3) << 5)
            y = p(a + 2) Xor (p(a + 2) << 24) Xor (p(a + 1) >> 8) Xor ((p(b + 2) >> 26) And &HFFFEBFFE)
            p(a + 2) = y Xor ((p(c + 2) >> 8) or (p(c + 3) << 24)) Xor (p(d + 2) << 5)
            y = p(a + 1) Xor (p(a + 1) << 24) Xor (p(a) >> 8) Xor ((p(b + 1) >> 26) And &HF9FDFF7F)
            p(a + 1) = y Xor ((p(c + 1) >> 8) or (p(c + 2) << 24)) Xor (p(d + 1) << 5)
            y = p(a) Xor (p(a) << 24) Xor ((p(b) >> 26) And &HB9FFFFDF)
            p(a) = y Xor ((p(c) >> 8) or (p(c + 1) << 24)) Xor (p(d) << 5)
            c = d : d = a : a += 4 : b += 4
            If b = 136 Then b = 0
        Loop While a <> 136
    End Sub

    Sub New(ByVal s As UInteger)
        MyBase.New(s)
    End Sub

    Sub New(ByVal init_key As UInteger())
        MyBase.New(init_key)
    End Sub

End Class

Class Sfmt21
    Inherits Sfmt

    Public readonly Overrides Property IdString() As String
        Get
            Return "SFMT-4253:32-3-3-3-5:fffffeff-fffb9d7f-ffdb9ff7-bff9fff7"
        End Get
    End Property

    Private Shared ParityData As UInteger() = {&H60000001&, &H623BE05&, &H4730C7B7&, &HE4DCB68E&}

    Protected Overrides Function GetParity() As UInteger()
        Return ParityData
    End Function

    Protected overrides Sub gen_rand_all()
        Dim a As Integer = 0 : Dim b As Integer = 128 : Dim c As Integer = 128
        Dim d As Integer = 132 : Dim y As UInteger : Dim p As UInteger() = x

        Do
            y = p(a + 3) Xor (p(a + 3) << 24) Xor (p(a + 2) >> 8) Xor ((p(b + 3) >> 3) And &HBFF9FFF7)
            p(a + 3) = y Xor (p(d + 3) << 3)
            y = p(a + 2) Xor (p(a + 2) << 24) Xor (p(a + 1) >> 8) Xor ((p(b + 2) >> 3) And &HFFDB9FF7)
            p(a + 2) = y Xor (p(c + 3) >> 8) Xor (p(d + 2) << 3)
            y = p(a + 1) Xor (p(a + 1) << 24) Xor (p(a) >> 8) Xor ((p(b + 1) >> 3) And &HFFFB9D7F)
            p(a + 1) = y Xor ((p(c + 2) >> 8) or (p(c + 3) << 24)) Xor (p(d + 1) << 3)
            y = p(a) Xor (p(a) << 24) Xor ((p(b) >> 3) And &HFFFFFEFF)
            p(a) = y Xor ((p(c + 1) >> 8) or (p(c + 2) << 24)) Xor (p(d) << 3)
            c = d : d = a : a += 4 : b += 4
            If b = 136 Then b = 0
        Loop While a <> 136
    End Sub

    Sub New(ByVal s As UInteger)
        MyBase.New(s)
    End Sub

    Sub New(ByVal init_key As UInteger())
        MyBase.New(init_key)
    End Sub

End Class

Class Sfmt22
    Inherits Sfmt

    Public readonly Overrides Property IdString() As String
        Get
            Return "SFMT-4253:32-21-3-7-1:ff3feefd-ffffecff-fffffcfd-fffbadfd"
        End Get
    End Property

    Private Shared ParityData As UInteger() = {&H70000001&, &HB4DC9C74&, &HFA71D735&, &H2B9421BD&}

    Protected Overrides Function GetParity() As UInteger()
        Return ParityData
    End Function

    Protected overrides Sub gen_rand_all()
        Dim a As Integer = 0 : Dim b As Integer = 128 : Dim c As Integer = 128
        Dim d As Integer = 132 : Dim y As UInteger : Dim p As UInteger() = x

        Do
            y = p(a + 3) Xor (p(a + 3) << 24) Xor (p(a + 2) >> 8) Xor ((p(b + 3) >> 7) And &HFFFBADFD)
            p(a + 3) = y Xor (p(c + 3) >> 8) Xor (p(d + 3) << 21)
            y = p(a + 2) Xor (p(a + 2) << 24) Xor (p(a + 1) >> 8) Xor ((p(b + 2) >> 7) And &HFFFFFCFD)
            p(a + 2) = y Xor ((p(c + 2) >> 8) or (p(c + 3) << 24)) Xor (p(d + 2) << 21)
            y = p(a + 1) Xor (p(a + 1) << 24) Xor (p(a) >> 8) Xor ((p(b + 1) >> 7) And &HFFFFECFF)
            p(a + 1) = y Xor ((p(c + 1) >> 8) or (p(c + 2) << 24)) Xor (p(d + 1) << 21)
            y = p(a) Xor (p(a) << 24) Xor ((p(b) >> 7) And &HFF3FEEFD)
            p(a) = y Xor ((p(c) >> 8) or (p(c + 1) << 24)) Xor (p(d) << 21)
            c = d : d = a : a += 4 : b += 4
            If b = 136 Then b = 0
        Loop While a <> 136
    End Sub

    Sub New(ByVal s As UInteger)
        MyBase.New(s)
    End Sub

    Sub New(ByVal init_key As UInteger())
        MyBase.New(init_key)
    End Sub

End Class

Class Sfmt23
    Inherits Sfmt

    Public readonly Overrides Property IdString() As String
        Get
            Return "SFMT-4253:13-22-1-9-3:ffffebfb-7fffbb7f-cbddfffb-fff7ff7f"
        End Get
    End Property

    Private Shared ParityData As UInteger() = {&H1&, &H179503C2&, &H84579CD5&, &H8BCF2F27&}

    Protected Overrides Function GetParity() As UInteger()
        Return ParityData
    End Function

    Protected overrides Sub gen_rand_all()
        Dim a As Integer = 0 : Dim b As Integer = 52 : Dim c As Integer = 128
        Dim d As Integer = 132 : Dim y As UInteger : Dim p As UInteger() = x

        Do
            y = p(a + 3) Xor (p(a + 3) << 8) Xor (p(a + 2) >> 24) Xor ((p(b + 3) >> 9) And &HFFF7FF7F)
            p(a + 3) = y Xor (p(c + 3) >> 24) Xor (p(d + 3) << 22)
            y = p(a + 2) Xor (p(a + 2) << 8) Xor (p(a + 1) >> 24) Xor ((p(b + 2) >> 9) And &HCBDDFFFB)
            p(a + 2) = y Xor ((p(c + 2) >> 24) or (p(c + 3) << 8)) Xor (p(d + 2) << 22)
            y = p(a + 1) Xor (p(a + 1) << 8) Xor (p(a) >> 24) Xor ((p(b + 1) >> 9) And &H7FFFBB7F)
            p(a + 1) = y Xor ((p(c + 1) >> 24) or (p(c + 2) << 8)) Xor (p(d + 1) << 22)
            y = p(a) Xor (p(a) << 8) Xor ((p(b) >> 9) And &HFFFFEBFB)
            p(a) = y Xor ((p(c) >> 24) or (p(c + 1) << 8)) Xor (p(d) << 22)
            c = d : d = a : a += 4 : b += 4
            If b = 136 Then b = 0
        Loop While a <> 136
    End Sub

    Sub New(ByVal s As UInteger)
        MyBase.New(s)
    End Sub

    Sub New(ByVal init_key As UInteger())
        MyBase.New(init_key)
    End Sub

End Class

Class Sfmt24
    Inherits Sfmt

    Public readonly Overrides Property IdString() As String
        Get
            Return "SFMT-4253:27-11-5-8-3:d73d23f7-ef7fffff-eeffffdf-fffbf6cf"
        End Get
    End Property

    Private Shared ParityData As UInteger() = {&H40000001&, &HBEC29ED7&, &H722046BC&, &H7D6AC005&}

    Protected Overrides Function GetParity() As UInteger()
        Return ParityData
    End Function

    Protected overrides Sub gen_rand_all()
        Dim a As Integer = 0 : Dim b As Integer = 108 : Dim c As Integer = 128
        Dim d As Integer = 132 : Dim y As UInteger : Dim p As UInteger() = x

        Do
            y = p(a + 3) Xor (p(a + 2) << 8) Xor (p(a + 1) >> 24) Xor ((p(b + 3) >> 8) And &HFFFBF6CF)
            p(a + 3) = y Xor (p(c + 3) >> 24) Xor (p(d + 3) << 11)
            y = p(a + 2) Xor (p(a + 1) << 8) Xor (p(a) >> 24) Xor ((p(b + 2) >> 8) And &HEEFFFFDF)
            p(a + 2) = y Xor ((p(c + 2) >> 24) or (p(c + 3) << 8)) Xor (p(d + 2) << 11)
            y = p(a + 1) Xor (p(a) << 8) Xor ((p(b + 1) >> 8) And &HEF7FFFFF)
            p(a + 1) = y Xor ((p(c + 1) >> 24) or (p(c + 2) << 8)) Xor (p(d + 1) << 11)
            y = p(a) Xor ((p(b) >> 8) And &HD73D23F7)
            p(a) = y Xor ((p(c) >> 24) or (p(c + 1) << 8)) Xor (p(d) << 11)
            c = d : d = a : a += 4 : b += 4
            If b = 136 Then b = 0
        Loop While a <> 136
    End Sub

    Sub New(ByVal s As UInteger)
        MyBase.New(s)
    End Sub

    Sub New(ByVal init_key As UInteger())
        MyBase.New(init_key)
    End Sub

End Class

Class Sfmt25
    Inherits Sfmt

    Public readonly Overrides Property IdString() As String
        Get
            Return "SFMT-4253:19-26-1-19-7:efbfbff7-fb7fffff-feeffdfb-7fbfebf9"
        End Get
    End Property

    Private Shared ParityData As UInteger() = {&HB0000001&, &HC49C2158&, &HDD1DB4E7&, &HDA08972&}

    Protected Overrides Function GetParity() As UInteger()
        Return ParityData
    End Function

    Protected overrides Sub gen_rand_all()
        Dim a As Integer = 0 : Dim b As Integer = 76 : Dim c As Integer = 128
        Dim d As Integer = 132 : Dim y As UInteger : Dim p As UInteger() = x

        Do
            y = p(a + 3) Xor (p(a + 3) << 8) Xor (p(a + 2) >> 24) Xor ((p(b + 3) >> 19) And &H7FBFEBF9)
            p(a + 3) = y Xor (p(d + 3) << 26)
            y = p(a + 2) Xor (p(a + 2) << 8) Xor (p(a + 1) >> 24) Xor ((p(b + 2) >> 19) And &HFEEFFDFB)
            p(a + 2) = y Xor (p(c + 3) >> 24) Xor (p(d + 2) << 26)
            y = p(a + 1) Xor (p(a + 1) << 8) Xor (p(a) >> 24) Xor ((p(b + 1) >> 19) And &HFB7FFFFF)
            p(a + 1) = y Xor ((p(c + 2) >> 24) or (p(c + 3) << 8)) Xor (p(d + 1) << 26)
            y = p(a) Xor (p(a) << 8) Xor ((p(b) >> 19) And &HEFBFBFF7)
            p(a) = y Xor ((p(c + 1) >> 24) or (p(c + 2) << 8)) Xor (p(d) << 26)
            c = d : d = a : a += 4 : b += 4
            If b = 136 Then b = 0
        Loop While a <> 136
    End Sub

    Sub New(ByVal s As UInteger)
        MyBase.New(s)
    End Sub

    Sub New(ByVal init_key As UInteger())
        MyBase.New(init_key)
    End Sub

End Class

Class Sfmt26
    Inherits Sfmt

    Public readonly Overrides Property IdString() As String
        Get
            Return "SFMT-4253:12-29-1-1-1:fff7dffd-ffdd7fbd-ffffbff7-ffff9dff"
        End Get
    End Property

    Private Shared ParityData As UInteger() = {&HE0000001&, &H8ECABA1B&, &H4A61645B&, &H6AAC5023&}

    Protected Overrides Function GetParity() As UInteger()
        Return ParityData
    End Function

    Protected overrides Sub gen_rand_all()
        Dim a As Integer = 0 : Dim b As Integer = 48 : Dim c As Integer = 128
        Dim d As Integer = 132 : Dim y As UInteger : Dim p As UInteger() = x

        Do
            y = p(a + 3) Xor (p(a + 3) << 8) Xor (p(a + 2) >> 24) Xor ((p(b + 3) >> 1) And &HFFFF9DFF)
            p(a + 3) = y Xor (p(c + 3) >> 8) Xor (p(d + 3) << 29)
            y = p(a + 2) Xor (p(a + 2) << 8) Xor (p(a + 1) >> 24) Xor ((p(b + 2) >> 1) And &HFFFFBFF7)
            p(a + 2) = y Xor ((p(c + 2) >> 8) or (p(c + 3) << 24)) Xor (p(d + 2) << 29)
            y = p(a + 1) Xor (p(a + 1) << 8) Xor (p(a) >> 24) Xor ((p(b + 1) >> 1) And &HFFDD7FBD)
            p(a + 1) = y Xor ((p(c + 1) >> 8) or (p(c + 2) << 24)) Xor (p(d + 1) << 29)
            y = p(a) Xor (p(a) << 8) Xor ((p(b) >> 1) And &HFFF7DFFD)
            p(a) = y Xor ((p(c) >> 8) or (p(c + 1) << 24)) Xor (p(d) << 29)
            c = d : d = a : a += 4 : b += 4
            If b = 136 Then b = 0
        Loop While a <> 136
    End Sub

    Sub New(ByVal s As UInteger)
        MyBase.New(s)
    End Sub

    Sub New(ByVal init_key As UInteger())
        MyBase.New(init_key)
    End Sub

End Class

Class Sfmt27
    Inherits Sfmt

    Public readonly Overrides Property IdString() As String
        Get
            Return "SFMT-4253:25-22-5-19-3:efffffef-fbdfb3ff-fbf7f7fd-fef7fffb"
        End Get
    End Property

    Private Shared ParityData As UInteger() = {&H80000001&, &HACAA212F&, &HAA5340C9&, &H5CA836D2&}

    Protected Overrides Function GetParity() As UInteger()
        Return ParityData
    End Function

    Protected overrides Sub gen_rand_all()
        Dim a As Integer = 0 : Dim b As Integer = 100 : Dim c As Integer = 128
        Dim d As Integer = 132 : Dim y As UInteger : Dim p As UInteger() = x

        Do
            y = p(a + 3) Xor (p(a + 2) << 8) Xor (p(a + 1) >> 24) Xor ((p(b + 3) >> 19) And &HFEF7FFFB)
            p(a + 3) = y Xor (p(c + 3) >> 24) Xor (p(d + 3) << 22)
            y = p(a + 2) Xor (p(a + 1) << 8) Xor (p(a) >> 24) Xor ((p(b + 2) >> 19) And &HFBF7F7FD)
            p(a + 2) = y Xor ((p(c + 2) >> 24) or (p(c + 3) << 8)) Xor (p(d + 2) << 22)
            y = p(a + 1) Xor (p(a) << 8) Xor ((p(b + 1) >> 19) And &HFBDFB3FF)
            p(a + 1) = y Xor ((p(c + 1) >> 24) or (p(c + 2) << 8)) Xor (p(d + 1) << 22)
            y = p(a) Xor ((p(b) >> 19) And &HEFFFFFEF)
            p(a) = y Xor ((p(c) >> 24) or (p(c + 1) << 8)) Xor (p(d) << 22)
            c = d : d = a : a += 4 : b += 4
            If b = 136 Then b = 0
        Loop While a <> 136
    End Sub

    Sub New(ByVal s As UInteger)
        MyBase.New(s)
    End Sub

    Sub New(ByVal init_key As UInteger())
        MyBase.New(init_key)
    End Sub

End Class

Class Sfmt28
    Inherits Sfmt

    Public readonly Overrides Property IdString() As String
        Get
            Return "SFMT-4253:24-2-3-7-1:ef8ffffa-fffbfff8-f7ffbfe9-77ffbffd"
        End Get
    End Property

    Private Shared ParityData As UInteger() = {&H20000001&, &H8F3C8AE4&, &HA3CF01C6&, &HA91D27DD&}

    Protected Overrides Function GetParity() As UInteger()
        Return ParityData
    End Function

    Protected overrides Sub gen_rand_all()
        Dim a As Integer = 0 : Dim b As Integer = 96 : Dim c As Integer = 128
        Dim d As Integer = 132 : Dim y As UInteger : Dim p As UInteger() = x

        Do
            y = p(a + 3) Xor (p(a + 3) << 24) Xor (p(a + 2) >> 8) Xor ((p(b + 3) >> 7) And &H77FFBFFD)
            p(a + 3) = y Xor (p(c + 3) >> 8) Xor (p(d + 3) << 2)
            y = p(a + 2) Xor (p(a + 2) << 24) Xor (p(a + 1) >> 8) Xor ((p(b + 2) >> 7) And &HF7FFBFE9)
            p(a + 2) = y Xor ((p(c + 2) >> 8) or (p(c + 3) << 24)) Xor (p(d + 2) << 2)
            y = p(a + 1) Xor (p(a + 1) << 24) Xor (p(a) >> 8) Xor ((p(b + 1) >> 7) And &HFFFBFFF8)
            p(a + 1) = y Xor ((p(c + 1) >> 8) or (p(c + 2) << 24)) Xor (p(d + 1) << 2)
            y = p(a) Xor (p(a) << 24) Xor ((p(b) >> 7) And &HEF8FFFFA)
            p(a) = y Xor ((p(c) >> 8) or (p(c + 1) << 24)) Xor (p(d) << 2)
            c = d : d = a : a += 4 : b += 4
            If b = 136 Then b = 0
        Loop While a <> 136
    End Sub

    Sub New(ByVal s As UInteger)
        MyBase.New(s)
    End Sub

    Sub New(ByVal init_key As UInteger())
        MyBase.New(init_key)
    End Sub

End Class

Class Sfmt29
    Inherits Sfmt

    Public readonly Overrides Property IdString() As String
        Get
            Return "SFMT-4253:4-14-5-9-3:7bfffff7-fff7fff3-ff9fbf9e-fffdafff"
        End Get
    End Property

    Private Shared ParityData As UInteger() = {&HC0000001&, &H93FCF151&, &H739A3CF7&, &H72B647F3&}

    Protected Overrides Function GetParity() As UInteger()
        Return ParityData
    End Function

    Protected overrides Sub gen_rand_all()
        Dim a As Integer = 0 : Dim b As Integer = 16 : Dim c As Integer = 128
        Dim d As Integer = 132 : Dim y As UInteger : Dim p As UInteger() = x

        Do
            y = p(a + 3) Xor (p(a + 2) << 8) Xor (p(a + 1) >> 24) Xor ((p(b + 3) >> 9) And &HFFFDAFFF)
            p(a + 3) = y Xor (p(c + 3) >> 24) Xor (p(d + 3) << 14)
            y = p(a + 2) Xor (p(a + 1) << 8) Xor (p(a) >> 24) Xor ((p(b + 2) >> 9) And &HFF9FBF9E)
            p(a + 2) = y Xor ((p(c + 2) >> 24) or (p(c + 3) << 8)) Xor (p(d + 2) << 14)
            y = p(a + 1) Xor (p(a) << 8) Xor ((p(b + 1) >> 9) And &HFFF7FFF3)
            p(a + 1) = y Xor ((p(c + 1) >> 24) or (p(c + 2) << 8)) Xor (p(d + 1) << 14)
            y = p(a) Xor ((p(b) >> 9) And &H7BFFFFF7)
            p(a) = y Xor ((p(c) >> 24) or (p(c + 1) << 8)) Xor (p(d) << 14)
            c = d : d = a : a += 4 : b += 4
            If b = 136 Then b = 0
        Loop While a <> 136
    End Sub

    Sub New(ByVal s As UInteger)
        MyBase.New(s)
    End Sub

    Sub New(ByVal init_key As UInteger())
        MyBase.New(init_key)
    End Sub

End Class

Class Sfmt30
    Inherits Sfmt

    Public readonly Overrides Property IdString() As String
        Get
            Return "SFMT-4253:21-20-1-19-3:ffb7fffd-9fefedfd-9edb6ffb-bedeb7ff"
        End Get
    End Property

    Private Shared ParityData As UInteger() = {&H40000001&, &H9ED70B6B&, &H661E1CA7&, &HFD968985&}

    Protected Overrides Function GetParity() As UInteger()
        Return ParityData
    End Function

    Protected overrides Sub gen_rand_all()
        Dim a As Integer = 0 : Dim b As Integer = 84 : Dim c As Integer = 128
        Dim d As Integer = 132 : Dim y As UInteger : Dim p As UInteger() = x

        Do
            y = p(a + 3) Xor (p(a + 3) << 8) Xor (p(a + 2) >> 24) Xor ((p(b + 3) >> 19) And &HBEDEB7FF)
            p(a + 3) = y Xor (p(c + 3) >> 24) Xor (p(d + 3) << 20)
            y = p(a + 2) Xor (p(a + 2) << 8) Xor (p(a + 1) >> 24) Xor ((p(b + 2) >> 19) And &H9EDB6FFB)
            p(a + 2) = y Xor ((p(c + 2) >> 24) or (p(c + 3) << 8)) Xor (p(d + 2) << 20)
            y = p(a + 1) Xor (p(a + 1) << 8) Xor (p(a) >> 24) Xor ((p(b + 1) >> 19) And &H9FEFEDFD)
            p(a + 1) = y Xor ((p(c + 1) >> 24) or (p(c + 2) << 8)) Xor (p(d + 1) << 20)
            y = p(a) Xor (p(a) << 8) Xor ((p(b) >> 19) And &HFFB7FFFD)
            p(a) = y Xor ((p(c) >> 24) or (p(c + 1) << 8)) Xor (p(d) << 20)
            c = d : d = a : a += 4 : b += 4
            If b = 136 Then b = 0
        Loop While a <> 136
    End Sub

    Sub New(ByVal s As UInteger)
        MyBase.New(s)
    End Sub

    Sub New(ByVal init_key As UInteger())
        MyBase.New(init_key)
    End Sub

End Class

Class Sfmt31
    Inherits Sfmt

    Public readonly Overrides Property IdString() As String
        Get
            Return "SFMT-4253:31-15-5-14-3:efbce7ff-feb7f77f-fff3ffbf-bfffb75f"
        End Get
    End Property

    Private Shared ParityData As UInteger() = {&H48000001&, &H836A277A&, &HC4833EB6&, &H22B0DC59&}

    Protected Overrides Function GetParity() As UInteger()
        Return ParityData
    End Function

    Protected overrides Sub gen_rand_all()
        Dim a As Integer = 0 : Dim b As Integer = 124 : Dim c As Integer = 128
        Dim d As Integer = 132 : Dim y As UInteger : Dim p As UInteger() = x

        Do
            y = p(a + 3) Xor (p(a + 2) << 8) Xor (p(a + 1) >> 24) Xor ((p(b + 3) >> 14) And &HBFFFB75F)
            p(a + 3) = y Xor (p(c + 3) >> 24) Xor (p(d + 3) << 15)
            y = p(a + 2) Xor (p(a + 1) << 8) Xor (p(a) >> 24) Xor ((p(b + 2) >> 14) And &HFFF3FFBF)
            p(a + 2) = y Xor ((p(c + 2) >> 24) or (p(c + 3) << 8)) Xor (p(d + 2) << 15)
            y = p(a + 1) Xor (p(a) << 8) Xor ((p(b + 1) >> 14) And &HFEB7F77F)
            p(a + 1) = y Xor ((p(c + 1) >> 24) or (p(c + 2) << 8)) Xor (p(d + 1) << 15)
            y = p(a) Xor ((p(b) >> 14) And &HEFBCE7FF)
            p(a) = y Xor ((p(c) >> 24) or (p(c + 1) << 8)) Xor (p(d) << 15)
            c = d : d = a : a += 4 : b += 4
            If b = 136 Then b = 0
        Loop While a <> 136
    End Sub

    Sub New(ByVal s As UInteger)
        MyBase.New(s)
    End Sub

    Sub New(ByVal init_key As UInteger())
        MyBase.New(init_key)
    End Sub

End Class

Class Sfmt_m

    Private Shared z as Sfmt() = { _
        New Sfmt  (1), _
        New Sfmt1 (&HFFFFFFFF&), _
        New Sfmt2 (&HFFFFFFFE&), _
        New Sfmt3 (&HFFFFFFFD&), _
        New Sfmt4 (&HFFFFFFFC&), _
        New Sfmt5 (&HFFFFFFFB&), _
        New Sfmt6 (&HFFFFFFFA&), _
        New Sfmt7 (&HFFFFFFF9&), _
        New Sfmt8 (&HFFFFFFF8&), _
        New Sfmt9 (&HFFFFFFF7&), _
        New Sfmt10(&HFFFFFFF6&), _
        New Sfmt11(&HFFFFFFF5&), _
        New Sfmt12(&HFFFFFFF4&), _
        New Sfmt13(&HFFFFFFF3&), _
        New Sfmt14(&HFFFFFFF2&), _
        New Sfmt15(&HFFFFFFF1&), _
        New Sfmt16(&HFFFFFFF0&), _
        New Sfmt17(&HFFFFFFEF&), _
        New Sfmt18(&HFFFFFFEE&), _
        New Sfmt19(&HFFFFFFED&), _
        New Sfmt20(&HFFFFFFEC&), _
        New Sfmt21(&HFFFFFFEB&), _
        New Sfmt22(&HFFFFFFEA&), _
        New Sfmt23(&HFFFFFFE9&), _
        New Sfmt24(&HFFFFFFE8&), _
        New Sfmt25(&HFFFFFFE7&), _
        New Sfmt26(&HFFFFFFE6&), _
        New Sfmt27(&HFFFFFFE5&), _
        New Sfmt28(&HFFFFFFE4&), _
        New Sfmt29(&HFFFFFFE3&), _
        New Sfmt30(&HFFFFFFE2&), _
        New Sfmt31(&HFFFFFFE1&) _
    }

    Public Shared Function IdString_m(ByVal i As Integer) As String
        Return z(i).IdString
    End Function

    Public Shared Sub InitMt_m(ByVal i As Integer,ByVal s As UInteger)
        z(i).InitMt(s)
    End Sub

    Public Shared Sub InitMtEx_m(ByVal i As Integer,ByVal k As UInteger())
        z(i).InitMtEx(k)
    End Sub

    Public Shared Function NextMt_m(ByVal i As Integer) As UInteger
        Return z(i).NextMt()
    End Function

    Public Shared Function NextInt_m(ByVal i As Integer,ByVal n As Integer) As Integer
        Return z(i).NextInt(n)
    End Function

    Public Shared Function NextBit_m(ByVal i As Integer) As Integer
        Return z(i).NextBit()
    End Function

    Public Shared Function NextByte_m(ByVal i As Integer) As Integer
        Return z(i).NextByte()
    End Function

    Public Shared Function NextUnif_m(ByVal i As Integer) As Double
        Return z(i).NextUnif()
    End Function

    Public Shared Function NextIntEx_m(ByVal i As Integer,ByVal r As Integer) As Integer
        Return z(i).NextIntEx(r)
    End Function

    Public Shared Function NextChisq_m(ByVal i As Integer,ByVal n As Double) As Double
        Return z(i).NextChisq(n)
    End Function

    Public Shared Function NextGamma_m(ByVal i As Integer,ByVal a As Double) As Double
        Return z(i).NextGamma(a)
    End Function

    Public Shared Function NextGeometric_m(ByVal i As Integer,ByVal p As Double) As Integer
        Return z(i).NextGeometric(p)
    End Function

    Public Shared Function NextTriangle_m(ByVal i As Integer) As Double
        Return z(i).NextTriangle()
    End Function

    Public Shared Function NextExp_m(ByVal i As Integer) As Double
        Return z(i).NextExp()
    End Function

    Public Shared Function NextNormal_m(ByVal i As Integer) As Double
        Return z(i).NextNormal()
    End Function

    Public Shared Sub NextUnitVect_m(ByVal i As Integer,ByRef v As Double(),ByVal n As Integer)
        z(i).NextUnitVect(v,n)
    End Sub

    Public Shared Function NextBinomial_m(ByVal i As Integer,ByVal n As Integer,ByVal p As Double) As Integer
        Return z(i).NextBinomial(n,p)
    End Function

    Public Shared Sub NextBinormal_m(ByVal i As Integer,ByVal r As Double,ByRef a As Double,ByRef b As Double)
        z(i).NextBinormal(r,a,b)
    End Sub

    Public Shared Function NextBeta_m(ByVal i As Integer,ByVal a As Double,ByVal b As Double) As Double
        Return z(i).NextBeta(a,b)
    End Function

    Public Shared Function NextPower_m(ByVal i As Integer,ByVal n As Double) As Double
        Return z(i).NextPower(n)
    End Function

    Public Shared Function NextLogistic_m(ByVal i As Integer) As Double
        Return z(i).NextLogistic()
    End Function

    Public Shared Function NextCauchy_m(ByVal i As Integer) As Double
        Return z(i).NextCauchy()
    End Function

    Public Shared Function NextPoisson_m(ByVal i As Integer,ByVal l As Double) As Integer
        Return z(i).NextPoisson(l)
    End Function

    Public Shared Function NextFDist_m(ByVal i As Integer,ByVal n1 As Double,ByVal n2 As Double) As Double
        Return z(i).NextFDist(n1,n2)
    End Function

    Public Shared Function NextTDist_m(ByVal i As Integer,ByVal n As Double) As Double
        Return z(i).NextTDist(n)
    End Function

    Public Shared Function NextWeibull_m(ByVal i As Integer,ByVal a As Double) As Double
        Return z(i).NextWeibull(a)
    End Function

End Class

