'
' Sfmt607.vb Cu
' coded by isaku@pb4.so-net.ne.jp
' 

Class Sfmt

    Private index As Integer
    Private coin_bits As Integer ' NextBit ł̎c̃rbg
    Private coin_save As UInteger ' NextBit ł̒lێ
    Private byte_pos As Integer ' NextByte ŎgpoCg
    Private byte_save As UInteger ' NextByte ł̒lێ
    Private range As Integer ' NextIntEx őO͈̔
    Private bse As UInteger  ' NextIntEx őO̊l
    Private shift As Integer ' NextIntEx őÕVtg
    Private normal_sw As Integer  ' NextNormal ŎcĂ
    Private normal_save As Double ' NextNormal ̎c̒l
    Protected x(19) As UInteger ' ԃe[u
    Private Shared ParityData As UInteger() = {&H1&, &H0&, &H0&, &H5986F054&}

    Protected Overridable Function GetParity() As UInteger()
        Return ParityData
    End Function

    Public readonly Overridable Property IdString() As String
        Get
            Return "SFMT-607:2-15-3-13-3:fdff37ff-ef7f3f7d-ff777b7d-7ff7fb2f"
        End Get
    End Property

    Protected Overridable Sub gen_rand_all()
        Dim a As Integer = 0 : Dim b As Integer = 8 : Dim c As Integer = 12
        Dim d As Integer = 16 : Dim y As UInteger : Dim p As UInteger() = x

        Do
            y = p(a + 3) Xor (p(a + 3) << 24) Xor (p(a + 2) >> 8) Xor ((p(b + 3) >> 13) And &H7FF7FB2F)
            p(a + 3) = y Xor (p(c + 3) >> 24) Xor (p(d + 3) << 15)
            y = p(a + 2) Xor (p(a + 2) << 24) Xor (p(a + 1) >> 8) Xor ((p(b + 2) >> 13) And &HFF777B7D)
            p(a + 2) = y Xor ((p(c + 2) >> 24) or (p(c + 3) << 8)) Xor (p(d + 2) << 15)
            y = p(a + 1) Xor (p(a + 1) << 24) Xor (p(a) >> 8) Xor ((p(b + 1) >> 13) And &HEF7F3F7D)
            p(a + 1) = y Xor ((p(c + 1) >> 24) or (p(c + 2) << 8)) Xor (p(d + 1) << 15)
            y = p(a) Xor (p(a) << 24) Xor ((p(b) >> 13) And &HFDFF37FF)
            p(a) = y Xor ((p(c) >> 24) or (p(c + 1) << 8)) Xor (p(d) << 15)
            c = d : d = a : a += 4 : b += 4
            If b = 20 Then b = 0
        Loop While a <> 20
    End Sub

    Private Sub period_certification()
        Dim work As UInteger : Dim inner As UInteger = 0 : Dim i, j As Integer
        Dim parity As UInteger() = GetParity()

        index = 20 : range = 0 : normal_sw = 0 : coin_bits = 0 : byte_pos = 0
        For i = 0 To 3 : inner = inner Xor x(i) And parity(i) : Next
        i = 16 : Do : inner = inner Xor inner >> i : i >>= 1 : Loop While i > 0
        inner = inner And 1
        If inner = 1 Then Return
        For i = 0 To 3
            j = 0 : work = 1
            Do
                If (work And parity(i)) <> 0 Then
                    x(i) = x(i) Xor work
                    Return
                End If
                j += 1
                work <<= 1
            Loop While j < 32
        Next
    End Sub

    ' ̎ s ɂ鏉
    Public Sub InitMt(ByVal s As UInteger)
        Dim p As UInteger
        x(0) = s
        For p = 1 To 19
            s = 1812433253 * (s Xor (s >> 30)) + p
            x(p) = s
        Next
        period_certification()
    End Sub

    Sub New(ByVal s As UInteger)
        InitMt(s)
    End Sub
    
    ' z init_key ɂ鏉
    Public Sub InitMtEx(ByVal init_key() As UInteger)
        Dim r, i, j, c As UInteger
        Dim key_len As UInteger = init_key.Length

        For i = 0 To 19 : x(i) = &H8B8B8B8B& : Next
        If key_len + 1 > 20 Then c = key_len + 1 Else c = 20
        r = x(0) Xor x(8) Xor x(19) : r = (r Xor (r >> 27)) * 1664525
        x(8) += r : r += key_len : x(11) += r : x(0) = r : c -= 1
        i = 1 : j = 0
        Do While j < c And j < key_len
            r = x(i) Xor x((i + 8) Mod 20) Xor x((i + 19) Mod 20)
            r = (r Xor (r >> 27)) * 1664525 : x((i + 8) Mod 20) += r
            r += init_key(j) + i : x((i + 11) Mod 20) += r
            x(i) = r : i = (i + 1) Mod 20 : j += 1
        Loop
        Do While j < c
            r = x(i) Xor x((i + 8) Mod 20) Xor x((i + 19) Mod 20)
            r = (r Xor (r >> 27)) * 1664525 : x((i + 8) Mod 20) += r : r += i
            x((i + 11) Mod 20) += r : x(i) = r : i = (i + 1) Mod 20 : j += 1
        Loop
        For j = 0 To 19
            r = x(i) + x((i + 8) Mod 20) + x((i + 19) Mod 20)
            r = (r Xor (r >> 27)) * 1566083941
            c = (i + 8) Mod 20 : x(c) = x(c) Xor r : r -= i
            c = (i + 11) Mod 20 : x(c) = x(c) Xor r
            x(i) = r : i = (i + 1) Mod 20
        Next
        period_certification()
    End Sub


    Sub New(ByVal init_key() As UInteger)
        InitMtEx(init_key)
    End Sub
    
    ' 32rbgȂ̗
    Public Function NextMt() As UInteger
        If index = 20 Then
            gen_rand_all()
            index = 0
        End If
        nextmt = x(index)
        index += 1
    End Function

    ' Oȏ n ̐
    Public Function NextInt(ByVal n As Integer) As Integer
        Return Int(n * (1.0 / 4294967296.0) * NextMt())
    End Function

    ' OPԂ
    Public Function NextBit() As integer
        coin_bits = coin_bits - 1
        If coin_bits = -1 Then
            coin_bits = 31
            coin_save = NextMt
        Else
            coin_save = coin_save >> 1
        End If
        NextBit = coin_save And 1
    End Function

    ' OPԂ
    Public Function NextByte() As integer
        byte_pos = byte_pos - 1
        If byte_pos = -1 Then
            byte_pos = 3
            byte_save = NextMt
        Else
            byte_save = byte_save >> 8
        End If
        NextByte = byte_save And 255
    End Function

    ' OȏP̗(53bitx)
    Public Function NextUnif() As Double
        Dim z As UInteger = NextMt() >> 11
        Dim y As UInteger = NextMt()
        Return (y * 2097152.0 + z) * (1.0 / 9007199254740992.0)
    End Function

    ' ۂߌ덷̂ȂOȏ range_ ̐
    Public Function NextIntEx(ByVal range_ As Integer) As Integer
        Dim y_, base_, remain_, shift_ As UInteger

        If range_ <= 0 Then Return 0
        If range_ <> range Then
            range = range_ : bse = range_ : shift = 0
            Do While bse <= 1 << 30
                bse <<= 1 : shift += 1
            Loop
        End If
        Do
            y_ = NextMt() >> 1
            If y_ < bse Then Return int(y_ >> shift)
            base_ = bse : shift_ = shift : y_ -= base_
            remain_ = (1 << 31) - base_
            Do While remain_ >= range_
                Do While base_ > remain_
                    base_ >>= 1 : shift_ -= 1
                Loop
                If y_ < base_ Then Return int(y_ >> shift_)
                y_ -= base_
                remain_ -= base_
            Loop
        Loop
    End Function
    
    ' Rx˂̃JCQ敪z
    Public Function NextChisq(ByVal n As Double) As Double
        Return 2 * NextGamma(0.5 * n)
    End Function

    ' p[^̃K}z
    Public Function NextGamma(ByVal a As Double) As double
        Dim t, u, xx, y As Double
        If a > 1 Then
            t = Math.Sqrt(2 * a - 1)
            Do
                Do
                    Do
                        Do
                            xx = 1 - NextUnif()
                            y = 2 * NextUnif() - 1
                        Loop While xx * xx + y * y > 1
                        y /= xx : xx = t * y + a - 1
                    Loop While xx <= 0
                    u = (a - 1) * Math.Log(xx / (a - 1)) - t * y
                Loop While u < -50.0
            Loop While NextUnif() > (1 + y * y) * Math.Exp(u)
        Else
            t = 2.7182818284590451 / (a + 2.7182818284590451)
            Do
                If NextUnif() < t Then
                    xx = Math.Pow(NextUnif(), 1 / a) : y = Math.Exp(-xx)
                Else
                    xx = 1 - Math.Log(1 - NextUnif()) : y = Math.Pow(xx, a - 1)
                End If
            Loop While NextUnif() >= y
        End If
        Return xx
    End Function

    ' mo̊􉽕z
    Public Function NextGeometric(ByVal p As Double) As Integer
        Return int(Math.Ceiling(Math.Log(1.0 - NextUnif()) / Math.Log(1 - p)))
    End Function

    ' Opz
    Public Function NextTriangle() As Double
        Dim a As Double = NextUnif()
        Dim b As Double = NextUnif()

        Return a - b
    End Function
    
    ' ςP̎wz
    Public Function NextExp() As Double
        Return -Math.Log(1 - NextUnif())
    End Function

    ' WKz(ő8.57)
    Public Function NextNormal() As Double
        Dim t, u As Double
        If normal_sw = 0 Then
            t = Math.Sqrt(-2 * Math.Log(1.0 - NextUnif()))
            u = 3.1415926535897931 * 2 * NextUnif()
            normal_save = t * Math.Sin(u) : normal_sw = 1
            Return t * Math.Cos(u)
        Else
            normal_sw = 0 : Return normal_save
        End If
    End Function
    
    ' m̃_PʃxNg
    Public Sub NextUnitVect(ByRef v As Double(), ByVal n As Integer)
        Dim i As Integer : Dim r As Double = 0
        ReDim v(n - 1)
        For i = 0 To n - 1
            v(i) = NextNormal() : r += v(i) * v(i)
        Next
        If r = 0 Then
            r = 1
        End If
        r = Math.Sqrt(r)
        For i = 0 To n - 1 : v(i) /= r : Next
    End Sub

    ' p[^m,ôQz
    Public Function NextBinomial(ByVal n As Integer, ByVal p As Double) As Integer
        Dim i As Integer : Dim r As Integer = 0

        For i = 0 To n - 1
            If NextUnif() < p Then r += 1
        Next
        Return r
    End Function

    ' ֌Wq̂QϗʐKz
    Public Sub NextBinormal(ByVal r As Double, ByRef a As Double, ByRef b As Double)
        Dim r1, r2, s As Double
        Do
            r1 = 2 * NextUnif() - 1
            r2 = 2 * NextUnif() - 1
            s = r1 * r1 + r2 * r2
        Loop While s > 1 Or s = 0
        s = -Math.Log(s) / s : r1 = Math.Sqrt((1 + r) * s) * r1
        r2 = Math.Sqrt((1 - r) * s) * r2 : a = r1 + r2 : b = r1 - r2
    End Sub

    ' p[^`,ãx[^z
    Public Function NextBeta(ByVal a As Double, ByVal b As Double) As Double
        Dim temp As Double = NextGamma(a)
        Return temp / (temp + NextGamma(b))
    End Function

    ' p[^m̗ݏ敪z
    Public Function NextPower(ByVal n As Double) As Double
        Return Math.Pow(NextUnif(), 1.0 / (n + 1))
    End Function

    ' WXeBbNz
    Public Function NextLogistic() As Double
        Dim r As Double
        Do : r = NextUnif() : Loop While r = 0
        Return Math.Log(r / (1 - r))
    End Function

    ' R[V[z
    Public Function NextCauchy() As Double
        Dim x, y As Double
        Do
            x = 1 - NextUnif() : y = 2 * NextUnif() - 1
        Loop While x * x + y * y > 1
        Return y / x
    End Function

    ' Rx n1,n2 ̂ez
    Public Function NextFDist(ByVal n1 As Double, ByVal n2 As Double) As Double
        Dim nc1 As Double = NextChisq(n1)
        Dim nc2 As Double = NextChisq(n2)
        Return (nc1 * n2) / (nc2 * n1)
    End Function

    ' σɂ̃|A\z
    Public Function NextPoisson(ByVal lambda As Double) As Integer
        Dim k As Integer = 0

        lambda = Math.Exp(lambda) * NextUnif()
        Do While lambda > 1
            lambda *= NextUnif()
            k += 1
        Loop
        Return k
    End Function

    ' Rxm̂z
    Public Function NextTDist(ByVal n As Double) As Double
        Dim a, b, c As Double
        If n <= 2 Then
            Do : a = NextChisq(n) : Loop While a = 0
            Return NextNormal() / Math.Sqrt(a / n)
        End If
        Do
            a = NextNormal() : b = a * a / (n - 2)
            c = Math.Log(1 - NextUnif()) / (1 - 0.5 * n)
        Loop While Math.Exp(-b - c) > 1 - b
        Return a / Math.Sqrt((1 - 2.0 / n) * (1 - b))
    End Function

    ' p[^̃Cuz
    Public Function NextWeibull(ByVal alpha As Double) As Double
        Return Math.Pow(-Math.Log(1 - NextUnif()), 1 / alpha)
    End Function
End Class

Class Sfmt1
    Inherits Sfmt

    Public readonly Overrides Property IdString() As String
        Get
            Return "SFMT-607:2-19-1-13-1:ffbfffbf-cdffffff-effbffed-fef8fbdc"
        End Get
    End Property

    Private Shared ParityData As UInteger() = {&H1&, &H0&, &H80000000&, &H30B388AF&}

    Protected Overrides Function GetParity() As UInteger()
        Return ParityData
    End Function

    Protected overrides Sub gen_rand_all()
        Dim a As Integer = 0 : Dim b As Integer = 8 : Dim c As Integer = 12
        Dim d As Integer = 16 : Dim y As UInteger : Dim p As UInteger() = x

        Do
            y = p(a + 3) Xor (p(a + 3) << 8) Xor (p(a + 2) >> 24) Xor ((p(b + 3) >> 13) And &HFEF8FBDC)
            p(a + 3) = y Xor (p(c + 3) >> 8) Xor (p(d + 3) << 19)
            y = p(a + 2) Xor (p(a + 2) << 8) Xor (p(a + 1) >> 24) Xor ((p(b + 2) >> 13) And &HEFFBFFED)
            p(a + 2) = y Xor ((p(c + 2) >> 8) or (p(c + 3) << 24)) Xor (p(d + 2) << 19)
            y = p(a + 1) Xor (p(a + 1) << 8) Xor (p(a) >> 24) Xor ((p(b + 1) >> 13) And &HCDFFFFFF)
            p(a + 1) = y Xor ((p(c + 1) >> 8) or (p(c + 2) << 24)) Xor (p(d + 1) << 19)
            y = p(a) Xor (p(a) << 8) Xor ((p(b) >> 13) And &HFFBFFFBF)
            p(a) = y Xor ((p(c) >> 8) or (p(c + 1) << 24)) Xor (p(d) << 19)
            c = d : d = a : a += 4 : b += 4
            If b = 20 Then b = 0
        Loop While a <> 20
    End Sub

    Sub New(ByVal s As UInteger)
        MyBase.New(s)
    End Sub

    Sub New(ByVal init_key As UInteger())
        MyBase.New(init_key)
    End Sub

End Class

Class Sfmt2
    Inherits Sfmt

    Public readonly Overrides Property IdString() As String
        Get
            Return "SFMT-607:1-13-3-11-5:df7fffff-f7ff77ff-fffff2ff-ffff473f"
        End Get
    End Property

    Private Shared ParityData As UInteger() = {&H1&, &H0&, &H0&, &HB5A64116&}

    Protected Overrides Function GetParity() As UInteger()
        Return ParityData
    End Function

    Protected overrides Sub gen_rand_all()
        Dim a As Integer = 0 : Dim b As Integer = 4 : Dim c As Integer = 12
        Dim d As Integer = 16 : Dim y As UInteger : Dim p As UInteger() = x

        Do
            y = p(a + 3) Xor (p(a + 3) << 24) Xor (p(a + 2) >> 8) Xor ((p(b + 3) >> 11) And &HFFFF473F)
            p(a + 3) = y Xor (p(d + 3) << 13)
            y = p(a + 2) Xor (p(a + 2) << 24) Xor (p(a + 1) >> 8) Xor ((p(b + 2) >> 11) And &HFFFFF2FF)
            p(a + 2) = y Xor (p(c + 3) >> 8) Xor (p(d + 2) << 13)
            y = p(a + 1) Xor (p(a + 1) << 24) Xor (p(a) >> 8) Xor ((p(b + 1) >> 11) And &HF7FF77FF)
            p(a + 1) = y Xor ((p(c + 2) >> 8) or (p(c + 3) << 24)) Xor (p(d + 1) << 13)
            y = p(a) Xor (p(a) << 24) Xor ((p(b) >> 11) And &HDF7FFFFF)
            p(a) = y Xor ((p(c + 1) >> 8) or (p(c + 2) << 24)) Xor (p(d) << 13)
            c = d : d = a : a += 4 : b += 4
            If b = 20 Then b = 0
        Loop While a <> 20
    End Sub

    Sub New(ByVal s As UInteger)
        MyBase.New(s)
    End Sub

    Sub New(ByVal init_key As UInteger())
        MyBase.New(init_key)
    End Sub

End Class

Class Sfmt3
    Inherits Sfmt

    Public readonly Overrides Property IdString() As String
        Get
            Return "SFMT-607:3-11-3-21-1:6fff7ffe-f5fffffe-bffffffe-afdfffff"
        End Get
    End Property

    Private Shared ParityData As UInteger() = {&H1&, &H0&, &H10000000&, &H6F6FEC6A&}

    Protected Overrides Function GetParity() As UInteger()
        Return ParityData
    End Function

    Protected overrides Sub gen_rand_all()
        Dim a As Integer = 0 : Dim b As Integer = 12 : Dim c As Integer = 12
        Dim d As Integer = 16 : Dim y As UInteger : Dim p As UInteger() = x

        Do
            y = p(a + 3) Xor (p(a + 3) << 24) Xor (p(a + 2) >> 8) Xor ((p(b + 3) >> 21) And &HAFDFFFFF)
            p(a + 3) = y Xor (p(c + 3) >> 8) Xor (p(d + 3) << 11)
            y = p(a + 2) Xor (p(a + 2) << 24) Xor (p(a + 1) >> 8) Xor ((p(b + 2) >> 21) And &HBFFFFFFE)
            p(a + 2) = y Xor ((p(c + 2) >> 8) or (p(c + 3) << 24)) Xor (p(d + 2) << 11)
            y = p(a + 1) Xor (p(a + 1) << 24) Xor (p(a) >> 8) Xor ((p(b + 1) >> 21) And &HF5FFFFFE)
            p(a + 1) = y Xor ((p(c + 1) >> 8) or (p(c + 2) << 24)) Xor (p(d + 1) << 11)
            y = p(a) Xor (p(a) << 24) Xor ((p(b) >> 21) And &H6FFF7FFE)
            p(a) = y Xor ((p(c) >> 8) or (p(c + 1) << 24)) Xor (p(d) << 11)
            c = d : d = a : a += 4 : b += 4
            If b = 20 Then b = 0
        Loop While a <> 20
    End Sub

    Sub New(ByVal s As UInteger)
        MyBase.New(s)
    End Sub

    Sub New(ByVal init_key As UInteger())
        MyBase.New(init_key)
    End Sub

End Class

Class Sfmt4
    Inherits Sfmt

    Public readonly Overrides Property IdString() As String
        Get
            Return "SFMT-607:2-15-1-3-1:ff77fff7-fd77ffff-fffffdcf-fffffffa"
        End Get
    End Property

    Private Shared ParityData As UInteger() = {&H1&, &H0&, &H20000000&, &HD63BBE55&}

    Protected Overrides Function GetParity() As UInteger()
        Return ParityData
    End Function

    Protected overrides Sub gen_rand_all()
        Dim a As Integer = 0 : Dim b As Integer = 8 : Dim c As Integer = 12
        Dim d As Integer = 16 : Dim y As UInteger : Dim p As UInteger() = x

        Do
            y = p(a + 3) Xor (p(a + 3) << 8) Xor (p(a + 2) >> 24) Xor ((p(b + 3) >> 3) And &HFFFFFFFA)
            p(a + 3) = y Xor (p(c + 3) >> 8) Xor (p(d + 3) << 15)
            y = p(a + 2) Xor (p(a + 2) << 8) Xor (p(a + 1) >> 24) Xor ((p(b + 2) >> 3) And &HFFFFFDCF)
            p(a + 2) = y Xor ((p(c + 2) >> 8) or (p(c + 3) << 24)) Xor (p(d + 2) << 15)
            y = p(a + 1) Xor (p(a + 1) << 8) Xor (p(a) >> 24) Xor ((p(b + 1) >> 3) And &HFD77FFFF)
            p(a + 1) = y Xor ((p(c + 1) >> 8) or (p(c + 2) << 24)) Xor (p(d + 1) << 15)
            y = p(a) Xor (p(a) << 8) Xor ((p(b) >> 3) And &HFF77FFF7)
            p(a) = y Xor ((p(c) >> 8) or (p(c + 1) << 24)) Xor (p(d) << 15)
            c = d : d = a : a += 4 : b += 4
            If b = 20 Then b = 0
        Loop While a <> 20
    End Sub

    Sub New(ByVal s As UInteger)
        MyBase.New(s)
    End Sub

    Sub New(ByVal init_key As UInteger())
        MyBase.New(init_key)
    End Sub

End Class

Class Sfmt5
    Inherits Sfmt

    Public readonly Overrides Property IdString() As String
        Get
            Return "SFMT-607:1-7-3-2-1:bedf9cff-dfe6dfff-fdfffffa-dfff7efb"
        End Get
    End Property

    Private Shared ParityData As UInteger() = {&H1&, &H0&, &H80000000&, &HA52AF51D&}

    Protected Overrides Function GetParity() As UInteger()
        Return ParityData
    End Function

    Protected overrides Sub gen_rand_all()
        Dim a As Integer = 0 : Dim b As Integer = 4 : Dim c As Integer = 12
        Dim d As Integer = 16 : Dim y As UInteger : Dim p As UInteger() = x

        Do
            y = p(a + 3) Xor (p(a + 3) << 24) Xor (p(a + 2) >> 8) Xor ((p(b + 3) >> 2) And &HDFFF7EFB)
            p(a + 3) = y Xor (p(c + 3) >> 8) Xor (p(d + 3) << 7)
            y = p(a + 2) Xor (p(a + 2) << 24) Xor (p(a + 1) >> 8) Xor ((p(b + 2) >> 2) And &HFDFFFFFA)
            p(a + 2) = y Xor ((p(c + 2) >> 8) or (p(c + 3) << 24)) Xor (p(d + 2) << 7)
            y = p(a + 1) Xor (p(a + 1) << 24) Xor (p(a) >> 8) Xor ((p(b + 1) >> 2) And &HDFE6DFFF)
            p(a + 1) = y Xor ((p(c + 1) >> 8) or (p(c + 2) << 24)) Xor (p(d + 1) << 7)
            y = p(a) Xor (p(a) << 24) Xor ((p(b) >> 2) And &HBEDF9CFF)
            p(a) = y Xor ((p(c) >> 8) or (p(c + 1) << 24)) Xor (p(d) << 7)
            c = d : d = a : a += 4 : b += 4
            If b = 20 Then b = 0
        Loop While a <> 20
    End Sub

    Sub New(ByVal s As UInteger)
        MyBase.New(s)
    End Sub

    Sub New(ByVal init_key As UInteger())
        MyBase.New(init_key)
    End Sub

End Class

Class Sfmt6
    Inherits Sfmt

    Public readonly Overrides Property IdString() As String
        Get
            Return "SFMT-607:1-14-1-1-1:ffefffff-7e6ffa77-fff7fffa-fbbffffb"
        End Get
    End Property

    Private Shared ParityData As UInteger() = {&H1&, &H0&, &H0&, &H57810851&}

    Protected Overrides Function GetParity() As UInteger()
        Return ParityData
    End Function

    Protected overrides Sub gen_rand_all()
        Dim a As Integer = 0 : Dim b As Integer = 4 : Dim c As Integer = 12
        Dim d As Integer = 16 : Dim y As UInteger : Dim p As UInteger() = x

        Do
            y = p(a + 3) Xor (p(a + 3) << 8) Xor (p(a + 2) >> 24) Xor ((p(b + 3) >> 1) And &HFBBFFFFB)
            p(a + 3) = y Xor (p(c + 3) >> 8) Xor (p(d + 3) << 14)
            y = p(a + 2) Xor (p(a + 2) << 8) Xor (p(a + 1) >> 24) Xor ((p(b + 2) >> 1) And &HFFF7FFFA)
            p(a + 2) = y Xor ((p(c + 2) >> 8) or (p(c + 3) << 24)) Xor (p(d + 2) << 14)
            y = p(a + 1) Xor (p(a + 1) << 8) Xor (p(a) >> 24) Xor ((p(b + 1) >> 1) And &H7E6FFA77)
            p(a + 1) = y Xor ((p(c + 1) >> 8) or (p(c + 2) << 24)) Xor (p(d + 1) << 14)
            y = p(a) Xor (p(a) << 8) Xor ((p(b) >> 1) And &HFFEFFFFF)
            p(a) = y Xor ((p(c) >> 8) or (p(c + 1) << 24)) Xor (p(d) << 14)
            c = d : d = a : a += 4 : b += 4
            If b = 20 Then b = 0
        Loop While a <> 20
    End Sub

    Sub New(ByVal s As UInteger)
        MyBase.New(s)
    End Sub

    Sub New(ByVal init_key As UInteger())
        MyBase.New(init_key)
    End Sub

End Class

Class Sfmt7
    Inherits Sfmt

    Public readonly Overrides Property IdString() As String
        Get
            Return "SFMT-607:2-14-1-11-1:7bfffbff-fba7ffbf-f7fffe3f-f36fffff"
        End Get
    End Property

    Private Shared ParityData As UInteger() = {&H1&, &H0&, &H0&, &H170C7993&}

    Protected Overrides Function GetParity() As UInteger()
        Return ParityData
    End Function

    Protected overrides Sub gen_rand_all()
        Dim a As Integer = 0 : Dim b As Integer = 8 : Dim c As Integer = 12
        Dim d As Integer = 16 : Dim y As UInteger : Dim p As UInteger() = x

        Do
            y = p(a + 3) Xor (p(a + 3) << 8) Xor (p(a + 2) >> 24) Xor ((p(b + 3) >> 11) And &HF36FFFFF)
            p(a + 3) = y Xor (p(c + 3) >> 8) Xor (p(d + 3) << 14)
            y = p(a + 2) Xor (p(a + 2) << 8) Xor (p(a + 1) >> 24) Xor ((p(b + 2) >> 11) And &HF7FFFE3F)
            p(a + 2) = y Xor ((p(c + 2) >> 8) or (p(c + 3) << 24)) Xor (p(d + 2) << 14)
            y = p(a + 1) Xor (p(a + 1) << 8) Xor (p(a) >> 24) Xor ((p(b + 1) >> 11) And &HFBA7FFBF)
            p(a + 1) = y Xor ((p(c + 1) >> 8) or (p(c + 2) << 24)) Xor (p(d + 1) << 14)
            y = p(a) Xor (p(a) << 8) Xor ((p(b) >> 11) And &H7BFFFBFF)
            p(a) = y Xor ((p(c) >> 8) or (p(c + 1) << 24)) Xor (p(d) << 14)
            c = d : d = a : a += 4 : b += 4
            If b = 20 Then b = 0
        Loop While a <> 20
    End Sub

    Sub New(ByVal s As UInteger)
        MyBase.New(s)
    End Sub

    Sub New(ByVal init_key As UInteger())
        MyBase.New(init_key)
    End Sub

End Class

Class Sfmt8
    Inherits Sfmt

    Public readonly Overrides Property IdString() As String
        Get
            Return "SFMT-607:1-14-5-3-1:ffe7ffff-ff6fefff-7f3fffff-ff7feffb"
        End Get
    End Property

    Private Shared ParityData As UInteger() = {&H1&, &H0&, &H40000000&, &HF4112310&}

    Protected Overrides Function GetParity() As UInteger()
        Return ParityData
    End Function

    Protected overrides Sub gen_rand_all()
        Dim a As Integer = 0 : Dim b As Integer = 4 : Dim c As Integer = 12
        Dim d As Integer = 16 : Dim y As UInteger : Dim p As UInteger() = x

        Do
            y = p(a + 3) Xor (p(a + 2) << 8) Xor (p(a + 1) >> 24) Xor ((p(b + 3) >> 3) And &HFF7FEFFB)
            p(a + 3) = y Xor (p(c + 3) >> 8) Xor (p(d + 3) << 14)
            y = p(a + 2) Xor (p(a + 1) << 8) Xor (p(a) >> 24) Xor ((p(b + 2) >> 3) And &H7F3FFFFF)
            p(a + 2) = y Xor ((p(c + 2) >> 8) or (p(c + 3) << 24)) Xor (p(d + 2) << 14)
            y = p(a + 1) Xor (p(a) << 8) Xor ((p(b + 1) >> 3) And &HFF6FEFFF)
            p(a + 1) = y Xor ((p(c + 1) >> 8) or (p(c + 2) << 24)) Xor (p(d + 1) << 14)
            y = p(a) Xor ((p(b) >> 3) And &HFFE7FFFF)
            p(a) = y Xor ((p(c) >> 8) or (p(c + 1) << 24)) Xor (p(d) << 14)
            c = d : d = a : a += 4 : b += 4
            If b = 20 Then b = 0
        Loop While a <> 20
    End Sub

    Sub New(ByVal s As UInteger)
        MyBase.New(s)
    End Sub

    Sub New(ByVal init_key As UInteger())
        MyBase.New(init_key)
    End Sub

End Class

Class Sfmt9
    Inherits Sfmt

    Public readonly Overrides Property IdString() As String
        Get
            Return "SFMT-607:1-5-3-6-3:d3ddebfb-ffdfffdf-ffbf9bff-efefbfff"
        End Get
    End Property

    Private Shared ParityData As UInteger() = {&H1&, &H0&, &H2000000&, &H67E80003&}

    Protected Overrides Function GetParity() As UInteger()
        Return ParityData
    End Function

    Protected overrides Sub gen_rand_all()
        Dim a As Integer = 0 : Dim b As Integer = 4 : Dim c As Integer = 12
        Dim d As Integer = 16 : Dim y As UInteger : Dim p As UInteger() = x

        Do
            y = p(a + 3) Xor (p(a + 3) << 24) Xor (p(a + 2) >> 8) Xor ((p(b + 3) >> 6) And &HEFEFBFFF)
            p(a + 3) = y Xor (p(c + 3) >> 24) Xor (p(d + 3) << 5)
            y = p(a + 2) Xor (p(a + 2) << 24) Xor (p(a + 1) >> 8) Xor ((p(b + 2) >> 6) And &HFFBF9BFF)
            p(a + 2) = y Xor ((p(c + 2) >> 24) or (p(c + 3) << 8)) Xor (p(d + 2) << 5)
            y = p(a + 1) Xor (p(a + 1) << 24) Xor (p(a) >> 8) Xor ((p(b + 1) >> 6) And &HFFDFFFDF)
            p(a + 1) = y Xor ((p(c + 1) >> 24) or (p(c + 2) << 8)) Xor (p(d + 1) << 5)
            y = p(a) Xor (p(a) << 24) Xor ((p(b) >> 6) And &HD3DDEBFB)
            p(a) = y Xor ((p(c) >> 24) or (p(c + 1) << 8)) Xor (p(d) << 5)
            c = d : d = a : a += 4 : b += 4
            If b = 20 Then b = 0
        Loop While a <> 20
    End Sub

    Sub New(ByVal s As UInteger)
        MyBase.New(s)
    End Sub

    Sub New(ByVal init_key As UInteger())
        MyBase.New(init_key)
    End Sub

End Class

Class Sfmt10
    Inherits Sfmt

    Public readonly Overrides Property IdString() As String
        Get
            Return "SFMT-607:3-13-1-3-3:7fffd6be-ffbefdfc-f7ff73f5-37fff7fb"
        End Get
    End Property

    Private Shared ParityData As UInteger() = {&H1&, &H0&, &H80000000&, &HCD8ABABA&}

    Protected Overrides Function GetParity() As UInteger()
        Return ParityData
    End Function

    Protected overrides Sub gen_rand_all()
        Dim a As Integer = 0 : Dim b As Integer = 12 : Dim c As Integer = 12
        Dim d As Integer = 16 : Dim y As UInteger : Dim p As UInteger() = x

        Do
            y = p(a + 3) Xor (p(a + 3) << 8) Xor (p(a + 2) >> 24) Xor ((p(b + 3) >> 3) And &H37FFF7FB)
            p(a + 3) = y Xor (p(c + 3) >> 24) Xor (p(d + 3) << 13)
            y = p(a + 2) Xor (p(a + 2) << 8) Xor (p(a + 1) >> 24) Xor ((p(b + 2) >> 3) And &HF7FF73F5)
            p(a + 2) = y Xor ((p(c + 2) >> 24) or (p(c + 3) << 8)) Xor (p(d + 2) << 13)
            y = p(a + 1) Xor (p(a + 1) << 8) Xor (p(a) >> 24) Xor ((p(b + 1) >> 3) And &HFFBEFDFC)
            p(a + 1) = y Xor ((p(c + 1) >> 24) or (p(c + 2) << 8)) Xor (p(d + 1) << 13)
            y = p(a) Xor (p(a) << 8) Xor ((p(b) >> 3) And &H7FFFD6BE)
            p(a) = y Xor ((p(c) >> 24) or (p(c + 1) << 8)) Xor (p(d) << 13)
            c = d : d = a : a += 4 : b += 4
            If b = 20 Then b = 0
        Loop While a <> 20
    End Sub

    Sub New(ByVal s As UInteger)
        MyBase.New(s)
    End Sub

    Sub New(ByVal init_key As UInteger())
        MyBase.New(init_key)
    End Sub

End Class

Class Sfmt11
    Inherits Sfmt

    Public readonly Overrides Property IdString() As String
        Get
            Return "SFMT-607:1-12-7-9-1:feffffde-fe8fbfb7-63effffd-7fe7b3f5"
        End Get
    End Property

    Private Shared ParityData As UInteger() = {&H1&, &H0&, &H0&, &H694481DD&}

    Protected Overrides Function GetParity() As UInteger()
        Return ParityData
    End Function

    Protected overrides Sub gen_rand_all()
        Dim a As Integer = 0 : Dim b As Integer = 4 : Dim c As Integer = 12
        Dim d As Integer = 16 : Dim y As UInteger : Dim p As UInteger() = x

        Do
            y = p(a + 3) Xor (p(a + 2) << 24) Xor (p(a + 1) >> 8) Xor ((p(b + 3) >> 9) And &H7FE7B3F5)
            p(a + 3) = y Xor (p(c + 3) >> 8) Xor (p(d + 3) << 12)
            y = p(a + 2) Xor (p(a + 1) << 24) Xor (p(a) >> 8) Xor ((p(b + 2) >> 9) And &H63EFFFFD)
            p(a + 2) = y Xor ((p(c + 2) >> 8) or (p(c + 3) << 24)) Xor (p(d + 2) << 12)
            y = p(a + 1) Xor (p(a) << 24) Xor ((p(b + 1) >> 9) And &HFE8FBFB7)
            p(a + 1) = y Xor ((p(c + 1) >> 8) or (p(c + 2) << 24)) Xor (p(d + 1) << 12)
            y = p(a) Xor ((p(b) >> 9) And &HFEFFFFDE)
            p(a) = y Xor ((p(c) >> 8) or (p(c + 1) << 24)) Xor (p(d) << 12)
            c = d : d = a : a += 4 : b += 4
            If b = 20 Then b = 0
        Loop While a <> 20
    End Sub

    Sub New(ByVal s As UInteger)
        MyBase.New(s)
    End Sub

    Sub New(ByVal init_key As UInteger())
        MyBase.New(init_key)
    End Sub

End Class

Class Sfmt12
    Inherits Sfmt

    Public readonly Overrides Property IdString() As String
        Get
            Return "SFMT-607:1-13-7-5-1:fffff9b7-bfebffdb-e7dfeefe-f3ff3eff"
        End Get
    End Property

    Private Shared ParityData As UInteger() = {&H1&, &H0&, &H80000000&, &H6E1C11BE&}

    Protected Overrides Function GetParity() As UInteger()
        Return ParityData
    End Function

    Protected overrides Sub gen_rand_all()
        Dim a As Integer = 0 : Dim b As Integer = 4 : Dim c As Integer = 12
        Dim d As Integer = 16 : Dim y As UInteger : Dim p As UInteger() = x

        Do
            y = p(a + 3) Xor (p(a + 2) << 24) Xor (p(a + 1) >> 8) Xor ((p(b + 3) >> 5) And &HF3FF3EFF)
            p(a + 3) = y Xor (p(c + 3) >> 8) Xor (p(d + 3) << 13)
            y = p(a + 2) Xor (p(a + 1) << 24) Xor (p(a) >> 8) Xor ((p(b + 2) >> 5) And &HE7DFEEFE)
            p(a + 2) = y Xor ((p(c + 2) >> 8) or (p(c + 3) << 24)) Xor (p(d + 2) << 13)
            y = p(a + 1) Xor (p(a) << 24) Xor ((p(b + 1) >> 5) And &HBFEBFFDB)
            p(a + 1) = y Xor ((p(c + 1) >> 8) or (p(c + 2) << 24)) Xor (p(d + 1) << 13)
            y = p(a) Xor ((p(b) >> 5) And &HFFFFF9B7)
            p(a) = y Xor ((p(c) >> 8) or (p(c + 1) << 24)) Xor (p(d) << 13)
            c = d : d = a : a += 4 : b += 4
            If b = 20 Then b = 0
        Loop While a <> 20
    End Sub

    Sub New(ByVal s As UInteger)
        MyBase.New(s)
    End Sub

    Sub New(ByVal init_key As UInteger())
        MyBase.New(init_key)
    End Sub

End Class

Class Sfmt13
    Inherits Sfmt

    Public readonly Overrides Property IdString() As String
        Get
            Return "SFMT-607:3-6-7-1-1:feffbff7-fffdd7ff-7ffffdff-fdffffff"
        End Get
    End Property

    Private Shared ParityData As UInteger() = {&H1&, &H0&, &H0&, &H47CD258&}

    Protected Overrides Function GetParity() As UInteger()
        Return ParityData
    End Function

    Protected overrides Sub gen_rand_all()
        Dim a As Integer = 0 : Dim b As Integer = 12 : Dim c As Integer = 12
        Dim d As Integer = 16 : Dim y As UInteger : Dim p As UInteger() = x

        Do
            y = p(a + 3) Xor (p(a + 2) << 24) Xor (p(a + 1) >> 8) Xor ((p(b + 3) >> 1) And &HFDFFFFFF)
            p(a + 3) = y Xor (p(c + 3) >> 8) Xor (p(d + 3) << 6)
            y = p(a + 2) Xor (p(a + 1) << 24) Xor (p(a) >> 8) Xor ((p(b + 2) >> 1) And &H7FFFFDFF)
            p(a + 2) = y Xor ((p(c + 2) >> 8) or (p(c + 3) << 24)) Xor (p(d + 2) << 6)
            y = p(a + 1) Xor (p(a) << 24) Xor ((p(b + 1) >> 1) And &HFFFDD7FF)
            p(a + 1) = y Xor ((p(c + 1) >> 8) or (p(c + 2) << 24)) Xor (p(d + 1) << 6)
            y = p(a) Xor ((p(b) >> 1) And &HFEFFBFF7)
            p(a) = y Xor ((p(c) >> 8) or (p(c + 1) << 24)) Xor (p(d) << 6)
            c = d : d = a : a += 4 : b += 4
            If b = 20 Then b = 0
        Loop While a <> 20
    End Sub

    Sub New(ByVal s As UInteger)
        MyBase.New(s)
    End Sub

    Sub New(ByVal init_key As UInteger())
        MyBase.New(init_key)
    End Sub

End Class

Class Sfmt14
    Inherits Sfmt

    Public readonly Overrides Property IdString() As String
        Get
            Return "SFMT-607:1-23-1-20-1:f5ffbfff-bffcfffe-ffbffefe-7fffbeef"
        End Get
    End Property

    Private Shared ParityData As UInteger() = {&H1&, &H0&, &H0&, &HDE196133&}

    Protected Overrides Function GetParity() As UInteger()
        Return ParityData
    End Function

    Protected overrides Sub gen_rand_all()
        Dim a As Integer = 0 : Dim b As Integer = 4 : Dim c As Integer = 12
        Dim d As Integer = 16 : Dim y As UInteger : Dim p As UInteger() = x

        Do
            y = p(a + 3) Xor (p(a + 3) << 8) Xor (p(a + 2) >> 24) Xor ((p(b + 3) >> 20) And &H7FFFBEEF)
            p(a + 3) = y Xor (p(c + 3) >> 8) Xor (p(d + 3) << 23)
            y = p(a + 2) Xor (p(a + 2) << 8) Xor (p(a + 1) >> 24) Xor ((p(b + 2) >> 20) And &HFFBFFEFE)
            p(a + 2) = y Xor ((p(c + 2) >> 8) or (p(c + 3) << 24)) Xor (p(d + 2) << 23)
            y = p(a + 1) Xor (p(a + 1) << 8) Xor (p(a) >> 24) Xor ((p(b + 1) >> 20) And &HBFFCFFFE)
            p(a + 1) = y Xor ((p(c + 1) >> 8) or (p(c + 2) << 24)) Xor (p(d + 1) << 23)
            y = p(a) Xor (p(a) << 8) Xor ((p(b) >> 20) And &HF5FFBFFF)
            p(a) = y Xor ((p(c) >> 8) or (p(c + 1) << 24)) Xor (p(d) << 23)
            c = d : d = a : a += 4 : b += 4
            If b = 20 Then b = 0
        Loop While a <> 20
    End Sub

    Sub New(ByVal s As UInteger)
        MyBase.New(s)
    End Sub

    Sub New(ByVal init_key As UInteger())
        MyBase.New(init_key)
    End Sub

End Class

Class Sfmt15
    Inherits Sfmt

    Public readonly Overrides Property IdString() As String
        Get
            Return "SFMT-607:2-13-1-16-3:fffffbbf-fffdffef-efb97fff-df7fffef"
        End Get
    End Property

    Private Shared ParityData As UInteger() = {&H1&, &H0&, &H80000000&, &H946DBC1C&}

    Protected Overrides Function GetParity() As UInteger()
        Return ParityData
    End Function

    Protected overrides Sub gen_rand_all()
        Dim a As Integer = 0 : Dim b As Integer = 8 : Dim c As Integer = 12
        Dim d As Integer = 16 : Dim y As UInteger : Dim p As UInteger() = x

        Do
            y = p(a + 3) Xor (p(a + 3) << 8) Xor (p(a + 2) >> 24) Xor ((p(b + 3) >> 16) And &HDF7FFFEF)
            p(a + 3) = y Xor (p(c + 3) >> 24) Xor (p(d + 3) << 13)
            y = p(a + 2) Xor (p(a + 2) << 8) Xor (p(a + 1) >> 24) Xor ((p(b + 2) >> 16) And &HEFB97FFF)
            p(a + 2) = y Xor ((p(c + 2) >> 24) or (p(c + 3) << 8)) Xor (p(d + 2) << 13)
            y = p(a + 1) Xor (p(a + 1) << 8) Xor (p(a) >> 24) Xor ((p(b + 1) >> 16) And &HFFFDFFEF)
            p(a + 1) = y Xor ((p(c + 1) >> 24) or (p(c + 2) << 8)) Xor (p(d + 1) << 13)
            y = p(a) Xor (p(a) << 8) Xor ((p(b) >> 16) And &HFFFFFBBF)
            p(a) = y Xor ((p(c) >> 24) or (p(c + 1) << 8)) Xor (p(d) << 13)
            c = d : d = a : a += 4 : b += 4
            If b = 20 Then b = 0
        Loop While a <> 20
    End Sub

    Sub New(ByVal s As UInteger)
        MyBase.New(s)
    End Sub

    Sub New(ByVal init_key As UInteger())
        MyBase.New(init_key)
    End Sub

End Class

Class Sfmt16
    Inherits Sfmt

    Public readonly Overrides Property IdString() As String
        Get
            Return "SFMT-607:1-17-3-22-5:dffffafe-dffffeff-fd77ffdf-fbfffffb"
        End Get
    End Property

    Private Shared ParityData As UInteger() = {&H1&, &H0&, &H0&, &HA7C70CC8&}

    Protected Overrides Function GetParity() As UInteger()
        Return ParityData
    End Function

    Protected overrides Sub gen_rand_all()
        Dim a As Integer = 0 : Dim b As Integer = 4 : Dim c As Integer = 12
        Dim d As Integer = 16 : Dim y As UInteger : Dim p As UInteger() = x

        Do
            y = p(a + 3) Xor (p(a + 3) << 24) Xor (p(a + 2) >> 8) Xor ((p(b + 3) >> 22) And &HFBFFFFFB)
            p(a + 3) = y Xor (p(d + 3) << 17)
            y = p(a + 2) Xor (p(a + 2) << 24) Xor (p(a + 1) >> 8) Xor ((p(b + 2) >> 22) And &HFD77FFDF)
            p(a + 2) = y Xor (p(c + 3) >> 8) Xor (p(d + 2) << 17)
            y = p(a + 1) Xor (p(a + 1) << 24) Xor (p(a) >> 8) Xor ((p(b + 1) >> 22) And &HDFFFFEFF)
            p(a + 1) = y Xor ((p(c + 2) >> 8) or (p(c + 3) << 24)) Xor (p(d + 1) << 17)
            y = p(a) Xor (p(a) << 24) Xor ((p(b) >> 22) And &HDFFFFAFE)
            p(a) = y Xor ((p(c + 1) >> 8) or (p(c + 2) << 24)) Xor (p(d) << 17)
            c = d : d = a : a += 4 : b += 4
            If b = 20 Then b = 0
        Loop While a <> 20
    End Sub

    Sub New(ByVal s As UInteger)
        MyBase.New(s)
    End Sub

    Sub New(ByVal init_key As UInteger())
        MyBase.New(init_key)
    End Sub

End Class

Class Sfmt17
    Inherits Sfmt

    Public readonly Overrides Property IdString() As String
        Get
            Return "SFMT-607:1-7-3-21-3:bffddfef-ffffffd7-3ffffff7-fff5effb"
        End Get
    End Property

    Private Shared ParityData As UInteger() = {&H1&, &H0&, &H40000000&, &HE7AAB0E7&}

    Protected Overrides Function GetParity() As UInteger()
        Return ParityData
    End Function

    Protected overrides Sub gen_rand_all()
        Dim a As Integer = 0 : Dim b As Integer = 4 : Dim c As Integer = 12
        Dim d As Integer = 16 : Dim y As UInteger : Dim p As UInteger() = x

        Do
            y = p(a + 3) Xor (p(a + 3) << 24) Xor (p(a + 2) >> 8) Xor ((p(b + 3) >> 21) And &HFFF5EFFB)
            p(a + 3) = y Xor (p(c + 3) >> 24) Xor (p(d + 3) << 7)
            y = p(a + 2) Xor (p(a + 2) << 24) Xor (p(a + 1) >> 8) Xor ((p(b + 2) >> 21) And &H3FFFFFF7)
            p(a + 2) = y Xor ((p(c + 2) >> 24) or (p(c + 3) << 8)) Xor (p(d + 2) << 7)
            y = p(a + 1) Xor (p(a + 1) << 24) Xor (p(a) >> 8) Xor ((p(b + 1) >> 21) And &HFFFFFFD7)
            p(a + 1) = y Xor ((p(c + 1) >> 24) or (p(c + 2) << 8)) Xor (p(d + 1) << 7)
            y = p(a) Xor (p(a) << 24) Xor ((p(b) >> 21) And &HBFFDDFEF)
            p(a) = y Xor ((p(c) >> 24) or (p(c + 1) << 8)) Xor (p(d) << 7)
            c = d : d = a : a += 4 : b += 4
            If b = 20 Then b = 0
        Loop While a <> 20
    End Sub

    Sub New(ByVal s As UInteger)
        MyBase.New(s)
    End Sub

    Sub New(ByVal init_key As UInteger())
        MyBase.New(init_key)
    End Sub

End Class

Class Sfmt18
    Inherits Sfmt

    Public readonly Overrides Property IdString() As String
        Get
            Return "SFMT-607:1-5-3-15-5:ffffdf7f-bfffed97-ffeadcbf-f7ffbefb"
        End Get
    End Property

    Private Shared ParityData As UInteger() = {&H1&, &H0&, &H0&, &H7AA354E4&}

    Protected Overrides Function GetParity() As UInteger()
        Return ParityData
    End Function

    Protected overrides Sub gen_rand_all()
        Dim a As Integer = 0 : Dim b As Integer = 4 : Dim c As Integer = 12
        Dim d As Integer = 16 : Dim y As UInteger : Dim p As UInteger() = x

        Do
            y = p(a + 3) Xor (p(a + 3) << 24) Xor (p(a + 2) >> 8) Xor ((p(b + 3) >> 15) And &HF7FFBEFB)
            p(a + 3) = y Xor (p(d + 3) << 5)
            y = p(a + 2) Xor (p(a + 2) << 24) Xor (p(a + 1) >> 8) Xor ((p(b + 2) >> 15) And &HFFEADCBF)
            p(a + 2) = y Xor (p(c + 3) >> 8) Xor (p(d + 2) << 5)
            y = p(a + 1) Xor (p(a + 1) << 24) Xor (p(a) >> 8) Xor ((p(b + 1) >> 15) And &HBFFFED97)
            p(a + 1) = y Xor ((p(c + 2) >> 8) or (p(c + 3) << 24)) Xor (p(d + 1) << 5)
            y = p(a) Xor (p(a) << 24) Xor ((p(b) >> 15) And &HFFFFDF7F)
            p(a) = y Xor ((p(c + 1) >> 8) or (p(c + 2) << 24)) Xor (p(d) << 5)
            c = d : d = a : a += 4 : b += 4
            If b = 20 Then b = 0
        Loop While a <> 20
    End Sub

    Sub New(ByVal s As UInteger)
        MyBase.New(s)
    End Sub

    Sub New(ByVal init_key As UInteger())
        MyBase.New(init_key)
    End Sub

End Class

Class Sfmt19
    Inherits Sfmt

    Public readonly Overrides Property IdString() As String
        Get
            Return "SFMT-607:2-10-3-23-1:ffebccfd-affffffd-f777bdff-af7effff"
        End Get
    End Property

    Private Shared ParityData As UInteger() = {&H1&, &H0&, &H80000000&, &HC824D8C1&}

    Protected Overrides Function GetParity() As UInteger()
        Return ParityData
    End Function

    Protected overrides Sub gen_rand_all()
        Dim a As Integer = 0 : Dim b As Integer = 8 : Dim c As Integer = 12
        Dim d As Integer = 16 : Dim y As UInteger : Dim p As UInteger() = x

        Do
            y = p(a + 3) Xor (p(a + 3) << 24) Xor (p(a + 2) >> 8) Xor ((p(b + 3) >> 23) And &HAF7EFFFF)
            p(a + 3) = y Xor (p(c + 3) >> 8) Xor (p(d + 3) << 10)
            y = p(a + 2) Xor (p(a + 2) << 24) Xor (p(a + 1) >> 8) Xor ((p(b + 2) >> 23) And &HF777BDFF)
            p(a + 2) = y Xor ((p(c + 2) >> 8) or (p(c + 3) << 24)) Xor (p(d + 2) << 10)
            y = p(a + 1) Xor (p(a + 1) << 24) Xor (p(a) >> 8) Xor ((p(b + 1) >> 23) And &HAFFFFFFD)
            p(a + 1) = y Xor ((p(c + 1) >> 8) or (p(c + 2) << 24)) Xor (p(d + 1) << 10)
            y = p(a) Xor (p(a) << 24) Xor ((p(b) >> 23) And &HFFEBCCFD)
            p(a) = y Xor ((p(c) >> 8) or (p(c + 1) << 24)) Xor (p(d) << 10)
            c = d : d = a : a += 4 : b += 4
            If b = 20 Then b = 0
        Loop While a <> 20
    End Sub

    Sub New(ByVal s As UInteger)
        MyBase.New(s)
    End Sub

    Sub New(ByVal init_key As UInteger())
        MyBase.New(init_key)
    End Sub

End Class

Class Sfmt20
    Inherits Sfmt

    Public readonly Overrides Property IdString() As String
        Get
            Return "SFMT-607:1-4-3-1-1:fe9fffef-ffbffeff-be57bdff-fefb3f5f"
        End Get
    End Property

    Private Shared ParityData As UInteger() = {&H1&, &H0&, &H80000000&, &H41129A62&}

    Protected Overrides Function GetParity() As UInteger()
        Return ParityData
    End Function

    Protected overrides Sub gen_rand_all()
        Dim a As Integer = 0 : Dim b As Integer = 4 : Dim c As Integer = 12
        Dim d As Integer = 16 : Dim y As UInteger : Dim p As UInteger() = x

        Do
            y = p(a + 3) Xor (p(a + 3) << 24) Xor (p(a + 2) >> 8) Xor ((p(b + 3) >> 1) And &HFEFB3F5F)
            p(a + 3) = y Xor (p(c + 3) >> 8) Xor (p(d + 3) << 4)
            y = p(a + 2) Xor (p(a + 2) << 24) Xor (p(a + 1) >> 8) Xor ((p(b + 2) >> 1) And &HBE57BDFF)
            p(a + 2) = y Xor ((p(c + 2) >> 8) or (p(c + 3) << 24)) Xor (p(d + 2) << 4)
            y = p(a + 1) Xor (p(a + 1) << 24) Xor (p(a) >> 8) Xor ((p(b + 1) >> 1) And &HFFBFFEFF)
            p(a + 1) = y Xor ((p(c + 1) >> 8) or (p(c + 2) << 24)) Xor (p(d + 1) << 4)
            y = p(a) Xor (p(a) << 24) Xor ((p(b) >> 1) And &HFE9FFFEF)
            p(a) = y Xor ((p(c) >> 8) or (p(c + 1) << 24)) Xor (p(d) << 4)
            c = d : d = a : a += 4 : b += 4
            If b = 20 Then b = 0
        Loop While a <> 20
    End Sub

    Sub New(ByVal s As UInteger)
        MyBase.New(s)
    End Sub

    Sub New(ByVal init_key As UInteger())
        MyBase.New(init_key)
    End Sub

End Class

Class Sfmt21
    Inherits Sfmt

    Public readonly Overrides Property IdString() As String
        Get
            Return "SFMT-607:2-5-3-18-5:fcbeffcf-5bfebb7f-fff5efff-efb5eff9"
        End Get
    End Property

    Private Shared ParityData As UInteger() = {&H1&, &H0&, &H0&, &H4925021A&}

    Protected Overrides Function GetParity() As UInteger()
        Return ParityData
    End Function

    Protected overrides Sub gen_rand_all()
        Dim a As Integer = 0 : Dim b As Integer = 8 : Dim c As Integer = 12
        Dim d As Integer = 16 : Dim y As UInteger : Dim p As UInteger() = x

        Do
            y = p(a + 3) Xor (p(a + 3) << 24) Xor (p(a + 2) >> 8) Xor ((p(b + 3) >> 18) And &HEFB5EFF9)
            p(a + 3) = y Xor (p(d + 3) << 5)
            y = p(a + 2) Xor (p(a + 2) << 24) Xor (p(a + 1) >> 8) Xor ((p(b + 2) >> 18) And &HFFF5EFFF)
            p(a + 2) = y Xor (p(c + 3) >> 8) Xor (p(d + 2) << 5)
            y = p(a + 1) Xor (p(a + 1) << 24) Xor (p(a) >> 8) Xor ((p(b + 1) >> 18) And &H5BFEBB7F)
            p(a + 1) = y Xor ((p(c + 2) >> 8) or (p(c + 3) << 24)) Xor (p(d + 1) << 5)
            y = p(a) Xor (p(a) << 24) Xor ((p(b) >> 18) And &HFCBEFFCF)
            p(a) = y Xor ((p(c + 1) >> 8) or (p(c + 2) << 24)) Xor (p(d) << 5)
            c = d : d = a : a += 4 : b += 4
            If b = 20 Then b = 0
        Loop While a <> 20
    End Sub

    Sub New(ByVal s As UInteger)
        MyBase.New(s)
    End Sub

    Sub New(ByVal init_key As UInteger())
        MyBase.New(init_key)
    End Sub

End Class

Class Sfmt22
    Inherits Sfmt

    Public readonly Overrides Property IdString() As String
        Get
            Return "SFMT-607:1-3-3-2-3:ffffffff-ffffeef7-bff6ff73-ffe7f7d7"
        End Get
    End Property

    Private Shared ParityData As UInteger() = {&H1&, &H0&, &H0&, &H737556B0&}

    Protected Overrides Function GetParity() As UInteger()
        Return ParityData
    End Function

    Protected overrides Sub gen_rand_all()
        Dim a As Integer = 0 : Dim b As Integer = 4 : Dim c As Integer = 12
        Dim d As Integer = 16 : Dim y As UInteger : Dim p As UInteger() = x

        Do
            y = p(a + 3) Xor (p(a + 3) << 24) Xor (p(a + 2) >> 8) Xor ((p(b + 3) >> 2) And &HFFE7F7D7)
            p(a + 3) = y Xor (p(c + 3) >> 24) Xor (p(d + 3) << 3)
            y = p(a + 2) Xor (p(a + 2) << 24) Xor (p(a + 1) >> 8) Xor ((p(b + 2) >> 2) And &HBFF6FF73)
            p(a + 2) = y Xor ((p(c + 2) >> 24) or (p(c + 3) << 8)) Xor (p(d + 2) << 3)
            y = p(a + 1) Xor (p(a + 1) << 24) Xor (p(a) >> 8) Xor ((p(b + 1) >> 2) And &HFFFFEEF7)
            p(a + 1) = y Xor ((p(c + 1) >> 24) or (p(c + 2) << 8)) Xor (p(d + 1) << 3)
            y = p(a) Xor (p(a) << 24) Xor ((p(b) >> 2) And &HFFFFFFFF)
            p(a) = y Xor ((p(c) >> 24) or (p(c + 1) << 8)) Xor (p(d) << 3)
            c = d : d = a : a += 4 : b += 4
            If b = 20 Then b = 0
        Loop While a <> 20
    End Sub

    Sub New(ByVal s As UInteger)
        MyBase.New(s)
    End Sub

    Sub New(ByVal init_key As UInteger())
        MyBase.New(init_key)
    End Sub

End Class

Class Sfmt23
    Inherits Sfmt

    Public readonly Overrides Property IdString() As String
        Get
            Return "SFMT-607:3-11-5-4-1:7fdfffff-7cddd7fa-febfdeee-ffbffef7"
        End Get
    End Property

    Private Shared ParityData As UInteger() = {&H1&, &H0&, &H0&, &HB4BE184D&}

    Protected Overrides Function GetParity() As UInteger()
        Return ParityData
    End Function

    Protected overrides Sub gen_rand_all()
        Dim a As Integer = 0 : Dim b As Integer = 12 : Dim c As Integer = 12
        Dim d As Integer = 16 : Dim y As UInteger : Dim p As UInteger() = x

        Do
            y = p(a + 3) Xor (p(a + 2) << 8) Xor (p(a + 1) >> 24) Xor ((p(b + 3) >> 4) And &HFFBFFEF7)
            p(a + 3) = y Xor (p(c + 3) >> 8) Xor (p(d + 3) << 11)
            y = p(a + 2) Xor (p(a + 1) << 8) Xor (p(a) >> 24) Xor ((p(b + 2) >> 4) And &HFEBFDEEE)
            p(a + 2) = y Xor ((p(c + 2) >> 8) or (p(c + 3) << 24)) Xor (p(d + 2) << 11)
            y = p(a + 1) Xor (p(a) << 8) Xor ((p(b + 1) >> 4) And &H7CDDD7FA)
            p(a + 1) = y Xor ((p(c + 1) >> 8) or (p(c + 2) << 24)) Xor (p(d + 1) << 11)
            y = p(a) Xor ((p(b) >> 4) And &H7FDFFFFF)
            p(a) = y Xor ((p(c) >> 8) or (p(c + 1) << 24)) Xor (p(d) << 11)
            c = d : d = a : a += 4 : b += 4
            If b = 20 Then b = 0
        Loop While a <> 20
    End Sub

    Sub New(ByVal s As UInteger)
        MyBase.New(s)
    End Sub

    Sub New(ByVal init_key As UInteger())
        MyBase.New(init_key)
    End Sub

End Class

Class Sfmt24
    Inherits Sfmt

    Public readonly Overrides Property IdString() As String
        Get
            Return "SFMT-607:2-21-5-4-1:ffbbf77f-ff7ffbfb-bffff7f7-efecdfff"
        End Get
    End Property

    Private Shared ParityData As UInteger() = {&H1&, &H0&, &H4000000&, &HF361B11F&}

    Protected Overrides Function GetParity() As UInteger()
        Return ParityData
    End Function

    Protected overrides Sub gen_rand_all()
        Dim a As Integer = 0 : Dim b As Integer = 8 : Dim c As Integer = 12
        Dim d As Integer = 16 : Dim y As UInteger : Dim p As UInteger() = x

        Do
            y = p(a + 3) Xor (p(a + 2) << 8) Xor (p(a + 1) >> 24) Xor ((p(b + 3) >> 4) And &HEFECDFFF)
            p(a + 3) = y Xor (p(c + 3) >> 8) Xor (p(d + 3) << 21)
            y = p(a + 2) Xor (p(a + 1) << 8) Xor (p(a) >> 24) Xor ((p(b + 2) >> 4) And &HBFFFF7F7)
            p(a + 2) = y Xor ((p(c + 2) >> 8) or (p(c + 3) << 24)) Xor (p(d + 2) << 21)
            y = p(a + 1) Xor (p(a) << 8) Xor ((p(b + 1) >> 4) And &HFF7FFBFB)
            p(a + 1) = y Xor ((p(c + 1) >> 8) or (p(c + 2) << 24)) Xor (p(d + 1) << 21)
            y = p(a) Xor ((p(b) >> 4) And &HFFBBF77F)
            p(a) = y Xor ((p(c) >> 8) or (p(c + 1) << 24)) Xor (p(d) << 21)
            c = d : d = a : a += 4 : b += 4
            If b = 20 Then b = 0
        Loop While a <> 20
    End Sub

    Sub New(ByVal s As UInteger)
        MyBase.New(s)
    End Sub

    Sub New(ByVal init_key As UInteger())
        MyBase.New(init_key)
    End Sub

End Class

Class Sfmt25
    Inherits Sfmt

    Public readonly Overrides Property IdString() As String
        Get
            Return "SFMT-607:1-13-3-18-7:dfbf5fff-cffd7eff-ffbe3fff-fdbfff9f"
        End Get
    End Property

    Private Shared ParityData As UInteger() = {&H1&, &H0&, &H80000000&, &HD28269A7&}

    Protected Overrides Function GetParity() As UInteger()
        Return ParityData
    End Function

    Protected overrides Sub gen_rand_all()
        Dim a As Integer = 0 : Dim b As Integer = 4 : Dim c As Integer = 12
        Dim d As Integer = 16 : Dim y As UInteger : Dim p As UInteger() = x

        Do
            y = p(a + 3) Xor (p(a + 3) << 24) Xor (p(a + 2) >> 8) Xor ((p(b + 3) >> 18) And &HFDBFFF9F)
            p(a + 3) = y Xor (p(d + 3) << 13)
            y = p(a + 2) Xor (p(a + 2) << 24) Xor (p(a + 1) >> 8) Xor ((p(b + 2) >> 18) And &HFFBE3FFF)
            p(a + 2) = y Xor (p(c + 3) >> 24) Xor (p(d + 2) << 13)
            y = p(a + 1) Xor (p(a + 1) << 24) Xor (p(a) >> 8) Xor ((p(b + 1) >> 18) And &HCFFD7EFF)
            p(a + 1) = y Xor ((p(c + 2) >> 24) or (p(c + 3) << 8)) Xor (p(d + 1) << 13)
            y = p(a) Xor (p(a) << 24) Xor ((p(b) >> 18) And &HDFBF5FFF)
            p(a) = y Xor ((p(c + 1) >> 24) or (p(c + 2) << 8)) Xor (p(d) << 13)
            c = d : d = a : a += 4 : b += 4
            If b = 20 Then b = 0
        Loop While a <> 20
    End Sub

    Sub New(ByVal s As UInteger)
        MyBase.New(s)
    End Sub

    Sub New(ByVal init_key As UInteger())
        MyBase.New(init_key)
    End Sub

End Class

Class Sfmt26
    Inherits Sfmt

    Public readonly Overrides Property IdString() As String
        Get
            Return "SFMT-607:3-11-5-12-3:ebffefff-fbfffaff-f7fffeff-7ffefffe"
        End Get
    End Property

    Private Shared ParityData As UInteger() = {&H1&, &H0&, &H40000000&, &H39660C35&}

    Protected Overrides Function GetParity() As UInteger()
        Return ParityData
    End Function

    Protected overrides Sub gen_rand_all()
        Dim a As Integer = 0 : Dim b As Integer = 12 : Dim c As Integer = 12
        Dim d As Integer = 16 : Dim y As UInteger : Dim p As UInteger() = x

        Do
            y = p(a + 3) Xor (p(a + 2) << 8) Xor (p(a + 1) >> 24) Xor ((p(b + 3) >> 12) And &H7FFEFFFE)
            p(a + 3) = y Xor (p(c + 3) >> 24) Xor (p(d + 3) << 11)
            y = p(a + 2) Xor (p(a + 1) << 8) Xor (p(a) >> 24) Xor ((p(b + 2) >> 12) And &HF7FFFEFF)
            p(a + 2) = y Xor ((p(c + 2) >> 24) or (p(c + 3) << 8)) Xor (p(d + 2) << 11)
            y = p(a + 1) Xor (p(a) << 8) Xor ((p(b + 1) >> 12) And &HFBFFFAFF)
            p(a + 1) = y Xor ((p(c + 1) >> 24) or (p(c + 2) << 8)) Xor (p(d + 1) << 11)
            y = p(a) Xor ((p(b) >> 12) And &HEBFFEFFF)
            p(a) = y Xor ((p(c) >> 24) or (p(c + 1) << 8)) Xor (p(d) << 11)
            c = d : d = a : a += 4 : b += 4
            If b = 20 Then b = 0
        Loop While a <> 20
    End Sub

    Sub New(ByVal s As UInteger)
        MyBase.New(s)
    End Sub

    Sub New(ByVal init_key As UInteger())
        MyBase.New(init_key)
    End Sub

End Class

Class Sfmt27
    Inherits Sfmt

    Public readonly Overrides Property IdString() As String
        Get
            Return "SFMT-607:2-11-5-6-3:ffffffdd-dff7bdf7-f3fff1ff-ffff7ffe"
        End Get
    End Property

    Private Shared ParityData As UInteger() = {&H1&, &H0&, &H0&, &H18CEEB85&}

    Protected Overrides Function GetParity() As UInteger()
        Return ParityData
    End Function

    Protected overrides Sub gen_rand_all()
        Dim a As Integer = 0 : Dim b As Integer = 8 : Dim c As Integer = 12
        Dim d As Integer = 16 : Dim y As UInteger : Dim p As UInteger() = x

        Do
            y = p(a + 3) Xor (p(a + 2) << 8) Xor (p(a + 1) >> 24) Xor ((p(b + 3) >> 6) And &HFFFF7FFE)
            p(a + 3) = y Xor (p(c + 3) >> 24) Xor (p(d + 3) << 11)
            y = p(a + 2) Xor (p(a + 1) << 8) Xor (p(a) >> 24) Xor ((p(b + 2) >> 6) And &HF3FFF1FF)
            p(a + 2) = y Xor ((p(c + 2) >> 24) or (p(c + 3) << 8)) Xor (p(d + 2) << 11)
            y = p(a + 1) Xor (p(a) << 8) Xor ((p(b + 1) >> 6) And &HDFF7BDF7)
            p(a + 1) = y Xor ((p(c + 1) >> 24) or (p(c + 2) << 8)) Xor (p(d + 1) << 11)
            y = p(a) Xor ((p(b) >> 6) And &HFFFFFFDD)
            p(a) = y Xor ((p(c) >> 24) or (p(c + 1) << 8)) Xor (p(d) << 11)
            c = d : d = a : a += 4 : b += 4
            If b = 20 Then b = 0
        Loop While a <> 20
    End Sub

    Sub New(ByVal s As UInteger)
        MyBase.New(s)
    End Sub

    Sub New(ByVal init_key As UInteger())
        MyBase.New(init_key)
    End Sub

End Class

Class Sfmt28
    Inherits Sfmt

    Public readonly Overrides Property IdString() As String
        Get
            Return "SFMT-607:2-21-3-11-5:ffff7ebf-fffd7fff-dffdfdff-ffa57bdf"
        End Get
    End Property

    Private Shared ParityData As UInteger() = {&H1&, &H0&, &H80000000&, &H41D828EF&}

    Protected Overrides Function GetParity() As UInteger()
        Return ParityData
    End Function

    Protected overrides Sub gen_rand_all()
        Dim a As Integer = 0 : Dim b As Integer = 8 : Dim c As Integer = 12
        Dim d As Integer = 16 : Dim y As UInteger : Dim p As UInteger() = x

        Do
            y = p(a + 3) Xor (p(a + 3) << 24) Xor (p(a + 2) >> 8) Xor ((p(b + 3) >> 11) And &HFFA57BDF)
            p(a + 3) = y Xor (p(d + 3) << 21)
            y = p(a + 2) Xor (p(a + 2) << 24) Xor (p(a + 1) >> 8) Xor ((p(b + 2) >> 11) And &HDFFDFDFF)
            p(a + 2) = y Xor (p(c + 3) >> 8) Xor (p(d + 2) << 21)
            y = p(a + 1) Xor (p(a + 1) << 24) Xor (p(a) >> 8) Xor ((p(b + 1) >> 11) And &HFFFD7FFF)
            p(a + 1) = y Xor ((p(c + 2) >> 8) or (p(c + 3) << 24)) Xor (p(d + 1) << 21)
            y = p(a) Xor (p(a) << 24) Xor ((p(b) >> 11) And &HFFFF7EBF)
            p(a) = y Xor ((p(c + 1) >> 8) or (p(c + 2) << 24)) Xor (p(d) << 21)
            c = d : d = a : a += 4 : b += 4
            If b = 20 Then b = 0
        Loop While a <> 20
    End Sub

    Sub New(ByVal s As UInteger)
        MyBase.New(s)
    End Sub

    Sub New(ByVal init_key As UInteger())
        MyBase.New(init_key)
    End Sub

End Class

Class Sfmt29
    Inherits Sfmt

    Public readonly Overrides Property IdString() As String
        Get
            Return "SFMT-607:3-20-7-7-1:beffbffb-bffffffb-ffffefff-eefbef3f"
        End Get
    End Property

    Private Shared ParityData As UInteger() = {&H1&, &H0&, &H0&, &H2A5C3390&}

    Protected Overrides Function GetParity() As UInteger()
        Return ParityData
    End Function

    Protected overrides Sub gen_rand_all()
        Dim a As Integer = 0 : Dim b As Integer = 12 : Dim c As Integer = 12
        Dim d As Integer = 16 : Dim y As UInteger : Dim p As UInteger() = x

        Do
            y = p(a + 3) Xor (p(a + 2) << 24) Xor (p(a + 1) >> 8) Xor ((p(b + 3) >> 7) And &HEEFBEF3F)
            p(a + 3) = y Xor (p(c + 3) >> 8) Xor (p(d + 3) << 20)
            y = p(a + 2) Xor (p(a + 1) << 24) Xor (p(a) >> 8) Xor ((p(b + 2) >> 7) And &HFFFFEFFF)
            p(a + 2) = y Xor ((p(c + 2) >> 8) or (p(c + 3) << 24)) Xor (p(d + 2) << 20)
            y = p(a + 1) Xor (p(a) << 24) Xor ((p(b + 1) >> 7) And &HBFFFFFFB)
            p(a + 1) = y Xor ((p(c + 1) >> 8) or (p(c + 2) << 24)) Xor (p(d + 1) << 20)
            y = p(a) Xor ((p(b) >> 7) And &HBEFFBFFB)
            p(a) = y Xor ((p(c) >> 8) or (p(c + 1) << 24)) Xor (p(d) << 20)
            c = d : d = a : a += 4 : b += 4
            If b = 20 Then b = 0
        Loop While a <> 20
    End Sub

    Sub New(ByVal s As UInteger)
        MyBase.New(s)
    End Sub

    Sub New(ByVal init_key As UInteger())
        MyBase.New(init_key)
    End Sub

End Class

Class Sfmt30
    Inherits Sfmt

    Public readonly Overrides Property IdString() As String
        Get
            Return "SFMT-607:1-18-1-7-1:f7ffb5fd-b76ff7fd-fdfff7df-f9dffffe"
        End Get
    End Property

    Private Shared ParityData As UInteger() = {&H1&, &H0&, &H0&, &HD99B3C70&}

    Protected Overrides Function GetParity() As UInteger()
        Return ParityData
    End Function

    Protected overrides Sub gen_rand_all()
        Dim a As Integer = 0 : Dim b As Integer = 4 : Dim c As Integer = 12
        Dim d As Integer = 16 : Dim y As UInteger : Dim p As UInteger() = x

        Do
            y = p(a + 3) Xor (p(a + 3) << 8) Xor (p(a + 2) >> 24) Xor ((p(b + 3) >> 7) And &HF9DFFFFE)
            p(a + 3) = y Xor (p(c + 3) >> 8) Xor (p(d + 3) << 18)
            y = p(a + 2) Xor (p(a + 2) << 8) Xor (p(a + 1) >> 24) Xor ((p(b + 2) >> 7) And &HFDFFF7DF)
            p(a + 2) = y Xor ((p(c + 2) >> 8) or (p(c + 3) << 24)) Xor (p(d + 2) << 18)
            y = p(a + 1) Xor (p(a + 1) << 8) Xor (p(a) >> 24) Xor ((p(b + 1) >> 7) And &HB76FF7FD)
            p(a + 1) = y Xor ((p(c + 1) >> 8) or (p(c + 2) << 24)) Xor (p(d + 1) << 18)
            y = p(a) Xor (p(a) << 8) Xor ((p(b) >> 7) And &HF7FFB5FD)
            p(a) = y Xor ((p(c) >> 8) or (p(c + 1) << 24)) Xor (p(d) << 18)
            c = d : d = a : a += 4 : b += 4
            If b = 20 Then b = 0
        Loop While a <> 20
    End Sub

    Sub New(ByVal s As UInteger)
        MyBase.New(s)
    End Sub

    Sub New(ByVal init_key As UInteger())
        MyBase.New(init_key)
    End Sub

End Class

Class Sfmt31
    Inherits Sfmt

    Public readonly Overrides Property IdString() As String
        Get
            Return "SFMT-607:1-21-5-19-1:bfff7eff-7fffbfef-fffbff7f-effeff6f"
        End Get
    End Property

    Private Shared ParityData As UInteger() = {&H1&, &H0&, &H0&, &H85B22D17&}

    Protected Overrides Function GetParity() As UInteger()
        Return ParityData
    End Function

    Protected overrides Sub gen_rand_all()
        Dim a As Integer = 0 : Dim b As Integer = 4 : Dim c As Integer = 12
        Dim d As Integer = 16 : Dim y As UInteger : Dim p As UInteger() = x

        Do
            y = p(a + 3) Xor (p(a + 2) << 8) Xor (p(a + 1) >> 24) Xor ((p(b + 3) >> 19) And &HEFFEFF6F)
            p(a + 3) = y Xor (p(c + 3) >> 8) Xor (p(d + 3) << 21)
            y = p(a + 2) Xor (p(a + 1) << 8) Xor (p(a) >> 24) Xor ((p(b + 2) >> 19) And &HFFFBFF7F)
            p(a + 2) = y Xor ((p(c + 2) >> 8) or (p(c + 3) << 24)) Xor (p(d + 2) << 21)
            y = p(a + 1) Xor (p(a) << 8) Xor ((p(b + 1) >> 19) And &H7FFFBFEF)
            p(a + 1) = y Xor ((p(c + 1) >> 8) or (p(c + 2) << 24)) Xor (p(d + 1) << 21)
            y = p(a) Xor ((p(b) >> 19) And &HBFFF7EFF)
            p(a) = y Xor ((p(c) >> 8) or (p(c + 1) << 24)) Xor (p(d) << 21)
            c = d : d = a : a += 4 : b += 4
            If b = 20 Then b = 0
        Loop While a <> 20
    End Sub

    Sub New(ByVal s As UInteger)
        MyBase.New(s)
    End Sub

    Sub New(ByVal init_key As UInteger())
        MyBase.New(init_key)
    End Sub

End Class

Class Sfmt_m

    Private Shared z as Sfmt() = { _
        New Sfmt  (1), _
        New Sfmt1 (&HFFFFFFFF&), _
        New Sfmt2 (&HFFFFFFFE&), _
        New Sfmt3 (&HFFFFFFFD&), _
        New Sfmt4 (&HFFFFFFFC&), _
        New Sfmt5 (&HFFFFFFFB&), _
        New Sfmt6 (&HFFFFFFFA&), _
        New Sfmt7 (&HFFFFFFF9&), _
        New Sfmt8 (&HFFFFFFF8&), _
        New Sfmt9 (&HFFFFFFF7&), _
        New Sfmt10(&HFFFFFFF6&), _
        New Sfmt11(&HFFFFFFF5&), _
        New Sfmt12(&HFFFFFFF4&), _
        New Sfmt13(&HFFFFFFF3&), _
        New Sfmt14(&HFFFFFFF2&), _
        New Sfmt15(&HFFFFFFF1&), _
        New Sfmt16(&HFFFFFFF0&), _
        New Sfmt17(&HFFFFFFEF&), _
        New Sfmt18(&HFFFFFFEE&), _
        New Sfmt19(&HFFFFFFED&), _
        New Sfmt20(&HFFFFFFEC&), _
        New Sfmt21(&HFFFFFFEB&), _
        New Sfmt22(&HFFFFFFEA&), _
        New Sfmt23(&HFFFFFFE9&), _
        New Sfmt24(&HFFFFFFE8&), _
        New Sfmt25(&HFFFFFFE7&), _
        New Sfmt26(&HFFFFFFE6&), _
        New Sfmt27(&HFFFFFFE5&), _
        New Sfmt28(&HFFFFFFE4&), _
        New Sfmt29(&HFFFFFFE3&), _
        New Sfmt30(&HFFFFFFE2&), _
        New Sfmt31(&HFFFFFFE1&) _
    }

    Public Shared Function IdString_m(ByVal i As Integer) As String
        Return z(i).IdString
    End Function

    Public Shared Sub InitMt_m(ByVal i As Integer,ByVal s As UInteger)
        z(i).InitMt(s)
    End Sub

    Public Shared Sub InitMtEx_m(ByVal i As Integer,ByVal k As UInteger())
        z(i).InitMtEx(k)
    End Sub

    Public Shared Function NextMt_m(ByVal i As Integer) As UInteger
        Return z(i).NextMt()
    End Function

    Public Shared Function NextInt_m(ByVal i As Integer,ByVal n As Integer) As Integer
        Return z(i).NextInt(n)
    End Function

    Public Shared Function NextBit_m(ByVal i As Integer) As Integer
        Return z(i).NextBit()
    End Function

    Public Shared Function NextByte_m(ByVal i As Integer) As Integer
        Return z(i).NextByte()
    End Function

    Public Shared Function NextUnif_m(ByVal i As Integer) As Double
        Return z(i).NextUnif()
    End Function

    Public Shared Function NextIntEx_m(ByVal i As Integer,ByVal r As Integer) As Integer
        Return z(i).NextIntEx(r)
    End Function

    Public Shared Function NextChisq_m(ByVal i As Integer,ByVal n As Double) As Double
        Return z(i).NextChisq(n)
    End Function

    Public Shared Function NextGamma_m(ByVal i As Integer,ByVal a As Double) As Double
        Return z(i).NextGamma(a)
    End Function

    Public Shared Function NextGeometric_m(ByVal i As Integer,ByVal p As Double) As Integer
        Return z(i).NextGeometric(p)
    End Function

    Public Shared Function NextTriangle_m(ByVal i As Integer) As Double
        Return z(i).NextTriangle()
    End Function

    Public Shared Function NextExp_m(ByVal i As Integer) As Double
        Return z(i).NextExp()
    End Function

    Public Shared Function NextNormal_m(ByVal i As Integer) As Double
        Return z(i).NextNormal()
    End Function

    Public Shared Sub NextUnitVect_m(ByVal i As Integer,ByRef v As Double(),ByVal n As Integer)
        z(i).NextUnitVect(v,n)
    End Sub

    Public Shared Function NextBinomial_m(ByVal i As Integer,ByVal n As Integer,ByVal p As Double) As Integer
        Return z(i).NextBinomial(n,p)
    End Function

    Public Shared Sub NextBinormal_m(ByVal i As Integer,ByVal r As Double,ByRef a As Double,ByRef b As Double)
        z(i).NextBinormal(r,a,b)
    End Sub

    Public Shared Function NextBeta_m(ByVal i As Integer,ByVal a As Double,ByVal b As Double) As Double
        Return z(i).NextBeta(a,b)
    End Function

    Public Shared Function NextPower_m(ByVal i As Integer,ByVal n As Double) As Double
        Return z(i).NextPower(n)
    End Function

    Public Shared Function NextLogistic_m(ByVal i As Integer) As Double
        Return z(i).NextLogistic()
    End Function

    Public Shared Function NextCauchy_m(ByVal i As Integer) As Double
        Return z(i).NextCauchy()
    End Function

    Public Shared Function NextPoisson_m(ByVal i As Integer,ByVal l As Double) As Integer
        Return z(i).NextPoisson(l)
    End Function

    Public Shared Function NextFDist_m(ByVal i As Integer,ByVal n1 As Double,ByVal n2 As Double) As Double
        Return z(i).NextFDist(n1,n2)
    End Function

    Public Shared Function NextTDist_m(ByVal i As Integer,ByVal n As Double) As Double
        Return z(i).NextTDist(n)
    End Function

    Public Shared Function NextWeibull_m(ByVal i As Integer,ByVal a As Double) As Double
        Return z(i).NextWeibull(a)
    End Function

End Class

