/*+--------------------------------+
@|{֐̉֐(16rbg)|
@+--------------------------------+*/
#if INT_MAX <= 32767

#if SL2 == 1
#define SL5(X) (       a[BE1(X  )]<<8)
#define SL6(X) (X==0?0:a[BE1(X-1)]>>8)
#endif

#if SL2 == 3
#define SL5(X) (X==0?0:a[BE1(X-1)]<<8)
#define SL6(X) (X<=1?0:a[BE1(X-2)]>>8)
#endif

#if SL2 == 5
#define SL5(X) (X<=1?0:a[BE1(X-2)]<<8)
#define SL6(X) (X<=2?0:a[BE1(X-3)]>>8)
#endif

#if SL2 == 7
#define SL5(X) (X<=2?0:a[BE1(X-3)]<<8)
#define SL6(X) (X<=3?0:a[BE1(X-4)]>>8)
#endif

#if SR2 == 1
#define SR5(X) (       c[BE1(X  )]>>8)
#define SR6(X) (X==7?0:c[BE1(X+1)]<<8)
#endif

#if SR2 == 3
#define SR5(X) (X==7?0:c[BE1(X+1)]>>8)
#define SR6(X) (X>=6?0:c[BE1(X+2)]<<8)
#endif

#if SR2 == 5
#define SR5(X) (X>=6?0:c[BE1(X+2)]>>8)
#define SR6(X) (X>=5?0:c[BE1(X+3)]<<8)
#endif

#if SR2 == 7
#define SR5(X) (X>=5?0:c[BE1(X+3)]>>8)
#define SR6(X) (X>=4?0:c[BE1(X+4)]<<8)
#endif

#if SR1 < 16
#define SB1(X) (b[BE1(X)]>>SR1)
#define SB2(X) (b[BE1(X+1)]<<(16-SR1))
#else
#define SB1(X)  0
#define SB2(X) (b[BE1(X+1)]>>(SR1-16))
#endif

#if SL1 < 16
#define SD1(X) ((d[BE1(X)]<<SL1)|(d[BE1(X-1)]>>(16-SL1)))
#define SD2(X)  (d[BE1(X)]<<SL1)
#else
#define SD1(X) (d[BE1(X-1)]<<(SL1-16))
#define SD2(X) 0
#endif

#define MS0 ((unsigned short)(MSK1&0xffffU))
#define MS1 ((unsigned short)(MSK1>>16))
#define MS2 ((unsigned short)(MSK2&0xffffU))
#define MS3 ((unsigned short)(MSK2>>16))
#define MS4 ((unsigned short)(MSK3&0xffffU))
#define MS5 ((unsigned short)(MSK3>>16))
#define MS6 ((unsigned short)(MSK4&0xffffU))
#define MS7 ((unsigned short)(MSK4>>16))

#define GEN_FOUR()                                              \
    x=(short)(a[BE1(7)]^(SL5(7)|SL6(7))^(SB1(7)&MS7));          \
    a[BE1(7)]=(short)(x^ SR5(7)        ^SD1(7));                \
    x=(short)(a[BE1(6)]^(SL5(6)|SL6(6))^((SB1(6)|SB2(6))&MS6)); \
    a[BE1(6)]=(short)(x^(SR5(6)|SR6(6))^SD2(6));                \
    x=(short)(a[BE1(5)]^(SL5(5)|SL6(5))^(SB1(5)&MS5));          \
    a[BE1(5)]=(short)(x^(SR5(5)|SR6(5))^SD1(5));                \
    x=(short)(a[BE1(4)]^(SL5(4)|SL6(4))^((SB1(4)|SB2(4))&MS4)); \
    a[BE1(4)]=(short)(x^(SR5(4)|SR6(4))^SD2(4));                \
    x=(short)(a[BE1(3)]^(SL5(3)|SL6(3))^(SB1(3)&MS3));          \
    a[BE1(3)]=(short)(x^(SR5(3)|SR6(3))^SD1(3));                \
    x=(short)(a[BE1(2)]^(SL5(2)|SL6(2))^((SB1(2)|SB2(2))&MS2)); \
    a[BE1(2)]=(short)(x^(SR5(2)|SR6(2))^SD2(2));                \
    x=(short)(a[BE1(1)]^(SL5(1)|SL6(1))^(SB1(1)&MS1));          \
    a[BE1(1)]=(short)(x^(SR5(1)|SR6(1))^SD1(1));                \
    x=(short)(a[BE1(0)]^ SL5(0)        ^((SB1(0)|SB2(0))&MS0)); \
    a[BE1(0)]=(short)(x^(SR5(0)|SR6(0))^SD2(0))

#ifdef STABLE_SPEED
#ifdef MSEQ2_OK
static 
#endif
void FUNC_NAME(state_p mt)
{
    int i=mt->index;
    unsigned short*a=(unsigned short*)(mt->u.x+i),x;
    unsigned short*b=i<N32-POS1*4?a+POS1*8:a+POS1*8-N16;
    unsigned short*c=i<8?a+N16-16:a-16;
    unsigned short*d=i<4?a+N16-8:a-8;
    GEN_FOUR();
}

#else
#ifdef MSEQ2_OK
static 
#endif
void FUNC_NAME(uint32_t*m)
{
    unsigned short*a=(unsigned short*)m;
    unsigned short*b=a+POS1*8,*c=a+N16-16,*d=a+N16-8,*e=a+N16,x;

    do {
        GEN_FOUR();
        c=d; d=a; a+=8; b+=8;
        if (b==e) b-=N16;
    } while (a!=e);
}
#endif

#elif defined(WORD64)

/*+--------------------------------+
@|{֐̉֐(64rbg)|
@+--------------------------------+*/
#define SL5(X) (a[X]<<(SL2*8))
#define SL6(X) (X==0?0:a[X-1]>>(64-SL2*8))
#define SR5(X) (c[X]>>(SR2*8))
#define SR6(X) (X==1?0:c[X+1]<<(64-SR2*8))

#define GEN_FOUR()                                          \
 x=a[1]^SL5(1)^SL6(1)^(((uint64_t)((b[3]>>SR1)&MSK4))<<32)^ \
 ((b[2]>>SR1)&MSK3);                                        \
 a[1]=x^SR5(1)^(((uint64_t)(d[3]<<SL1))<<32)^(d[2]<<SL1);   \
 x=a[0]^SL5(0)^(((uint64_t)((b[1]>>SR1)&MSK2))<<32)^        \
 ((b[0]>>SR1)&MSK1);                                        \
 a[0]=x^(SR5(0)|SR6(0))^(((uint64_t)(d[1]<<SL1))<<32)^(d[0]<<SL1)

#ifdef STABLE_SPEED
#ifdef MSEQ2_OK
static 
#endif
void FUNC_NAME(state_p mt)
{
    int i=mt->index>>1;
    uint64_t*a=mt->u.y+i,x;
    uint32_t*b=(uint32_t*)(i<N64-POS1*2?a+POS1*2:a+POS1*2-N64);
    uint64_t*c=i<4?a+N64-4:a-4;
    uint32_t*d=(uint32_t*)(i<2?a+N64-2:a-2);
    GEN_FOUR();
}

#else

#ifdef MSEQ2_OK
static 
#endif
void FUNC_NAME(uint64_t*m)
{
    uint64_t*a=m,*c=a+N64-4,*e=a+N64,x;
    uint32_t*b=(uint32_t*)(a+POS1*2),*d=(uint32_t*)(a+N64-2);
    do {
        GEN_FOUR();
        c=(uint64_t*)d; d=(uint32_t*)a; a+=2; b+=4;
        if (b==(uint32_t*)e) b-=N32;
    } while (a!=e);
}

#endif

#else

/*+--------------------------------+
@|{֐̉֐(32rbg)|
@+--------------------------------+*/
#if SL2 < 4
#define SL5(X) (a[X]<<(SL2*8))
#define SL6(X) (X==0?0:a[X-1]>>(32-SL2*8))
#else
#define SL5(X) (X==0?0:a[X-1]<<(SL2*8-32))
#define SL6(X) (X<=1?0:a[X-2]>>(64-SL2*8))
#endif

#if SR2 < 4
#define SR5(X) (c[X]>>(SR2*8))
#define SR6(X) (X==3?0:c[X+1]<<(32-SR2*8))
#else
#define SR5(X) (X==3?0:c[X+1]>>(SR2*8-32))
#define SR6(X) (X>=2?0:c[X+2]<<(64-SR2*8))
#endif

#define GEN_FOUR()                             \
    x=a[3]^SL5(3)^SL6(3)^((b[3]>>SR1)&MSK4);   \
    a[3]=x^SR5(3)^(d[3]<<SL1);                 \
    x=a[2]^SL5(2)^SL6(2)^((b[2]>>SR1)&MSK3);   \
    a[2]=x^(SR5(2)|SR6(2))^(d[2]<<SL1);        \
    x=a[1]^SL5(1)^SL6(1)^((b[1]>>SR1)&MSK2);   \
    a[1]=x^(SR5(1)|SR6(1))^(d[1]<<SL1);        \
    x=a[0]^SL5(0)^((b[0]>>SR1)&MSK1);          \
    a[0]=x^(SR5(0)|SR6(0))^(d[0]<<SL1)

#ifdef STABLE_SPEED
#ifdef MSEQ2_OK
static 
#endif
void FUNC_NAME(state_p mt)
{

    int i=mt->index;
    uint32_t*a=mt->u.x+i,x;
    uint32_t*b=i<N32-POS1*4?a+POS1*4:a+POS1*4-N32;
    uint32_t*c=i<8?a+N32-8:a-8;
    uint32_t*d=i<4?a+N32-4:a-4;
    GEN_FOUR();
}

#else

#ifdef MSEQ2_OK
static 
#endif
void FUNC_NAME(uint32_t*m)
{
    uint32_t*a=m,*b=a+POS1*4,*c=a+N32-8,*d=a+N32-4,*e=a+N32,x;

    do {
        GEN_FOUR();
        c=d; d=a; a+=4; b+=4;
        if (b==e) b-=N32;
    } while (a!=e);
}

#endif

#endif

/*+----------------------------+
@|{֐̉֐(SSE2)|
@+----------------------------+*/
#ifdef HAVE_SSE2

#ifdef STABLE_SPEED

#ifdef MSEQ2_OK
static 
#endif
void SSE2_NAME(state_p mt)
{
    static union { unsigned x[4]; __m128i m; } u =
    { {MSK1,MSK2,MSK3,MSK4} };
    int i=mt->index/4; __m128i*t=mt->u.m,v,x,y,z,mask;

    mask=_mm_load_si128(&u.m);
    x=_mm_load_si128(&t[i]);
    y=_mm_srli_epi32(i<N128-POS1?t[i+POS1]:t[i+POS1-N128],SR1);
    z=_mm_srli_si128(i<2?t[i+N128-2]:t[i-2],SR2);
    v=_mm_slli_epi32(i==0?t[N128-1]:t[i-1],SL1);
    z=_mm_xor_si128(z,x);
    z=_mm_xor_si128(z,v);
    x=_mm_slli_si128(x,SL2);
    y=_mm_and_si128(y,mask);
    z=_mm_xor_si128(z,x);
    z=_mm_xor_si128(z,y);
    _mm_store_si128(&t[i],z);
}

#else

#define GEN_RECUR(P)                  \
    x=_mm_load_si128(&t[i]);          \
    y=_mm_srli_epi32(t[i+(P)],SR1);   \
    z=_mm_srli_si128(c,SR2);          \
    v=_mm_slli_epi32(d,SL1);          \
    z=_mm_xor_si128(z,x);             \
    z=_mm_xor_si128(z,v);             \
    x=_mm_slli_si128(x,SL2);          \
    y=_mm_and_si128(y,mask);          \
    z=_mm_xor_si128(z,x);             \
    z=_mm_xor_si128(z,y);             \
    _mm_store_si128(&t[i],z); c=d; d=z

#ifdef MSEQ2_OK
static 
#endif
void SSE2_NAME(__m128i*t)
{
    static union { unsigned x[4]; __m128i m; } u =
    { {MSK1,MSK2,MSK3,MSK4} };
    int i; __m128i c,d,v,x,y,z,mask;

    mask=_mm_load_si128(&u.m);
    c=_mm_load_si128(&t[N128-2]);
    d=_mm_load_si128(&t[N128-1]);
    for (i=0;i<N128-POS1;i++) { GEN_RECUR(POS1); }
    for (;i<N128;i++) { GEN_RECUR(POS1-N128); }
}

#endif

#endif

#if INT_MAX <= 32767
#undef SB1
#undef SB2
#undef SD1
#undef SD2
#undef MS0
#undef MS1
#undef MS2
#undef MS3
#undef MS4
#undef MS5
#undef MS6
#undef MS7
#endif

#if defined(HAVE_SSE2) && !defined(STABLE_SPEED)
#undef GEN_RECUR
#endif

#undef POS1
#undef SL1
#undef SL2
#undef SR1
#undef SR2
#undef MSK1
#undef MSK2
#undef MSK3
#undef MSK4
#undef SL5
#undef SL6
#undef SR5
#undef SR6
#undef GEN_FOUR
#undef FUNC_NAME
#undef SSE2_NAME
