/*
Sfmt10.java Cu(11213)
coded by isaku@pb4.so-net.ne.jp
*/

class Sfmt10 extends Sfmt
{
    public String IdString() {
        return"SFMT-11213:33-6-7-7-1:fffff9ff-fb7fffff-ebeffdfe-fbfbffff";
    }

    protected int[]GetParity()
    { return new int[]{ 0x00000001,0x00000000,0x8a3d0800,0x026e932d }; }


    public void gen_rand_all() {
        int a=0,b=132,c=344,d=348,y; int[]p=x;

        do {
            y=p[a+3]^(p[a+2]<<24)^(p[a+1]>>>8)^((p[b+3]>>>7)&0xfbfbffff);
            p[a+3]=y^(p[c+3]>>>8)^(p[d+3]<<6);
            y=p[a+2]^(p[a+1]<<24)^(p[a]>>>8)^((p[b+2]>>>7)&0xebeffdfe);
            p[a+2]=y^((p[c+2]>>>8)|(p[c+3]<<24))^(p[d+2]<<6);
            y=p[a+1]^(p[a]<<24)^((p[b+1]>>>7)&0xfb7fffff);
            p[a+1]=y^((p[c+1]>>>8)|(p[c+2]<<24))^(p[d+1]<<6);
            y=p[a]^((p[b]>>>7)&0xfffff9ff);
            p[a]=y^((p[c]>>>8)|(p[c+1]<<24))^(p[d]<<6);
            c=d; d=a; a+=4; b+=4;
            if (b==352) b=0;
        } while (a!=352);
    }

    Sfmt10(int s) { super(s); }
    Sfmt10(int[]init_key)  { super(init_key); }
}
