/*
Sfmt13.java Cu(11213)
coded by isaku@pb4.so-net.ne.jp
*/

class Sfmt13 extends Sfmt
{
    public String IdString() {
        return"SFMT-11213:77-9-3-10-3:fffffffe-3feefbff-f7fefeff-f5bc9fff";
    }

    protected int[]GetParity()
    { return new int[]{ 0x00000001,0x00000000,0x73b20000,0xb134ef9c }; }


    public void gen_rand_all() {
        int a=0,b=308,c=344,d=348,y; int[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<24)^(p[a+2]>>>8)^((p[b+3]>>>10)&0xf5bc9fff);
            p[a+3]=y^(p[c+3]>>>24)^(p[d+3]<<9);
            y=p[a+2]^(p[a+2]<<24)^(p[a+1]>>>8)^((p[b+2]>>>10)&0xf7fefeff);
            p[a+2]=y^((p[c+2]>>>24)|(p[c+3]<<8))^(p[d+2]<<9);
            y=p[a+1]^(p[a+1]<<24)^(p[a]>>>8)^((p[b+1]>>>10)&0x3feefbff);
            p[a+1]=y^((p[c+1]>>>24)|(p[c+2]<<8))^(p[d+1]<<9);
            y=p[a]^(p[a]<<24)^((p[b]>>>10)&0xfffffffe);
            p[a]=y^((p[c]>>>24)|(p[c+1]<<8))^(p[d]<<9);
            c=d; d=a; a+=4; b+=4;
            if (b==352) b=0;
        } while (a!=352);
    }

    Sfmt13(int s) { super(s); }
    Sfmt13(int[]init_key)  { super(init_key); }
}
