/*
Sfmt14.java Cu(11213)
coded by isaku@pb4.so-net.ne.jp
*/

class Sfmt14 extends Sfmt
{
    public String IdString() {
        return"SFMT-11213:45-17-1-6-3:f77bbfef-bcf7bfdf-bffff7e7-fffaff7b";
    }

    protected int[]GetParity()
    { return new int[]{ 0x00000001,0x00000000,0xce408000,0x1344dad1 }; }


    public void gen_rand_all() {
        int a=0,b=180,c=344,d=348,y; int[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<8)^(p[a+2]>>>24)^((p[b+3]>>>6)&0xfffaff7b);
            p[a+3]=y^(p[c+3]>>>24)^(p[d+3]<<17);
            y=p[a+2]^(p[a+2]<<8)^(p[a+1]>>>24)^((p[b+2]>>>6)&0xbffff7e7);
            p[a+2]=y^((p[c+2]>>>24)|(p[c+3]<<8))^(p[d+2]<<17);
            y=p[a+1]^(p[a+1]<<8)^(p[a]>>>24)^((p[b+1]>>>6)&0xbcf7bfdf);
            p[a+1]=y^((p[c+1]>>>24)|(p[c+2]<<8))^(p[d+1]<<17);
            y=p[a]^(p[a]<<8)^((p[b]>>>6)&0xf77bbfef);
            p[a]=y^((p[c]>>>24)|(p[c+1]<<8))^(p[d]<<17);
            c=d; d=a; a+=4; b+=4;
            if (b==352) b=0;
        } while (a!=352);
    }

    Sfmt14(int s) { super(s); }
    Sfmt14(int[]init_key)  { super(init_key); }
}
