/*
Sfmt15.java Cu(11213)
coded by isaku@pb4.so-net.ne.jp
*/

class Sfmt15 extends Sfmt
{
    public String IdString() {
        return"SFMT-11213:41-13-1-4-3:fb5d7fff-fbff7bff-f7ff677f-c67fffbf";
    }

    protected int[]GetParity()
    { return new int[]{ 0x00000001,0x00000000,0x0eb18000,0xafe068e2 }; }


    public void gen_rand_all() {
        int a=0,b=164,c=344,d=348,y; int[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<8)^(p[a+2]>>>24)^((p[b+3]>>>4)&0xc67fffbf);
            p[a+3]=y^(p[c+3]>>>24)^(p[d+3]<<13);
            y=p[a+2]^(p[a+2]<<8)^(p[a+1]>>>24)^((p[b+2]>>>4)&0xf7ff677f);
            p[a+2]=y^((p[c+2]>>>24)|(p[c+3]<<8))^(p[d+2]<<13);
            y=p[a+1]^(p[a+1]<<8)^(p[a]>>>24)^((p[b+1]>>>4)&0xfbff7bff);
            p[a+1]=y^((p[c+1]>>>24)|(p[c+2]<<8))^(p[d+1]<<13);
            y=p[a]^(p[a]<<8)^((p[b]>>>4)&0xfb5d7fff);
            p[a]=y^((p[c]>>>24)|(p[c+1]<<8))^(p[d]<<13);
            c=d; d=a; a+=4; b+=4;
            if (b==352) b=0;
        } while (a!=352);
    }

    Sfmt15(int s) { super(s); }
    Sfmt15(int[]init_key)  { super(init_key); }
}
