/*
Sfmt18.java Cu(11213)
coded by isaku@pb4.so-net.ne.jp
*/

class Sfmt18 extends Sfmt
{
    public String IdString() {
        return"SFMT-11213:9-18-5-15-1:5fe7eff7-dbffdff3-dbff6ff7-bb377fff";
    }

    protected int[]GetParity()
    { return new int[]{ 0x00000001,0x00000000,0xa0b64800,0xc3969fa3 }; }


    public void gen_rand_all() {
        int a=0,b=36,c=344,d=348,y; int[]p=x;

        do {
            y=p[a+3]^(p[a+2]<<8)^(p[a+1]>>>24)^((p[b+3]>>>15)&0xbb377fff);
            p[a+3]=y^(p[c+3]>>>8)^(p[d+3]<<18);
            y=p[a+2]^(p[a+1]<<8)^(p[a]>>>24)^((p[b+2]>>>15)&0xdbff6ff7);
            p[a+2]=y^((p[c+2]>>>8)|(p[c+3]<<24))^(p[d+2]<<18);
            y=p[a+1]^(p[a]<<8)^((p[b+1]>>>15)&0xdbffdff3);
            p[a+1]=y^((p[c+1]>>>8)|(p[c+2]<<24))^(p[d+1]<<18);
            y=p[a]^((p[b]>>>15)&0x5fe7eff7);
            p[a]=y^((p[c]>>>8)|(p[c+1]<<24))^(p[d]<<18);
            c=d; d=a; a+=4; b+=4;
            if (b==352) b=0;
        } while (a!=352);
    }

    Sfmt18(int s) { super(s); }
    Sfmt18(int[]init_key)  { super(init_key); }
}
