/*
Sfmt19.java Cu(11213)
coded by isaku@pb4.so-net.ne.jp
*/

class Sfmt19 extends Sfmt
{
    public String IdString() {
        return"SFMT-11213:48-11-7-17-1:ffd7ebff-efffff7b-efbfffbd-f7f7efae";
    }

    protected int[]GetParity()
    { return new int[]{ 0x00000001,0x00000000,0x76adc000,0xdd5c6c66 }; }


    public void gen_rand_all() {
        int a=0,b=192,c=344,d=348,y; int[]p=x;

        do {
            y=p[a+3]^(p[a+2]<<24)^(p[a+1]>>>8)^((p[b+3]>>>17)&0xf7f7efae);
            p[a+3]=y^(p[c+3]>>>8)^(p[d+3]<<11);
            y=p[a+2]^(p[a+1]<<24)^(p[a]>>>8)^((p[b+2]>>>17)&0xefbfffbd);
            p[a+2]=y^((p[c+2]>>>8)|(p[c+3]<<24))^(p[d+2]<<11);
            y=p[a+1]^(p[a]<<24)^((p[b+1]>>>17)&0xefffff7b);
            p[a+1]=y^((p[c+1]>>>8)|(p[c+2]<<24))^(p[d+1]<<11);
            y=p[a]^((p[b]>>>17)&0xffd7ebff);
            p[a]=y^((p[c]>>>8)|(p[c+1]<<24))^(p[d]<<11);
            c=d; d=a; a+=4; b+=4;
            if (b==352) b=0;
        } while (a!=352);
    }

    Sfmt19(int s) { super(s); }
    Sfmt19(int[]init_key)  { super(init_key); }
}
