/*
Sfmt2.java Cu(11213)
coded by isaku@pb4.so-net.ne.jp
*/

class Sfmt2 extends Sfmt
{
    public String IdString() {
        return"SFMT-11213:72-13-3-1-1:7ff7ffff-afffcdde-effffeff-ffffffff";
    }

    protected int[]GetParity()
    { return new int[]{ 0x00000001,0x00000000,0x03dc0000,0x1f9394f8 }; }


    public void gen_rand_all() {
        int a=0,b=288,c=344,d=348,y; int[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<24)^(p[a+2]>>>8)^((p[b+3]>>>1)&0xffffffff);
            p[a+3]=y^(p[c+3]>>>8)^(p[d+3]<<13);
            y=p[a+2]^(p[a+2]<<24)^(p[a+1]>>>8)^((p[b+2]>>>1)&0xeffffeff);
            p[a+2]=y^((p[c+2]>>>8)|(p[c+3]<<24))^(p[d+2]<<13);
            y=p[a+1]^(p[a+1]<<24)^(p[a]>>>8)^((p[b+1]>>>1)&0xafffcdde);
            p[a+1]=y^((p[c+1]>>>8)|(p[c+2]<<24))^(p[d+1]<<13);
            y=p[a]^(p[a]<<24)^((p[b]>>>1)&0x7ff7ffff);
            p[a]=y^((p[c]>>>8)|(p[c+1]<<24))^(p[d]<<13);
            c=d; d=a; a+=4; b+=4;
            if (b==352) b=0;
        } while (a!=352);
    }

    Sfmt2(int s) { super(s); }
    Sfmt2(int[]init_key)  { super(init_key); }
}
