/*
Sfmt24.java Cu(11213)
coded by isaku@pb4.so-net.ne.jp
*/

class Sfmt24 extends Sfmt
{
    public String IdString() {
        return"SFMT-11213:42-13-7-21-1:ff3ebfbe-ff7fffde-5ffffbef-fffefbfb";
    }

    protected int[]GetParity()
    { return new int[]{ 0x00000001,0x00000000,0x0443a000,0x35321b2a }; }


    public void gen_rand_all() {
        int a=0,b=168,c=344,d=348,y; int[]p=x;

        do {
            y=p[a+3]^(p[a+2]<<24)^(p[a+1]>>>8)^((p[b+3]>>>21)&0xfffefbfb);
            p[a+3]=y^(p[c+3]>>>8)^(p[d+3]<<13);
            y=p[a+2]^(p[a+1]<<24)^(p[a]>>>8)^((p[b+2]>>>21)&0x5ffffbef);
            p[a+2]=y^((p[c+2]>>>8)|(p[c+3]<<24))^(p[d+2]<<13);
            y=p[a+1]^(p[a]<<24)^((p[b+1]>>>21)&0xff7fffde);
            p[a+1]=y^((p[c+1]>>>8)|(p[c+2]<<24))^(p[d+1]<<13);
            y=p[a]^((p[b]>>>21)&0xff3ebfbe);
            p[a]=y^((p[c]>>>8)|(p[c+1]<<24))^(p[d]<<13);
            c=d; d=a; a+=4; b+=4;
            if (b==352) b=0;
        } while (a!=352);
    }

    Sfmt24(int s) { super(s); }
    Sfmt24(int[]init_key)  { super(init_key); }
}
