/*
Sfmt25.java Cu(11213)
coded by isaku@pb4.so-net.ne.jp
*/

class Sfmt25 extends Sfmt
{
    public String IdString() {
        return"SFMT-11213:38-16-3-1-5:fdf7dbff-fbffdffb-fbffbfd9-fffffdbd";
    }

    protected int[]GetParity()
    { return new int[]{ 0x00000001,0x00000000,0x16d92000,0xacd93bf9 }; }


    public void gen_rand_all() {
        int a=0,b=152,c=344,d=348,y; int[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<24)^(p[a+2]>>>8)^((p[b+3]>>>1)&0xfffffdbd);
            p[a+3]=y^(p[d+3]<<16);
            y=p[a+2]^(p[a+2]<<24)^(p[a+1]>>>8)^((p[b+2]>>>1)&0xfbffbfd9);
            p[a+2]=y^(p[c+3]>>>8)^(p[d+2]<<16);
            y=p[a+1]^(p[a+1]<<24)^(p[a]>>>8)^((p[b+1]>>>1)&0xfbffdffb);
            p[a+1]=y^((p[c+2]>>>8)|(p[c+3]<<24))^(p[d+1]<<16);
            y=p[a]^(p[a]<<24)^((p[b]>>>1)&0xfdf7dbff);
            p[a]=y^((p[c+1]>>>8)|(p[c+2]<<24))^(p[d]<<16);
            c=d; d=a; a+=4; b+=4;
            if (b==352) b=0;
        } while (a!=352);
    }

    Sfmt25(int s) { super(s); }
    Sfmt25(int[]init_key)  { super(init_key); }
}
