/*
Sfmt28.java Cu(11213)
coded by isaku@pb4.so-net.ne.jp
*/

class Sfmt28 extends Sfmt
{
    public String IdString() {
        return"SFMT-11213:14-11-1-21-1:ffffffbd-ff7feffe-b6ffd7ff-97f9fe7f";
    }

    protected int[]GetParity()
    { return new int[]{ 0x00000001,0x00000000,0x22d14000,0xf393e8a4 }; }


    public void gen_rand_all() {
        int a=0,b=56,c=344,d=348,y; int[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<8)^(p[a+2]>>>24)^((p[b+3]>>>21)&0x97f9fe7f);
            p[a+3]=y^(p[c+3]>>>8)^(p[d+3]<<11);
            y=p[a+2]^(p[a+2]<<8)^(p[a+1]>>>24)^((p[b+2]>>>21)&0xb6ffd7ff);
            p[a+2]=y^((p[c+2]>>>8)|(p[c+3]<<24))^(p[d+2]<<11);
            y=p[a+1]^(p[a+1]<<8)^(p[a]>>>24)^((p[b+1]>>>21)&0xff7feffe);
            p[a+1]=y^((p[c+1]>>>8)|(p[c+2]<<24))^(p[d+1]<<11);
            y=p[a]^(p[a]<<8)^((p[b]>>>21)&0xffffffbd);
            p[a]=y^((p[c]>>>8)|(p[c+1]<<24))^(p[d]<<11);
            c=d; d=a; a+=4; b+=4;
            if (b==352) b=0;
        } while (a!=352);
    }

    Sfmt28(int s) { super(s); }
    Sfmt28(int[]init_key)  { super(init_key); }
}
