/*
Sfmt29.java Cu(11213)
coded by isaku@pb4.so-net.ne.jp
*/

class Sfmt29 extends Sfmt
{
    public String IdString() {
        return"SFMT-11213:16-27-1-5-3:dfffef7f-eff97fdf-fff3fcfa-fe7feeff";
    }

    protected int[]GetParity()
    { return new int[]{ 0x00000001,0x00000000,0x16f44800,0x24ce4227 }; }


    public void gen_rand_all() {
        int a=0,b=64,c=344,d=348,y; int[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<8)^(p[a+2]>>>24)^((p[b+3]>>>5)&0xfe7feeff);
            p[a+3]=y^(p[c+3]>>>24)^(p[d+3]<<27);
            y=p[a+2]^(p[a+2]<<8)^(p[a+1]>>>24)^((p[b+2]>>>5)&0xfff3fcfa);
            p[a+2]=y^((p[c+2]>>>24)|(p[c+3]<<8))^(p[d+2]<<27);
            y=p[a+1]^(p[a+1]<<8)^(p[a]>>>24)^((p[b+1]>>>5)&0xeff97fdf);
            p[a+1]=y^((p[c+1]>>>24)|(p[c+2]<<8))^(p[d+1]<<27);
            y=p[a]^(p[a]<<8)^((p[b]>>>5)&0xdfffef7f);
            p[a]=y^((p[c]>>>24)|(p[c+1]<<8))^(p[d]<<27);
            c=d; d=a; a+=4; b+=4;
            if (b==352) b=0;
        } while (a!=352);
    }

    Sfmt29(int s) { super(s); }
    Sfmt29(int[]init_key)  { super(init_key); }
}
