/*
Sfmt6.java Cu(11213)
coded by isaku@pb4.so-net.ne.jp
*/

class Sfmt6 extends Sfmt
{
    public String IdString() {
        return"SFMT-11213:45-13-3-10-5:fbffd7ff-ddf7f7e7-9bffe71f-ff7ec3ff";
    }

    protected int[]GetParity()
    { return new int[]{ 0x00000001,0x00000000,0x830e0000,0xcd4127af }; }


    public void gen_rand_all() {
        int a=0,b=180,c=344,d=348,y; int[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<24)^(p[a+2]>>>8)^((p[b+3]>>>10)&0xff7ec3ff);
            p[a+3]=y^(p[d+3]<<13);
            y=p[a+2]^(p[a+2]<<24)^(p[a+1]>>>8)^((p[b+2]>>>10)&0x9bffe71f);
            p[a+2]=y^(p[c+3]>>>8)^(p[d+2]<<13);
            y=p[a+1]^(p[a+1]<<24)^(p[a]>>>8)^((p[b+1]>>>10)&0xddf7f7e7);
            p[a+1]=y^((p[c+2]>>>8)|(p[c+3]<<24))^(p[d+1]<<13);
            y=p[a]^(p[a]<<24)^((p[b]>>>10)&0xfbffd7ff);
            p[a]=y^((p[c+1]>>>8)|(p[c+2]<<24))^(p[d]<<13);
            c=d; d=a; a+=4; b+=4;
            if (b==352) b=0;
        } while (a!=352);
    }

    Sfmt6(int s) { super(s); }
    Sfmt6(int[]init_key)  { super(init_key); }
}
