/*
Sfmt8.java Cu(11213)
coded by isaku@pb4.so-net.ne.jp
*/

class Sfmt8 extends Sfmt
{
    public String IdString() {
        return"SFMT-11213:86-19-1-5-1:fffffebf-fdeffadf-7fb71fcf-ffff5fff";
    }

    protected int[]GetParity()
    { return new int[]{ 0x00000001,0x00000000,0x953e8000,0xf7bd34c4 }; }


    public void gen_rand_all() {
        int a=0,b=344,c=344,d=348,y; int[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<8)^(p[a+2]>>>24)^((p[b+3]>>>5)&0xffff5fff);
            p[a+3]=y^(p[c+3]>>>8)^(p[d+3]<<19);
            y=p[a+2]^(p[a+2]<<8)^(p[a+1]>>>24)^((p[b+2]>>>5)&0x7fb71fcf);
            p[a+2]=y^((p[c+2]>>>8)|(p[c+3]<<24))^(p[d+2]<<19);
            y=p[a+1]^(p[a+1]<<8)^(p[a]>>>24)^((p[b+1]>>>5)&0xfdeffadf);
            p[a+1]=y^((p[c+1]>>>8)|(p[c+2]<<24))^(p[d+1]<<19);
            y=p[a]^(p[a]<<8)^((p[b]>>>5)&0xfffffebf);
            p[a]=y^((p[c]>>>8)|(p[c+1]<<24))^(p[d]<<19);
            c=d; d=a; a+=4; b+=4;
            if (b==352) b=0;
        } while (a!=352);
    }

    Sfmt8(int s) { super(s); }
    Sfmt8(int[]init_key)  { super(init_key); }
}
