/*
Sfmt12.java Cu(1279)
coded by isaku@pb4.so-net.ne.jp
*/

class Sfmt12 extends Sfmt
{
    public String IdString() {
        return"SFMT-1279:8-6-3-9-1:effff777-eefbfdff-feffffff-fff7fffe";
    }

    protected int[]GetParity()
    { return new int[]{ 0x00000001,0x00000000,0x00000000,0x80000000 }; }


    public void gen_rand_all() {
        int a=0,b=32,c=32,d=36,y; int[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<24)^(p[a+2]>>>8)^((p[b+3]>>>9)&0xfff7fffe);
            p[a+3]=y^(p[c+3]>>>8)^(p[d+3]<<6);
            y=p[a+2]^(p[a+2]<<24)^(p[a+1]>>>8)^((p[b+2]>>>9)&0xfeffffff);
            p[a+2]=y^((p[c+2]>>>8)|(p[c+3]<<24))^(p[d+2]<<6);
            y=p[a+1]^(p[a+1]<<24)^(p[a]>>>8)^((p[b+1]>>>9)&0xeefbfdff);
            p[a+1]=y^((p[c+1]>>>8)|(p[c+2]<<24))^(p[d+1]<<6);
            y=p[a]^(p[a]<<24)^((p[b]>>>9)&0xeffff777);
            p[a]=y^((p[c]>>>8)|(p[c+1]<<24))^(p[d]<<6);
            c=d; d=a; a+=4; b+=4;
            if (b==40) b=0;
        } while (a!=40);
    }

    Sfmt12(int s) { super(s); }
    Sfmt12(int[]init_key)  { super(init_key); }
}
