/*
Sfmt14.java Cu(1279)
coded by isaku@pb4.so-net.ne.jp
*/

class Sfmt14 extends Sfmt
{
    public String IdString() {
        return"SFMT-1279:1-19-3-4-1:ff7fffff-fffbfd7f-ffefffea-fddfdfde";
    }

    protected int[]GetParity()
    { return new int[]{ 0x00000001,0x00000000,0x00000000,0x40000000 }; }


    public void gen_rand_all() {
        int a=0,b=4,c=32,d=36,y; int[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<24)^(p[a+2]>>>8)^((p[b+3]>>>4)&0xfddfdfde);
            p[a+3]=y^(p[c+3]>>>8)^(p[d+3]<<19);
            y=p[a+2]^(p[a+2]<<24)^(p[a+1]>>>8)^((p[b+2]>>>4)&0xffefffea);
            p[a+2]=y^((p[c+2]>>>8)|(p[c+3]<<24))^(p[d+2]<<19);
            y=p[a+1]^(p[a+1]<<24)^(p[a]>>>8)^((p[b+1]>>>4)&0xfffbfd7f);
            p[a+1]=y^((p[c+1]>>>8)|(p[c+2]<<24))^(p[d+1]<<19);
            y=p[a]^(p[a]<<24)^((p[b]>>>4)&0xff7fffff);
            p[a]=y^((p[c]>>>8)|(p[c+1]<<24))^(p[d]<<19);
            c=d; d=a; a+=4; b+=4;
            if (b==40) b=0;
        } while (a!=40);
    }

    Sfmt14(int s) { super(s); }
    Sfmt14(int[]init_key)  { super(init_key); }
}
