/*
Sfmt18.java Cu(1279)
coded by isaku@pb4.so-net.ne.jp
*/

class Sfmt18 extends Sfmt
{
    public String IdString() {
        return"SFMT-1279:7-13-7-2-1:7df7ffff-dfd7ff7f-f7f2b3dd-e77ffddf";
    }

    protected int[]GetParity()
    { return new int[]{ 0x00000001,0x00000000,0x00000000,0x00000000 }; }


    public void gen_rand_all() {
        int a=0,b=28,c=32,d=36,y; int[]p=x;

        do {
            y=p[a+3]^(p[a+2]<<24)^(p[a+1]>>>8)^((p[b+3]>>>2)&0xe77ffddf);
            p[a+3]=y^(p[c+3]>>>8)^(p[d+3]<<13);
            y=p[a+2]^(p[a+1]<<24)^(p[a]>>>8)^((p[b+2]>>>2)&0xf7f2b3dd);
            p[a+2]=y^((p[c+2]>>>8)|(p[c+3]<<24))^(p[d+2]<<13);
            y=p[a+1]^(p[a]<<24)^((p[b+1]>>>2)&0xdfd7ff7f);
            p[a+1]=y^((p[c+1]>>>8)|(p[c+2]<<24))^(p[d+1]<<13);
            y=p[a]^((p[b]>>>2)&0x7df7ffff);
            p[a]=y^((p[c]>>>8)|(p[c+1]<<24))^(p[d]<<13);
            c=d; d=a; a+=4; b+=4;
            if (b==40) b=0;
        } while (a!=40);
    }

    Sfmt18(int s) { super(s); }
    Sfmt18(int[]init_key)  { super(init_key); }
}
