/*
Sfmt23.java Cu(1279)
coded by isaku@pb4.so-net.ne.jp
*/

class Sfmt23 extends Sfmt
{
    public String IdString() {
        return"SFMT-1279:7-11-3-12-5:fdfeedff-dffcfff7-7bdffffe-ffdfffea";
    }

    protected int[]GetParity()
    { return new int[]{ 0x00000001,0x00000000,0x00000000,0x00000000 }; }


    public void gen_rand_all() {
        int a=0,b=28,c=32,d=36,y; int[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<24)^(p[a+2]>>>8)^((p[b+3]>>>12)&0xffdfffea);
            p[a+3]=y^(p[d+3]<<11);
            y=p[a+2]^(p[a+2]<<24)^(p[a+1]>>>8)^((p[b+2]>>>12)&0x7bdffffe);
            p[a+2]=y^(p[c+3]>>>8)^(p[d+2]<<11);
            y=p[a+1]^(p[a+1]<<24)^(p[a]>>>8)^((p[b+1]>>>12)&0xdffcfff7);
            p[a+1]=y^((p[c+2]>>>8)|(p[c+3]<<24))^(p[d+1]<<11);
            y=p[a]^(p[a]<<24)^((p[b]>>>12)&0xfdfeedff);
            p[a]=y^((p[c+1]>>>8)|(p[c+2]<<24))^(p[d]<<11);
            c=d; d=a; a+=4; b+=4;
            if (b==40) b=0;
        } while (a!=40);
    }

    Sfmt23(int s) { super(s); }
    Sfmt23(int[]init_key)  { super(init_key); }
}
