/*
Sfmt4.java Cu(1279)
coded by isaku@pb4.so-net.ne.jp
*/

class Sfmt4 extends Sfmt
{
    public String IdString() {
        return"SFMT-1279:3-20-1-5-1:fddfbf9f-eefffb37-fff7df7b-fffefbef";
    }

    protected int[]GetParity()
    { return new int[]{ 0x00000001,0x00000000,0x00000000,0x00000000 }; }


    public void gen_rand_all() {
        int a=0,b=12,c=32,d=36,y; int[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<8)^(p[a+2]>>>24)^((p[b+3]>>>5)&0xfffefbef);
            p[a+3]=y^(p[c+3]>>>8)^(p[d+3]<<20);
            y=p[a+2]^(p[a+2]<<8)^(p[a+1]>>>24)^((p[b+2]>>>5)&0xfff7df7b);
            p[a+2]=y^((p[c+2]>>>8)|(p[c+3]<<24))^(p[d+2]<<20);
            y=p[a+1]^(p[a+1]<<8)^(p[a]>>>24)^((p[b+1]>>>5)&0xeefffb37);
            p[a+1]=y^((p[c+1]>>>8)|(p[c+2]<<24))^(p[d+1]<<20);
            y=p[a]^(p[a]<<8)^((p[b]>>>5)&0xfddfbf9f);
            p[a]=y^((p[c]>>>8)|(p[c+1]<<24))^(p[d]<<20);
            c=d; d=a; a+=4; b+=4;
            if (b==40) b=0;
        } while (a!=40);
    }

    Sfmt4(int s) { super(s); }
    Sfmt4(int[]init_key)  { super(init_key); }
}
