/*
Sfmt5.java Cu(1279)
coded by isaku@pb4.so-net.ne.jp
*/

class Sfmt5 extends Sfmt
{
    public String IdString() {
        return"SFMT-1279:5-15-3-12-1:fddf9f97-f97fbff7-7fbfbff7-bfbf1fff";
    }

    protected int[]GetParity()
    { return new int[]{ 0x00000001,0x00000000,0x00000000,0x20000000 }; }


    public void gen_rand_all() {
        int a=0,b=20,c=32,d=36,y; int[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<24)^(p[a+2]>>>8)^((p[b+3]>>>12)&0xbfbf1fff);
            p[a+3]=y^(p[c+3]>>>8)^(p[d+3]<<15);
            y=p[a+2]^(p[a+2]<<24)^(p[a+1]>>>8)^((p[b+2]>>>12)&0x7fbfbff7);
            p[a+2]=y^((p[c+2]>>>8)|(p[c+3]<<24))^(p[d+2]<<15);
            y=p[a+1]^(p[a+1]<<24)^(p[a]>>>8)^((p[b+1]>>>12)&0xf97fbff7);
            p[a+1]=y^((p[c+1]>>>8)|(p[c+2]<<24))^(p[d+1]<<15);
            y=p[a]^(p[a]<<24)^((p[b]>>>12)&0xfddf9f97);
            p[a]=y^((p[c]>>>8)|(p[c+1]<<24))^(p[d]<<15);
            c=d; d=a; a+=4; b+=4;
            if (b==40) b=0;
        } while (a!=40);
    }

    Sfmt5(int s) { super(s); }
    Sfmt5(int[]init_key)  { super(init_key); }
}
