/*
Sfmt6.java Cu(1279)
coded by isaku@pb4.so-net.ne.jp
*/

class Sfmt6 extends Sfmt
{
    public String IdString() {
        return"SFMT-1279:6-13-3-21-1:fffbffff-fffe96ef-edd7ff2f-f5f7f8ed";
    }

    protected int[]GetParity()
    { return new int[]{ 0x00000001,0x00000000,0x00000000,0x40000000 }; }


    public void gen_rand_all() {
        int a=0,b=24,c=32,d=36,y; int[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<24)^(p[a+2]>>>8)^((p[b+3]>>>21)&0xf5f7f8ed);
            p[a+3]=y^(p[c+3]>>>8)^(p[d+3]<<13);
            y=p[a+2]^(p[a+2]<<24)^(p[a+1]>>>8)^((p[b+2]>>>21)&0xedd7ff2f);
            p[a+2]=y^((p[c+2]>>>8)|(p[c+3]<<24))^(p[d+2]<<13);
            y=p[a+1]^(p[a+1]<<24)^(p[a]>>>8)^((p[b+1]>>>21)&0xfffe96ef);
            p[a+1]=y^((p[c+1]>>>8)|(p[c+2]<<24))^(p[d+1]<<13);
            y=p[a]^(p[a]<<24)^((p[b]>>>21)&0xfffbffff);
            p[a]=y^((p[c]>>>8)|(p[c+1]<<24))^(p[d]<<13);
            c=d; d=a; a+=4; b+=4;
            if (b==40) b=0;
        } while (a!=40);
    }

    Sfmt6(int s) { super(s); }
    Sfmt6(int[]init_key)  { super(init_key); }
}
