/*
Sfmt10.java Cu(19937)
coded by isaku@pb4.so-net.ne.jp
*/

class Sfmt10 extends Sfmt
{
    public String IdString() {
        return"SFMT-19937:128-11-3-1-5:7dbebfff-7ffffffe-ded6ffef-fefeff6e";
    }

    protected int[]GetParity()
    { return new int[]{ 0x00000001,0x00000000,0x00000000,0x42530085 }; }


    public void gen_rand_all() {
        int a=0,b=512,c=616,d=620,y; int[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<24)^(p[a+2]>>>8)^((p[b+3]>>>1)&0xfefeff6e);
            p[a+3]=y^(p[d+3]<<11);
            y=p[a+2]^(p[a+2]<<24)^(p[a+1]>>>8)^((p[b+2]>>>1)&0xded6ffef);
            p[a+2]=y^(p[c+3]>>>8)^(p[d+2]<<11);
            y=p[a+1]^(p[a+1]<<24)^(p[a]>>>8)^((p[b+1]>>>1)&0x7ffffffe);
            p[a+1]=y^((p[c+2]>>>8)|(p[c+3]<<24))^(p[d+1]<<11);
            y=p[a]^(p[a]<<24)^((p[b]>>>1)&0x7dbebfff);
            p[a]=y^((p[c+1]>>>8)|(p[c+2]<<24))^(p[d]<<11);
            c=d; d=a; a+=4; b+=4;
            if (b==624) b=0;
        } while (a!=624);
    }

    Sfmt10(int s) { super(s); }
    Sfmt10(int[]init_key)  { super(init_key); }
}
