/*
Sfmt11.java Cu(19937)
coded by isaku@pb4.so-net.ne.jp
*/

class Sfmt11 extends Sfmt
{
    public String IdString() {
        return"SFMT-19937:106-19-1-9-1:ffeeffdf-ffffdfff-bd6ff9ff-fdafebff";
    }

    protected int[]GetParity()
    { return new int[]{ 0x00000001,0x00000000,0x00000000,0x47a2caf4 }; }


    public void gen_rand_all() {
        int a=0,b=424,c=616,d=620,y; int[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<8)^(p[a+2]>>>24)^((p[b+3]>>>9)&0xfdafebff);
            p[a+3]=y^(p[c+3]>>>8)^(p[d+3]<<19);
            y=p[a+2]^(p[a+2]<<8)^(p[a+1]>>>24)^((p[b+2]>>>9)&0xbd6ff9ff);
            p[a+2]=y^((p[c+2]>>>8)|(p[c+3]<<24))^(p[d+2]<<19);
            y=p[a+1]^(p[a+1]<<8)^(p[a]>>>24)^((p[b+1]>>>9)&0xffffdfff);
            p[a+1]=y^((p[c+1]>>>8)|(p[c+2]<<24))^(p[d+1]<<19);
            y=p[a]^(p[a]<<8)^((p[b]>>>9)&0xffeeffdf);
            p[a]=y^((p[c]>>>8)|(p[c+1]<<24))^(p[d]<<19);
            c=d; d=a; a+=4; b+=4;
            if (b==624) b=0;
        } while (a!=624);
    }

    Sfmt11(int s) { super(s); }
    Sfmt11(int[]init_key)  { super(init_key); }
}
