/*
Sfmt15.java Cu(19937)
coded by isaku@pb4.so-net.ne.jp
*/

class Sfmt15 extends Sfmt
{
    public String IdString() {
        return"SFMT-19937:12-13-3-3-1:ffffffbb-fffff7ab-fdfff7c2-bdff9efb";
    }

    protected int[]GetParity()
    { return new int[]{ 0x00000001,0x00000000,0x00000000,0xa631116a }; }


    public void gen_rand_all() {
        int a=0,b=48,c=616,d=620,y; int[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<24)^(p[a+2]>>>8)^((p[b+3]>>>3)&0xbdff9efb);
            p[a+3]=y^(p[c+3]>>>8)^(p[d+3]<<13);
            y=p[a+2]^(p[a+2]<<24)^(p[a+1]>>>8)^((p[b+2]>>>3)&0xfdfff7c2);
            p[a+2]=y^((p[c+2]>>>8)|(p[c+3]<<24))^(p[d+2]<<13);
            y=p[a+1]^(p[a+1]<<24)^(p[a]>>>8)^((p[b+1]>>>3)&0xfffff7ab);
            p[a+1]=y^((p[c+1]>>>8)|(p[c+2]<<24))^(p[d+1]<<13);
            y=p[a]^(p[a]<<24)^((p[b]>>>3)&0xffffffbb);
            p[a]=y^((p[c]>>>8)|(p[c+1]<<24))^(p[d]<<13);
            c=d; d=a; a+=4; b+=4;
            if (b==624) b=0;
        } while (a!=624);
    }

    Sfmt15(int s) { super(s); }
    Sfmt15(int[]init_key)  { super(init_key); }
}
