/*
Sfmt17.java Cu(19937)
coded by isaku@pb4.so-net.ne.jp
*/

class Sfmt17 extends Sfmt
{
    public String IdString() {
        return"SFMT-19937:124-13-3-11-1:ffbff7ef-7b7e7fcd-fddaff7f-b7dbfdfc";
    }

    protected int[]GetParity()
    { return new int[]{ 0x00000001,0x00000000,0x00000000,0x02889855 }; }


    public void gen_rand_all() {
        int a=0,b=496,c=616,d=620,y; int[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<24)^(p[a+2]>>>8)^((p[b+3]>>>11)&0xb7dbfdfc);
            p[a+3]=y^(p[c+3]>>>8)^(p[d+3]<<13);
            y=p[a+2]^(p[a+2]<<24)^(p[a+1]>>>8)^((p[b+2]>>>11)&0xfddaff7f);
            p[a+2]=y^((p[c+2]>>>8)|(p[c+3]<<24))^(p[d+2]<<13);
            y=p[a+1]^(p[a+1]<<24)^(p[a]>>>8)^((p[b+1]>>>11)&0x7b7e7fcd);
            p[a+1]=y^((p[c+1]>>>8)|(p[c+2]<<24))^(p[d+1]<<13);
            y=p[a]^(p[a]<<24)^((p[b]>>>11)&0xffbff7ef);
            p[a]=y^((p[c]>>>8)|(p[c+1]<<24))^(p[d]<<13);
            c=d; d=a; a+=4; b+=4;
            if (b==624) b=0;
        } while (a!=624);
    }

    Sfmt17(int s) { super(s); }
    Sfmt17(int[]init_key)  { super(init_key); }
}
