/*
Sfmt18.java Cu(19937)
coded by isaku@pb4.so-net.ne.jp
*/

class Sfmt18 extends Sfmt
{
    public String IdString() {
        return"SFMT-19937:112-20-1-15-1:ffbf7efe-fabf7fff-f6ff7fef-f74f6f3f";
    }

    protected int[]GetParity()
    { return new int[]{ 0x00000001,0x00000000,0x00000000,0x921dce22 }; }


    public void gen_rand_all() {
        int a=0,b=448,c=616,d=620,y; int[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<8)^(p[a+2]>>>24)^((p[b+3]>>>15)&0xf74f6f3f);
            p[a+3]=y^(p[c+3]>>>8)^(p[d+3]<<20);
            y=p[a+2]^(p[a+2]<<8)^(p[a+1]>>>24)^((p[b+2]>>>15)&0xf6ff7fef);
            p[a+2]=y^((p[c+2]>>>8)|(p[c+3]<<24))^(p[d+2]<<20);
            y=p[a+1]^(p[a+1]<<8)^(p[a]>>>24)^((p[b+1]>>>15)&0xfabf7fff);
            p[a+1]=y^((p[c+1]>>>8)|(p[c+2]<<24))^(p[d+1]<<20);
            y=p[a]^(p[a]<<8)^((p[b]>>>15)&0xffbf7efe);
            p[a]=y^((p[c]>>>8)|(p[c+1]<<24))^(p[d]<<20);
            c=d; d=a; a+=4; b+=4;
            if (b==624) b=0;
        } while (a!=624);
    }

    Sfmt18(int s) { super(s); }
    Sfmt18(int[]init_key)  { super(init_key); }
}
