/*
Sfmt25.java Cu(19937)
coded by isaku@pb4.so-net.ne.jp
*/

class Sfmt25 extends Sfmt
{
    public String IdString() {
        return"SFMT-19937:153-11-3-4-3:ffebf7fd-fffdffff-ffffffef-fffbdfb7";
    }

    protected int[]GetParity()
    { return new int[]{ 0x00000001,0x00000000,0x00000000,0x7f72515e }; }


    public void gen_rand_all() {
        int a=0,b=612,c=616,d=620,y; int[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<24)^(p[a+2]>>>8)^((p[b+3]>>>4)&0xfffbdfb7);
            p[a+3]=y^(p[c+3]>>>24)^(p[d+3]<<11);
            y=p[a+2]^(p[a+2]<<24)^(p[a+1]>>>8)^((p[b+2]>>>4)&0xffffffef);
            p[a+2]=y^((p[c+2]>>>24)|(p[c+3]<<8))^(p[d+2]<<11);
            y=p[a+1]^(p[a+1]<<24)^(p[a]>>>8)^((p[b+1]>>>4)&0xfffdffff);
            p[a+1]=y^((p[c+1]>>>24)|(p[c+2]<<8))^(p[d+1]<<11);
            y=p[a]^(p[a]<<24)^((p[b]>>>4)&0xffebf7fd);
            p[a]=y^((p[c]>>>24)|(p[c+1]<<8))^(p[d]<<11);
            c=d; d=a; a+=4; b+=4;
            if (b==624) b=0;
        } while (a!=624);
    }

    Sfmt25(int s) { super(s); }
    Sfmt25(int[]init_key)  { super(init_key); }
}
