/*
Sfmt26.java Cu(19937)
coded by isaku@pb4.so-net.ne.jp
*/

class Sfmt26 extends Sfmt
{
    public String IdString() {
        return"SFMT-19937:64-7-7-7-1:fbbefeef-ffffffc7-fbffed57-fafffddf";
    }

    protected int[]GetParity()
    { return new int[]{ 0x00000001,0x00000000,0x00000000,0x7094862a }; }


    public void gen_rand_all() {
        int a=0,b=256,c=616,d=620,y; int[]p=x;

        do {
            y=p[a+3]^(p[a+2]<<24)^(p[a+1]>>>8)^((p[b+3]>>>7)&0xfafffddf);
            p[a+3]=y^(p[c+3]>>>8)^(p[d+3]<<7);
            y=p[a+2]^(p[a+1]<<24)^(p[a]>>>8)^((p[b+2]>>>7)&0xfbffed57);
            p[a+2]=y^((p[c+2]>>>8)|(p[c+3]<<24))^(p[d+2]<<7);
            y=p[a+1]^(p[a]<<24)^((p[b+1]>>>7)&0xffffffc7);
            p[a+1]=y^((p[c+1]>>>8)|(p[c+2]<<24))^(p[d+1]<<7);
            y=p[a]^((p[b]>>>7)&0xfbbefeef);
            p[a]=y^((p[c]>>>8)|(p[c+1]<<24))^(p[d]<<7);
            c=d; d=a; a+=4; b+=4;
            if (b==624) b=0;
        } while (a!=624);
    }

    Sfmt26(int s) { super(s); }
    Sfmt26(int[]init_key)  { super(init_key); }
}
