/*
Sfmt27.java Cu(19937)
coded by isaku@pb4.so-net.ne.jp
*/

class Sfmt27 extends Sfmt
{
    public String IdString() {
        return"SFMT-19937:150-7-3-3-1:ffff7fef-ffbf5aff-a6ff7fbd-bffffbff";
    }

    protected int[]GetParity()
    { return new int[]{ 0x00000001,0x00000000,0x40000000,0x5ee9dc90 }; }


    public void gen_rand_all() {
        int a=0,b=600,c=616,d=620,y; int[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<24)^(p[a+2]>>>8)^((p[b+3]>>>3)&0xbffffbff);
            p[a+3]=y^(p[c+3]>>>8)^(p[d+3]<<7);
            y=p[a+2]^(p[a+2]<<24)^(p[a+1]>>>8)^((p[b+2]>>>3)&0xa6ff7fbd);
            p[a+2]=y^((p[c+2]>>>8)|(p[c+3]<<24))^(p[d+2]<<7);
            y=p[a+1]^(p[a+1]<<24)^(p[a]>>>8)^((p[b+1]>>>3)&0xffbf5aff);
            p[a+1]=y^((p[c+1]>>>8)|(p[c+2]<<24))^(p[d+1]<<7);
            y=p[a]^(p[a]<<24)^((p[b]>>>3)&0xffff7fef);
            p[a]=y^((p[c]>>>8)|(p[c+1]<<24))^(p[d]<<7);
            c=d; d=a; a+=4; b+=4;
            if (b==624) b=0;
        } while (a!=624);
    }

    Sfmt27(int s) { super(s); }
    Sfmt27(int[]init_key)  { super(init_key); }
}
