/*
Sfmt5.java Cu(19937)
coded by isaku@pb4.so-net.ne.jp
*/

class Sfmt5 extends Sfmt
{
    public String IdString() {
        return"SFMT-19937:120-18-1-1-1:ffefef5d-ff25ff7d-eebfefee-fabfdfff";
    }

    protected int[]GetParity()
    { return new int[]{ 0x00000001,0x00000000,0x02000000,0xc9bbd290 }; }


    public void gen_rand_all() {
        int a=0,b=480,c=616,d=620,y; int[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<8)^(p[a+2]>>>24)^((p[b+3]>>>1)&0xfabfdfff);
            p[a+3]=y^(p[c+3]>>>8)^(p[d+3]<<18);
            y=p[a+2]^(p[a+2]<<8)^(p[a+1]>>>24)^((p[b+2]>>>1)&0xeebfefee);
            p[a+2]=y^((p[c+2]>>>8)|(p[c+3]<<24))^(p[d+2]<<18);
            y=p[a+1]^(p[a+1]<<8)^(p[a]>>>24)^((p[b+1]>>>1)&0xff25ff7d);
            p[a+1]=y^((p[c+1]>>>8)|(p[c+2]<<24))^(p[d+1]<<18);
            y=p[a]^(p[a]<<8)^((p[b]>>>1)&0xffefef5d);
            p[a]=y^((p[c]>>>8)|(p[c+1]<<24))^(p[d]<<18);
            c=d; d=a; a+=4; b+=4;
            if (b==624) b=0;
        } while (a!=624);
    }

    Sfmt5(int s) { super(s); }
    Sfmt5(int[]init_key)  { super(init_key); }
}
