/*
Sfmt15.java Cu(2281)
coded by isaku@pb4.so-net.ne.jp
*/

class Sfmt15 extends Sfmt
{
    public String IdString() {
        return"SFMT-2281:9-10-7-13-1:dfffeeef-fffffddf-fbfbfe5f-cffbfdef";
    }

    protected int[]GetParity()
    { return new int[]{ 0x00000001,0x00000000,0x00000000,0xdb3cce00 }; }


    public void gen_rand_all() {
        int a=0,b=36,c=64,d=68,y; int[]p=x;

        do {
            y=p[a+3]^(p[a+2]<<24)^(p[a+1]>>>8)^((p[b+3]>>>13)&0xcffbfdef);
            p[a+3]=y^(p[c+3]>>>8)^(p[d+3]<<10);
            y=p[a+2]^(p[a+1]<<24)^(p[a]>>>8)^((p[b+2]>>>13)&0xfbfbfe5f);
            p[a+2]=y^((p[c+2]>>>8)|(p[c+3]<<24))^(p[d+2]<<10);
            y=p[a+1]^(p[a]<<24)^((p[b+1]>>>13)&0xfffffddf);
            p[a+1]=y^((p[c+1]>>>8)|(p[c+2]<<24))^(p[d+1]<<10);
            y=p[a]^((p[b]>>>13)&0xdfffeeef);
            p[a]=y^((p[c]>>>8)|(p[c+1]<<24))^(p[d]<<10);
            c=d; d=a; a+=4; b+=4;
            if (b==72) b=0;
        } while (a!=72);
    }

    Sfmt15(int s) { super(s); }
    Sfmt15(int[]init_key)  { super(init_key); }
}
