/*
Sfmt22.java Cu(2281)
coded by isaku@pb4.so-net.ne.jp
*/

class Sfmt22 extends Sfmt
{
    public String IdString() {
        return"SFMT-2281:10-19-3-17-1:effbdfff-fffdbeed-fefd3fbf-ff5beffe";
    }

    protected int[]GetParity()
    { return new int[]{ 0x00000001,0x00000000,0x00000000,0xdedc0400 }; }


    public void gen_rand_all() {
        int a=0,b=40,c=64,d=68,y; int[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<24)^(p[a+2]>>>8)^((p[b+3]>>>17)&0xff5beffe);
            p[a+3]=y^(p[c+3]>>>8)^(p[d+3]<<19);
            y=p[a+2]^(p[a+2]<<24)^(p[a+1]>>>8)^((p[b+2]>>>17)&0xfefd3fbf);
            p[a+2]=y^((p[c+2]>>>8)|(p[c+3]<<24))^(p[d+2]<<19);
            y=p[a+1]^(p[a+1]<<24)^(p[a]>>>8)^((p[b+1]>>>17)&0xfffdbeed);
            p[a+1]=y^((p[c+1]>>>8)|(p[c+2]<<24))^(p[d+1]<<19);
            y=p[a]^(p[a]<<24)^((p[b]>>>17)&0xeffbdfff);
            p[a]=y^((p[c]>>>8)|(p[c+1]<<24))^(p[d]<<19);
            c=d; d=a; a+=4; b+=4;
            if (b==72) b=0;
        } while (a!=72);
    }

    Sfmt22(int s) { super(s); }
    Sfmt22(int[]init_key)  { super(init_key); }
}
