/*
Sfmt23.java Cu(2281)
coded by isaku@pb4.so-net.ne.jp
*/

class Sfmt23 extends Sfmt
{
    public String IdString() {
        return"SFMT-2281:11-17-7-20-1:bdffddfd-dfdffffc-bffeffd6-ff7fffff";
    }

    protected int[]GetParity()
    { return new int[]{ 0x00000001,0x00000000,0x00000000,0x3923e800 }; }


    public void gen_rand_all() {
        int a=0,b=44,c=64,d=68,y; int[]p=x;

        do {
            y=p[a+3]^(p[a+2]<<24)^(p[a+1]>>>8)^((p[b+3]>>>20)&0xff7fffff);
            p[a+3]=y^(p[c+3]>>>8)^(p[d+3]<<17);
            y=p[a+2]^(p[a+1]<<24)^(p[a]>>>8)^((p[b+2]>>>20)&0xbffeffd6);
            p[a+2]=y^((p[c+2]>>>8)|(p[c+3]<<24))^(p[d+2]<<17);
            y=p[a+1]^(p[a]<<24)^((p[b+1]>>>20)&0xdfdffffc);
            p[a+1]=y^((p[c+1]>>>8)|(p[c+2]<<24))^(p[d+1]<<17);
            y=p[a]^((p[b]>>>20)&0xbdffddfd);
            p[a]=y^((p[c]>>>8)|(p[c+1]<<24))^(p[d]<<17);
            c=d; d=a; a+=4; b+=4;
            if (b==72) b=0;
        } while (a!=72);
    }

    Sfmt23(int s) { super(s); }
    Sfmt23(int[]init_key)  { super(init_key); }
}
