/*
Sfmt24.java Cu(2281)
coded by isaku@pb4.so-net.ne.jp
*/

class Sfmt24 extends Sfmt
{
    public String IdString() {
        return"SFMT-2281:9-21-3-20-5:ffffffdf-dfffffff-ff6ffffa-ffffdfff";
    }

    protected int[]GetParity()
    { return new int[]{ 0x00000001,0x00000000,0x00000000,0x8a9b2080 }; }


    public void gen_rand_all() {
        int a=0,b=36,c=64,d=68,y; int[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<24)^(p[a+2]>>>8)^((p[b+3]>>>20)&0xffffdfff);
            p[a+3]=y^(p[d+3]<<21);
            y=p[a+2]^(p[a+2]<<24)^(p[a+1]>>>8)^((p[b+2]>>>20)&0xff6ffffa);
            p[a+2]=y^(p[c+3]>>>8)^(p[d+2]<<21);
            y=p[a+1]^(p[a+1]<<24)^(p[a]>>>8)^((p[b+1]>>>20)&0xdfffffff);
            p[a+1]=y^((p[c+2]>>>8)|(p[c+3]<<24))^(p[d+1]<<21);
            y=p[a]^(p[a]<<24)^((p[b]>>>20)&0xffffffdf);
            p[a]=y^((p[c+1]>>>8)|(p[c+2]<<24))^(p[d]<<21);
            c=d; d=a; a+=4; b+=4;
            if (b==72) b=0;
        } while (a!=72);
    }

    Sfmt24(int s) { super(s); }
    Sfmt24(int[]init_key)  { super(init_key); }
}
