/*
Sfmt28.java Cu(2281)
coded by isaku@pb4.so-net.ne.jp
*/

class Sfmt28 extends Sfmt
{
    public String IdString() {
        return"SFMT-2281:3-2-3-19-1:bbfffcff-f7bffcdf-e39ffffd-f7bebfff";
    }

    protected int[]GetParity()
    { return new int[]{ 0x00000001,0x00000000,0x00000000,0xd324a000 }; }


    public void gen_rand_all() {
        int a=0,b=12,c=64,d=68,y; int[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<24)^(p[a+2]>>>8)^((p[b+3]>>>19)&0xf7bebfff);
            p[a+3]=y^(p[c+3]>>>8)^(p[d+3]<<2);
            y=p[a+2]^(p[a+2]<<24)^(p[a+1]>>>8)^((p[b+2]>>>19)&0xe39ffffd);
            p[a+2]=y^((p[c+2]>>>8)|(p[c+3]<<24))^(p[d+2]<<2);
            y=p[a+1]^(p[a+1]<<24)^(p[a]>>>8)^((p[b+1]>>>19)&0xf7bffcdf);
            p[a+1]=y^((p[c+1]>>>8)|(p[c+2]<<24))^(p[d+1]<<2);
            y=p[a]^(p[a]<<24)^((p[b]>>>19)&0xbbfffcff);
            p[a]=y^((p[c]>>>8)|(p[c+1]<<24))^(p[d]<<2);
            c=d; d=a; a+=4; b+=4;
            if (b==72) b=0;
        } while (a!=72);
    }

    Sfmt28(int s) { super(s); }
    Sfmt28(int[]init_key)  { super(init_key); }
}
