/*
Sfmt5.java Cu(2281)
coded by isaku@pb4.so-net.ne.jp
*/

class Sfmt5 extends Sfmt
{
    public String IdString() {
        return"SFMT-2281:10-10-3-9-3:ff9ffff7-fdffffff-bf3f7fff-fbffff7c";
    }

    protected int[]GetParity()
    { return new int[]{ 0x00000001,0x00000000,0x00000000,0xc66e2000 }; }


    public void gen_rand_all() {
        int a=0,b=40,c=64,d=68,y; int[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<24)^(p[a+2]>>>8)^((p[b+3]>>>9)&0xfbffff7c);
            p[a+3]=y^(p[c+3]>>>24)^(p[d+3]<<10);
            y=p[a+2]^(p[a+2]<<24)^(p[a+1]>>>8)^((p[b+2]>>>9)&0xbf3f7fff);
            p[a+2]=y^((p[c+2]>>>24)|(p[c+3]<<8))^(p[d+2]<<10);
            y=p[a+1]^(p[a+1]<<24)^(p[a]>>>8)^((p[b+1]>>>9)&0xfdffffff);
            p[a+1]=y^((p[c+1]>>>24)|(p[c+2]<<8))^(p[d+1]<<10);
            y=p[a]^(p[a]<<24)^((p[b]>>>9)&0xff9ffff7);
            p[a]=y^((p[c]>>>24)|(p[c+1]<<8))^(p[d]<<10);
            c=d; d=a; a+=4; b+=4;
            if (b==72) b=0;
        } while (a!=72);
    }

    Sfmt5(int s) { super(s); }
    Sfmt5(int[]init_key)  { super(init_key); }
}
