/*
Sfmt6.java Cu(2281)
coded by isaku@pb4.so-net.ne.jp
*/

class Sfmt6 extends Sfmt
{
    public String IdString() {
        return"SFMT-2281:11-8-3-5-5:ff6ffba9-fffff7f7-ffdfdfff-f2ffffff";
    }

    protected int[]GetParity()
    { return new int[]{ 0x00000001,0x00000000,0x00000000,0x1b40e800 }; }


    public void gen_rand_all() {
        int a=0,b=44,c=64,d=68,y; int[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<24)^(p[a+2]>>>8)^((p[b+3]>>>5)&0xf2ffffff);
            p[a+3]=y^(p[d+3]<<8);
            y=p[a+2]^(p[a+2]<<24)^(p[a+1]>>>8)^((p[b+2]>>>5)&0xffdfdfff);
            p[a+2]=y^(p[c+3]>>>8)^(p[d+2]<<8);
            y=p[a+1]^(p[a+1]<<24)^(p[a]>>>8)^((p[b+1]>>>5)&0xfffff7f7);
            p[a+1]=y^((p[c+2]>>>8)|(p[c+3]<<24))^(p[d+1]<<8);
            y=p[a]^(p[a]<<24)^((p[b]>>>5)&0xff6ffba9);
            p[a]=y^((p[c+1]>>>8)|(p[c+2]<<24))^(p[d]<<8);
            c=d; d=a; a+=4; b+=4;
            if (b==72) b=0;
        } while (a!=72);
    }

    Sfmt6(int s) { super(s); }
    Sfmt6(int[]init_key)  { super(init_key); }
}
