/*
Sfmt8.java Cu(2281)
coded by isaku@pb4.so-net.ne.jp
*/

class Sfmt8 extends Sfmt
{
    public String IdString() {
        return"SFMT-2281:11-14-7-5-1:f7bffff9-6efff7ff-fbfbffdf-fff8ffbf";
    }

    protected int[]GetParity()
    { return new int[]{ 0x00000001,0x00000000,0x00000000,0x48acb400 }; }


    public void gen_rand_all() {
        int a=0,b=44,c=64,d=68,y; int[]p=x;

        do {
            y=p[a+3]^(p[a+2]<<24)^(p[a+1]>>>8)^((p[b+3]>>>5)&0xfff8ffbf);
            p[a+3]=y^(p[c+3]>>>8)^(p[d+3]<<14);
            y=p[a+2]^(p[a+1]<<24)^(p[a]>>>8)^((p[b+2]>>>5)&0xfbfbffdf);
            p[a+2]=y^((p[c+2]>>>8)|(p[c+3]<<24))^(p[d+2]<<14);
            y=p[a+1]^(p[a]<<24)^((p[b+1]>>>5)&0x6efff7ff);
            p[a+1]=y^((p[c+1]>>>8)|(p[c+2]<<24))^(p[d+1]<<14);
            y=p[a]^((p[b]>>>5)&0xf7bffff9);
            p[a]=y^((p[c]>>>8)|(p[c+1]<<24))^(p[d]<<14);
            c=d; d=a; a+=4; b+=4;
            if (b==72) b=0;
        } while (a!=72);
    }

    Sfmt8(int s) { super(s); }
    Sfmt8(int[]init_key)  { super(init_key); }
}
