/*
Sfmt9.java Cu(2281)
coded by isaku@pb4.so-net.ne.jp
*/

class Sfmt9 extends Sfmt
{
    public String IdString() {
        return"SFMT-2281:2-20-1-5-3:ffffffbf-7dffdfeb-df7fffdf-feff69ee";
    }

    protected int[]GetParity()
    { return new int[]{ 0x00000001,0x00000000,0x00000000,0x32455000 }; }


    public void gen_rand_all() {
        int a=0,b=8,c=64,d=68,y; int[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<8)^(p[a+2]>>>24)^((p[b+3]>>>5)&0xfeff69ee);
            p[a+3]=y^(p[c+3]>>>24)^(p[d+3]<<20);
            y=p[a+2]^(p[a+2]<<8)^(p[a+1]>>>24)^((p[b+2]>>>5)&0xdf7fffdf);
            p[a+2]=y^((p[c+2]>>>24)|(p[c+3]<<8))^(p[d+2]<<20);
            y=p[a+1]^(p[a+1]<<8)^(p[a]>>>24)^((p[b+1]>>>5)&0x7dffdfeb);
            p[a+1]=y^((p[c+1]>>>24)|(p[c+2]<<8))^(p[d+1]<<20);
            y=p[a]^(p[a]<<8)^((p[b]>>>5)&0xffffffbf);
            p[a]=y^((p[c]>>>24)|(p[c+1]<<8))^(p[d]<<20);
            c=d; d=a; a+=4; b+=4;
            if (b==72) b=0;
        } while (a!=72);
    }

    Sfmt9(int s) { super(s); }
    Sfmt9(int[]init_key)  { super(init_key); }
}
