/*
Sfmt11.java Cu(4253)
coded by isaku@pb4.so-net.ne.jp
*/

class Sfmt11 extends Sfmt
{
    public String IdString() {
        return"SFMT-4253:12-17-5-5-3:ffffffff-bdffffff-e7fffffe-f3b7f7ef";
    }

    protected int[]GetParity()
    { return new int[]{ 0xa0000001,0xe4d017d4,0xe32206c7,0xe65fe0ee }; }


    public void gen_rand_all() {
        int a=0,b=48,c=128,d=132,y; int[]p=x;

        do {
            y=p[a+3]^(p[a+2]<<8)^(p[a+1]>>>24)^((p[b+3]>>>5)&0xf3b7f7ef);
            p[a+3]=y^(p[c+3]>>>24)^(p[d+3]<<17);
            y=p[a+2]^(p[a+1]<<8)^(p[a]>>>24)^((p[b+2]>>>5)&0xe7fffffe);
            p[a+2]=y^((p[c+2]>>>24)|(p[c+3]<<8))^(p[d+2]<<17);
            y=p[a+1]^(p[a]<<8)^((p[b+1]>>>5)&0xbdffffff);
            p[a+1]=y^((p[c+1]>>>24)|(p[c+2]<<8))^(p[d+1]<<17);
            y=p[a]^((p[b]>>>5)&0xffffffff);
            p[a]=y^((p[c]>>>24)|(p[c+1]<<8))^(p[d]<<17);
            c=d; d=a; a+=4; b+=4;
            if (b==136) b=0;
        } while (a!=136);
    }

    Sfmt11(int s) { super(s); }
    Sfmt11(int[]init_key)  { super(init_key); }
}
