/*
Sfmt17.java Cu(4253)
coded by isaku@pb4.so-net.ne.jp
*/

class Sfmt17 extends Sfmt
{
    public String IdString() {
        return"SFMT-4253:13-13-5-4-3:bf7febad-ff3ff756-fafaf6f6-fffffffc";
    }

    protected int[]GetParity()
    { return new int[]{ 0x28000001,0xf2e5468c,0x7b320d81,0xd79d5d0d }; }


    public void gen_rand_all() {
        int a=0,b=52,c=128,d=132,y; int[]p=x;

        do {
            y=p[a+3]^(p[a+2]<<8)^(p[a+1]>>>24)^((p[b+3]>>>4)&0xfffffffc);
            p[a+3]=y^(p[c+3]>>>24)^(p[d+3]<<13);
            y=p[a+2]^(p[a+1]<<8)^(p[a]>>>24)^((p[b+2]>>>4)&0xfafaf6f6);
            p[a+2]=y^((p[c+2]>>>24)|(p[c+3]<<8))^(p[d+2]<<13);
            y=p[a+1]^(p[a]<<8)^((p[b+1]>>>4)&0xff3ff756);
            p[a+1]=y^((p[c+1]>>>24)|(p[c+2]<<8))^(p[d+1]<<13);
            y=p[a]^((p[b]>>>4)&0xbf7febad);
            p[a]=y^((p[c]>>>24)|(p[c+1]<<8))^(p[d]<<13);
            c=d; d=a; a+=4; b+=4;
            if (b==136) b=0;
        } while (a!=136);
    }

    Sfmt17(int s) { super(s); }
    Sfmt17(int[]init_key)  { super(init_key); }
}
