/*
Sfmt23.java Cu(4253)
coded by isaku@pb4.so-net.ne.jp
*/

class Sfmt23 extends Sfmt
{
    public String IdString() {
        return"SFMT-4253:13-22-1-9-3:ffffebfb-7fffbb7f-cbddfffb-fff7ff7f";
    }

    protected int[]GetParity()
    { return new int[]{ 0x00000001,0x179503c2,0x84579cd5,0x8bcf2f27 }; }


    public void gen_rand_all() {
        int a=0,b=52,c=128,d=132,y; int[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<8)^(p[a+2]>>>24)^((p[b+3]>>>9)&0xfff7ff7f);
            p[a+3]=y^(p[c+3]>>>24)^(p[d+3]<<22);
            y=p[a+2]^(p[a+2]<<8)^(p[a+1]>>>24)^((p[b+2]>>>9)&0xcbddfffb);
            p[a+2]=y^((p[c+2]>>>24)|(p[c+3]<<8))^(p[d+2]<<22);
            y=p[a+1]^(p[a+1]<<8)^(p[a]>>>24)^((p[b+1]>>>9)&0x7fffbb7f);
            p[a+1]=y^((p[c+1]>>>24)|(p[c+2]<<8))^(p[d+1]<<22);
            y=p[a]^(p[a]<<8)^((p[b]>>>9)&0xffffebfb);
            p[a]=y^((p[c]>>>24)|(p[c+1]<<8))^(p[d]<<22);
            c=d; d=a; a+=4; b+=4;
            if (b==136) b=0;
        } while (a!=136);
    }

    Sfmt23(int s) { super(s); }
    Sfmt23(int[]init_key)  { super(init_key); }
}
