/*
Sfmt25.java Cu(4253)
coded by isaku@pb4.so-net.ne.jp
*/

class Sfmt25 extends Sfmt
{
    public String IdString() {
        return"SFMT-4253:19-26-1-19-7:efbfbff7-fb7fffff-feeffdfb-7fbfebf9";
    }

    protected int[]GetParity()
    { return new int[]{ 0xb0000001,0xc49c2158,0xdd1db4e7,0x0da08972 }; }


    public void gen_rand_all() {
        int a=0,b=76,c=128,d=132,y; int[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<8)^(p[a+2]>>>24)^((p[b+3]>>>19)&0x7fbfebf9);
            p[a+3]=y^(p[d+3]<<26);
            y=p[a+2]^(p[a+2]<<8)^(p[a+1]>>>24)^((p[b+2]>>>19)&0xfeeffdfb);
            p[a+2]=y^(p[c+3]>>>24)^(p[d+2]<<26);
            y=p[a+1]^(p[a+1]<<8)^(p[a]>>>24)^((p[b+1]>>>19)&0xfb7fffff);
            p[a+1]=y^((p[c+2]>>>24)|(p[c+3]<<8))^(p[d+1]<<26);
            y=p[a]^(p[a]<<8)^((p[b]>>>19)&0xefbfbff7);
            p[a]=y^((p[c+1]>>>24)|(p[c+2]<<8))^(p[d]<<26);
            c=d; d=a; a+=4; b+=4;
            if (b==136) b=0;
        } while (a!=136);
    }

    Sfmt25(int s) { super(s); }
    Sfmt25(int[]init_key)  { super(init_key); }
}
