/*
Sfmt3.java Cu(4253)
coded by isaku@pb4.so-net.ne.jp
*/

class Sfmt3 extends Sfmt
{
    public String IdString() {
        return"SFMT-4253:28-8-3-3-5:afffdffb-ffffdfbf-fbffdf77-7d7cfef7";
    }

    protected int[]GetParity()
    { return new int[]{ 0x20000001,0x8ed2d92a,0xefc5d057,0xa6e061d3 }; }


    public void gen_rand_all() {
        int a=0,b=112,c=128,d=132,y; int[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<24)^(p[a+2]>>>8)^((p[b+3]>>>3)&0x7d7cfef7);
            p[a+3]=y^(p[d+3]<<8);
            y=p[a+2]^(p[a+2]<<24)^(p[a+1]>>>8)^((p[b+2]>>>3)&0xfbffdf77);
            p[a+2]=y^(p[c+3]>>>8)^(p[d+2]<<8);
            y=p[a+1]^(p[a+1]<<24)^(p[a]>>>8)^((p[b+1]>>>3)&0xffffdfbf);
            p[a+1]=y^((p[c+2]>>>8)|(p[c+3]<<24))^(p[d+1]<<8);
            y=p[a]^(p[a]<<24)^((p[b]>>>3)&0xafffdffb);
            p[a]=y^((p[c+1]>>>8)|(p[c+2]<<24))^(p[d]<<8);
            c=d; d=a; a+=4; b+=4;
            if (b==136) b=0;
        } while (a!=136);
    }

    Sfmt3(int s) { super(s); }
    Sfmt3(int[]init_key)  { super(init_key); }
}
