/*
Sfmt5.java Cu(4253)
coded by isaku@pb4.so-net.ne.jp
*/

class Sfmt5 extends Sfmt
{
    public String IdString() {
        return"SFMT-4253:8-7-3-19-1:bffffffb-6f9ffbff-7f9fe7f7-bfeffffb";
    }

    protected int[]GetParity()
    { return new int[]{ 0x40000001,0x4e4b2758,0xb998e05a,0xc4f1b268 }; }


    public void gen_rand_all() {
        int a=0,b=32,c=128,d=132,y; int[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<24)^(p[a+2]>>>8)^((p[b+3]>>>19)&0xbfeffffb);
            p[a+3]=y^(p[c+3]>>>8)^(p[d+3]<<7);
            y=p[a+2]^(p[a+2]<<24)^(p[a+1]>>>8)^((p[b+2]>>>19)&0x7f9fe7f7);
            p[a+2]=y^((p[c+2]>>>8)|(p[c+3]<<24))^(p[d+2]<<7);
            y=p[a+1]^(p[a+1]<<24)^(p[a]>>>8)^((p[b+1]>>>19)&0x6f9ffbff);
            p[a+1]=y^((p[c+1]>>>8)|(p[c+2]<<24))^(p[d+1]<<7);
            y=p[a]^(p[a]<<24)^((p[b]>>>19)&0xbffffffb);
            p[a]=y^((p[c]>>>8)|(p[c+1]<<24))^(p[d]<<7);
            c=d; d=a; a+=4; b+=4;
            if (b==136) b=0;
        } while (a!=136);
    }

    Sfmt5(int s) { super(s); }
    Sfmt5(int[]init_key)  { super(init_key); }
}
