/*
Sfmt7.java Cu(4253)
coded by isaku@pb4.so-net.ne.jp
*/

class Sfmt7 extends Sfmt
{
    public String IdString() {
        return"SFMT-4253:14-6-3-3-5:7fdff3fb-57dfffdb-fe9ffddf-fefdae7f";
    }

    protected int[]GetParity()
    { return new int[]{ 0x42000001,0xeb34cfce,0x3eab62b1,0x95b6f6eb }; }


    public void gen_rand_all() {
        int a=0,b=56,c=128,d=132,y; int[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<24)^(p[a+2]>>>8)^((p[b+3]>>>3)&0xfefdae7f);
            p[a+3]=y^(p[d+3]<<6);
            y=p[a+2]^(p[a+2]<<24)^(p[a+1]>>>8)^((p[b+2]>>>3)&0xfe9ffddf);
            p[a+2]=y^(p[c+3]>>>8)^(p[d+2]<<6);
            y=p[a+1]^(p[a+1]<<24)^(p[a]>>>8)^((p[b+1]>>>3)&0x57dfffdb);
            p[a+1]=y^((p[c+2]>>>8)|(p[c+3]<<24))^(p[d+1]<<6);
            y=p[a]^(p[a]<<24)^((p[b]>>>3)&0x7fdff3fb);
            p[a]=y^((p[c+1]>>>8)|(p[c+2]<<24))^(p[d]<<6);
            c=d; d=a; a+=4; b+=4;
            if (b==136) b=0;
        } while (a!=136);
    }

    Sfmt7(int s) { super(s); }
    Sfmt7(int[]init_key)  { super(init_key); }
}
