/*
Sfmt8.java Cu(4253)
coded by isaku@pb4.so-net.ne.jp
*/

class Sfmt8 extends Sfmt
{
    public String IdString() {
        return"SFMT-4253:23-11-7-6-1:ffbfbe7f-ffbfdf6d-bfbffdfd-fffffffd";
    }

    protected int[]GetParity()
    { return new int[]{ 0x60000001,0x045bc889,0x7b26b276,0xf4e713f6 }; }


    public void gen_rand_all() {
        int a=0,b=92,c=128,d=132,y; int[]p=x;

        do {
            y=p[a+3]^(p[a+2]<<24)^(p[a+1]>>>8)^((p[b+3]>>>6)&0xfffffffd);
            p[a+3]=y^(p[c+3]>>>8)^(p[d+3]<<11);
            y=p[a+2]^(p[a+1]<<24)^(p[a]>>>8)^((p[b+2]>>>6)&0xbfbffdfd);
            p[a+2]=y^((p[c+2]>>>8)|(p[c+3]<<24))^(p[d+2]<<11);
            y=p[a+1]^(p[a]<<24)^((p[b+1]>>>6)&0xffbfdf6d);
            p[a+1]=y^((p[c+1]>>>8)|(p[c+2]<<24))^(p[d+1]<<11);
            y=p[a]^((p[b]>>>6)&0xffbfbe7f);
            p[a]=y^((p[c]>>>8)|(p[c+1]<<24))^(p[d]<<11);
            c=d; d=a; a+=4; b+=4;
            if (b==136) b=0;
        } while (a!=136);
    }

    Sfmt8(int s) { super(s); }
    Sfmt8(int[]init_key)  { super(init_key); }
}
