/*
Sfmt11.java Cu(607)
coded by isaku@pb4.so-net.ne.jp
*/

class Sfmt11 extends Sfmt
{
    public String IdString() {
        return"SFMT-607:1-12-7-9-1:feffffde-fe8fbfb7-63effffd-7fe7b3f5";
    }

    protected int[]GetParity()
    { return new int[]{ 0x00000001,0x00000000,0x00000000,0x694481dd }; }


    public void gen_rand_all() {
        int a=0,b=4,c=12,d=16,y; int[]p=x;

        do {
            y=p[a+3]^(p[a+2]<<24)^(p[a+1]>>>8)^((p[b+3]>>>9)&0x7fe7b3f5);
            p[a+3]=y^(p[c+3]>>>8)^(p[d+3]<<12);
            y=p[a+2]^(p[a+1]<<24)^(p[a]>>>8)^((p[b+2]>>>9)&0x63effffd);
            p[a+2]=y^((p[c+2]>>>8)|(p[c+3]<<24))^(p[d+2]<<12);
            y=p[a+1]^(p[a]<<24)^((p[b+1]>>>9)&0xfe8fbfb7);
            p[a+1]=y^((p[c+1]>>>8)|(p[c+2]<<24))^(p[d+1]<<12);
            y=p[a]^((p[b]>>>9)&0xfeffffde);
            p[a]=y^((p[c]>>>8)|(p[c+1]<<24))^(p[d]<<12);
            c=d; d=a; a+=4; b+=4;
            if (b==20) b=0;
        } while (a!=20);
    }

    Sfmt11(int s) { super(s); }
    Sfmt11(int[]init_key)  { super(init_key); }
}
