/*
Sfmt12.java Cu(607)
coded by isaku@pb4.so-net.ne.jp
*/

class Sfmt12 extends Sfmt
{
    public String IdString() {
        return"SFMT-607:1-13-7-5-1:fffff9b7-bfebffdb-e7dfeefe-f3ff3eff";
    }

    protected int[]GetParity()
    { return new int[]{ 0x00000001,0x00000000,0x80000000,0x6e1c11be }; }


    public void gen_rand_all() {
        int a=0,b=4,c=12,d=16,y; int[]p=x;

        do {
            y=p[a+3]^(p[a+2]<<24)^(p[a+1]>>>8)^((p[b+3]>>>5)&0xf3ff3eff);
            p[a+3]=y^(p[c+3]>>>8)^(p[d+3]<<13);
            y=p[a+2]^(p[a+1]<<24)^(p[a]>>>8)^((p[b+2]>>>5)&0xe7dfeefe);
            p[a+2]=y^((p[c+2]>>>8)|(p[c+3]<<24))^(p[d+2]<<13);
            y=p[a+1]^(p[a]<<24)^((p[b+1]>>>5)&0xbfebffdb);
            p[a+1]=y^((p[c+1]>>>8)|(p[c+2]<<24))^(p[d+1]<<13);
            y=p[a]^((p[b]>>>5)&0xfffff9b7);
            p[a]=y^((p[c]>>>8)|(p[c+1]<<24))^(p[d]<<13);
            c=d; d=a; a+=4; b+=4;
            if (b==20) b=0;
        } while (a!=20);
    }

    Sfmt12(int s) { super(s); }
    Sfmt12(int[]init_key)  { super(init_key); }
}
