/*
Sfmt13.java Cu(607)
coded by isaku@pb4.so-net.ne.jp
*/

class Sfmt13 extends Sfmt
{
    public String IdString() {
        return"SFMT-607:3-6-7-1-1:feffbff7-fffdd7ff-7ffffdff-fdffffff";
    }

    protected int[]GetParity()
    { return new int[]{ 0x00000001,0x00000000,0x00000000,0x047cd258 }; }


    public void gen_rand_all() {
        int a=0,b=12,c=12,d=16,y; int[]p=x;

        do {
            y=p[a+3]^(p[a+2]<<24)^(p[a+1]>>>8)^((p[b+3]>>>1)&0xfdffffff);
            p[a+3]=y^(p[c+3]>>>8)^(p[d+3]<<6);
            y=p[a+2]^(p[a+1]<<24)^(p[a]>>>8)^((p[b+2]>>>1)&0x7ffffdff);
            p[a+2]=y^((p[c+2]>>>8)|(p[c+3]<<24))^(p[d+2]<<6);
            y=p[a+1]^(p[a]<<24)^((p[b+1]>>>1)&0xfffdd7ff);
            p[a+1]=y^((p[c+1]>>>8)|(p[c+2]<<24))^(p[d+1]<<6);
            y=p[a]^((p[b]>>>1)&0xfeffbff7);
            p[a]=y^((p[c]>>>8)|(p[c+1]<<24))^(p[d]<<6);
            c=d; d=a; a+=4; b+=4;
            if (b==20) b=0;
        } while (a!=20);
    }

    Sfmt13(int s) { super(s); }
    Sfmt13(int[]init_key)  { super(init_key); }
}
