/*
Sfmt19.java Cu(607)
coded by isaku@pb4.so-net.ne.jp
*/

class Sfmt19 extends Sfmt
{
    public String IdString() {
        return"SFMT-607:2-10-3-23-1:ffebccfd-affffffd-f777bdff-af7effff";
    }

    protected int[]GetParity()
    { return new int[]{ 0x00000001,0x00000000,0x80000000,0xc824d8c1 }; }


    public void gen_rand_all() {
        int a=0,b=8,c=12,d=16,y; int[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<24)^(p[a+2]>>>8)^((p[b+3]>>>23)&0xaf7effff);
            p[a+3]=y^(p[c+3]>>>8)^(p[d+3]<<10);
            y=p[a+2]^(p[a+2]<<24)^(p[a+1]>>>8)^((p[b+2]>>>23)&0xf777bdff);
            p[a+2]=y^((p[c+2]>>>8)|(p[c+3]<<24))^(p[d+2]<<10);
            y=p[a+1]^(p[a+1]<<24)^(p[a]>>>8)^((p[b+1]>>>23)&0xaffffffd);
            p[a+1]=y^((p[c+1]>>>8)|(p[c+2]<<24))^(p[d+1]<<10);
            y=p[a]^(p[a]<<24)^((p[b]>>>23)&0xffebccfd);
            p[a]=y^((p[c]>>>8)|(p[c+1]<<24))^(p[d]<<10);
            c=d; d=a; a+=4; b+=4;
            if (b==20) b=0;
        } while (a!=20);
    }

    Sfmt19(int s) { super(s); }
    Sfmt19(int[]init_key)  { super(init_key); }
}
