/*
Sfmt2.java Cu(607)
coded by isaku@pb4.so-net.ne.jp
*/

class Sfmt2 extends Sfmt
{
    public String IdString() {
        return"SFMT-607:1-13-3-11-5:df7fffff-f7ff77ff-fffff2ff-ffff473f";
    }

    protected int[]GetParity()
    { return new int[]{ 0x00000001,0x00000000,0x00000000,0xb5a64116 }; }


    public void gen_rand_all() {
        int a=0,b=4,c=12,d=16,y; int[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<24)^(p[a+2]>>>8)^((p[b+3]>>>11)&0xffff473f);
            p[a+3]=y^(p[d+3]<<13);
            y=p[a+2]^(p[a+2]<<24)^(p[a+1]>>>8)^((p[b+2]>>>11)&0xfffff2ff);
            p[a+2]=y^(p[c+3]>>>8)^(p[d+2]<<13);
            y=p[a+1]^(p[a+1]<<24)^(p[a]>>>8)^((p[b+1]>>>11)&0xf7ff77ff);
            p[a+1]=y^((p[c+2]>>>8)|(p[c+3]<<24))^(p[d+1]<<13);
            y=p[a]^(p[a]<<24)^((p[b]>>>11)&0xdf7fffff);
            p[a]=y^((p[c+1]>>>8)|(p[c+2]<<24))^(p[d]<<13);
            c=d; d=a; a+=4; b+=4;
            if (b==20) b=0;
        } while (a!=20);
    }

    Sfmt2(int s) { super(s); }
    Sfmt2(int[]init_key)  { super(init_key); }
}
