/*
Sfmt20.java Cu(607)
coded by isaku@pb4.so-net.ne.jp
*/

class Sfmt20 extends Sfmt
{
    public String IdString() {
        return"SFMT-607:1-4-3-1-1:fe9fffef-ffbffeff-be57bdff-fefb3f5f";
    }

    protected int[]GetParity()
    { return new int[]{ 0x00000001,0x00000000,0x80000000,0x41129a62 }; }


    public void gen_rand_all() {
        int a=0,b=4,c=12,d=16,y; int[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<24)^(p[a+2]>>>8)^((p[b+3]>>>1)&0xfefb3f5f);
            p[a+3]=y^(p[c+3]>>>8)^(p[d+3]<<4);
            y=p[a+2]^(p[a+2]<<24)^(p[a+1]>>>8)^((p[b+2]>>>1)&0xbe57bdff);
            p[a+2]=y^((p[c+2]>>>8)|(p[c+3]<<24))^(p[d+2]<<4);
            y=p[a+1]^(p[a+1]<<24)^(p[a]>>>8)^((p[b+1]>>>1)&0xffbffeff);
            p[a+1]=y^((p[c+1]>>>8)|(p[c+2]<<24))^(p[d+1]<<4);
            y=p[a]^(p[a]<<24)^((p[b]>>>1)&0xfe9fffef);
            p[a]=y^((p[c]>>>8)|(p[c+1]<<24))^(p[d]<<4);
            c=d; d=a; a+=4; b+=4;
            if (b==20) b=0;
        } while (a!=20);
    }

    Sfmt20(int s) { super(s); }
    Sfmt20(int[]init_key)  { super(init_key); }
}
