/*
Sfmt24.java Cu(607)
coded by isaku@pb4.so-net.ne.jp
*/

class Sfmt24 extends Sfmt
{
    public String IdString() {
        return"SFMT-607:2-21-5-4-1:ffbbf77f-ff7ffbfb-bffff7f7-efecdfff";
    }

    protected int[]GetParity()
    { return new int[]{ 0x00000001,0x00000000,0x04000000,0xf361b11f }; }


    public void gen_rand_all() {
        int a=0,b=8,c=12,d=16,y; int[]p=x;

        do {
            y=p[a+3]^(p[a+2]<<8)^(p[a+1]>>>24)^((p[b+3]>>>4)&0xefecdfff);
            p[a+3]=y^(p[c+3]>>>8)^(p[d+3]<<21);
            y=p[a+2]^(p[a+1]<<8)^(p[a]>>>24)^((p[b+2]>>>4)&0xbffff7f7);
            p[a+2]=y^((p[c+2]>>>8)|(p[c+3]<<24))^(p[d+2]<<21);
            y=p[a+1]^(p[a]<<8)^((p[b+1]>>>4)&0xff7ffbfb);
            p[a+1]=y^((p[c+1]>>>8)|(p[c+2]<<24))^(p[d+1]<<21);
            y=p[a]^((p[b]>>>4)&0xffbbf77f);
            p[a]=y^((p[c]>>>8)|(p[c+1]<<24))^(p[d]<<21);
            c=d; d=a; a+=4; b+=4;
            if (b==20) b=0;
        } while (a!=20);
    }

    Sfmt24(int s) { super(s); }
    Sfmt24(int[]init_key)  { super(init_key); }
}
