/*
Sfmt26.java Cu(607)
coded by isaku@pb4.so-net.ne.jp
*/

class Sfmt26 extends Sfmt
{
    public String IdString() {
        return"SFMT-607:3-11-5-12-3:ebffefff-fbfffaff-f7fffeff-7ffefffe";
    }

    protected int[]GetParity()
    { return new int[]{ 0x00000001,0x00000000,0x40000000,0x39660c35 }; }


    public void gen_rand_all() {
        int a=0,b=12,c=12,d=16,y; int[]p=x;

        do {
            y=p[a+3]^(p[a+2]<<8)^(p[a+1]>>>24)^((p[b+3]>>>12)&0x7ffefffe);
            p[a+3]=y^(p[c+3]>>>24)^(p[d+3]<<11);
            y=p[a+2]^(p[a+1]<<8)^(p[a]>>>24)^((p[b+2]>>>12)&0xf7fffeff);
            p[a+2]=y^((p[c+2]>>>24)|(p[c+3]<<8))^(p[d+2]<<11);
            y=p[a+1]^(p[a]<<8)^((p[b+1]>>>12)&0xfbfffaff);
            p[a+1]=y^((p[c+1]>>>24)|(p[c+2]<<8))^(p[d+1]<<11);
            y=p[a]^((p[b]>>>12)&0xebffefff);
            p[a]=y^((p[c]>>>24)|(p[c+1]<<8))^(p[d]<<11);
            c=d; d=a; a+=4; b+=4;
            if (b==20) b=0;
        } while (a!=20);
    }

    Sfmt26(int s) { super(s); }
    Sfmt26(int[]init_key)  { super(init_key); }
}
