/*
Sfmt27.java Cu(607)
coded by isaku@pb4.so-net.ne.jp
*/

class Sfmt27 extends Sfmt
{
    public String IdString() {
        return"SFMT-607:2-11-5-6-3:ffffffdd-dff7bdf7-f3fff1ff-ffff7ffe";
    }

    protected int[]GetParity()
    { return new int[]{ 0x00000001,0x00000000,0x00000000,0x18ceeb85 }; }


    public void gen_rand_all() {
        int a=0,b=8,c=12,d=16,y; int[]p=x;

        do {
            y=p[a+3]^(p[a+2]<<8)^(p[a+1]>>>24)^((p[b+3]>>>6)&0xffff7ffe);
            p[a+3]=y^(p[c+3]>>>24)^(p[d+3]<<11);
            y=p[a+2]^(p[a+1]<<8)^(p[a]>>>24)^((p[b+2]>>>6)&0xf3fff1ff);
            p[a+2]=y^((p[c+2]>>>24)|(p[c+3]<<8))^(p[d+2]<<11);
            y=p[a+1]^(p[a]<<8)^((p[b+1]>>>6)&0xdff7bdf7);
            p[a+1]=y^((p[c+1]>>>24)|(p[c+2]<<8))^(p[d+1]<<11);
            y=p[a]^((p[b]>>>6)&0xffffffdd);
            p[a]=y^((p[c]>>>24)|(p[c+1]<<8))^(p[d]<<11);
            c=d; d=a; a+=4; b+=4;
            if (b==20) b=0;
        } while (a!=20);
    }

    Sfmt27(int s) { super(s); }
    Sfmt27(int[]init_key)  { super(init_key); }
}
