/*
Sfmt28.java Cu(607)
coded by isaku@pb4.so-net.ne.jp
*/

class Sfmt28 extends Sfmt
{
    public String IdString() {
        return"SFMT-607:2-21-3-11-5:ffff7ebf-fffd7fff-dffdfdff-ffa57bdf";
    }

    protected int[]GetParity()
    { return new int[]{ 0x00000001,0x00000000,0x80000000,0x41d828ef }; }


    public void gen_rand_all() {
        int a=0,b=8,c=12,d=16,y; int[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<24)^(p[a+2]>>>8)^((p[b+3]>>>11)&0xffa57bdf);
            p[a+3]=y^(p[d+3]<<21);
            y=p[a+2]^(p[a+2]<<24)^(p[a+1]>>>8)^((p[b+2]>>>11)&0xdffdfdff);
            p[a+2]=y^(p[c+3]>>>8)^(p[d+2]<<21);
            y=p[a+1]^(p[a+1]<<24)^(p[a]>>>8)^((p[b+1]>>>11)&0xfffd7fff);
            p[a+1]=y^((p[c+2]>>>8)|(p[c+3]<<24))^(p[d+1]<<21);
            y=p[a]^(p[a]<<24)^((p[b]>>>11)&0xffff7ebf);
            p[a]=y^((p[c+1]>>>8)|(p[c+2]<<24))^(p[d]<<21);
            c=d; d=a; a+=4; b+=4;
            if (b==20) b=0;
        } while (a!=20);
    }

    Sfmt28(int s) { super(s); }
    Sfmt28(int[]init_key)  { super(init_key); }
}
