/*
Sfmt4.java Cu(607)
coded by isaku@pb4.so-net.ne.jp
*/

class Sfmt4 extends Sfmt
{
    public String IdString() {
        return"SFMT-607:2-15-1-3-1:ff77fff7-fd77ffff-fffffdcf-fffffffa";
    }

    protected int[]GetParity()
    { return new int[]{ 0x00000001,0x00000000,0x20000000,0xd63bbe55 }; }


    public void gen_rand_all() {
        int a=0,b=8,c=12,d=16,y; int[]p=x;

        do {
            y=p[a+3]^(p[a+3]<<8)^(p[a+2]>>>24)^((p[b+3]>>>3)&0xfffffffa);
            p[a+3]=y^(p[c+3]>>>8)^(p[d+3]<<15);
            y=p[a+2]^(p[a+2]<<8)^(p[a+1]>>>24)^((p[b+2]>>>3)&0xfffffdcf);
            p[a+2]=y^((p[c+2]>>>8)|(p[c+3]<<24))^(p[d+2]<<15);
            y=p[a+1]^(p[a+1]<<8)^(p[a]>>>24)^((p[b+1]>>>3)&0xfd77ffff);
            p[a+1]=y^((p[c+1]>>>8)|(p[c+2]<<24))^(p[d+1]<<15);
            y=p[a]^(p[a]<<8)^((p[b]>>>3)&0xff77fff7);
            p[a]=y^((p[c]>>>8)|(p[c+1]<<24))^(p[d]<<15);
            c=d; d=a; a+=4; b+=4;
            if (b==20) b=0;
        } while (a!=20);
    }

    Sfmt4(int s) { super(s); }
    Sfmt4(int[]init_key)  { super(init_key); }
}
